!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_keyval_list_tool
  use cubetools_parameters
  use cubetools_format
  use cubesyntax_messaging
  !
  public :: keyval_list_t
  public :: keyval
  private
  !
  type keyval_list_t
   contains
     procedure, private :: list_inte => cubesyntax_keyval_list_inte
!!$     procedure, private :: list_long => cubesyntax_keyval_list_long
     procedure, private :: list_real => cubesyntax_keyval_list_real
     procedure, private :: list_dble => cubesyntax_keyval_list_dble
     procedure, private :: list_strg => cubesyntax_keyval_list_strg
     generic,   public  :: list => list_inte,list_real,list_dble,list_strg
  end type keyval_list_t
  type(keyval_list_t) :: keyval
  !
  integer(kind=4) :: list_l = 40
  !
  character(len=mess_l) :: mess
  !
contains
  !
  subroutine cubesyntax_keyval_list_inte(prog,name,value,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(keyval_list_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: name
    integer(kind=inte_k), intent(in)    :: value
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>LIST>INTE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    mess = '  '//cubetools_format_stdkey_boldval(name,value,'i0',list_l)
    call cubesyntax_message(seve%r,rname,mess)
  end subroutine cubesyntax_keyval_list_inte
  !
  subroutine cubesyntax_keyval_list_real(prog,name,value,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(keyval_list_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: name
    real(kind=real_k),    intent(in)    :: value
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>LIST>REAL'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    mess = '  '//cubetools_format_stdkey_boldval(name,value,fsimple,list_l)
    call cubesyntax_message(seve%r,rname,mess)
  end subroutine cubesyntax_keyval_list_real
  !
  subroutine cubesyntax_keyval_list_dble(prog,name,value,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(keyval_list_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: name
    real(kind=dble_k),    intent(in)    :: value
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>LIST>DBLE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    mess = '  '//cubetools_format_stdkey_boldval(name,value,fdouble,list_l)
    call cubesyntax_message(seve%r,rname,mess)
  end subroutine cubesyntax_keyval_list_dble
  !
  subroutine cubesyntax_keyval_list_strg(prog,name,value,error)
    !-------------------------------------------------------------------
    ! 
    !-------------------------------------------------------------------
    class(keyval_list_t), intent(in)    :: prog
    character(len=*),     intent(in)    :: name
    character(len=*),     intent(in)    :: value
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>LIST>STRG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    mess = '  '//cubetools_format_stdkey_boldval(name,value,list_l)
    call cubesyntax_message(seve%r,rname,mess)
  end subroutine cubesyntax_keyval_list_strg
end module cubesyntax_keyval_list_tool
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! The following routines are independent of the kind of wavelets.
! 
subroutine gwavelet_subtract(iorder,wavelets,vec,error)
  use gmath_interfaces, except_this=>gwavelet_subtract
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Subtract the ith order when asked
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: iorder 
  real(kind=4),    intent(in)    :: wavelets(:,:)
  real(kind=4),    intent(inout) :: vec(:)
  logical,         intent(inout) :: error
  ! Local
  integer(kind=4) :: nvec,nwav
  character(len=message_length) :: mess
  character(len=*), parameter :: rname='GWAVELET/SUBTRACT'
  !
  nvec = size(wavelets,1)
  nwav = size(wavelets,2)
  if (iorder.gt.nwav) then
    write(mess,'(A,I0,A)') 'Order ',iorder,' is not available for option /BASE'
    call gmath_message(seve%e,rname,mess)
    error = .true.
    return
  elseif (iorder.gt.0) then
     if (size(vec).ne.nvec) then
        write(mess,'(A,I0,A,I0)') 'Size mismatch: ',nvec,',',size(vec)
        call gmath_message(seve%e,rname,mess)
        error = .true.
        return
     endif
     vec(:) = vec(:)-wavelets(:,iorder)
  else
     ! Do not modify input spectrum
  endif
  !
end subroutine gwavelet_subtract
!
subroutine gwavelet_mirror(nvec,vec1,vec2,error)
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gwavelet_mirror
  !---------------------------------------------------------------------
  ! @ private
  ! Double the size of a vector, fill the central part with the initial
  ! vector and fill the left and right part with mirror versions of the
  ! initial vector.
  ! On return the vec2 array has been allocated and filled
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: nvec       ! Data size
  real(kind=4),              intent(in)    :: vec1(nvec) ! Data
  real(kind=4), allocatable, intent(inout) :: vec2(:)    ! Results
  logical,                   intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=4) :: ivec,nhalf,ier
  character(len=*), parameter :: rname='GWAVELET/MIRROR'
  !
  allocate(vec2(2*nvec),stat=ier)
  if (failed_allocate(rname,'vec2',ier,error)) return
  nhalf = nvec/2   ! Remember nvec may be odd
  do ivec=1,nhalf  ! First half of the input spectrum (mirrored)
    vec2(nhalf+1-ivec) = vec1(ivec)
  enddo
  do ivec=1,nvec  ! Full input spectrum
    vec2(nhalf+ivec) = vec1(ivec)
  enddo
  do ivec=nhalf+1,nvec  ! 2nd half of the input spectrum (mirrored)
    vec2(2*nvec+nhalf+1-ivec) = vec1(ivec)
  enddo
end subroutine gwavelet_mirror
!
subroutine gwavelet_extract(nvec,nwav,wavelets2,wavelets1,error)
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gwavelet_extract
  !---------------------------------------------------------------------
  ! @ private
  ! Extract the central part of a wavelet array
  ! On return the wavelet1 array has been allocated and filled
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: nvec                   ! Data size
  integer(kind=4),           intent(in)    :: nwav                   ! Number of wavelets
  real(kind=4),              intent(in)    :: wavelets2(2*nvec,nwav) ! Data
  real(kind=4), allocatable, intent(inout) :: wavelets1(:,:)         ! Results
  logical,                   intent(inout) :: error                  ! Logical error flag
  ! Local
  logical :: alloc
  integer(kind=4) :: nhalf,iwav,ier
  character(len=*), parameter :: rname='GWAVELET/EXTRACT'
  !
  nhalf = nvec/2 ! Remember nvec may be odd
  if (.not.allocated(wavelets1)) then
    alloc = .true.
  elseif (size(wavelets1,1).ne.nvec .or. size(wavelets1,2).ne.nwav) then
    deallocate(wavelets1)
    alloc = .true.
  else
    alloc = .false.
  endif
  if (alloc) then
    allocate(wavelets1(nvec,nwav),stat=ier)
    if (failed_allocate(rname,'wavelets',ier,error))  return
  endif
  ! Fill the values
  do iwav=1,nwav
    wavelets1(:,iwav) = wavelets2(nhalf+1:nhalf+nvec,iwav)
  enddo
end subroutine gwavelet_extract
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! The following routines assume gaps wavelets.
!
subroutine gwavelet_gaps(vec1,wavelets1,error)
  use gmath_interfaces, except_this=>gwavelet_gaps
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the wavelets for an input 1D data
  ! Take care of edge effects by mirroring the vector at each edge
  ! On return the input 'wavelets' array has been allocated and filled
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)    :: vec1(:)        ! Data
  real(kind=4), allocatable, intent(inout) :: wavelets1(:,:) ! Results
  logical,                   intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=4) :: nvec,nwav
  real(kind=4), allocatable :: vec2(:),wavelets2(:,:)
  character(len=*), parameter :: rname='GWAVELET/GAPS'
  !
  nvec = size(vec1)
  call gwavelet_mirror(nvec,vec1,vec2,error)
  if (error) goto 10
  call gwavelet_gaps_sub(vec2,2*nvec,wavelets2,nwav,error)
  if (error)  goto 10
  call gwavelet_extract(nvec,nwav,wavelets2,wavelets1,error)
  if (error) goto 10
  !
10 continue
  if (allocated(vec2))  deallocate(vec2)
  if (allocated(wavelets2))  deallocate(wavelets2)
  !
end subroutine gwavelet_gaps
!
subroutine gwavelet_gaps_sub(vec,vsize,wavelets,nwav,error)
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gwavelet_gaps_sub
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Compute and modify inplace the wavelets for input 1D data
  ! On return the input wavelets array has been allocated and filled
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: vsize          ! Vector size
  real(kind=4),              intent(inout) :: vec(vsize)     ! Data / working buffer
  real(kind=4), allocatable, intent(inout) :: wavelets(:,:)  ! Results
  integer(kind=4),           intent(out)   :: nwav           ! Number of wavelets in working buffer
  logical,                   intent(inout) :: error          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GWAVELET/GAPS/SUB'
  integer(kind=4), parameter :: fwidth=5  ! Filter width
  real(kind=4), parameter :: filter(fwidth) =  &
    (/ 1./16., 1./4., 3./8., 1./4., 1./16. /)
  integer(kind=4) :: ier
  !
  call gwavelet_gaps_prepare(vsize,fwidth,nwav)
  if (nwav.le.0) then
    call gmath_message(seve%e,rname,'Number of wavelets lower or equal to 0')
    error = .true.
    return
  endif
  !
  allocate(wavelets(vsize,nwav),stat=ier)
  if (failed_allocate(rname,'wavelets',ier,error))  return
  !
  ! Compute
  call gwavelet_gaps_compute(vec,vsize,filter,fwidth,nwav,wavelets,error)
  if (error)  return
  !
end subroutine gwavelet_gaps_sub
!
subroutine gwavelet_gaps_prepare(vsize,fw,nwav)
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the number of wavelets which will be needed
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: vsize  ! Data size
  integer(kind=4), intent(in)  :: fw     ! Filter width
  integer(kind=4), intent(out) :: nwav   ! Number of wavelets
  !
  nwav = int(log(real(vsize,kind=4)/real(fw,kind=4))/log(2.))
  !
end subroutine gwavelet_gaps_prepare
!
subroutine gwavelet_gaps_compute(vec,vsize,f1,fw1,nwav,wav,error)
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gwavelet_gaps_compute
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the wavelets
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: vsize            ! Data size
  real(kind=4),    intent(inout) :: vec(vsize)       ! Data / working buffer
  integer(kind=4), intent(in)    :: fw1              ! Original filter width
  real(kind=4),    intent(in)    :: f1(fw1)          ! Original filter
  integer(kind=4), intent(in)    :: nwav             ! Number of wavelets
  real(kind=4),    intent(out)   :: wav(vsize,nwav)  ! Wavelets on return
  logical,         intent(inout) :: error            ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GWAVELET'
  integer(kind=4) :: fwn,fwmax,ier,ifv,iwav
  real(kind=4), allocatable :: fn(:)
  !
  ! Filter width grows iteratively for each wavelet order:
  !   fw(n) = 2*fw(n-1)-1
  ! We compute the maximum size we will have to work with and allocate
  ! it once. We can prove that:
  !   fw(n) = 2**(n-1) * (fw(1)-1) + 1
  fwmax = 2**(nwav-1) * (fw1-1) + 1
  allocate(fn(fwmax),stat=ier)
  if (failed_allocate(rname,'fn',ier,error))  return
  !
  ! 1st order
  fwn = fw1
  fn(1:fwn) = f1(:)
  call gwavelet_convolve(vec,wav(1,nwav),vsize,fn,fwn)
  vec(:) = vec(:)-wav(:,1)
  !
  ! Higher orders
  do iwav=2,nwav
    !
    ! Compute next filter by interleaving 0 values. Start from the end
    ! to allow working in the same array.
    fn(2*fwn-1) = fn(fwn)
    do ifv=fwn-1,1,-1
      fn(2*ifv) = 0.
      fn(2*ifv-1) = fn(ifv)
    enddo
    fwn = 2*fwn-1
    !
    ! Convolve
    call gwavelet_convolve(wav(1,nwav-iwav+2),wav(1,nwav-iwav+1),vsize,fn,fwn)
    ! Subtract
    vec(:) = vec(:)-wav(:,nwav-iwav+1)
    !
  enddo
  !
  if (allocated(fn)) deallocate(fn)
  !
end subroutine gwavelet_gaps_compute
!
subroutine gwavelet_convolve(din,dout,dsize,kern,ksize)
  !---------------------------------------------------------------------
  ! @ private
  ! 1D convolution
  ! This version is optimized for convolution kernels which have
  ! 0-valued elements.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: dsize        ! Data size
  real(kind=4),    intent(in)  :: din(dsize)   ! Data in
  real(kind=4),    intent(out) :: dout(dsize)  ! Data out
  integer(kind=4), intent(in)  :: ksize        ! Kernel size
  real(kind=4),    intent(in)  :: kern(ksize)  ! Kernel
  ! Local
  integer(kind=4) :: i,k,koff
  !
  ! There are many zeros in 'kern' in the wavelet context: loops are
  ! inverted (possible because they are independant) and ignored when
  ! the kernel value is 0.
  koff = (ksize+1)/2
  dout(:) = 0.
  do k=1,ksize
    if (kern(k).eq.0.)  cycle
    do i=1,dsize
      if (i+k-koff.le.0 .or. i+k-koff.gt.dsize)  cycle
      dout(i) = dout(i) + din(i+k-koff)*kern(k)
    enddo
  enddo
  !
  ! Should we ensure that the convolution kernel is normalized?
  ! norm = 1./sum(kern)
  !
end subroutine gwavelet_convolve
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!-----------------------------------------------------------------------
! The following transposition engine is based on the idea that many
! transpositions can be re-written as permutation of the 2nd and 4th
! dimensions of a 5D array. The most "difficult" part is to find how
! to remap the input array on such a 5D array, by repacking contiguous
! dimensions and inserting others which are degenerated.
!
! Examples:
! - 21:       a(n1,n2) <= b(1, n1, 1, n2, 1)
!             tr(a) = tr(b) = c(1,n2,1,n1,1)
! - 321:      a(n1,n2,n3) <= b(1, n1, n2, n3, 1)
!             tr(a) = tr(b) = c(1,n3,n2,n1,1)
! - 312:      a(n1,n2,n3) <= b(1, n1*n2, 1, n3, 1)
!             tr(a) = tr(b) = c(1,n3,1,n1*n2,1)
! - 1567423:  a(n1,n2,n3,n4,n5,n6,n7) <= b(n1, n2*n3, n4, n5*n6*n7, 1)
!             tr(a) = tr(b) = c(n1,n5*n6*n7,n4,n2*n3,1)
!
! Pros:
!  - since we always swap the 2nd and 4th dimension of the 5D array,
!    there is no need of a permutation array in the transposition loop.
!  - up to now all the transpositions needed in the Gildas context are
!    supported in a single pass.
!  - such an approach allows the calling programs to loop on the 5th
!    dimension of the 5D array, i.e. allocate only a working buffer
!    of dimensions m1*m2*m3*m4. This is particularly useful when
!    transposing disk images.
! Cons:
!  - all the transpositions are not supported. Some of them imply
!    executing several times the 5D transposition loop to achieve a
!    goal. If the problem fits in memory, a general (7D) transposition
!    loop with a permutation array should be prefered since the result
!    is achieved in a single pass.
!-----------------------------------------------------------------------
module gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !  No need to share the code 'tr_maxdims': the transposition engine
  ! is able to deal with a number of dimensions lower or equal, or
  ! to complain for larger numbers.
  !---------------------------------------------------------------------
  integer(kind=4), parameter :: tr_maxdims=7
end module gmath_transpose
!
subroutine transpose_getcode(strin,strout,code,error)
  use gbl_message
  use gmath_interfaces, except_this=>transpose_getcode
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ public
  !  Convert a dimension string into a transposition code, e.g.
  !   'VLM' transposed to 'LMV'  <=>  transposition code '231'
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: strin   !
  character(len=*), intent(in)    :: strout  !
  character(len=*), intent(out)   :: code    !
  logical,          intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: ni,no,nc,i
  character(len=tr_maxdims) :: in,out
  !
  ni = len_trim(strin)
  no = len_trim(strout)
  nc = len(code)
  !
  ! Sanity check
  if (ni.ne.no)  goto 100
  if (no.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Transposition supported up to 7 dimensions')
    goto 100
  endif
  if (no.gt.nc) then
    call gmath_message(seve%e,rname,'Programming error, string for code too short')
    goto 100
  endif
  !
  ! Case-insensitive work
  in = strin
  call sic_upper(in)
  out = strout
  call sic_upper(out)
  !
  code = ''
  do i=1,no
    code(i:i) = char(ichar('0')+index(in,out(i:i)))
  enddo
  !
  call transpose_check(code,error)
  if (error)  goto 100
  return
  !
  ! Error
100 continue
  call gmath_message(seve%e,rname,  &
    'Could not transpose '//trim(strin)//' to '//strout)
  error = .true.
  return
  !
end subroutine transpose_getcode
!
subroutine transpose_getorder(code,itr,mdims,error)
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>transpose_getorder
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ public
  ! Decode transposition code into an index of axis orders
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: code        ! Transposition code
  integer(kind=4),  intent(in)    :: mdims       ! Maximum number of dimensions
  integer(kind=4),  intent(out)   :: itr(mdims)  ! Transposition index array
  logical,          intent(inout) :: error       ! Error flag
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: n
  !
  if (mdims.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Unsupported number of dimensions')
    error = .true.
    return
  endif
  !
  call transpose_check(code,error)
  if (error)  return
  !
  ! Find transposition code
  itr(:) = 0
  read (code,'(7I1)',iostat=n) itr(1:len_trim(code))
  if (n.ne.0) then
    call gmath_message(seve%e,rname,'Invalid transposition '//code)
    call putios('E-TRANSPOSE,  ',n)
    error = .true.
    return
  endif
  !
end subroutine transpose_getorder
!
subroutine transpose_check(code,error)
  use gbl_message
  use gmath_interfaces, except_this=>transpose_check
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  ! Check that the input code is correct, i.e. check:
  !  - code too large (unsupported number of dimensions)
  !  - illegal characters (e.g. letters)
  !  - correct numbering (each dimension must be present once and only
  !    once)
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: code   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: nc,ic,p1,p2
  !
  nc = len_trim(code)
  if (nc.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Too many dimensions in transposition code '//code)
    error = .true.
    return
  endif
  !
  p1 = 1
  p2 = 1
  do ic=1,nc
    p1 = p1*ic
    p2 = p2*index(code,char(ic+ichar('0')))
  enddo
  !
  if (p1.ne.p2) then
    call gmath_message(seve%e,rname,'Invalid transposition code '//code)
    error = .true.
    return
  endif
  !
end subroutine transpose_check
!
subroutine transpose_getblock(idim,ndims,code,block,error)
  use gildas_def
  use gbl_message
  use gmath_interfaces, except_this=>transpose_getblock
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ public
  !  Repack the transposition order into a general case of the following form:
  !      unchanged, swap1,  unchanged, swap2,   unchanged
  !      Nelems,    Nfirst, Nmiddle,   Nsecond, Nlast
  !---------------------------------------------------------------------
  integer(kind=4),            intent(in)    :: ndims        ! Effective or maximum number of dimensions
  integer(kind=index_length), intent(in)    :: idim(ndims)  ! Array dimensions
  character(len=*),           intent(in)    :: code         ! Transposition code
  integer(kind=index_length), intent(out)   :: block(5)     ! Resulting transposition pack
  logical,                    intent(inout) :: error        ! Error flag
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: repack(5),id,fd
  integer(kind=index_length) :: dims(tr_maxdims)
  integer(kind=index_length) :: nelems,nfirst,nmiddle,nsecon,nlast
  character(len=tr_maxdims) :: start,goal
  !
  if (ndims.gt.tr_maxdims) then
    call gmath_message(seve%e,rname,'Unsupported number of dimensions')
    error = .true.
    return
  endif
  !
  do id=1,ndims
    dims(id) = max(1,idim(id))
  enddo
  do id = ndims+1,tr_maxdims
    dims(id) = 1
  enddo
  !
  start = '1234567'
  goal  = start
  goal(1:len_trim(code)) = trim(code)
  if (start.eq.goal) then
    ! The subsequent optimizations will only perform a r4tor4
    call gmath_message(seve%w,rname,'No transposition here: '//code)
  endif
  !
  call transpose_repack(start,goal,repack)
  !
  if (start.ne.goal) then
    ! 'start' has been updated on return but does not yet match the goal
    ! Several permutations are not yet implemented
    call gmath_message(seve%e,rname,  &
      'Not implemented: more than 1 permutation needed for '//code)
    call transpose_guess(code)
    error = .true.
    return
  endif
  !
  nelems = 1
  fd = 1
  do id=fd,fd+repack(1)-1
    nelems = nelems*dims(id)
  enddo
  !
  nfirst = 1
  fd = fd+repack(1)
  do id=fd,fd+repack(2)-1
    nfirst = nfirst*dims(id)
  enddo
  !
  nmiddle = 1
  fd = fd+repack(2)
  do id=fd,fd+repack(3)-1
    nmiddle = nmiddle*dims(id)
  enddo
  !
  nsecon = 1
  fd = fd+repack(3)
  do id=fd,fd+repack(4)-1
    nsecon = nsecon*dims(id)
  enddo
  !
  nlast = 1
  fd = fd+repack(4)
  do id=fd,fd+repack(5)-1
    nlast = nlast*dims(id)
  enddo
  !
  block(1) = nelems
  block(2) = nfirst
  block(3) = nmiddle
  block(4) = nsecon
  block(5) = nlast
  !
end subroutine transpose_getblock
!
subroutine transpose_repack(start,goal,repack)
  use gbl_message
  use gmath_interfaces, except_this=>transpose_repack
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !   Compute the repack array for the 'goal' starting from 'start'
  !   Note that there is no assumption on the order of the start code
  ! (in particular you can not assume it is '1234567'). This is a
  ! desired feature to call consecutively this subroutine to achieve the
  ! goal in several steps.
  !   Note also that there no assumption on the characters it contains,
  ! e.g. if you plan to modify this code, think on what should be done
  ! if start='baefdcg' and goal='bedgafc'
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: start      ! Updated on return
  character(len=*), intent(in)    :: goal       !
  integer(kind=4),  intent(out)   :: repack(5)  ! How the dimensions should be packed
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  character(len=tr_maxdims) :: before,swap1,middle,swap2,after
  integer(kind=4) :: poss,posg,l1,l2
  character(len=message_length) :: mess
  !
  ! If no permutation, repack everything in the 1st (unchanged) group
  repack(:) = (/ tr_maxdims,0,0,0,0 /)
  !
  ! Find where the difference starts
  do posg=1,tr_maxdims
    if (goal(posg:posg).ne.start(posg:posg))  exit
  enddo
  if (posg.ge.tr_maxdims)  return  ! start == goal, nothing to do
  !
  ! Find the pattern to swap (swap2), its length, and its position in 'start'
  swap2 = goal(posg:)
  do
    l2 = len_trim(swap2)
    poss = index(start,swap2(1:l2))
    if (poss.ne.0)  exit
    swap2(l2:l2) = ' '
  enddo
  !
  ! Find swap1 and middle
  swap1  = start(posg:poss-1)  ! This is swap1+middle: we have to separate them cleverly...
  middle = ''
  do
    l1 = len_trim(swap1)
    if (index(goal(posg+l2:),swap1(1:l1)).ne.0)  exit
    middle = swap1(l1:l1)//middle
    swap1(l1:l1) = ' '
  enddo
  !
  ! And finally find the boundaries
  before = start(1:posg-1)
  after  = start(poss+l2:)
  !
  write(mess,100)  &
    trim(before),trim(swap1),trim(middle),trim(swap2),trim(after),  &
    ' -> ',                                                         &
    trim(before),trim(swap2),trim(middle),trim(swap1),trim(after)
  call gmath_message(seve%d,rname,mess)
  !
  start = trim(before)//trim(swap2)//trim(middle)//trim(swap1)//trim(after)
  !
  ! Set the repack array
  repack(1) = len_trim(before)
  repack(2) = len_trim(swap1)
  repack(3) = len_trim(middle)
  repack(4) = len_trim(swap2)
  repack(5) = len_trim(after)
  ! write(*,'(5(I2))')  repack(:)
  !
100 format( 2 ('(',A,')', '[',A,']', '(',A,')', '[',A,']', '(',A,')', A))
end subroutine transpose_repack
!
subroutine transpose_guess(code)
  use gbl_message
  use gmath_interfaces, except_this=>transpose_guess
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !  Give users the serie of permutations needed to achieve the goal.
  ! Note that each user permutation must be given from '1234567' to
  ! 'intermediate-goal', e.g. 2143 = 2134 + 1243
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: code
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  character(len=tr_maxdims) :: start,goal,interm
  integer(kind=4) :: nt,nd,repack(5)
  character(len=message_length) :: mess
  !
  nd = len_trim(code)
  start = '1234567'
  goal  = start
  goal(1:nd) = trim(code)
  nt = 0
  !
  call gmath_message(seve%i,rname,'Transpositions needed to achieve '//trim(code)//':')
  do while (start.ne.goal)
    nt = nt+1
    call transpose_repack(start,goal,repack)
    !
    call transposition_repack_to_code(repack,interm)
    write(mess,'(A,I0,A,A)')  '  #',nt,': ',interm(1:nd)
    call gmath_message(seve%r,rname,mess)
  enddo
  !
end subroutine transpose_guess
!
subroutine transposition_repack_to_code(repack,code)
  use gmath_interfaces, except_this=>transposition_repack_to_code
  use gmath_transpose
  !---------------------------------------------------------------------
  ! @ private
  !  Generate the transposition code from the repack array
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: repack(5)  !
  character(len=*), intent(out) :: code       !
  ! Local
  integer(kind=4) :: id,fd
  character(len=tr_maxdims) :: before,swap1,middle,swap2,after
  !
  before = ''
  fd = 1
  do id=fd,fd+repack(1)-1
    before = trim(before)//char(id+ichar('0'))
  enddo
  !
  swap1 = ''
  fd = fd+repack(1)
  do id=fd,fd+repack(2)-1
    swap1 = trim(swap1)//char(id+ichar('0'))
  enddo
  !
  middle = ''
  fd = fd+repack(2)
  do id=fd,fd+repack(3)-1
    middle = trim(middle)//char(id+ichar('0'))
  enddo
  !
  swap2 = ''
  fd = fd+repack(3)
  do id=fd,fd+repack(4)-1
    swap2 = trim(swap2)//char(id+ichar('0'))
  enddo
  !
  after = ''
  fd = fd+repack(4)
  do id=fd,fd+repack(5)-1
    after = trim(after)//char(id+ichar('0'))
  enddo
  !
  code = trim(before)//trim(swap2)//trim(middle)//trim(swap1)//trim(after)
  !
end subroutine transposition_repack_to_code
!
subroutine trans4all(x,y,nb,n1,nm,n2,nl)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Swap the 2nd and 4th dimension among the 5 ones.
  ! This version for 4-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nb                 !
  integer(kind=index_length), intent(in)  :: n1                 !
  integer(kind=index_length), intent(in)  :: nm                 !
  integer(kind=index_length), intent(in)  :: n2                 !
  integer(kind=index_length), intent(in)  :: nl                 !
  real(kind=4),               intent(out) :: x(nb,n2,nm,n1,nl)  !
  real(kind=4),               intent(in)  :: y(nb,n1,nm,n2,nl)  !
  ! Local
  integer(kind=index_length) :: i,j,k,l,m
  !
  do k=1,nl
    do j=1,n2
      do m=1,nm
        do i=1,n1
          do l=1,nb
            x(l,j,m,i,k) = y(l,i,m,j,k)
          enddo
        enddo
      enddo
    enddo
  enddo
end subroutine trans4all
!
subroutine trans4(in,ou,nelems,nx,nm,ny)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! Swap the 2nd and 4th dimension among the 4 ones.
  ! This version for 4-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nelems               !
  integer(kind=index_length), intent(in)  :: nx                   !
  integer(kind=index_length), intent(in)  :: nm                   !
  integer(kind=index_length), intent(in)  :: ny                   !
  real(kind=4),               intent(in)  :: in(nelems,nx,nm,ny)  !
  real(kind=4),               intent(out) :: ou(nelems,ny,nm,nx)  !
  ! Local
  integer(kind=index_length) :: i,j,l,m
  !
  do j=1,ny
    do m=1,nm
      do i=1,nx
        do l=1,nelems
          ou(l,j,m,i) = in(l,i,m,j)
        enddo
      enddo
    enddo
  enddo
end subroutine trans4
!
subroutine trans4slice(nelems,nfirst,nmiddl,nsecon,in,kin,lin,ou,kou,lou)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! Swap the 2nd and 4th dimension among the 4 ones, for the slices
  ! [kin:lin] in 'nsecon' and [kou:lou] in 'nfirst'.
  ! This version for 4-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nelems                      !
  integer(kind=index_length), intent(in)  :: nfirst                      !
  integer(kind=index_length), intent(in)  :: nmiddl                      !
  integer(kind=index_length), intent(in)  :: nsecon                      !
  integer(kind=index_length), intent(in)  :: kin,lin                     !
  integer(kind=index_length), intent(in)  :: kou,lou                     !
  real(kind=4),               intent(in)  :: in(nelems,nfirst,nmiddl,*)  !
  real(kind=4),               intent(out) :: ou(nelems,nsecon,nmiddl,*)  !
  ! Local
  integer(kind=index_length) :: ibig,jbig,iou,jin,l,m
  !
  do iou=1,lou-kou+1           ! Size of output array
    ibig = iou+kou-1
    do jin=1,lin-kin+1         ! Size of input array
      jbig = jin+kin-1
      do m=1,nmiddl
        do l=1,nelems
          ou(l,jbig,m,iou) = in(l,ibig,m,jin)
        enddo
      enddo
    enddo
  enddo
end subroutine trans4slice
!
subroutine trans8all(x,y,nb,n1,nm,n2,nl)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Swap the 2nd and 4th dimension among the 5 ones.
  ! This version for 8-bytes words.
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nb                 !
  integer(kind=index_length), intent(in)  :: n1                 !
  integer(kind=index_length), intent(in)  :: nm                 !
  integer(kind=index_length), intent(in)  :: n2                 !
  integer(kind=index_length), intent(in)  :: nl                 !
  real(kind=8),               intent(out) :: x(nb,n2,nm,n1,nl)  !
  real(kind=8),               intent(in)  :: y(nb,n1,nm,n2,nl)  !
  ! Local
  integer(kind=index_length) :: i,j,k,l,m
  !
  do k=1,nl
    do j=1,n2
      do m=1,nm
        do i=1,n1
          do l=1,nb
            x(l,j,m,i,k) = y(l,i,m,j,k)
          enddo
        enddo
      enddo
    enddo
  enddo
end subroutine trans8all

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
function eclass_inte_eq(a,b)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two integers
  !---------------------------------------------------------------------
  logical :: eclass_inte_eq
  integer(kind=4), intent(in) :: a
  integer(kind=4), intent(in) :: b
  !
  eclass_inte_eq = a.eq.b
  !
end function eclass_inte_eq
!
function eclass_2inte_eq(i1,i2,j1,j2)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two pairs of integers
  !---------------------------------------------------------------------
  logical :: eclass_2inte_eq
  integer(kind=4), intent(in) :: i1,i2
  integer(kind=4), intent(in) :: j1,j2
  !
  eclass_2inte_eq = i1.eq.i2 .and. j1.eq.j2
  !
end function eclass_2inte_eq
!
function eclass_2inte1char_eq(i1,i2,j1,j2,k1,k2)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two pairs of integers + 1 pair of chars
  !---------------------------------------------------------------------
  logical :: eclass_2inte1char_eq
  integer(kind=4),  intent(in) :: i1,i2
  integer(kind=4),  intent(in) :: j1,j2
  character(len=*), intent(in) :: k1,k2
  !
  eclass_2inte1char_eq = i1.eq.i2 .and. j1.eq.j2 .and. k1.eq.k2
  !
end function eclass_2inte1char_eq
!
function eclass_2inte2char_eq(i1,i2,j1,j2,k1,k2,l1,l2)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two pairs of integers + 2 pairs of chars
  !---------------------------------------------------------------------
  logical :: eclass_2inte2char_eq
  integer(kind=4),  intent(in) :: i1,i2
  integer(kind=4),  intent(in) :: j1,j2
  character(len=*), intent(in) :: k1,k2
  character(len=*), intent(in) :: l1,l2
  !
  eclass_2inte2char_eq = i1.eq.i2 .and. j1.eq.j2 .and.   &
                         k1.eq.k2 .and. l1.eq.l2
  !
end function eclass_2inte2char_eq
!
function eclass_dble_eq(a,b)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two real*8
  ! WARNING: there is no tolerance here, because we assume we compare
  ! values which we know must be equal
  !---------------------------------------------------------------------
  logical :: eclass_dble_eq
  real(kind=8), intent(in) :: a
  real(kind=8), intent(in) :: b
  !
  eclass_dble_eq = a.eq.b
  !
end function eclass_dble_eq
!
function eclass_2dble_eq(x1,x2,y1,y2)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two pairs of real*8 (e.g. coordinates)
  ! WARNING: there is no tolerance here, because we assume we compare
  ! values which we know must be equal
  !---------------------------------------------------------------------
  logical :: eclass_2dble_eq
  real(kind=8), intent(in) :: x1,x2
  real(kind=8), intent(in) :: y1,y2
  !
  eclass_2dble_eq = x1.eq.x2 .and. y1.eq.y2
  !
end function eclass_2dble_eq
!
function eclass_2dble3inte_eq(x1,x2,y1,y2,i1,i2,j1,j2,k1,k2)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two pairs of real*8 and two triplets of
  ! integer*4
  !---------------------------------------------------------------------
  logical :: eclass_2dble3inte_eq
  real(kind=8),    intent(in) :: x1,x2
  real(kind=8),    intent(in) :: y1,y2
  integer(kind=4), intent(in) :: i1,i2
  integer(kind=4), intent(in) :: j1,j2
  integer(kind=4), intent(in) :: k1,k2
  !
  eclass_2dble3inte_eq = x1.eq.x2 .and. y1.eq.y2 .and.  &
                         i1.eq.i2 .and. j1.eq.j2 .and. k1.eq.k2
  !
end function eclass_2dble3inte_eq
!
function eclass_char_eq(a,b)
  !---------------------------------------------------------------------
  ! @ public
  ! Equality routine between two characters
  !---------------------------------------------------------------------
  logical :: eclass_char_eq
  character(len=*), intent(in) :: a
  character(len=*), intent(in) :: b
  !
  eclass_char_eq = a.eq.b
  !
end function eclass_char_eq
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine eclass_inte(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,             external      :: equiv   ! l = equiv(i1,i2)
  type(eclass_inte_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val(eclass%nequ) = eclass%val(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val(ival),eclass%val(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val(eclass%nequ) = eclass%val(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_inte
!
subroutine eclass_2inte(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,              external      :: equiv   !
  type(eclass_2inte_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2inte
!
subroutine eclass_2inte1char(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2inte1char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,                   external      :: equiv   !
  type(eclass_2inte1char_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%val3(eclass%nequ) = eclass%val3(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ),  &
                eclass%val3(ival),eclass%val3(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%val3(eclass%nequ) = eclass%val3(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2inte1char
!
subroutine eclass_2inte2char(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2inte2char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,                   external      :: equiv   !
  type(eclass_2inte2char_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%val3(eclass%nequ) = eclass%val3(1)
  ! eclass%val4(eclass%nequ) = eclass%val4(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ),  &
                eclass%val3(ival),eclass%val3(iequ),  &
                eclass%val4(ival),eclass%val4(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%val3(eclass%nequ) = eclass%val3(ival)
      eclass%val4(eclass%nequ) = eclass%val4(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2inte2char
!
subroutine eclass_dble(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_dble
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,             external      :: equiv   !
  type(eclass_dble_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val(eclass%nequ) = eclass%val(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val(ival),eclass%val(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val(eclass%nequ) = eclass%val(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_dble
!
subroutine eclass_2dble(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2dble
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,              external      :: equiv   !
  type(eclass_2dble_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2dble
!
subroutine eclass_2dble1char(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2dble1char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,                   external      :: equiv   !
  type(eclass_2dble1char_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%val3(eclass%nequ) = eclass%val3(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ),  &
                eclass%val3(ival),eclass%val3(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%val3(eclass%nequ) = eclass%val3(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2dble1char
!
subroutine eclass_2dble3inte(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_2dble3inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,                   external      :: equiv   !
  type(eclass_2dble3inte_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val1(eclass%nequ) = eclass%val1(1)
  ! eclass%val2(eclass%nequ) = eclass%val2(1)
  ! eclass%val3(eclass%nequ) = eclass%val3(1)
  ! eclass%val4(eclass%nequ) = eclass%val4(1)
  ! eclass%val5(eclass%nequ) = eclass%val5(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val1(ival),eclass%val1(iequ),  &
                eclass%val2(ival),eclass%val2(iequ),  &
                eclass%val3(ival),eclass%val3(iequ),  &
                eclass%val4(ival),eclass%val4(iequ),  &
                eclass%val5(ival),eclass%val5(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val1(eclass%nequ) = eclass%val1(ival)
      eclass%val2(eclass%nequ) = eclass%val2(ival)
      eclass%val3(eclass%nequ) = eclass%val3(ival)
      eclass%val4(eclass%nequ) = eclass%val4(ival)
      eclass%val5(eclass%nequ) = eclass%val5(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_2dble3inte
!
subroutine eclass_char(equiv,eclass)
  use gmath_interfaces, except_this=>eclass_char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  logical,             external      :: equiv   ! l = equiv(c1,c2)
  type(eclass_char_t), intent(inout) :: eclass  !
  ! Local
  integer(kind=4) :: ival,iequ
  logical :: listed
  !
  if (eclass%nval.le.0) then
    eclass%nequ = 0
    return
  endif
  !
  ! First element is also the first equivalence class
  eclass%nequ = 1
  ! eclass%val(eclass%nequ) = eclass%val(1)
  ! eclass%cnt(eclass%nequ) = eclass%cnt(1)
  eclass%bak(1) = eclass%nequ
  !
  ! Loop over first element of all pairs
  do ival=2,eclass%nval
    listed = .false.
    do iequ=1,eclass%nequ
      if (equiv(eclass%val(ival),eclass%val(iequ))) then
        listed = .true.
        eclass%cnt(iequ) = eclass%cnt(iequ)+eclass%cnt(ival)
        eclass%bak(ival) = iequ
        exit
      endif
    enddo
    if (.not.listed) then
      eclass%nequ = eclass%nequ+1
      eclass%val(eclass%nequ) = eclass%val(ival)
      eclass%cnt(eclass%nequ) = eclass%cnt(ival)
      eclass%bak(ival) = eclass%nequ
    endif
  enddo
  !
end subroutine eclass_char
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine reallocate_eclass_inte(eclass,nval,error)
  use gbl_message
  use gmath_interfaces, except_this=>reallocate_eclass_inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_inte_t), intent(inout) :: eclass
  integer(kind=4),     intent(in)    :: nval
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>INTE'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_inte(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val(nval),eclass%cnt(nval),eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_inte(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_inte
!
subroutine reallocate_eclass_2inte(eclass,nval,error)
  use gbl_message
  use gmath_interfaces, except_this=>reallocate_eclass_2inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte_t), intent(inout) :: eclass
  integer(kind=4),      intent(in)    :: nval
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2INTE'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2inte(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),eclass%cnt(nval),eclass%bak(nval),  &
       stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2inte(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2inte
!
subroutine reallocate_eclass_2inte1char(eclass,nval,error)
  use gbl_message
  use gmath_interfaces, except_this=>reallocate_eclass_2inte1char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte1char_t), intent(inout) :: eclass
  integer(kind=4),           intent(in)    :: nval
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2INTE1CHAR'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2inte1char(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),eclass%val3(nval),  &
              eclass%cnt(nval),eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2inte1char(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2inte1char
!
subroutine reallocate_eclass_2inte2char(eclass,nval,error)
  use gbl_message
  use gmath_interfaces, except_this=>reallocate_eclass_2inte2char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte2char_t), intent(inout) :: eclass
  integer(kind=4),           intent(in)    :: nval
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2INTE2CHAR'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2inte2char(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),  &
              eclass%val3(nval),eclass%val4(nval),  &
              eclass%cnt(nval),eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2inte2char(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2inte2char
!
subroutine reallocate_eclass_dble(eclass,nval,error)
  use gbl_message
  use gmath_interfaces, except_this=>reallocate_eclass_dble
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_dble_t), intent(inout) :: eclass
  integer(kind=4),     intent(in)    :: nval
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>DBLE'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_dble(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val(nval),eclass%cnt(nval),eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_dble(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_dble
!
subroutine reallocate_eclass_2dble(eclass,nval,error)
  use gbl_message
  use gmath_interfaces, except_this=>reallocate_eclass_2dble
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble_t), intent(inout) :: eclass
  integer(kind=4),      intent(in)    :: nval
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2DBLE'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2dble(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),eclass%cnt(nval),eclass%bak(nval),  &
       stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2dble(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2dble
!
subroutine reallocate_eclass_2dble1char(eclass,nval,error)
  use gbl_message
  use gmath_interfaces, except_this=>reallocate_eclass_2dble1char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble1char_t), intent(inout) :: eclass
  integer(kind=4),           intent(in)    :: nval
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2DBLE1CHAR'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2dble1char(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),eclass%val3(nval),  &
              eclass%cnt(nval),eclass%bak(nval),  &
              stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2dble1char(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2dble1char
!
subroutine reallocate_eclass_2dble3inte(eclass,nval,error)
  use gbl_message
  use gmath_interfaces, except_this=>reallocate_eclass_2dble3inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble3inte_t), intent(inout) :: eclass
  integer(kind=4),           intent(in)    :: nval
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>2DBLE3INTE'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val1)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_2dble3inte(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val1(nval),eclass%val2(nval),eclass%val3(nval),  &
              eclass%val4(nval),eclass%val5(nval),eclass%cnt(nval),   &
              eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_2dble3inte(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_2dble3inte
!
subroutine reallocate_eclass_char(eclass,nval,error)
  use gbl_message
  use gmath_interfaces, except_this=>reallocate_eclass_char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_char_t), intent(inout) :: eclass
  integer(kind=4),     intent(in)    :: nval
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>ECLASS>CHAR'
  logical :: alloc
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  alloc = .true.
  if (associated(eclass%val)) then
     if (eclass%nval.eq.nval) then
        write(mess,'(a,i0)')  &
          'Eclass already associated at the right size: ',nval
        call gmath_message(seve%d,rname,mess)
        alloc = .false.
     else
        write(mess,'(a)') 'Pointer eclass already associated but with a different size => Freeing it first'
        call gmath_message(seve%d,rname,mess)
        call free_eclass_char(eclass,error)
        if (error)  return
     endif
  endif
  !
  if (alloc) then
     allocate(eclass%val(nval),eclass%cnt(nval),eclass%bak(nval),stat=ier)
     if (ier.ne.0) then
        call gmath_message(seve%e,rname,'Could not allocate memory for eclass')
        call free_eclass_char(eclass,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated ECLASS of size: ',nval
     call gmath_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  eclass%nval = nval
  !
end subroutine reallocate_eclass_char
!
subroutine free_eclass_inte(eclass,error)
  use gbl_message
  use gmath_interfaces, except_this=>free_eclass_inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_inte_t), intent(inout) :: eclass
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>INTE'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val))  return
  !
  eclass%nval = 0
  if (associated(eclass%val))  deallocate(eclass%val)
  if (associated(eclass%cnt))  deallocate(eclass%cnt)
  if (associated(eclass%bak))  deallocate(eclass%bak)
  !
end subroutine free_eclass_inte
!
subroutine free_eclass_2inte(eclass,error)
  use gbl_message
  use gmath_interfaces, except_this=>free_eclass_2inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte_t), intent(inout) :: eclass
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2INTE'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2inte
!
subroutine free_eclass_2inte1char(eclass,error)
  use gbl_message
  use gmath_interfaces, except_this=>free_eclass_2inte1char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte1char_t), intent(inout) :: eclass
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2INTE1CHAR'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%val3))  deallocate(eclass%val3)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2inte1char
!
subroutine free_eclass_2inte2char(eclass,error)
  use gbl_message
  use gmath_interfaces, except_this=>free_eclass_2inte2char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2inte2char_t), intent(inout) :: eclass
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2INTE2CHAR'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%val3))  deallocate(eclass%val3)
  if (associated(eclass%val4))  deallocate(eclass%val4)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2inte2char
!
subroutine free_eclass_dble(eclass,error)
  use gbl_message
  use gmath_interfaces, except_this=>free_eclass_dble
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_dble_t), intent(inout) :: eclass
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>DBLE'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val))  return
  !
  eclass%nval = 0
  if (associated(eclass%val))  deallocate(eclass%val)
  if (associated(eclass%cnt))  deallocate(eclass%cnt)
  if (associated(eclass%bak))  deallocate(eclass%bak)
  !
end subroutine free_eclass_dble
!
subroutine free_eclass_2dble(eclass,error)
  use gbl_message
  use gmath_interfaces, except_this=>free_eclass_2dble
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble_t), intent(inout) :: eclass
  logical,              intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2DBLE'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2dble
!
subroutine free_eclass_2dble1char(eclass,error)
  use gbl_message
  use gmath_interfaces, except_this=>free_eclass_2dble1char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble1char_t), intent(inout) :: eclass
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2DBLE1CHAR'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%val3))  deallocate(eclass%val3)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2dble1char
!
subroutine free_eclass_2dble3inte(eclass,error)
  use gbl_message
  use gmath_interfaces, except_this=>free_eclass_2dble3inte
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_2dble3inte_t), intent(inout) :: eclass
  logical,                   intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>2DBLE3INTE'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val1))  return
  !
  eclass%nval = 0
  if (associated(eclass%val1))  deallocate(eclass%val1)
  if (associated(eclass%val2))  deallocate(eclass%val2)
  if (associated(eclass%val3))  deallocate(eclass%val3)
  if (associated(eclass%val4))  deallocate(eclass%val4)
  if (associated(eclass%val5))  deallocate(eclass%val5)
  if (associated(eclass%cnt))   deallocate(eclass%cnt)
  if (associated(eclass%bak))   deallocate(eclass%bak)
  !
end subroutine free_eclass_2dble3inte
!
subroutine free_eclass_char(eclass,error)
  use gbl_message
  use gmath_interfaces, except_this=>free_eclass_char
  use eclass_types
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(eclass_char_t), intent(inout) :: eclass
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='FREE>ECLASS>CHAR'
  !
  call gmath_message(seve%t,rname,'Welcome')
  !
  if (.not.associated(eclass%val))  return
  !
  eclass%nval = 0
  if (associated(eclass%val))  deallocate(eclass%val)
  if (associated(eclass%cnt))  deallocate(eclass%cnt)
  if (associated(eclass%bak))  deallocate(eclass%bak)
  !
end subroutine free_eclass_char
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine eclass_getnext(eclass,iclass,ielem,found,error)
  use gbl_message
  use eclass_types
  use gmath_interfaces, except_this=>eclass_getnext
  !---------------------------------------------------------------------
  ! @ public
  !  Utility routine: get the index of the next element which is in the
  ! iclass-th class.
  !---------------------------------------------------------------------
  class(eclass_common_t), intent(in)    :: eclass  ! The equivalence classes
  integer(kind=4),        intent(in)    :: iclass  ! The ith equivalence class we search into
  integer(kind=4),        intent(inout) :: ielem   ! Starting point (can be 0) and next (output) value found
  logical,                intent(out)   :: found   ! Found a new element?
  logical,                intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ECLASS>GET>NEXT'
  integer(kind=4) :: ival
  !
  if (iclass.le.0 .or. iclass.gt.eclass%nequ) then
    call gmath_message(seve%e,rname,'Invalid class number')
    error = .true.
    return
  endif
  !
  found = .false.
  do ival=ielem+1,eclass%nval
    if (eclass%bak(ival).eq.iclass) then
      ielem = ival
      found = .true.
      return
    endif
  enddo
  !
end subroutine eclass_getnext
!
subroutine eclass_getprev(eclass,iclass,ielem,found,error)
  use gbl_message
  use eclass_types
  use gmath_interfaces, except_this=>eclass_getprev
  !---------------------------------------------------------------------
  ! @ public
  !  Utility routine: get the index of the previous element which is in
  ! the iclass-th class.
  !---------------------------------------------------------------------
  class(eclass_common_t), intent(in)    :: eclass  ! The equivalence classes
  integer(kind=4),        intent(in)    :: iclass  ! The ith equivalence class we search into
  integer(kind=4),        intent(inout) :: ielem   ! Starting point (can be N+1) and previous (output) value found
  logical,                intent(out)   :: found   ! Found a new element?
  logical,                intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ECLASS>GET>PREV'
  integer(kind=4) :: ival
  !
  if (iclass.le.0 .or. iclass.gt.eclass%nequ) then
    call gmath_message(seve%e,rname,'Invalid class number')
    error = .true.
    return
  endif
  !
  found = .false.
  do ival=ielem-1,1,-1
    if (eclass%bak(ival).eq.iclass) then
      ielem = ival
      found = .true.
      return
    endif
  enddo
  !
end subroutine eclass_getprev

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_sort_codes
  integer(kind=4), parameter :: code_sort_bt=1     ! BASE then TIME
  integer(kind=4), parameter :: code_sort_tb=2     ! TIME then BASE
  integer(kind=4), parameter :: code_sort_ubtf=3   ! UNIQUE-BASE then TIME then FREQ
  integer(kind=4), parameter :: code_sort_ft=4     ! FREQ then TIME
  integer(kind=4), parameter :: code_sort_field=5  ! FIELD
  !
  integer(kind=4), parameter :: ncode_sort=5
  character(len=8), parameter :: sort_names(ncode_sort) = &
    (/ 'BASE    ','TIME    ','UNIQUE  ','FREQTIME','FIELD   ' /)
end module uv_sort_codes
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module uv_sort
  use gbl_message
  !
  public :: uv_sort_comm
  public :: uv_tri,uv_findtb
  private
  !
contains
  !
  subroutine uv_sort_comm(line,error)
    use gkernel_interfaces
    use uv_sort_codes
    !----------------------------------------------------------------------
    ! UVSORT [TIME|BASE|FIELD]
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer(kind=4) :: code,na
    character(len=6) :: argu,vvoc
    !
    ! Parse input line. Default argument is TIME
    argu = 'TIME'
    call sic_ke(line,0,1,argu,na,.false.,error)
    if (error) return
    call sic_ambigs('UV_SORT',argu,vvoc,code,sort_names,ncode_sort,error)
    if (error) return
    !
    ! Sort uv buffer
    if (code.eq.code_sort_field) then
       call uv_fsort(error)
    else
       call uv_tri(code,error)
    endif
    if (error) return
  end subroutine uv_sort_comm
  !
  subroutine uv_fsort(error)
    use image_def
    use gkernel_interfaces
    use uvmosaic_tool, only: loadfiuv
    use uv_rotate_shift_and_sort_tool, only: sortuv,loaduv
    use uv_buffers
    use uvmap_buffers, only: uvmap_prog
    !-----------------------------------------------------------------
    ! Allows for sorting for fields using mosaic uv sorting routines
    !-----------------------------------------------------------------
    logical, intent(inout) :: error
    !
    logical :: warning,sorted
    logical, allocatable :: signv(:)
    integer(kind=4) :: ier,ncol,nv,nf,xoff,yoff,loff,moff,ixcol,iycol
    integer(kind=index_length) :: iv,ifi,fsize(1)
    integer(kind=4), allocatable :: it(:)
    real(kind=4) :: cs(2),uvmax,uvmin,xy(2)
    real(kind=4), allocatable :: uarr(:),varr(:),foff(:,:),newv(:)
    real(kind=8), allocatable :: farr(:)
    character(len=*), parameter :: rname='UV_SORT'
    !
    if (.not.associated(duv)) then
       call map_message(seve%e,rname,'No UV data')
       error = .true.
       return
    endif
    ! Do we find pointing offsets?
    xoff = huv%gil%column_pointer(code_uvt_xoff)
    yoff = huv%gil%column_pointer(code_uvt_yoff)
    if ((xoff.ne.0).or.(yoff.ne.0)) then
       ! Yes => This is a mosaic
       if (yoff.ne.xoff+1) then
          ! Ill-defined mosaic
          call map_message(seve%e,rname,'Mosaic Y column does not follow the X column')
          error = .true.
          return
       endif
       ixcol = xoff
       iycol = yoff
    else
       ! No => Do we find phase offsets?
       loff = huv%gil%column_pointer(code_uvt_loff)
       moff = huv%gil%column_pointer(code_uvt_moff)
       if ((loff.ne.0).or.(moff.ne.0)) then
          ! Yes => This is a mosaic
          if (moff.ne.loff+1) then
             ! Ill-defined mosaic
             call map_message(seve%e,rname,'Mosaic M column does not follow the L column')
             error = .true.
             return
          endif
          ixcol = loff
          iycol = moff
       else
          ! No => This is a single-field
          error = .true.
          call map_message(seve%e,rname,'UV table contains a single field, cannot sort it by field')
          return
       endif
    endif
    !
    ! Create Sorted UV data
    call sic_delvariable('UVS',.false.,warning)
    !
    ! Check if new UV Table (uvtb%data) is already allocated
    if (allocated(uvtb%data))  deallocate (uvtb%data)
    !
    ! Copy header information
    call gildas_null(uvtb%head)
    call gdf_copy_header(huv,uvtb%head,error)
    if (error) return
    !
    ! Allocate duvt
    allocate(uvtb%data(uvtb%head%gil%dim(1),uvtb%head%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Error allocating secondary UV buffer')
       error = .true.
       return
    endif
    call sic_def_real('UVS',uvtb%data,uvtb%head%gil%ndim,uvtb%head%gil%dim,.false.,error)
    if (error) return
    !
    ! Start sorting using routines from Mosaic mode
    !
    nv = huv%gil%dim(2)
    ncol = huv%gil%dim(1)
    cs(1) = 1.0 ! no UV shift
    cs(2) = 0.0 ! no UV shift
    xy(1) = 0.0 ! no UV shift
    xy(2) = 0.0 ! no UV shift
    !
    allocate(uarr(nv), varr(nv), signv(nv), farr(nv), it(nv), stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Error allocating work arrays')
       error = .true.
       return
    endif
    call loaduv(duv, ncol, nv, cs, uarr, varr, signv, uvmax, uvmin)
    ! Loading field numbers
    call loadfiuv(duv, ncol, nv, farr, it, sorted, ixcol, iycol, varr, nf, foff)
    !
    ! Proceed to sorting
    if (.not.sorted) then
       call gr8_trie (farr,it,nv,error) ! Actual sorting using quicksort
       deallocate (farr, stat=ier) ! Deallocate farr to save some memory
       allocate (newv(nv), stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Error allocating work arrays')
          error = .true.
          return
       endif
       !
       ! v is sorted here so sortuv can be used later
       do iv=1,nv
          newv(iv) = varr(it(iv))
       enddo
       varr(:) = newv(:)
       deallocate (newv,stat=ier) ! Deallocate newv to save some memory
    else
       deallocate (farr,stat=ier) ! if data is already sorted dealocate farr since it will not be used
    endif
    ! Apply sorting to output visibilities
    call sortuv (duv, uvtb%data, ncol, nv, huv%gil%ntrail, xy, uarr, varr, signv, it)
    !
    ! Deallocate reamining arrays to avoid leaks
    deallocate(uarr, varr, signv, it)
    !
    ! Adding field start and end info to Fields variable
    if (allocated(uvmap_prog%ifields)) deallocate(uvmap_prog%ifields)
    allocate(uvmap_prog%ifields(nf+1))
    ifi = 1
    uvmap_prog%ifields(ifi) = 1
    do iv=1,nv
       if ( (foff(1,ifi).ne.uvtb%data(ixcol,iv)) .or. &
            &  (foff(2,ifi).ne.uvtb%data(iycol,iv)) ) then
          ifi = ifi+1
          uvmap_prog%ifields(ifi) = iv
       endif
    enddo
    uvmap_prog%ifields(nf+1) = nv+1
    fsize(1) = nf+1  
    call sic_def_inte("FIELDS%ifields",uvmap_prog%ifields,1,fsize,.true.,error)
    deallocate(foff)
    !
    error = .false.
  end subroutine uv_fsort
  !
  subroutine uv_tri(code,error)
    use gkernel_interfaces
    use uv_buffers
    !----------------------------------------------------------------------
    ! UVSORT [TIME|BASE|UNIQUE]
    !----------------------------------------------------------------------
    integer(kind=4), intent(in)    :: code  ! Sorting code
    logical,         intent(inout) :: error
    !
    integer(kind=4) :: ier,nd,nv,id,iv
    integer(kind=4), allocatable :: it(:),ot(:)
    real(kind=8), allocatable :: order(:)
    logical :: sorted, warning, alloc
    character(len=*), parameter :: rname='UV_SORT'
    !
    if (.not.associated(duv)) then
       call map_message(seve%e,rname,'No UV data')
       error = .true.
       return
    endif
    !
    ! Create Sorted UV data
    call sic_delvariable('UVS',.false.,warning)
    !
    ! Check first if UVT is already matching UV
    alloc = .false.
    if (allocated(uvtb%data)) then
       if ( (huv%gil%dim(2).ne.uvtb%head%gil%dim(1)) .or. &
            & (huv%gil%dim(1)+3.ne.uvtb%head%gil%dim(2)) ) then
          deallocate (uvtb%data)
       else
          alloc = .true.
       endif
    endif
    !
    call gildas_null (uvtb%head, type = 'TUV')
    call gdf_transpose_header(huv,uvtb%head,'21  ',error)
    if (error)  return
    nd = uvtb%head%gil%dim(2)
    nv = uvtb%head%gil%dim(1)
    uvtb%head%gil%dim(2) = nd+3
    !
    if (.not.alloc) then
       allocate(uvtb%data(uvtb%head%gil%dim(1),uvtb%head%gil%dim(2)),stat=ier)
       if (ier.ne.0) then
          call map_message(seve%e,rname,'Error getting UV memory ')
          error = .true.
          return
       endif
    endif
    call sic_def_real('UVS',uvtb%data,uvtb%head%gil%ndim,uvtb%head%gil%dim,.false.,error)
    if (error) return
    !
    allocate(order(nv),it(nv),ot(nv),stat=ier)
    if (ier.ne.0) then
       call map_message(seve%e,rname,'Error getting memory ')
       error = .true.
       return
    endif
    !
    call uv_findtb(code,duv,nv,nd,order,it,ot,sorted,error)
    if (error)  return
    if (sorted) then
       print *,'****  SHOW UV -- already sorted for code ',code
       do id=1,nd
          do iv=1,nv
             uvtb%data(iv,id) = duv(id,iv)
          enddo
       enddo
    else
       do id=1,nd
          do iv=1,nv
             uvtb%data(iv,id) = duv(id,it(iv))
          enddo
       enddo
    endif
    do iv=1,nv
       uvtb%data(iv,nd+1) = 1.0
    enddo
    deallocate(order,it,ot)
  end subroutine uv_tri
  !
  subroutine uv_findtb(code,uv,nv,nd,order,it,ot,sorted,error,freq)
    use gkernel_interfaces
    use uv_sort_codes
    !---------------------------------------------------------------
    ! Support for SHOW UV
    !---------------------------------------------------------------
    integer(kind=4),        intent(in)    :: code       ! Code for sort operation
    integer(kind=4),        intent(in)    :: nd,nv      ! Size of visibility table
    real(kind=4),           intent(in)    :: uv(nd,nv)  ! Input UV data
    real(kind=8),           intent(out)   :: order(nv)  ! Sorting array buffer (do not use)
    integer(kind=4),        intent(out)   :: it(nv)     ! Sort index
    integer(kind=4),        intent(out)   :: ot(nv)     ! Reverse order
    logical,                intent(out)   :: sorted     ! Is already sorted
    logical,                intent(inout) :: error      ! Logical error flag
    real(kind=8), optional, intent(in)    :: freq(nv)   ! [MHz] Freq. at visibility center
    !
    integer(kind=4), parameter :: datecol=4
    integer(kind=4), parameter :: timecol=5
    integer(kind=4), parameter :: anticol=6
    integer(kind=4), parameter :: antjcol=7
    real(kind=4) :: rdate
    real(kind=8) :: olast
    integer(kind=4) :: iv
    character(len=*), parameter :: rname='UV_SORT'
    !
    select case (code)
    case (code_sort_bt)
       ! Order BASE(primary) then TIME(secondary). Build float list as:
       !   Antenna I   x  100*10000*86400 [pseudo-sec]
       ! + Antenna J   x      10000*86400 [pseudo-sec]
       ! + OffsetDate  x            86400 [sec]
       ! + Time                           [sec]
       ! This assumes 'OffsetDate' is less then 10000, and 'Antenna J' is less
       ! than 100.
       rdate = uv(datecol,1)
       do iv=1,nv
          order(iv) = 10000.d0*86400.0d0*(100.d0*uv(anticol,iv)+uv(antjcol,iv)) +  &
               (uv(datecol,iv)-rdate)*86400.d0 + uv(timecol,iv)
       enddo
       !
    case (code_sort_ubtf)
      ! Order by UNIQUE-BASE then TIME then FREQ
      if (.not.present(freq)) then
        call map_message(seve%e,rname,'Internal error: frequency array missing')
        error = .true.
        return
      endif
      call uv_findtb_ubtf(uv,nv,nd,freq,it,ot,sorted,error)
      return  ! Always, subsequent code not needed.
      !
    case (code_sort_ft)
      ! Order by FREQ then TIME
      if (.not.present(freq)) then
        call map_message(seve%e,rname,'Internal error: frequency array missing')
        error = .true.
        return
      endif
      call uv_findtb_ft(uv,nv,nd,freq,it,ot,sorted,error)
      return  ! Always, subsequent code not needed.
      !
    case (code_sort_tb)
       ! Order TIME(primary) then BASE(secondary). Build float list as:
       !   OffsetDate  x  86400  [sec]
       ! + Time                  [sec]
       ! + Antenna I   x  0.01   [pseudo-sec]
       ! + Antenna J   x  0.0001 [pseudo-sec]
       ! This assumes 'Antenna I' and 'Antenna J' are less than 100.
       rdate = uv(datecol,1)
       do iv=1,nv
          order(iv) = (uv(datecol,iv)-rdate)*86400.d0 + uv(timecol,iv) +   &
               (100.0d0*uv(anticol,iv)+uv(antjcol,iv))*1.0d-4
       enddo
       !
    case default
       call map_message(seve%e,rname,'Code is not implemented')
       error = .true.
       return
    end select
    !
    ! Check order... This is for dummy UV Tables produced by e.g. UV_CIRCLE
    ! which have no unique ordering...
    olast = order(1)
    sorted = .true.
    do iv=1,nv
       if (order(iv).lt.olast) then
          sorted = .false.
          exit
       endif
       olast = order(iv)
    enddo
    if (sorted) then
       do iv=1,nv
          it(iv) = iv
          ot(iv) = iv
       enddo
    else
       call gr8_trie(order,it,nv,error)
       if (error) return
       do iv=1,nv
          ot(it(iv)) = iv
       enddo
    endif
  end subroutine uv_findtb
  !
  subroutine uv_findtb_ubtf(uv,nv,nd,freq,it,ot,sorted,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Sort by:
    !  min-antenna, then
    !  max-antenna, then
    !  date, then
    !  time, then
    !  frequency
    !---------------------------------------------------------------------
    integer(kind=4), intent(in)    :: nd,nv      ! Size of visibility table
    real(kind=4),    intent(in)    :: uv(nd,nv)  ! Input UV data
    real(kind=8),    intent(in)    :: freq(nv)   ! [MHz] Freq. at visibility center
    integer(kind=4), intent(out)   :: it(nv)     ! Sort index
    integer(kind=4), intent(out)   :: ot(nv)     ! Reverse order
    logical,         intent(out)   :: sorted     ! Is already sorted?
    logical,         intent(inout) :: error      ! Logical error flag
    ! Local
    integer(kind=4), parameter :: datecol=4
    integer(kind=4), parameter :: timecol=5
    integer(kind=4), parameter :: anticol=6
    integer(kind=4), parameter :: antjcol=7
    integer(kind=4) :: iv,vlast
    !
    do iv=1,nv
      it(iv) = iv
    enddo
    !
    call gi4_quicksort_index_with_user_gtge(it,nv,  &
      ubtf_gt,ubtf_ge,error)
    if (error)  return
    !
    ! Set the already 'sorted' flag
    vlast = it(1)
    sorted = .true.
    do iv=1,nv
      if (it(iv).lt.vlast) then
        sorted = .false.
        exit
      endif
      vlast = it(iv)
    enddo
    !
    ! Set the reverse sorting array
    do iv=1,nv
      ot(it(iv)) = iv
    enddo
    !
  contains
    !
    ! Sorting functions
    function ubtf_gt(m,l)
      logical :: ubtf_gt
      integer(kind=4), intent(in) :: m,l
      ! Local
      integer(kind=4) :: antmi,antmj,antli,antlj,antmmin,antmmax,antlmin,antlmax
      antmi = nint(uv(anticol,m))
      antmj = nint(uv(antjcol,m))
      antli = nint(uv(anticol,l))
      antlj = nint(uv(antjcol,l))
      if (antmi.lt.antmj) then
        antmmin = antmi
        antmmax = antmj
      else
        antmmin = antmj
        antmmax = antmi
      endif
      if (antli.lt.antlj) then
        antlmin = antli
        antlmax = antlj
      else
        antlmin = antlj
        antlmax = antli
      endif
      if (antmmin.ne.antlmin) then
        ubtf_gt = antmmin.gt.antlmin
        return
      endif
      if (antmmax.ne.antlmax) then
        ubtf_gt = antmmax.gt.antlmax
        return
      endif
      if (uv(datecol,m).ne.uv(datecol,l)) then
        ubtf_gt = uv(datecol,m).gt.uv(datecol,l)
        return
      endif
      if (uv(timecol,m).ne.uv(timecol,l)) then
        ubtf_gt = uv(timecol,m).gt.uv(timecol,l)
        return
      endif
      ubtf_gt = freq(m).gt.freq(l)
    end function ubtf_gt
    !
    function ubtf_ge(m,l)
      logical :: ubtf_ge
      integer(kind=4), intent(in) :: m,l
      ! Local
      integer(kind=4) :: antmi,antmj,antli,antlj,antmmin,antmmax,antlmin,antlmax
      antmi = nint(uv(anticol,m))
      antmj = nint(uv(antjcol,m))
      antli = nint(uv(anticol,l))
      antlj = nint(uv(antjcol,l))
      if (antmi.lt.antmj) then
        antmmin = antmi
        antmmax = antmj
      else
        antmmin = antmj
        antmmax = antmi
      endif
      if (antli.lt.antlj) then
        antlmin = antli
        antlmax = antlj
      else
        antlmin = antlj
        antlmax = antli
      endif
      if (antmmin.ne.antlmin) then
        ubtf_ge = antmmin.ge.antlmin
        return
      endif
      if (antmmax.ne.antlmax) then
        ubtf_ge = antmmax.ge.antlmax
        return
      endif
      if (uv(datecol,m).ne.uv(datecol,l)) then
        ubtf_ge = uv(datecol,m).ge.uv(datecol,l)
        return
      endif
      if (uv(timecol,m).ne.uv(timecol,l)) then
        ubtf_ge = uv(timecol,m).ge.uv(timecol,l)
        return
      endif
      ubtf_ge = freq(m).ge.freq(l)
    end function ubtf_ge
  end subroutine uv_findtb_ubtf
  !
  subroutine uv_findtb_ft(uv,nv,nd,freq,it,ot,sorted,error)
    use gkernel_interfaces
    !---------------------------------------------------------------------
    ! Sort by:
    !  frequency, then
    !  date, then
    !  time
    !---------------------------------------------------------------------
    integer(kind=4), intent(in)    :: nd,nv      ! Size of visibility table
    real(kind=4),    intent(in)    :: uv(nd,nv)  ! Input UV data
    real(kind=8),    intent(in)    :: freq(nv)   ! [MHz] Freq. at visibility center
    integer(kind=4), intent(out)   :: it(nv)     ! Sort index
    integer(kind=4), intent(out)   :: ot(nv)     ! Reverse order
    logical,         intent(out)   :: sorted     ! Is already sorted?
    logical,         intent(inout) :: error      ! Logical error flag
    ! Local
    integer(kind=4), parameter :: datecol=4
    integer(kind=4), parameter :: timecol=5
    integer(kind=4) :: iv,vlast
    !
    do iv=1,nv
      it(iv) = iv
    enddo
    !
    call gi4_quicksort_index_with_user_gtge(it,nv,ft_gt,ft_ge,error)
    if (error)  return
    !
    ! Set the already 'sorted' flag
    vlast = it(1)
    sorted = .true.
    do iv=1,nv
      if (it(iv).lt.vlast) then
        sorted = .false.
        exit
      endif
      vlast = it(iv)
    enddo
    !
    ! Set the reverse sorting array
    do iv=1,nv
      ot(it(iv)) = iv
    enddo
    !
  contains
    !
    ! Sorting functions
    function ft_gt(m,l)
      logical :: ft_gt
      integer(kind=4), intent(in) :: m,l
      if (freq(m).ne.freq(l)) then
        ft_gt = freq(m).gt.freq(l)
        return
      endif
      if (uv(datecol,m).ne.uv(datecol,l)) then
        ft_gt = uv(datecol,m).gt.uv(datecol,l)
        return
      endif
      ft_gt = uv(timecol,m).gt.uv(timecol,l)
    end function ft_gt
    !
    function ft_ge(m,l)
      logical :: ft_ge
      integer(kind=4), intent(in) :: m,l
      if (freq(m).ne.freq(l)) then
        ft_ge = freq(m).ge.freq(l)
        return
      endif
      if (uv(datecol,m).ne.uv(datecol,l)) then
        ft_ge = uv(datecol,m).ge.uv(datecol,l)
        return
      endif
      ft_ge = uv(timecol,m).ge.uv(timecol,l)
    end function ft_ge
  end subroutine uv_findtb_ft
  !
end module uv_sort
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtindex_code2sic(error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_parameters
  use mrtindex_interfaces, except_this=>mrtindex_code2sic
  !---------------------------------------------------------------------
  ! @ public
  ! Create the MRT% Sic structure mapping the index codes.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='INDEX>CODE2SIC'
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  ! Create structure if needed
  if (.not.sic_varexist('mrt')) then
     call sic_defstructure('mrt%',.true.,error)
     if (error) return
  endif
  !
  ! *** JP why UNKNOWN is not a kind of obstypes as any other? This calls for troubles...
  call sic_def_charn('mrt%backend',   backends_mrtcal,   1,nbackends_mrtcal+1,.false.,error)
  call sic_def_charn('mrt%obstype',   obstypes_mrtcal,   1,nobstypes_mrtcal+1,.false.,error)
  call sic_def_charn('mrt%switchmode',switchmodes_mrtcal,1,nswitchmodes+1,    .false.,error)
  call sic_def_charn('mrt%filstatus', completenesses,    1,ncompleteness,     .false.,error)
  call sic_def_charn('mrt%calstatus', calstatus,         1,ncalstatus,        .false.,error)
  call sic_def_charn('mrt%solstatus', solstatus,         1,nsolstatus,        .false.,error)
  ! If there is an error, the user/developer wants to know... => no resetting
  !
end subroutine mrtindex_code2sic
!
subroutine mrtindex_cx2sic(cx,error)
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_cx2sic
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  ! Create the MDX% Sic structure mapping the CX arrays (always available)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: cx
  logical,                   intent(inout) :: error
  ! Local
  integer(kind=index_length) :: dim(4)
  character(len=*), parameter :: rname='INDEX>CX2SIC'
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  ! Create structure if needed
  if (.not.sic_varexist('mdx')) then
     call sic_defstructure('mdx%',.true.,error)
     if (error) return
  endif
  !
  ! Removed previously defined structure variable
  call sic_delvariable('mdx%curr',        .false.,error)
  call sic_delvariable('mdx%mnum',        .false.,error)
  call sic_delvariable('mdx%fnum',        .false.,error)
  call sic_delvariable('mdx%num',         .false.,error)
  call sic_delvariable('mdx%ver',         .false.,error)
  call sic_delvariable('mdx%telescope',   .false.,error)
  call sic_delvariable('mdx%projid',      .false.,error)
  call sic_delvariable('mdx%source',      .false.,error)
  call sic_delvariable('mdx%dobs',        .false.,error)
  call sic_delvariable('mdx%ut',          .false.,error)
  call sic_delvariable('mdx%lst',         .false.,error)
  call sic_delvariable('mdx%scan',        .false.,error)
  call sic_delvariable('mdx%backend',     .false.,error)
  call sic_delvariable('mdx%obstype',     .false.,error)
  call sic_delvariable('mdx%switchmode',  .false.,error)
  call sic_delvariable('mdx%polarimetry', .false.,error)
  call sic_delvariable('mdx%filstatus',   .false.,error)
  call sic_delvariable('mdx%calstatus',   .false.,error)
  call sic_delvariable('mdx%solstatus',   .false.,error)
  call sic_delvariable('mdx%filename',    .false.,error)
  error = .false.
  !
  if (cx%next.gt.1) then
     dim(1) = cx%next-1
     call sic_def_long ('mdx%mnum',        cx%mnum,        1,dim,.false.,error)
     call sic_def_long ('mdx%fnum',        cx%fnum,        1,dim,.false.,error)
     call sic_def_long ('mdx%num',         cx%num,         1,dim,.false.,error)
     call sic_def_inte ('mdx%ver',         cx%version,     1,dim,.false.,error)
     call sic_def_inte ('mdx%telescope',   cx%telescope,   1,dim,.false.,error)
     call sic_def_charn('mdx%projid',      cx%projid,      1,dim,.false.,error)
     call sic_def_charn('mdx%source',      cx%source,      1,dim,.false.,error)
     call sic_def_inte ('mdx%dobs',        cx%dobs,        1,dim,.false.,error)
     call sic_def_dble ('mdx%ut',          cx%ut,          1,dim,.false.,error)
     call sic_def_dble ('mdx%lst',         cx%lst,         1,dim,.false.,error)
     call sic_def_inte ('mdx%scan',        cx%scan,        1,dim,.false.,error)
     call sic_def_inte ('mdx%backend',     cx%backend,     1,dim,.false.,error)
     call sic_def_inte ('mdx%obstype',     cx%obstype,     1,dim,.false.,error)
     call sic_def_inte ('mdx%switchmode',  cx%switchmode,  1,dim,.false.,error)
     call sic_def_inte ('mdx%polarimetry', cx%polstatus,   1,dim,.false.,error)
     call sic_def_inte ('mdx%filstatus',   cx%filstatus,   1,dim,.false.,error)
     call sic_def_inte ('mdx%calstatus',   cx%calstatus,   1,dim,.false.,error)
     call sic_def_inte ('mdx%solstatus',   cx%solstatus,   1,dim,.false.,error)
     call sic_def_charn('mdx%filename',    cx%filename,    1,dim,.false.,error)
     error = .false.
  endif
  !
end subroutine mrtindex_cx2sic
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine mrtindex_index_to_optimize_inplace(indx,fileid,fnum,mnum,num,  &
  sort,islast,optx,ioptx,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Write the indx at the given position, overwriting the previous
  ! element, if any
  !---------------------------------------------------------------------
  type(mrtindex_indx_t),        intent(in)    :: indx    ! The entry index on disk
  integer(kind=4),            intent(in)    :: fileid  ! Index file associated to the entry
  integer(kind=entry_length), intent(in)    :: fnum    ! Position in associated file
  integer(kind=entry_length), intent(in)    :: mnum    ! Position in memory (IX)
  integer(kind=entry_length), intent(in)    :: num     ! "Observation" number
  integer(kind=entry_length), intent(in)    :: sort    ! Position in the sorted index
  logical,                    intent(in)    :: islast  ! "is-last-version" status
  type(mrtindex_optimize_t),  intent(inout) :: optx    !
  integer(kind=entry_length), intent(in)    :: ioptx   ! Position in output optx
  logical,                    intent(inout) :: error   !
  !
  ! Memory only elements
  optx%idir(ioptx)         = fileid
  optx%fnum(ioptx)         = fnum
  optx%mnum(ioptx)         = mnum
  optx%num(ioptx)          = num
  optx%sort(ioptx)         = sort
  optx%islast(ioptx)       = islast
  ! Disk elements
  optx%bloc(ioptx)         = indx%bloc
  optx%word(ioptx)         = indx%word
  optx%version(ioptx)      = indx%version
  optx%telescope(ioptx)    = indx%telescope
  optx%source(ioptx)       = indx%source
  optx%projid(ioptx)       = indx%projid
  optx%ut(ioptx)           = indx%ut
  optx%lst(ioptx)          = indx%lst
  optx%az(ioptx)           = indx%az
  optx%el(ioptx)           = indx%el
  optx%lon(ioptx)          = indx%lon
  optx%lat(ioptx)          = indx%lat
  optx%system(ioptx)       = indx%system
  optx%equinox(ioptx)      = indx%equinox
  optx%frontend(:,ioptx)   = indx%frontend(:)
  optx%dobs(ioptx)         = indx%dobs
  optx%scan(ioptx)         = indx%scan
  optx%backend(ioptx)      = indx%backend
  optx%obstype(ioptx)      = indx%obstype
  optx%switchmode(ioptx)   = indx%switchmode
  optx%polstatus(ioptx)    = indx%polstatus
  optx%filstatus(ioptx)    = indx%filstatus
  optx%calstatus(ioptx)    = indx%calstatus
  optx%solstatus(ioptx)    = indx%solstatus
  optx%filename(ioptx)     = indx%filename
  optx%itime(ioptx)        = indx%itime
  !
end subroutine mrtindex_index_to_optimize_inplace
!
subroutine mrtindex_index_to_key(indx,key,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_indx_t), intent(in)    :: indx   !
  type(mrtindex_key_t),  intent(inout) :: key    !
  logical,             intent(inout) :: error  !
  !
  key%version      = indx%version
  key%telescope    = indx%telescope
  key%projid       = indx%projid
  key%source       = indx%source
  key%dobs         = indx%dobs
  key%ut           = indx%ut
  key%lst          = indx%lst
  key%az           = indx%az
  key%el           = indx%el
  key%lon          = indx%lon
  key%lat          = indx%lat
  key%system       = indx%system
  key%equinox      = indx%equinox
  key%frontend(:)  = indx%frontend(:)
  key%scan         = indx%scan
  key%backend      = indx%backend
  key%obstype      = indx%obstype
  key%switchmode   = indx%switchmode
  key%polstatus    = indx%polstatus
  key%filstatus    = indx%filstatus
  key%calstatus    = indx%calstatus
  key%solstatus    = indx%solstatus
  key%filename     = indx%filename
  !
end subroutine mrtindex_index_to_key
!
subroutine mrtindex_key_to_index(key,indx,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_key_t),  intent(in)    :: key    !
  type(mrtindex_indx_t), intent(inout) :: indx   !
  logical,             intent(inout) :: error  !
  !
  ! indx%bloc = not relevant in key
  ! indx%word = not relevant in key
  indx%version     = key%version
  indx%telescope   = key%telescope
  indx%projid      = key%projid
  indx%source      = key%source
  indx%dobs        = key%dobs
  indx%ut          = key%ut
  indx%lst         = key%lst
  indx%az          = key%az
  indx%el          = key%el
  indx%lon         = key%lon
  indx%lat         = key%lat
  indx%system      = key%system
  indx%equinox     = key%equinox
  indx%frontend(:) = key%frontend(:)
  indx%scan        = key%scan
  indx%backend     = key%backend
  indx%obstype     = key%obstype
  indx%switchmode  = key%switchmode
  indx%polstatus   = key%polstatus
  indx%filstatus   = key%filstatus
  indx%calstatus   = key%calstatus
  indx%solstatus   = key%solstatus
  indx%filename    = key%filename
  ! indx%itime = not relevant in key
  !
end subroutine mrtindex_key_to_index
!
subroutine mrtindex_optimize_to_key(optx,ient,key,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: optx   !
  integer(kind=entry_length), intent(in)    :: ient   !
  type(mrtindex_key_t),         intent(out)   :: key    !
  logical,                    intent(inout) :: error  !
  !
  key%version      = optx%version(ient)
  key%telescope    = optx%telescope(ient)
  key%projid       = optx%projid(ient)
  key%source       = optx%source(ient)
  key%dobs         = optx%dobs(ient)
  key%ut           = optx%ut(ient)
  key%lst          = optx%lst(ient)
  key%az           = optx%az(ient)
  key%el           = optx%el(ient)
  key%lon          = optx%lon(ient)
  key%lat          = optx%lat(ient)
  key%system       = optx%system(ient)
  key%equinox      = optx%equinox(ient)
  key%frontend(:)  = optx%frontend(:,ient)
  key%scan         = optx%scan(ient)
  key%backend      = optx%backend(ient)
  key%obstype      = optx%obstype(ient)
  key%switchmode   = optx%switchmode(ient)
  key%polstatus    = optx%polstatus(ient)
  key%filstatus    = optx%filstatus(ient)
  key%calstatus    = optx%calstatus(ient)
  key%solstatus    = optx%solstatus(ient)
  key%filename     = optx%filename(ient)
  !
end subroutine mrtindex_optimize_to_key
!
subroutine mrtindex_optimize_to_entry(optx,ient,entry,error)
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  "GET" the full entry (header+sections), read from disk
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: optx   !
  integer(kind=entry_length), intent(in)    :: ient   !
  type(mrtindex_entry_t),       intent(inout) :: entry  !
  logical,                    intent(inout) :: error  !
  ! Local
  integer(kind=4) :: fileid
  integer(kind=entry_length) :: jent
  !
  ! Open file if not already opened:
  fileid = optx%idir(ient)
  call mrtindex_file_old(fileid,.false.,error)
  if (error)  return
  !
  ! Read the whole entry from disk
  jent = optx%fnum(ient)
  call mrtindex_entry_read(ix_files(fileid),jent,entry,error)
  if (error)  return
  !
end subroutine mrtindex_optimize_to_entry
!
subroutine mrtindex_optimize_to_optimize_1d(in,out,error)
  use gbl_message
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_optimize_1d
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public-generic mrtindex_optimize_to_optimize
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t), intent(in)    :: in
  type(mrtindex_optimize_t), intent(inout) :: out
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=entry_length) :: ient,nent
  character(len=*), parameter :: rname='OPTIMIZE>TO>OPTIMIZE>1D'
  !
  call mrtindex_message(seve%t,rname,'Welcome')
  !
  ! Reallocate without keeping the data
  nent = in%next-1
  call reallocate_mrtoptimize(out,nent,.false.,error)
  if (error)  return
  ! Copy
  out%next = 1
  do ient=1,nent
    call mrtindex_optimize_to_optimize(in,ient,out,error)
    if (error)  return
  enddo ! ient
  !
end subroutine mrtindex_optimize_to_optimize_1d
!
subroutine mrtindex_optimize_to_optimize_next(in,i,out,error)
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_optimize_next
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public-generic mrtindex_optimize_to_optimize
  ! Copy the i-th element of the input optimize to the next available
  ! position in output optimize. It does not check if the optimize
  ! index is correctly allocated.
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: in
  integer(kind=entry_length), intent(in)    :: i
  type(mrtindex_optimize_t),    intent(inout) :: out
  logical,                    intent(inout) :: error
  !
  call mrtindex_optimize_to_optimize_inplace(in,i,out,out%next,error)
  if (error)  return
  out%next = out%next+1
  !
end subroutine mrtindex_optimize_to_optimize_next
!
subroutine mrtindex_optimize_to_optimize_inplace(in,i,out,j,error)
  use classic_api
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public-generic mrtindex_optimize_to_optimize
  ! Copy the i-th element of the input optimize to the j-th position
  ! in output optimize. It does not check if the optimize index is
  ! correctly allocated.
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: in
  integer(kind=entry_length), intent(in)    :: i
  type(mrtindex_optimize_t),    intent(inout) :: out
  integer(kind=entry_length), intent(in)    :: j
  logical,                    intent(inout) :: error
  !
  out%bloc(j)         = in%bloc(i)
  out%word(j)         = in%word(i)
  out%version(j)      = in%version(i)
  out%telescope(j)    = in%telescope(i)
  out%projid(j)       = in%projid(i)
  out%source(j)       = in%source(i)
  out%dobs(j)         = in%dobs(i)
  out%ut(j)           = in%ut(i)
  out%lst(j)          = in%lst(i)
  out%az(j)           = in%az(i)
  out%el(j)           = in%el(i)
  out%lon(j)          = in%lon(i)
  out%lat(j)          = in%lat(i)
  out%system(j)       = in%system(i)
  out%equinox(j)      = in%equinox(i)
  out%frontend(:,j)   = in%frontend(:,i)
  out%scan(j)         = in%scan(i)
  out%backend(j)      = in%backend(i)
  out%obstype(j)      = in%obstype(i)
  out%switchmode(j)   = in%switchmode(i)
  out%polstatus(j)    = in%polstatus(i)
  out%filstatus(j)    = in%filstatus(i)
  out%calstatus(j)    = in%calstatus(i)
  out%solstatus(j)    = in%solstatus(i)
  out%filename(j)     = in%filename(i)
  out%itime(j)        = in%itime(i)
  out%num(j)          = in%num(i)
  out%mnum(j)         = in%mnum(i)
  out%fnum(j)         = in%fnum(i)
  out%sort(j)         = j  ! Yes!
  out%idir(j)         = in%idir(i)
  out%islast(j)       = in%islast(i)
  !
end subroutine mrtindex_optimize_to_optimize_inplace
!
subroutine mrtindex_optimize_to_filename(optx,ient,filename,error)
  use mrtindex_types
  use mrtindex_vars
  use mrtindex_interfaces, except_this=>mrtindex_optimize_to_filename
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(in)    :: optx
  integer(kind=entry_length), intent(in)    :: ient
  character(len=*),           intent(out)   :: filename
  logical,                    intent(inout) :: error
  !
  filename = trim(ix_dirs(optx%idir(ient)))//'/'//optx%filename(ient)
  !
end subroutine mrtindex_optimize_to_filename
!
subroutine mrtindex_optimize_setsort(in,error)
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_optimize_setsort
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute the sorting list of the input index (in%sort)
  !---------------------------------------------------------------------
  type(mrtindex_optimize_t),    intent(inout) :: in           !
  logical,                    intent(inout) :: error        !
  ! Local
  integer(kind=entry_length) :: nelem
  !
  ! Remark: in%sort() must contain the unsorted element before
  ! entering gi0_quicksort_index_with_user_gtge
  nelem = in%next-1
  call gi0_quicksort_index_with_user_gtge(in%sort,nelem,  &
    mrtindex_find_gt,mrtindex_find_ge,error)
  if (error)  return
  !
contains
  !
  ! Sorting functions: first by DOBS then by UT. Then by SCAN for
  ! safety, then by BACKEND for cosmetics, then by VERSION.
  ! Use local functions which know the 'in' object (this avoids
  ! making it a global variable).
  function mrtindex_find_gt(m,l)
    logical :: mrtindex_find_gt
    integer(kind=entry_length), intent(in) :: m,l
    if (in%dobs(m).ne.in%dobs(l)) then
      mrtindex_find_gt = in%dobs(m).gt.in%dobs(l)
      return
    endif
    if (in%ut(m).ne.in%ut(l)) then
      ! If one is NaN, skip this test
      if (in%ut(m).eq.in%ut(m) .and. in%ut(l).eq.in%ut(l)) then
        mrtindex_find_gt = in%ut(m).gt.in%ut(l)
        return
      endif
    endif
    if (in%scan(m).ne.in%scan(l)) then
      mrtindex_find_gt = in%scan(m).gt.in%scan(l)
      return
    endif
    if (in%backend(m).ne.in%backend(l)) then
      mrtindex_find_gt = in%backend(m).gt.in%backend(l)
      return
    endif
    mrtindex_find_gt = in%version(m).gt.in%version(l)
  end function mrtindex_find_gt
  !
  function mrtindex_find_ge(m,l)
    logical :: mrtindex_find_ge
    integer(kind=entry_length), intent(in) :: m,l
    if (in%dobs(m).ne.in%dobs(l)) then
      mrtindex_find_ge = in%dobs(m).ge.in%dobs(l)
      return
    endif
    if (in%ut(m).ne.in%ut(l)) then
      ! If one is NaN, skip this test
      if (in%ut(m).eq.in%ut(m) .and. in%ut(l).eq.in%ut(l)) then
        mrtindex_find_ge = in%ut(m).ge.in%ut(l)
        return
      endif
    endif
    if (in%scan(m).ne.in%scan(l)) then
      mrtindex_find_ge = in%scan(m).ge.in%scan(l)
      return
    endif
    if (in%backend(m).ne.in%backend(l)) then
      mrtindex_find_ge = in%backend(m).ge.in%backend(l)
      return
    endif
    mrtindex_find_ge = in%version(m).ge.in%version(l)
  end function mrtindex_find_ge
  !
end subroutine mrtindex_optimize_setsort
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_entry_zindx(indx,error)
  use gbl_constant
  use gkernel_interfaces
  use imbfits_parameters
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'mrtindex_indx_t' structure. Default can not be in
  ! in the structure definition because of the 'sequence' statement
  !---------------------------------------------------------------------
  type(mrtindex_indx_t), intent(out)   :: indx
  logical,             intent(inout) :: error
  !
  indx%bloc = 0
  indx%word = 0
  indx%version = 0
  indx%telescope = telescope_unknown
  indx%source = ''
  indx%projid = ''
  call gag_notanum(indx%ut)
  call gag_notanum(indx%lst)
  call gag_notanum(indx%az)
  call gag_notanum(indx%el)
  call gag_notanum(indx%lon)
  call gag_notanum(indx%lat)
  indx%system = type_un
  indx%equinox = equinox_null
  indx%frontend(:) = ''
  indx%dobs = -32768
  indx%scan = 0
  indx%backend = backend_unknown
  indx%obstype = obstype_unknown
  indx%switchmode = switchmode_unk
  indx%polstatus = 0
  indx%filstatus = complete_unreadable
  indx%calstatus = calstatus_none
  indx%solstatus = solstatus_none
  indx%filename = ''
  indx%itime = 0
  !
end subroutine mrtindex_entry_zindx
!
subroutine mrtindex_entry_zkey(key,error)
  use gbl_constant
  use gkernel_interfaces
  use imbfits_parameters
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'mrtindex_key_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_key_t), intent(out)   :: key
  logical,            intent(inout) :: error
  !
  key%version = 0
  key%telescope = telescope_unknown
  key%projid = ''
  key%source = ''
  key%dobs = -32768
  call gag_notanum(key%ut)
  call gag_notanum(key%lst)
  call gag_notanum(key%az)
  call gag_notanum(key%el)
  call gag_notanum(key%lon)
  call gag_notanum(key%lat)
  key%system = type_un
  key%equinox = equinox_null
  key%frontend(:) = ''
  key%scan = 0
  key%backend = backend_unknown
  key%obstype = obstype_unknown
  key%switchmode = switchmode_unk
  key%polstatus = 0
  key%filstatus = complete_unreadable
  key%calstatus = calstatus_none
  key%solstatus = solstatus_none
  key%filename = ''
  !
end subroutine mrtindex_entry_zkey
!
subroutine mrtindex_entry_zprim(prim,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'sec_primary_t' structure
  !---------------------------------------------------------------------
  type(sec_primary_t), intent(out)   :: prim
  logical,             intent(inout) :: error
  !
  prim%imbfvers = 0.0
! prim%lam      = 0.d0
! prim%bet      = 0.d0
! prim%timegoal = 0.d0
! prim%nsubgoal = 0
! prim%nsub     = 0
  !
end subroutine mrtindex_entry_zprim
!
subroutine mrtindex_entry_zcalib(calib,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  Zero-ify an 'sec_calib_t' structure
  !---------------------------------------------------------------------
  type(sec_calib_t), intent(inout) :: calib
  logical,           intent(inout) :: error
  !
  calib%nfreq = 0
  calib%nset  = 0
  calib%npix  = 0
  if (allocated(calib%frontend))  deallocate(calib%frontend)
  if (allocated(calib%freq))      deallocate(calib%freq)
  if (allocated(calib%atsys))     deallocate(calib%atsys)
  if (allocated(calib%ztau))      deallocate(calib%ztau)
  !
end subroutine mrtindex_entry_zcalib
!
subroutine mrtindex_entry_zscience(sci,error)
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Zero-ify an 'sec_science_t' structure
  !---------------------------------------------------------------------
  type(sec_science_t), intent(out)   :: sci
  logical,             intent(inout) :: error
  !
  sci%caldobs = -32768
  sci%calscan = 0
  sci%calback = backend_unknown
  sci%calvers = 0
  !
end subroutine mrtindex_entry_zscience
!
subroutine mrtindex_entry_zheader(head,error)
  use mrtindex_interfaces, except_this=>mrtindex_entry_zheader
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Zero-ify an 'mrtindex_header_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(inout) :: head
  logical,               intent(inout) :: error
  !
  head%presec(:) = .false.
  !
  call mrtindex_entry_zkey(head%key,error)
  if (error)  return
  call mrtindex_entry_zprim(head%pri,error)
  if (error)  return
  call mrtindex_entry_zcalib(head%cal,error)
  if (error)  return
  call mrtindex_entry_zscience(head%sci,error)
  if (error)  return
  call head%poi%zero(error)
  if (error)  return
end subroutine mrtindex_entry_zheader
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_entry_fheader(head,error)
  use mrtindex_interfaces, except_this=>mrtindex_entry_fheader
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Free an 'mrtindex_header_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(inout) :: head
  logical,               intent(inout) :: error
  !
  ! key: nothing to destroy
  !
  ! pri: nothing to destroy
  !
  ! cal:
  call free_calib_section(head%cal,error)
  if (error)  continue
  !
  ! sci: nothing to destroy
  !
  ! poi:
  call head%poi%free(error)
  if (error)  continue
  !
end subroutine mrtindex_entry_fheader
!
subroutine mrtindex_entry_free(entry,error)
  use mrtindex_interfaces, except_this=>mrtindex_entry_free
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Free an 'mrtindex_entry_t' structure
  !---------------------------------------------------------------------
  type(mrtindex_entry_t), intent(inout) :: entry
  logical,              intent(inout) :: error
  !
  ! indx: nothing to destroy
  !
  ! desc: nothing to destroy
  !
  ! head:
  call mrtindex_entry_fheader(entry%head,error)
  if (error)  continue
  !
end subroutine mrtindex_entry_free
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_entry_lcalib(head,string,error)
  use gildas_def
  use gkernel_interfaces
  use class_parameter
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  List the calibration section, i.e. produce a string suited for
  ! MLIST
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(in)    :: head
  character(len=*),        intent(out)   :: string
  logical,                 intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='ENTRY>LCALIB'
  integer(kind=size_length) :: ndata
  real(kind=4) :: medval
  integer(kind=4) :: ier,ifreq,iset,ipix,nc
  real(kind=4), allocatable :: atsys(:,:)
  character(len=64) :: tmpstring
  !
  string = ''
  if (.not.head%presec(sec_calib_id))  return
  !
  allocate(atsys(head%cal%nfreq,head%cal%npix),stat=ier)
  if (failed_allocate(rname,'atsys',ier,error))  return
  !
  nc = 1
  ndata = head%cal%nfreq * head%cal%npix
  do iset=1,head%cal%nset
    ! Fill temporary (contiguous) buffer
    do ipix=1,head%cal%npix
      do ifreq=1,head%cal%nfreq
        atsys(ifreq,ipix) = head%cal%atsys(ifreq,iset,ipix)
      enddo
    enddo
    ! Compute the median along the Freq and Pix dimensions
    call gr4_median(atsys,ndata,0.,-1.,medval,error)
    if (error)  return
    !
    ! Write in temporary string
    if (medval.eq.class_bad) then
      write(tmpstring,'(A,A,A)')   trim(head%cal%frontend(iset)),':','--'
    else
      write(tmpstring,'(A,A,I0)')  trim(head%cal%frontend(iset)),':',nint(medval)
    endif
    !
    if (truncate_and_return(nc,string))  return  ! Detect if at least 1 char available at 'nc'
    string(nc:) = tmpstring                      ! Possibly truncated
    nc = nc+len_trim(tmpstring)-1                ! Trimmed length
    if (truncate_and_return(nc,string))  return  ! Detect if truncation happened
    nc = nc+2  ! Room for a blank space (not evaluated in truncate_and_return if last loop)
  enddo
  !
  deallocate(atsys)
  !
contains
  !
  function truncate_and_return(nc,string)
    logical :: truncate_and_return
    integer(kind=4),  intent(in)    :: nc
    character(len=*), intent(inout) :: string
    ! Local
    integer(kind=4) :: mc
    !
    truncate_and_return = nc.gt.len(string)
    if (truncate_and_return) then
      mc = len(string)
      string(mc-2:mc) = '...'
    endif
  end function truncate_and_return
  !
end subroutine mrtindex_entry_lcalib
!
subroutine mrtindex_entry_lpointing(head,string,error)
  use gildas_def
  use gkernel_interfaces
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  List the pointing section, i.e. produce a string suited for
  ! MLIST
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(in)    :: head
  character(len=*),        intent(out)   :: string
  logical,                 intent(inout) :: error
  ! Local
  integer(kind=4) :: nc,isol
  !
  string = ''
  if (.not.head%presec(sec_pointing_id))  return
  !
  nc = 0
  do isol=1,head%poi%nsol
    ! Produce some mean result for the user
!     write(string(nc+2:),'(A,A,F4.1)')  &
!           head%poi%sol(isol)%val(1),':',  &
!           head%poi%sol(isol)%nfit(2)
!     nc = len_trim(string)
  enddo
  !
  ! ZZZ Dummy results for the time being (the section needs to be redefined)
  write(string,'(A)')  'Az:N/A  El:N/A'
end subroutine mrtindex_entry_lpointing
!
subroutine mrtindex_entry_lscience(head,string,nc,error)
  use gildas_def
  use mrtindex_dependencies_interfaces
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ private
  !  List the science section, i.e. produce a string suited for
  ! MLIST
  !---------------------------------------------------------------------
  type(mrtindex_header_t), intent(in)    :: head
  character(len=*),      intent(out)   :: string
  integer(kind=4),       intent(out)   :: nc
  logical,               intent(inout) :: error
  !
  string = ''
  nc = 19+backname_length  ! 11+1 + 3+1 + backname_length+1 + 2
  !
  if (.not.head%presec(sec_science_id))  return
  !
  call gag_todate(head%sci%caldobs,string,error)
  if (error)  return
  !
  write(string(13:),'(I3,1X,A,1X,I2)')  &
    head%sci%calscan,                   &
    backends_mrtcal(head%sci%calback),  &
    head%sci%calvers
  !
end subroutine mrtindex_entry_lscience
!
!-----------------------------------------------------------------------
!
subroutine mrtindex_append_entry(entry,ient,oent,ix,error)
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_append_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  Append a NEW entry, with a new version number (automatically set
  ! to a new available value) in the file (on disk) and in IX (in
  ! memory). CX is NOT updated (this is a feature)
  !---------------------------------------------------------------------
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Old entry position in IX
  integer(kind=entry_length), intent(out)   :: oent   ! New entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX>APPEND>ENTRY'
  character(len=message_length) :: mess
  integer(kind=4) :: over,fileid
  integer(kind=entry_length) :: ifound,onum,osort
  logical :: dupl,olast
  !
  if (ient.le.0 .or. ient.ge.ix%next) then
    write(mess,'(A,I0,A)') 'No such entry number #',ient,' in IX'
    call mrtindex_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Set the new version value
  onum = ix%num(ient)  ! Keep same observation number
  over = 0             ! i.e. find the last version
  call mrtindex_numver2ent(rname,ix,onum,over,ifound,dupl,error)
  if (error)  return
  entry%indx%version = ix%version(ifound)+1  ! New available version
  !
  ! In which file?
  if (ox_fileid.ne.0) then
    ! Use a custom output file (INDEX OUTPUT)
    fileid = ox_fileid
    ! For safety, check if the directory associated to the output index is
    ! the same as the input index. Else, this means the user is mixing
    ! several directories and this becomes very complicated...
    if (ix_dirs(ox_fileid).ne.ix_dirs(ix%idir(ient))) then
      call mrtindex_message(seve%e,rname,  &
        'Directories mismatch for input and output indexes')
      error = .true.
      return
    endif
  else
    ! Use the original index file
    fileid = ix%idir(ient)
  endif
  !
  ! Open file if not already opened
  call mrtindex_file_old(fileid,.true.,error)
  if (error)  return
  call mrtindex_entry_write(ix_files(fileid),entry,error)
  if (error)  return
  ! Update the File Descriptor on disk (in particular desc%xnext)
  call classic_filedesc_write(ix_files(fileid),error)
  if (error)  return
  ! Input file has been modified, nullify the reading buffers
  call classic_recordbuf_nullify(ibufbi)
  call classic_recordbuf_nullify(ibufobs)
  !
  ! Also append IX
  ! Make room for 1 more entry
  call reallocate_mrtoptimize(ix,ix%next,.true.,error)
  if (error)  return
  !
  oent = ix%next
  onum = ix%num(ient)  ! Keep same observation number
  osort = oent  ! Declare it at last position in the sorted index, the
                ! re-sorting is done just after
  olast = .true.  ! Is-last-version
  call mrtindex_index_to_optimize_inplace(entry%indx,fileid,entry%desc%xnum,  &
    oent,onum,osort,olast,ix,oent,error)
  if (error)  return
  ix%next = ix%next+1
  !
  ! And keep the sort array sorted!
  call mrtindex_optimize_setsort(ix,error)
  if (error)  return
  !
  ix%islast(ifound) = .false.  ! This is not the last version anymore
  !
end subroutine mrtindex_append_entry
!
subroutine mrtindex_update_entry(entry,ient,ix,error)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_update_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  Update an old entry in the file (on disk) and in IX (in memory).
  ! CX is NOT updated, this is a feature.
  !---------------------------------------------------------------------
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='UPDATE>ENTRY'
  character(len=message_length) :: mess
  !
  call mrtindex_modify_entry(mrtindex_entry_update,entry,ient,ix,error)
  if (error) then
    write(mess,'(A,I0,A,A)')  'Could not update entry #',entry%desc%xnum,  &
      ' in file ',ix_files(ix%idir(ient))%spec
    call mrtindex_message(seve%e,rname,mess)
    return
  endif
  !
end subroutine mrtindex_update_entry
!
subroutine mrtindex_extend_entry(entry,ient,ix,error)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_extend_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ public
  !  Extend the LAST entry in the file (on disk, in particular, add the
  ! new sections) and update in IX (in memory).
  !  CX is NOT updated, this is a feature.
  !---------------------------------------------------------------------
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='EXTEND>ENTRY'
  character(len=message_length) :: mess
  !
  call mrtindex_modify_entry(mrtindex_entry_extend,entry,ient,ix,error)
  if (error) then
    write(mess,'(A,I0,A,A)')  'Could not extend entry #',entry%desc%xnum,  &
      ' in file ',ix_files(ix%idir(ient))%spec
    call mrtindex_message(seve%e,rname,mess)
    return
  endif
  !
end subroutine mrtindex_extend_entry
!
subroutine mrtindex_modify_entry(mrtindex_entry_modify,entry,ient,ix,error)
  use gbl_message
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_modify_entry
  use mrtindex_types
  use mrtindex_vars
  !---------------------------------------------------------------------
  ! @ private
  !  UPDATE or EXTEND an old entry in the file (on disk) and update in
  ! IX (in memory). CX is NOT updated, this is a feature.
  !  To be called by mrtindex_update_entry or mrtindex_extend_entry only!!!
  !---------------------------------------------------------------------
  interface
    subroutine mrtindex_entry_modify(fileout,entry,error)
    use classic_api
    use mrtindex_types
    type(classic_file_t),   intent(inout) :: fileout
    type(mrtindex_entry_t), intent(inout) :: entry
    logical,                intent(inout) :: error
    end subroutine mrtindex_entry_modify
  end interface
  type(mrtindex_entry_t),     intent(inout) :: entry  !
  integer(kind=entry_length), intent(in)    :: ient   ! Entry position in IX
  type(mrtindex_optimize_t),  intent(inout) :: ix
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='INDEX>MODIFY>ENTRY'
  character(len=message_length) :: mess
  integer(kind=4) :: fileid
  integer(kind=entry_length) :: inum,isort
  logical :: ilast
  !
  if (ient.le.0 .or. ient.ge.ix%next) then
    write(mess,'(A,I0,A)') 'No such entry number #',ient,' in IX'
    call mrtindex_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! In which file? Always in the same file as before
  fileid = ix%idir(ient)
  !
  ! Open file if not already opened
  call mrtindex_file_old(fileid,.true.,error)
  if (error)  return
  call mrtindex_entry_modify(ix_files(fileid),entry,error)
  if (error)  return
  ! Update the File Descriptor on disk (in particular desc%next because
  ! EXTEND mode may enlarge the file)
  call classic_filedesc_write(ix_files(fileid),error)
  if (error)  return
  call classic_file_fflush(ix_files(fileid),error)
  if (error)  return
  ! Input file has been modified, nullify the reading buffers
  call classic_recordbuf_nullify(ibufbi)
  call classic_recordbuf_nullify(ibufobs)
  !
  ! Update the entry in IX
  inum = ix%num(ient)
  isort = ix%sort(ient)  ! Its position in the sorted index does not change
  ilast = ix%islast(ient)
  call mrtindex_index_to_optimize_inplace(entry%indx,fileid,entry%desc%xnum,  &
    ient,inum,isort,ilast,ix,ient,error)
  if (error)  return
  !
end subroutine mrtindex_modify_entry
!
subroutine mrtindex_numver2ent(rname,ix,num,ver,ient,dupl,error)
  use gbl_message
  use gkernel_interfaces
  use classic_api
  use mrtindex_interfaces, except_this=>mrtindex_numver2ent
  use mrtindex_types
  !---------------------------------------------------------------------
  ! @ public
  !  Convert an observation number and version to the entry position
  ! in IX. ver<0 means to choose the newest version.
  !---------------------------------------------------------------------
  character(len=*),           intent(in)    :: rname  ! Calling routine name
  type(mrtindex_optimize_t),  intent(in)    :: ix
  integer(kind=entry_length), intent(in)    :: num    ! Observation number
  integer(kind=4),            intent(in)    :: ver    ! Version number
  integer(kind=entry_length), intent(out)   :: ient   ! Entry found
  logical,                    intent(inout) :: dupl   ! Error because of multiple match?
  logical,                    intent(inout) :: error  ! Logical error flag
  ! Local
  logical :: found
  character(len=message_length) :: mess
  integer(kind=entry_length) :: jent,kent,lent
  integer(kind=4) :: iver
  !
  found = .false.
  dupl = .false.
  ient = 0
  !
  ! Protect against empty index
  if (ix%next.le.1)  goto 100
  !
  ! Reject requests beyond the boundaries
  if (ix%num(ix%sort(1))        .gt.num)  goto 100
  if (ix%num(ix%sort(ix%next-1)).lt.num)  goto 100
  !
  call gi0_dicho_with_user_ltgt(ix%next-1,.true.,jent,  &
    mrtindex_ix_num_lt,mrtindex_ix_num_gt,error)
  if (error)  return
  ! In return jent is the observation lower or equal to the request
  ! in the sorted array (ix%sort)
  !
  if (ver.le.0) then
    iver = 0
    do kent=jent,ix%next-1
      lent = ix%sort(kent)
      if (ix%num(lent).eq.num) then
        if (found .and. ix%version(lent).eq.iver)  goto 101
        found = .true.
        ient = lent
        iver = ix%version(lent)
        ! Continue until we reach the last version
      else
        exit
      endif
    enddo
  else
    do kent=jent,ix%next-1
      lent = ix%sort(kent)
      if (ix%num(lent).eq.num) then
        if (ix%version(lent).eq.ver) then
          if (found)  goto 101
          found = .true.
          ient = lent
          ! Continue until we reach last version, in order to check
          ! if there are multiple match
        endif
      else
        exit
      endif
    enddo
  endif
  if (found)  return
  !
100 continue
  if (ver.le.0) then
    write(mess,'(A,I0)') 'No such observation #',num
  else
    write(mess,'(A,I0,A,I0)') 'No such observation #',num,'.',ver
  endif
  call mrtindex_message(seve%e,rname,mess)
  error = .true.
  return
  !
101 continue
  dupl = .true.
  write(mess,'(A,4(I0,A))') 'Multiple match for observation ',  &
    num,'.',ver,' (entries ',ient,' and ',lent,')'
  call mrtindex_message(seve%e,rname,mess)
  error = .true.
  return
  !
contains
  !
  function mrtindex_ix_num_lt(m)
    logical :: mrtindex_ix_num_lt
    integer(kind=entry_length), intent(in) :: m
    mrtindex_ix_num_lt = ix%num(ix%sort(m)).lt.num
  end function mrtindex_ix_num_lt
  !
  function mrtindex_ix_num_gt(m)
    logical :: mrtindex_ix_num_gt
    integer(kind=entry_length), intent(in) :: m
    mrtindex_ix_num_gt = ix%num(ix%sort(m)).gt.num
  end function mrtindex_ix_num_gt
  !
end subroutine mrtindex_numver2ent
!
subroutine mrtindex_mjd2gagut(scandate,mjd,dobs,ut,error)
  use phys_const
  use gbl_message
  use gkernel_interfaces
  use mrtindex_interfaces, except_this=>mrtindex_mjd2gagut
  !---------------------------------------------------------------------
  ! @ public
  ! Split MJD into DATE + UT, but taking care to respect the scan date
  ! which could have been set before midnight. In such a case, UT will
  ! go beyond 2*pi
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: scandate  ! [gag]
  real(kind=8),    intent(in)    :: mjd       ! [day]
  integer(kind=4), intent(out)   :: dobs      ! [gag]
  real(kind=8),    intent(out)   :: ut        ! [rad]
  logical,         intent(inout) :: error     !
  !
  character(len=*), parameter :: rname='MJD2GAGUT'
  character(len=message_length) :: mess
  character(len=8) :: datestring
  !
  call gag_mjd2gagut(mjd,dobs,ut,error)
  if (error)  return
  !
  if (scandate.eq.-32768) then
    call mrtindex_message(seve%w,rname,'Scan date is not set')
    return
  endif
  if (dobs.eq.scandate)  return  ! No midnight overlap
  !
  ! Tolerate 2h=pi/6 forward on next day (1h = max scan length)
  if (dobs.eq.scandate+1 .and. ut.lt.pi/6.d0) then
    ! Keep DOBS as scan date, set UT beyond 24h
    dobs = scandate
    ut = ut+2.d0*pi
  else
    call gag_toyyyymmdd(scandate,datestring,error)
    write(mess,'(a,a8,a,1pg25.16)')  &
      'Inconsistent date in filename (',datestring,') and MJD ',mjd
    call mrtindex_message(seve%e,rname,mess)
    error = .true.
    return
  endif
end subroutine mrtindex_mjd2gagut
!
subroutine datelist_decode(line,optdate,string,error)
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>datelist_decode
  !---------------------------------------------------------------------
  ! @ private
  !  Re-encode a Sic-list of dates for the CURRENT line as known and
  ! parsed by Sic, into a string of GAG dates (much easier to parse
  ! afterwards).
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     !
  integer(kind=4),  intent(in)    :: optdate  ! Option /DATE identifier
  character(len=*), intent(out)   :: string   ! Decoded as GAG dates
  logical,          intent(inout) :: error    !
  ! Local
  integer(kind=4) :: oc,iarg,nc,gagdate
  character(len=32) :: argum
  !
  string = ''
  oc = 1
  do iarg=1,sic_narg(optdate)
    call sic_ke(line,optdate,iarg,argum,nc,.true.,error)
    if (error)  return
    !
    if (argum.eq.'TO') then
      ! Date1 TO Date2 (keep "TO" as is)
      ! NB: "BY" not yet recognized, probably useless in this context
      write(string(oc:),'(A)')  'TO'
      oc = oc+3
    else
      call date_decode(argum,gagdate,error)
      if (error)  return
      write(string(oc:),'(I0)')  gagdate
      oc = len_trim(string)+2
    endif
  enddo
  !
end subroutine datelist_decode
!
subroutine date_decode(string,dobs,error)
  use gbl_message
  use mrtindex_dependencies_interfaces
  use mrtindex_interfaces, except_this=>date_decode
  !---------------------------------------------------------------------
  ! @ private
  ! Decode a string date in any supported format into a gag date.
  ! Supported formats are:
  !  - DD-MMM-YYYY
  !  - YYYYMMDD
  !  - Keywords "TODAY" and "YESTERDAY"
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: string  !
  integer(kind=4),  intent(out)   :: dobs    !
  logical,          intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='DATE>DECODE'
  integer(kind=4) :: ikey
  integer(kind=4), parameter :: mkeys=2
  character(len=11) :: date
  character(len=9) :: datekeys(mkeys),keyword
  ! Data
  data datekeys / 'TODAY','YESTERDAY' /
  !
  ! Search for a keyword
  date = string
  call sic_upper(date)
  call sic_ambigs_sub(rname,date,keyword,ikey,datekeys,mkeys,error)
  if (error)  return
  !
  if (ikey.ne.0) then
    call sic_gagdate(dobs)  ! Today
    if (ikey.eq.2)  dobs = dobs-1  ! Yesterday
    return
  endif
  !
  ! Not TODAY or YESTERDAY, try other formats
  if (index(string,'-').gt.0) then  ! DD-MMM-YYYY
    call gag_fromdate(date,dobs,error)
  else                              ! YYYYMMDD
    call gag_fromyyyymmdd(date,dobs,error)
  endif
  if (error) then
    call mrtindex_message(seve%e,rname,'Could not decode date '//string)
    return
  endif
  !
end subroutine date_decode
!
function imbfits_name(date)
  use mrtindex_parse_types
  !---------------------------------------------------------------------
  ! @ private
  !   Build an IMB-FITS file name according to the IRAM 30m standard.
  ! This function factorizes this standard at a unique place
  !---------------------------------------------------------------------
  character(len=imbfits_pattern_length) :: imbfits_name  ! Function value on return
  character(len=*), intent(in) :: date   ! The date string, can be '*'
  !
  imbfits_name = 'iram30m-*-'//trim(date)//'s*-imb.fits'
  !
end function imbfits_name
!
!-----------------------------------------------------------------------
!
function mrtindex_telescope(itel)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the telescope name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=telescope_length) :: mrtindex_telescope
  integer(kind=4), intent(in) :: itel
  !
  mrtindex_telescope = telescopes(itel)
  !
end function mrtindex_telescope
!
function mrtindex_backend(iback)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the backend name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=backname_length) :: mrtindex_backend
  integer(kind=4), intent(in) :: iback
  !
  mrtindex_backend = backends_mrtcal(iback)
  !
end function mrtindex_backend
!
function mrtindex_obstype_decode(name,error)
  use gbl_message
  use mrtindex_interfaces, except_this=>mrtindex_obstype_decode
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Decode the IMBFIST obstype name and return the corresponding
  ! MRTCAL code
  !---------------------------------------------------------------------
  integer(kind=4) :: mrtindex_obstype_decode
  character(len=*), intent(in)    :: name
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='OBSTYPE>DECODE'
  character(len=obstype_length) :: obsin,obsfound
  !
  obsin = name
  call sic_upper(obsin)
  call sic_ambigs_sub(rname,obsin,obsfound,mrtindex_obstype_decode,obstypes_imbfits,  &
    nobstypes_imbfits+1,error)
  mrtindex_obstype_decode = mrtindex_obstype_decode-1  ! Because obstypes_imbfits numbering starts at 0
  if (mrtindex_obstype_decode.eq.-1) then
    call mrtindex_message(seve%w,rname,'Observation type '''//trim(obsin)//  &
      ''' not supported')
    mrtindex_obstype_decode = obstype_unknown
    ! Not an error, continue
  elseif (mrtindex_obstype_decode.eq.obstype_onoff) then
    mrtindex_obstype_decode = obstype_tracked
  endif
  !
end function mrtindex_obstype_decode
!
function mrtindex_obstype_imbfits(itype)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the observation type name (IMBFITS) given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=obstype_length) :: mrtindex_obstype_imbfits
  integer(kind=4), intent(in) :: itype
  !
  mrtindex_obstype_imbfits = obstypes_imbfits(itype)
  !
end function mrtindex_obstype_imbfits
!
function mrtindex_obstype(itype)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the observation type name (MRTCAL) given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=obstype_length) :: mrtindex_obstype
  integer(kind=4), intent(in) :: itype
  !
  mrtindex_obstype = obstypes_mrtcal(itype)
  !
end function mrtindex_obstype
!
function mrtindex_swmode_imbfits(imode)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the switching mode name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=switchmode_length) :: mrtindex_swmode_imbfits
  integer(kind=4), intent(in) :: imode
  !
  mrtindex_swmode_imbfits = switchmodes_imbfits(imode)
  !
end function mrtindex_swmode_imbfits
!
function mrtindex_swmode(imode)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the switching mode name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=switchmode_length) :: mrtindex_swmode
  integer(kind=4), intent(in) :: imode
  !
  mrtindex_swmode = switchmodes_mrtcal(imode)
  !
end function mrtindex_swmode
!
function mrtindex_swmode_voxml(imode)
  use mrtindex_parameters
  !---------------------------------------------------------------------
  ! @ public
  ! Return the switching mode name given its identifier.
  ! ---
  ! Note that sharing character arrays between libraries is not
  ! portable, this is why a function is used.
  !---------------------------------------------------------------------
  character(len=switchmode_length) :: mrtindex_swmode_voxml
  integer(kind=4), intent(in) :: imode
  !
  mrtindex_swmode_voxml = switchmodes_voxml(imode)
  !
end function mrtindex_swmode_voxml

subroutine gtemplate_load
  !---------------------------------------------------------------------
  ! Define and load languages of the package.
  !---------------------------------------------------------------------
  ! Global
  external :: gtemplate_run
  logical, external :: gtemplate_error
  ! Local
  ! Define commands of a new language
  integer, parameter :: mcom=4
  character(len=12) :: vocab(mcom)
  data vocab /                      &
    ' DUMMY', '/OPT1', '/OPT2',     &  ! A command with 2 options
    ' VOID' /                          ! A standalone command
  !
  ! Load the new language:
  call sic_begin(           &
    'TEMPLATE',             &  ! Language name
    'GAG_HELP_GTEMPLATE',   &  !
    mcom,                   &  ! Number of commands + options in language
    vocab,                  &  ! Array of commands
    '1.0    27-Oct-2008 ',  &  ! Some version string
    gtemplate_run,          &  ! The routine which handles incoming commands
    gtemplate_error)           ! The error status routine of the library
  !
end subroutine gtemplate_load
!<FF>
subroutine gtemplate_run(line,comm,error)
  !---------------------------------------------------------------------
  ! Support routine for the language GTEMPLATE.
  ! This routine is able to call the routines associated to each
  ! command of the language GTEMPLATE
  !---------------------------------------------------------------------
  use gbl_message
  character(len=*),  intent(in)    :: line   ! Command line to send to support routines
  character(len=12), intent(in)    :: comm   ! Command resolved by the SIC interpreter
  logical,           intent(inout) :: error  ! Logical error flag
  !
  call gtemplate_message(seve%c,'GTEMPLATE',line)
  !
  ! Call appropriate subroutine according to COMM
  select case(comm)
  case('DUMMY')
    call gtemplate_dummy(line,error)
  case('VOID')
    call gtemplate_void(line,error)
  case default
    call gtemplate_message(seve%e,'GTEMPLATE_RUN','Unimplemented command '//comm)
    error = .true.
  end select
  !
end subroutine gtemplate_run
!<FF>
function gtemplate_error()
  !---------------------------------------------------------------------
  ! Support routine for the error status of the library. Does nothing
  ! here.
  !---------------------------------------------------------------------
  logical :: gtemplate_error
  !
  gtemplate_error = .false.
  !
end function gtemplate_error

module gmath_fourt
  !---------------------------------------------------------------------
  ! Pre-Computed Sin/Cos for FFT, up to 32768 (MMAX=15)
  ! We limit FFT length to 20000 due to the prime number decomposition
  !---------------------------------------------------------------------
  integer(kind=4), parameter :: mmax=15
  ! Pre-computed Sin/Cos, Bloc Start and Bit-Reverse
  real(kind=4), allocatable :: w1c(:),w3c(:)
  integer(kind=4), allocatable :: jx0(:),bitrev(:)
  integer(kind=4) :: idfft=0
  !$OMP THREADPRIVATE (w1c,w3c,jx0,bitrev,idfft)
end module gmath_fourt
!
module gmath_fftw
  use gildas_def
  !$ use omp_lib
  !---------------------------------------------------------------------
  !    Support for Fastest Fourier Transform in the West (of Italy)
  !
  ! These codes are for FFTW Version 3.1.1
  !---------------------------------------------------------------------
  integer(kind=4), parameter :: fftw_r2hc    =  0
  integer(kind=4), parameter :: fftw_hc2r    =  1
  integer(kind=4), parameter :: fftw_dht     =  2
  integer(kind=4), parameter :: fftw_redft00 =  3
  integer(kind=4), parameter :: fftw_redft01 =  4
  integer(kind=4), parameter :: fftw_redft10 =  5
  integer(kind=4), parameter :: fftw_redft11 =  6
  integer(kind=4), parameter :: fftw_rodft00 =  7
  integer(kind=4), parameter :: fftw_rodft01 =  8
  integer(kind=4), parameter :: fftw_rodft10 =  9
  integer(kind=4), parameter :: fftw_rodft11 = 10
  !
  integer(kind=4), parameter :: fftw_forward  = -1
  integer(kind=4), parameter :: fftw_backward = +1
  !
  integer(kind=4), parameter :: fftw_measure                = 0
  integer(kind=4), parameter :: fftw_destroy_input          = 1
  integer(kind=4), parameter :: fftw_unaligned              = 2
  integer(kind=4), parameter :: fftw_conserve_memory        = 4
  integer(kind=4), parameter :: fftw_exhaustive             = 8
  integer(kind=4), parameter :: fftw_preserve_input         = 16
  integer(kind=4), parameter :: fftw_patient                = 32
  integer(kind=4), parameter :: fftw_estimate               = 64
  integer(kind=4), parameter :: fftw_estimate_patient       = 128
  integer(kind=4), parameter :: fftw_believe_pcost          = 256
  integer(kind=4), parameter :: fftw_no_dft_r2hc            = 512
  integer(kind=4), parameter :: fftw_no_nonthreaded         = 1024
  integer(kind=4), parameter :: fftw_no_buffering           = 2048
  integer(kind=4), parameter :: fftw_no_indirect_op         = 4096
  integer(kind=4), parameter :: fftw_allow_large_generic    = 8192
  integer(kind=4), parameter :: fftw_no_rank_splits         = 16384
  integer(kind=4), parameter :: fftw_no_vrank_splits        = 32768
  integer(kind=4), parameter :: fftw_no_vrecurse            = 65536
  integer(kind=4), parameter :: fftw_no_simd                = 131072
  integer(kind=4), parameter :: fftw_no_slow                = 262144
  integer(kind=4), parameter :: fftw_no_fixed_radix_large_n = 524288
  integer(kind=4), parameter :: fftw_allow_pruning          = 1048576
  !
  ! One plan for Direct and one for Reverse
  logical, save :: fftw_debug=.false.
#if defined(FFTW)
#if defined(GAG_USE_OPENMP)
  logical, save :: fftw_use=.false.
#else
  logical, save :: fftw_use=.true.
#endif
  integer(kind=address_length), save :: fftw_plan(2)=(/0,0/)
  integer(kind=4), save :: fftw_ndim(2)=(/0,0/)
  logical, save :: fftw_exist(2) = (/ .false.,.false. /)
  integer(kind=4), save :: fftw_dims(16,2)
#else 
  logical, save :: fftw_use=.false.
#endif
  !
end module gmath_fftw
!
subroutine fourt_set_usage(status)
  use gmath_interfaces, except_this=>fourt_set_usage
  use gbl_message
  use gmath_fftw
  !---------------------------------------------------------------------
  ! @ public
  !   Toggle the use of FFTW and its Debug mode, and
  !   return the previous status
  !---------------------------------------------------------------------
  logical, intent(inout) :: status(2)  !  Use and Debug FFTW code ?
  !
#if defined(FFTW)
  fftw_use = status(1)
  fftw_debug = status(2)
#else
  if (status(1)) call gmath_message(seve%w,'FFT','Not compiled with FFTW, FAST mode not available')
  status= .false. 
#endif
end subroutine fourt_set_usage
!
subroutine fourt_get_usage(status) 
  use gmath_fftw
  !---------------------------------------------------------------------
  ! @ public
  !   Toggle the use of FFTW and its Debug mode, and
  !   return the previous status 
  !---------------------------------------------------------------------
  logical, intent(out) :: status(2)    !  Use and Debug FFTW code ?
  !
  status = [fftw_use,fftw_debug]
end subroutine fourt_get_usage
!
subroutine fourt_plan(data,nn,ndim,isign,iform)
  !$ use omp_lib
  use gildas_def
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>fourt_plan
  use gmath_fftw
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is renamed elsewhere)
  ! Fast Fourier Transform Planner
  !
  ! If the data is of type Real (IFORM=0), the imaginary part should be
  ! set to 0. WORK should be dimensionned to twice the largest dimension.
  !
  ! NOTES:
  !     Calls FFTW when available, if FFTW_USE is set.
  !     Calls specialized procedures for 1-D and 2-D FFT with powers of 2,
  !         based on near-optimal Split-Radix method of P.Duhamel.
  !     Calls the Cooley-Tukey FOURTCT in other cases.
  !---------------------------------------------------------------------
  complex(kind=4) :: data(*)  ! Complex array of data             Input/Output
  integer(kind=4) :: nn(*)    ! Dimensions of data array          Input
  integer(kind=4) :: ndim     ! Number of dimensions              Input
  integer(kind=4) :: isign    ! Sign of FT (-1 Direct, 1 Inverse) Input
  integer(kind=4) :: iform    ! Type of data (0 Real, 1 Complex)  (Unused)
#if defined(FFTW)
  ! Local
  character(len=*), parameter :: rname='FOURT_PLAN'
  integer(kind=4) :: iplan
  logical :: destroy
  character(len=message_length) :: mess
  integer :: the_seve = seve%d
  !
  ! Real Transform not yet ready here (REAL array conventions differ between
  !    FFTW and the other routines...)
  ! So always use the Complex DFT case
  !
  if (.not.fftw_use) return
!$  if (omp_in_parallel()) then
!$    if (fftw_debug) call gmath_message(seve%e,rname,'FOURT_PLAN call invalid in Parallel')
!$    return
!$  endif
  !
  ! Check consistency with previous call
  iplan = (isign+3)/2          ! 1 Direct, 2 Reverse
  if (fftw_exist(iplan)) then
    if (fftw_debug) then
      write(mess,*) 'Testing Plan ',iplan
      call gmath_message(the_seve,rname,mess)
    endif
    destroy = .false.
    if (ndim.ne.fftw_ndim(iplan)) destroy = .true.
    if ( any(nn(1:ndim).ne.fftw_dims(1:ndim,iplan)) ) destroy = .true.
    if (destroy) then
      if (fftw_debug) then
        write(mess,*) 'Destroying Plan ',iplan, fftw_plan(iplan)
        call gmath_message(the_seve,rname,mess)
      endif
      call sfftw_destroy_plan(fftw_plan(iplan))
      fftw_exist(iplan) = .false.
    else
      if (fftw_debug) then
        write(mess,*) 'Reusing Plan ',iplan
        call gmath_message(the_seve,rname,mess)
      endif
      return
    endif
  else
    if (fftw_debug) then 
      write(mess,*) 'No such Plan ',iplan
      call gmath_message(the_seve,rname,mess)
    endif
  endif
  !
  ! Declare the plan
  call sfftw_plan_dft(fftw_plan(iplan),ndim,nn,data,data,isign,fftw_estimate)
  ! Log its characteristics
  fftw_ndim(iplan) = ndim
  fftw_dims(:,iplan) = 0
  fftw_dims(1:ndim,iplan) = nn(1:ndim)
  fftw_exist(iplan)=.true.
  if (fftw_debug) then
    write(mess,100) 'Creating FFTW Plan ',iplan,fftw_ndim(iplan),fftw_dims(1:ndim,iplan)
    call gmath_message(seve%w,rname,mess)
  endif
100 format(a,i3,i3,20(1X,I0))
#endif
end subroutine fourt_plan
!
subroutine fourt(data,nn,ndim,isign,iform,work)
  !$ use omp_lib
  use gildas_def
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>fourt,    &
                        no_interface1=>fft1d,  &
                        no_interface2=>fft2d,  &
                        no_interface3=>fourct
  use gmath_fftw
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is renamed elsewhere)
  ! Fast Fourier Transform
  !
  ! If the data is of type Real (IFORM=0), the imaginary part should be
  ! set to 0. WORK should be dimensioned to twice the largest dimension.
  !
  ! NOTES:
  !  For COMPLEX (IFORM=1) transforms
  !     Calls FFTW when available
  !     Calls specialized procedures for 1-D and 2-D FFT with powers of 2,
  !         based on near-optimal Split-Radix method of P.Duhamel.
  !     Calls the Cooley-Tukey FOURTCT in other cases.
  !  For REAL (IFORM=0) transforms
  !     Calls FFTW when available, but in COMPLEX mode only
  !     Calls specialized procedures for 1-D and 2-D FFT with powers of 2.
  !     Calls the Cooley-Tukey FOURTCT in other cases.
  !  data(*) is declared as "complex (*)" here for the interface,
  !     but passed to subroutines treating it as "real (2,*)"
  !---------------------------------------------------------------------
  complex(kind=4), intent(inout) :: data(*)  ! Complex array of data
  integer(kind=4), intent(in)    :: nn(*)    ! Dimensions of data array
  integer(kind=4), intent(in)    :: ndim     ! Number of dimensions
  integer(kind=4), intent(in)    :: isign    ! Sign of FT (-1 Direct, 1 Inverse)
  integer(kind=4), intent(in)    :: iform    ! Type of data (0 Real, 1 Complex)
  real(kind=4)                   :: work(*)  ! Work space
#if defined(FFTW)
  ! Local
  character(len=*), parameter :: rname='FOURT'
  integer(kind=4) :: iplan
  character(len=message_length) :: mess
  integer :: the_seve = seve%d
#endif
  integer(kind=4) :: n,m1,m2,seuil
  ! SEUIL has been determined experimentally on HP-700 series.
  data seuil/0/
  !
#if defined(FFTW)
  if (fftw_use) then
    !
    ! Use the plan if possible
    iplan = (3+isign)/2
    if (fftw_exist(iplan)) then
!
! Test if the Plan is valid, comparing sizes to fftw_sndim and fftw_dims
    if ( (fftw_ndim(iplan).eq.ndim) .and. all(fftw_dims(1:ndim,iplan).eq.nn(1:ndim)) ) then
        if (fftw_debug) then
          write(mess,*) 'Using plan ',iplan,isign
          call gmath_message(the_seve,rname,mess)
        endif
!
! Can work with different adresses than in Plan
        call sfftw_execute_dft(fftw_plan(iplan),data,data)
        return
      endif
    endif
  else if (fftw_debug) then
    call gmath_message(the_seve,rname,'No matching FFTW plan, Falling back on FOURT')
  endif
#endif
  !
  if (ndim.eq.1) then
    m1 = power_of_two(nn(1))
    if (m1.gt.0) then
      n = nn(1)
      call fft1d(data,n,isign,m1,work(1),work(n+1))
    else
      call fourct(data,nn,ndim,isign,iform,work)
    endif
  elseif (ndim.eq.2) then
    m1 = power_of_two(nn(1))
    m2 = power_of_two(nn(2))
    if (m1.gt.seuil .and. m2.gt.seuil) then
      n = max(nn(1),nn(2))
      call fft2d(data,nn(1),nn(2),isign,m1,m2,work(1),work(n+1),n)
    else
      call fourct(data,nn,ndim,isign,iform,work)
    endif
  else
    call fourct(data,nn,ndim,isign,iform,work)
  endif
end subroutine fourt
!
subroutine fft1d(data,n,isign,m,xr,xi)
  use gmath_interfaces, except_this=>fft1d
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ private-mandatory (because of explicit renaming elsewhere)
  ! Transformee de Fourier               Pierre Duhamel
  !
  ! Ce sous-programme calcule la transformee de Fourier directe
  ! (ISIGN=-1) ou inverse (ISIGN=1) du tableau complexe DATA de
  ! dimension N=2**M (n doit etre compris entre 8 et 2**mmax et etre
  ! une puissance de 2)
  !---------------------------------------------------------------------
  complex(kind=4), intent(inout) :: data(*)  !
  integer(kind=4), intent(in)    :: n        !
  integer(kind=4), intent(in)    :: isign    !
  integer(kind=4), intent(in)    :: m        !
  real(kind=4)                   :: xr(*)    !
  real(kind=4)                   :: xi(*)    !
  ! Local
  integer(kind=4) :: i,k
  !
  if (idfft.ne.m) call inifft(m,n)
  do i=1,n
    xr(i)=real(data(i))
    xi(i)=aimag(data(i))
  enddo
  if (isign.lt.0) then
    call fftcfr(xr,xi,m,n)
  else
    call fftcfr(xi,xr,m,n)
  endif
  do i=1,n
    k = bitrev(i)
    data(i)=cmplx(xr(k),xi(k))
  enddo
end subroutine fft1d
!
subroutine fft2d(data,dim1,dim2,isign,m1,m2,xr,xi,mm)
  use gmath_interfaces, except_this=>fft2d
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ private-mandatory (because of explicit renaming elsewhere)
  ! Joue le meme role que Fourt : Pas de Normalisation.
  !
  ! If Signe=-1 Then
  !       Direct Fourier Transform
  ! Else
  !       Inverse Fourier Transform
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: dim1             !
  integer(kind=4), intent(in)    :: dim2             !
  complex(kind=4), intent(inout) :: data(dim1,dim2)  !
  integer(kind=4), intent(in)    :: isign            !
  integer(kind=4), intent(in)    :: m1               !
  integer(kind=4), intent(in)    :: m2               !
  integer(kind=4), intent(in)    :: mm               !
  real(kind=4)                   :: xr(mm)           !
  real(kind=4)                   :: xi(mm)           !
  ! Local
  integer(kind=4) :: ifft,jfft,kfft
  integer(kind=4) :: m,n
  !
  ! Init DIM1
  m = m1
  n = dim1
  if (idfft.ne.m) call inifft(m,n)
  if (isign.lt.0) then
    do jfft=1,dim2
      do ifft=1,dim1
        xr(ifft)=real(data(ifft,jfft))
        xi(ifft)=aimag(data(ifft,jfft))
      enddo
      !
      call fftcfr(xr,xi,m,n)
      !
      do ifft=1,dim1
        kfft = bitrev(ifft)
        data(ifft,jfft)=cmplx(xr(kfft),xi(kfft))
      enddo
    enddo
  else
    do jfft=1,dim2
      do ifft=1,dim1
        xi(ifft)=real(data(ifft,jfft))
        xr(ifft)=aimag(data(ifft,jfft))
      enddo
      !
      call fftcfr(xr,xi,m,n)
      !
      do ifft=1,dim1
        kfft = bitrev(ifft)
        data(ifft,jfft)=cmplx(xi(kfft),xr(kfft))
      enddo
    enddo
  endif
  !
  ! Init DIM2
  m = m2
  n = dim2
  if (idfft.ne.m) call inifft(m,n)
  if (isign.lt.0) then
    do jfft=1,dim1
      ! Transpose
      do ifft=1,dim2
        xr(ifft)=real(data(jfft,ifft))
        xi(ifft)=aimag(data(jfft,ifft))
      enddo
      !
      call fftcfr(xr,xi,m,n)
      !
      ! Transpose and Bit-Reverse
      do ifft=1,dim2
        kfft = bitrev(ifft)
        data(jfft,ifft)=cmplx(xr(kfft),xi(kfft))
      enddo
    enddo
  else
    do jfft=1,dim1
      ! Transpose
      do ifft=1,dim2
        xi(ifft)=real(data(jfft,ifft))
        xr(ifft)=aimag(data(jfft,ifft))
      enddo
      !
      call fftcfr(xr,xi,m,n)
      !
      ! Transpose and Bit-Reverse
      do ifft=1,dim2
        kfft = bitrev(ifft)
        data(jfft,ifft)=cmplx(xi(kfft),xr(kfft))
      enddo
    enddo
  endif
end subroutine fft2d
! 
subroutine fftcfr(xr,xi,m,n)
  use gmath_interfaces, except_this=>fftcfr
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ private
  ! FFT de sequence complexe (xr + j*xi) de taille 2**m
  !
  ! Algorithme SRFFT, version rapide, qui necessite donc un appel
  ! de INIFFT , et decimation en frequences (les rearrangements sont a
  ! effectuer apres appel a la FFT)
  !
  !  Un algorithme de transformation de Fourier rapide a double base.
  !    Pierre DUHAMEL
  !  Annales des teleommunications, tome 40, n! 9-10, sept-oct 1985
  !---------------------------------------------------------------------
  real(kind=4)                 :: xr(*)  !
  real(kind=4)                 :: xi(*)  !
  integer(kind=4), intent(in)  :: m      !
  integer(kind=4), intent(in)  :: n      !
  ! Local
  real(kind=4), parameter :: c21=0.707106781186547
  real(kind=4), parameter :: cm=-1.414213562373095
  real(kind=4) :: sp,s,r,t,rp,y2,x2,t1,u
  integer(kind=4) :: nd4,n1,istep,ib,nb,lnb,jstep,ij,llnb
  integer(kind=4) :: j,i,i0,i1,i2,i3,i4,i5,i6,i7
  !
  !     n = 2**m
  nd4 = n/4
  n1 = n/2
  !
  istep = 1
  ib = 0
  nb = 1
  lnb = 0
  !
  ! Boucle sur les etages
  do j=1,m-3
    n1 = n1/2
    !
    ! Boucle sur les blocs
    do i=ib+1,ib+nb
      !
      !-------------0-mult butterfly------------
      i0 = jx0(i)
      i1 = i0+n1
      i2 = i1+n1
      i3 = i2+n1
      sp = xr(i1)-xr(i3)
      s = xi(i1)-xi(i3)
      xr(i1) = xr(i1)+xr(i3)
      r = xr(i0)-xr(i2)
      xr(i3) = r-s
      xr(i0) = xr(i0)+xr(i2)
      xr(i2) = r+s
      r = xi(i0)-xi(i2)
      xi(i0) = xi(i0)+xi(i2)
      xi(i1) = xi(i1)+xi(i3)
      xi(i3) = r+sp
      xi(i2) = r-sp
      !
      !-------------general 6-mult butterfly--------
      jstep = 0
      do ij=i0+1,i0+n1-1
        i1 = ij+n1
        i2 = i1+n1
        i3 = i2+n1
        r = xi(ij)-xi(i2)
        xi(ij) = xi(ij)+xi(i2)
        s = xi(i1)-xi(i3)
        xi(i1) = xi(i1)+xi(i3)
        sp = xr(i1)-xr(i3)
        t = r-sp
        r = r+sp
        xr(i1) = xr(i1)+xr(i3)
        rp = xr(ij)-xr(i2)
        sp = rp+s
        jstep = jstep+istep
        xi(i2) = t*w1c(jstep)-sp*w1c(nd4-jstep)
        xr(ij) = xr(ij)+xr(i2)
        xr(i2) = sp*w1c(jstep)+t*w1c(nd4-jstep)
        rp = rp-s
        xi(i3) = r*w3c(jstep)+rp*w3c(nd4-jstep)
        xr(i3) = rp*w3c(jstep)-r*w3c(nd4-jstep)
      enddo
    enddo
    !
    ib = ib+nb
    llnb = lnb
    lnb = nb
    nb = lnb+llnb+llnb
    istep = istep+istep
  enddo
  !
  do i=ib+1,ib+nb
    !
    !-------------8-point butterfly--------------
    i0 = jx0(i)
    i1 = i0+1
    i3 = i0+3
    i5 = i0+5
    i7 = i0+7
    r = xi(i1)-xi(i5)
    xi(i1) = xi(i1)+xi(i5)
    s = xi(i3)-xi(i7)
    xi(i3) = xi(i3)+xi(i7)
    sp = xr(i3)-xr(i7)
    xr(i3) = xr(i3)+xr(i7)
    rp = xr(i1)-xr(i5)
    t = s+rp
    y2 = (t-sp+r)*c21
    x2 = t*cm+y2
    xr(i1) = xr(i1)+xr(i5)
    t = r+sp
    sp = (t-rp+s)*c21
    rp = t*cm+sp
    !
    i2 = i0+2
    i4 = i0+4
    i6 = i0+6
    r = xi(i0)-xi(i4)
    xi(i0) = xi(i0)+xi(i4)
    s = xi(i2)-xi(i6)
    xi(i2) = xi(i2)+xi(i6)
    t = xr(i2)-xr(i6)
    t1 = r+t
    xi(i6) = t1+rp
    xi(i7) = t1-rp
    t = r-t
    xi(i4) = t+x2
    xi(i5) = t-x2
    xr(i2) = xr(i2)+xr(i6)
    r = xr(i0)-xr(i4)
    t = r-s
    xr(i6) = t+sp
    xr(i7) = t-sp
    xr(i0) = xr(i0)+xr(i4)
    s = r+s
    xr(i4) = s+y2
    xr(i5) = s-y2
  enddo
  !
  !--------------4-point dft----------------
  ib = ib+nb
  nb = nb+lnb+lnb
  do i=ib+1,ib+nb
    i0 = jx0(i)
    i1 = i0+1
    i2 = i1+1
    i3 = i2+1
    r = xi(i0)+xi(i2)
    s = xi(i0)-xi(i2)
    t = xi(i1)+xi(i3)
    xi(i0) = r+t
    u = xi(i1)-xi(i3)
    xi(i1) = r-t
    r = xr(i1)+xr(i3)
    t = xr(i1)-xr(i3)
    xi(i3) = s+t
    xi(i2) = s-t
    t = xr(i0)-xr(i2)
    xr(i3) = t-u
    s = xr(i0)+xr(i2)
    xr(i0) = s+r
    xr(i1) = s-r
    xr(i2) = t+u
  enddo
end subroutine fftcfr
!
subroutine inifft(m,n)
  use gmath_interfaces, except_this=>inifft
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ private
  !  Precalcul des cos, debuts de blocs et bit-reversal
  !
  !  Sous programme a appeler avant utilisation des versions rapides.
  ! Il est commun a toutes les versions, et un seul appel a INIFFT est
  ! necessaire.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: m
  integer(kind=4), intent(in) :: n
  ! Local
  real(kind=8) :: ang, c, s, dpi, xn
  integer(kind=4) :: m1,n1,ia1,ia2,ia3,nh,ibr,i,ipair,k,j,jbr,jbri,indt
  integer(kind=4) :: n2,n2p1,n4,n8,n16,n6,n12,ip,nb,lnb,ip1,llnb
  !
  !     n   = 2**m
  if (idfft.eq.m) return
  !
  call inifft_allocate()
  !
  idfft = m
  xn  = n
  dpi = 6.283185307179586d0
  ang = dpi/xn
  n2  = n/2
  n2p1= n2+1
  n4  = n/4
  n8  = n4/2
  n16 = n8/2
  n6  = n/6
  n12 = n6/2
  !
  ! Sin/Cos
  c = cos(ang)
  s = sin(ang)
  w1c(1) = c
  w1c(n4-1) = s
  w1c(n/8) = 0.707106781186547
  do i=2,n16
    w1c(i) = w1c(i-1)*c-w1c(n4-i+1)*s
    w1c(n4-i) = w1c(n4-i+1)*c+w1c(i-1)*s
    w1c(n8+i-1) = w1c(n8+i-2)*c-w1c(n8-i+2)*s
    w1c(n8-i+1) = w1c(n8-i+2)*c+w1c(n8+i-2)*s
  enddo
  do i=1,n12
    w3c(i) = w1c(3*i)
  enddo
  do i=n12+1,n6
    w3c(i) = -w1c(n2-3*i)
  enddo
  do i=n6+1,n4-1
    w3c(i) = -w1c(3*i-n2)
  enddo
  !
  ! Bloc Beginning
  jx0(1) = 1
  jx0(2) = 1
  jx0(3) = 1
  jx0(4) = n2p1
  jx0(5) = 3*n4+1
  ip = 5
  nb = 3
  lnb = 1
  do i=1,m-4
    do j=ip+1,ip+nb
      jx0(j) = jx0(j-nb)/2+1
    enddo
    ip = ip+nb
    ip1=-(nb+nb+lnb)
    do j=ip+1,ip+lnb
      jx0(j) = jx0(j+ip1)/4+n2p1
      jx0(j+lnb) = jx0(j)+n4
    enddo
    ip = ip+lnb+lnb
    llnb = lnb
    lnb = nb
    nb = lnb+llnb+llnb
  enddo
  !
  ! Bit-Reversal
  do i=1,n
    bitrev(i) = i
  enddo
  !
  m1 = m/2
  n1 = 2**m1
  ia1= n1/2
  ia2= n/n1
  ia3= ia1+ia2
  nh = n/2
  do ipair=0,(m-m1-m1)*n1,n1
    ibr = 0
    indt = bitrev(ipair+ia1+1)
    bitrev(ipair+ia1+1) = bitrev(ipair+ia2+1)
    bitrev(ipair+ia2+1) = indt
    do i=2+ipair,ia1+ipair
      k = nh
      !            if (k.gt.ibr) go to 23
      !24          ibr = ibr-k
      !            k = k/2
      !            if (k.le.ibr) go to 24
      !23          ibr = ibr+k
      do while (k.le.ibr)
        ibr = ibr-k
        k = k/2
      enddo
      ibr = ibr+k
      !
      indt = bitrev(ibr+i+ia1)
      bitrev(ibr+i+ia1) = bitrev(ibr+i+ia2)
      bitrev(ibr+i+ia2) = indt
      !
      jbr = 0
      !
      if (m.ge.4) then
        do j=ibr+ipair+1,ibr+i-1
          jbri=jbr+i
          indt = bitrev(jbri)
          bitrev(jbri) = bitrev(j)
          bitrev(j) = indt
          indt = bitrev(jbri+ia1)
          bitrev(jbri+ia1) = bitrev(j+ia2)
          bitrev(j+ia2) = indt
          indt = bitrev(jbri+ia2)
          bitrev(jbri+ia2) = bitrev(j+ia1)
          bitrev(j+ia1) = indt
          indt = bitrev(jbri+ia3)
          bitrev(jbri+ia3) = bitrev(j+ia3)
          bitrev(j+ia3) = indt
          k = nh
          !               if (k.gt.jbr) go to 33
          !34             jbr = jbr-k
          !               k = k/2
          !               if (k.le.jbr) go to 34
          !33             jbr = jbr+k
          do while (k.le.jbr)
            jbr = jbr-k
            k = k/2
          enddo
          jbr = jbr+k
        enddo
      endif
    enddo
  enddo
  !
contains
  !
  subroutine inifft_allocate()
    use gmath_dependencies_interfaces
    !-------------------------------------------------------------------
    ! Allocate (once for all) the buffers to the maximum possible size
    !
    ! Required memory:
    !         w1c     :       nmax/4
    !         w3c     :       nmax/4
    !         jx0     :       nmax/3
    !         BITREV  :       nmax
    !                      ---------
    !         total   :  11/6*nmax
    !-------------------------------------------------------------------
    ! Local
    logical :: error
    integer(kind=4) :: nmax,ns3,ns4,ier
    !
    if (allocated(bitrev))  return
    !
    error = .false.
    nmax=2**mmax
    ns3=nmax/3
    ns4=nmax/4
    allocate(w1c(ns4),w3c(ns4),jx0(ns3),bitrev(nmax),stat=ier)
    if (failed_allocate('INITFFT','FFT buffers',ier,error)) return
  end subroutine inifft_allocate
  !
end subroutine inifft
!
function power_of_two(dim)
  use gmath_fourt
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer(kind=4) :: power_of_two     ! Value on return
  integer(kind=4), intent(in) :: dim  !
  ! Local
  integer(kind=4) :: power(0:mmax),i
  data power /1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768/
  !
  ! MMAX is a parameter defined in gmath_fourt specifying the maximum
  ! power of two preallocated in BITREV and other pointers
  !
  do i = 1,mmax
    if (dim.eq.power(i)) then
      power_of_two = i
      return
    endif
  enddo
  power_of_two = -1
end function power_of_two
!
subroutine gi4_round_forfft(isize,osize,error,tolerance,exponent)
  use gildas_def
  use gbl_message
  use gmath_interfaces, except_this=>gi4_round_forfft
  !---------------------------------------------------------------------
  ! @ public
  !
  !  Find the nearest number in the form 2^n 3^p 5^q with p and q
  ! smaller than Exponent (can be 0, then only powers of two are
  ! returned.)
  !
  !  Round to near if within Tolerance. Use Ceiling if not.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)           :: isize      ! Input size
  integer(kind=4), intent(out)          :: osize      ! Output size
  real(kind=4),    intent(in), optional :: tolerance  ! Tolerance
  integer(kind=4), intent(in), optional :: exponent   ! Max exponent
  logical,         intent(inout)        :: error      !
  ! Saved globals
  character(len=*), parameter :: rname='ROUND_MAPSIZE'
  integer(kind=size_length), save :: nval(0:2)
  integer, parameter :: numbers=72
  ! There are 72 numbers between 64 and 20000 for exponent 2
  integer(kind=4), save :: values(numbers,0:2)
  integer(kind=4) :: it(numbers)
  integer(kind=4), save :: the_expo=-1
  real(kind=4), save :: the_tolerance=0.10
  !
  integer(kind=size_length) :: ival
  integer(kind=4) :: x2, x3, y3, x5, y5
  integer(kind=4) :: count, iexpo, i,j,k
  !
  if (present(tolerance)) then
    if (tolerance.lt.0 .or. tolerance.gt.0.3) then
      call gmath_message(seve%e,rname,'Tolerance out of range ]0,0.3]')
      error = .true.
      return
    endif
    the_tolerance = tolerance
  endif
  !
  ! Initialize the values
  if (the_expo.eq.-1) then
    ! Start from 5 to make sure X2 is > 32, and end at 2^(5+9) = 16384 
    ! to be less than  20000
    do i=1,9
      values(i,0) = 2**(i+5)
    enddo
    nval(0) = 9
    !
    do iexpo=1,2
      count = 0
      !
      ! Start from 1 to make sure X2 is even, and end at 2^14 = 16384 
      ! to be less than  20000
      do i=1,14  
        x2 = 2**i
        do j=0,iexpo
          x3 = 3**j
          y3 = x2*x3
          if (y3.gt.20000) exit
          do k=0,iexpo
            x5 = 5**k
            y5 = y3*x5
            if (y5.gt.20000) exit
            if (y5.ge.64) then
              count = count+1
              if (count.gt.ubound(values,1)) Stop 'Programming error'
              values(count,iexpo) = y5
            endif
          enddo
        enddo
      enddo
      call gi4_trie(values(1:count,iexpo),it,count,error)
      nval(iexpo) = count
    enddo
    the_expo = 0  ! Default value after initialization
  endif
  !
  if (present(exponent)) then
    if (exponent.lt.0 .or. exponent.gt.2) then
      call gmath_message(seve%e,rname,'Exponent not 0,1 or 2')
      error = .true.
      return
    endif
    the_expo = exponent
  endif
  !
  if (isize.gt.values(nval(the_expo),the_expo)) then
    call gmath_message(seve%w,rname,'Size exceeds capability, has been truncated')
    osize = values(nval(the_expo),the_expo)
    return
  else if (isize.lt.values(1,the_expo)/2) then
    call gmath_message(seve%e,rname,'Size below 32 pixels')
    error = .true.
    return
  else if (isize.lt.values(1,the_expo)) then
    call gmath_message(seve%d,rname,'Size rounded upwards to 64')
    osize = values(1,the_expo)
    return
  else
    ! Dichotomic search to find out the position in the values array
    call gi4_dicho(nval(the_expo),values(:,the_expo),isize,.false.,  &
      ival,error)
    if (error)  return
  endif
  !
  if (isize-values(ival,the_expo).lt.the_tolerance*isize) then
    osize = values(ival,the_expo)
  else
    osize = values(ival+1,the_expo)
  endif
end subroutine gi4_round_forfft
!
subroutine fourct(data,nn,ndim,isign,iform,work)
  use gildas_def
  use phys_const
  use gmath_interfaces, except_this=>fourct
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Cooley-Tukey Fast Fourier Transform
  !
  ! If the data is of type Real (IFORM=0), the imaginary part should be
  ! set to 0. WORK should be dimensioned to twice the largest dimension
  ! which is not a power of 2. It can be replaced by 0 if all dimensions
  ! are powers of 2.
  !
  ! The FT are not normalized in the standard way. If a Direct FT is
  ! performed, then an Inverse FT on the result, the original data is
  ! multiply by the size of the data (product of all dimensions).
  !----------------------------------------------------------------------
  real(kind=4),    intent(inout) :: data(*)  ! Complex array of data
  integer(kind=4), intent(in)    :: nn(*)    ! Dimensions of data array
  integer(kind=4), intent(in)    :: ndim     ! Number of dimensions
  integer(kind=4), intent(in)    :: isign    ! Sign of FT (-1 Direct, 1 Inverse)
  integer(kind=4), intent(in)    :: iform    ! Type of data (0 Real, 1 Complex)
  real(kind=4)                   :: work(*)  ! Work space
  ! Local
  integer(kind=4) :: ifact(32),np0,idim,nprev
  integer(kind=4) :: if,idiv,iquot,irem,inon2,non2p
  integer(kind=4) :: ifmin,i1rng,icase,np2hf,kmin
  integer(kind=4) :: ipar,ifp1,ifp2,nhalf,nwork
  !
  integer(kind=size_length) :: np1,np2,ntot
  integer(kind=size_length) :: ntwo
  integer(kind=size_length) :: mmax,lmax,kdif,kstep
  integer(kind=size_length) :: i,j,i1,i2,i3,j2,j1,j3,k1,k2,k3,k4,l,m,n
  integer(kind=size_length) :: i1max,i2max,j2max,j3max,imax,imin,jmax,jmin
  integer(kind=size_length) :: np1tw
  !
  ! Made these Double Precision to avoid round-off errors
  real(kind=8), parameter :: rthlf=.7071067811865475244d0
  real(kind=8) :: tempr,tempi,theta,wr,wi,w2r,w2i,w3r,w3i
  real(kind=8) :: u1r,u1i,u2r,u2i,u3r,u3i,u4r,u4i,t2r,t2i,t3r,t3i,t4r,t4i
  real(kind=8) :: wstpr,wstpi,thetm,wminr,wmini,twowr,sr,si,oldsr,oldsi
  real(kind=8) :: stmpr,stmpi,wtemp,sumr,sumi,difr,difi
  !
  np0=0
  nprev=0
  if (ndim-1) 920,1,1
1 ntot=2
  do 2 idim=1,ndim
    if (nn(idim)) 920,920,2
2 ntot=ntot*nn(idim)  ! Enddo idim
  !
  !     MAIN LOOP FOR EACH DIMENSION
  !
  np1=2
  do 910 idim=1,ndim
    n=nn(idim)
    np2=np1*n
    if(n-1)920,900,5
    !
    !     IS N A POWER OF TWO AND IF NOT, WHAT ARE ITS FACTORS
    !
5   m=n
    ntwo=np1
    if=1
    idiv=2
10  iquot=m/idiv
    irem=m-idiv*iquot
    if(iquot-idiv)50,11,11
11  if(irem)20,12,20
12  ntwo=ntwo+ntwo
    ifact(if)=idiv
    if=if+1
    m=iquot
    go to 10
20  idiv=3
    inon2=if
30  iquot=m/idiv
    irem=m-idiv*iquot
    if(iquot-idiv)60,31,31
31  if(irem)40,32,40
32  ifact(if)=idiv
    if=if+1
    m=iquot
    go to 30
40  idiv=idiv+2
    go to 30
50  inon2=if
    if(irem)60,51,60
51  ntwo=ntwo+ntwo
    go to 70
60  ifact(if)=m
70  non2p=np2/ntwo
    !
    !     SEPARATE FOUR CASES--
    !        1. COMPLEX TRANSFORM
    !        2. REAL TRANSFORM FOR THE 2ND, 3RD, ETC. DIMENSION.  METHOD--
    !           TRANSFORM HALF THE DATA, SUPPLYING THE OTHER HALF BY CON-
    !           JUGATE SYMMETRY.
    !        3. REAL TRANSFORM FOR THE 1ST DIMENSION, N ODD.  METHOD--
    !           SET THE IMAGINARY PARTS TO ZERO.
    !        4. REAL TRANSFORM FOR THE 1ST DIMENSION, N EVEN.  METHOD--
    !           TRANSFORM A COMPLEX ARRAY OF LENGTH N/2 WHOSE REAL PARTS
    !           ARE THE EVEN NUMBERED REAL VALUES AND WHOSE IMAGINARY PARTS
    !           ARE THE ODD NUMBERED REAL VALUES.  SEPARATE AND SUPPLY
    !           THE SECOND HALF BY CONJUGATE SYMMETRY.
    !
    ifmin = 1
    i1rng = np1
    if (iform .le. 0 .and. idim .lt. 4) go to 71
    icase = 1
    go to 100
    !
71  if (idim .le. 1) go to 72
    icase = 2
    i1rng = np0 * (1 + nprev / 2)
    go to 100
    !
72  if (ntwo .gt. np1) go to 73
    icase = 3
    go to 100
    !
73  icase = 4
    ifmin = 2
    ntwo = ntwo / 2
    n = n / 2
    np2 = np2 / 2
    ntot = ntot / 2
    !
    i = - 1
    do 80 j = 1, ntot
      i = i + 2
      data(j) = data(i)
80  continue  ! Enddo j
    !
    !     SHUFFLE DATA BY BIT REVERSAL, SINCE N=2**K.  AS THE SHUFFLING
    !     CAN BE DONE BY SIMPLE INTERCHANGE, NO WORKING ARRAY IS NEEDED
    !
100 if(non2p-1)101,101,200
101 np2hf=np2/2
    j=1
    do 150 i2=1,np2,np1
      if(j-i2)121,130,130
121   i1max=i2+np1-2
      do 125 i1=i2,i1max,2
        do 125 i3=i1,ntot,np2
          j3=j+i3-i2
          tempr=data(i3)
          tempi=data(i3+1)
          data(i3)=data(j3)
          data(i3+1)=data(j3+1)
          data(j3)=tempr
125   data(j3+1)=tempi  ! Enddo i1,i3
130   m=np2hf
140   if(j-m)150,150,141
141   j=j-m
      m=m/2
      if(m-np1)150,140,140
150 j=j+m  ! Enddo i2
    go to 300
    !
    !     SHUFFLE DATA BY DIGIT REVERSAL FOR GENERAL N
    !
200 nwork=2*n
    do 270 i1=1,np1,2
      do 270 i3=i1,ntot,np2
        j=i3
        do 260 i=1,nwork,2
          if(icase-3)210,220,210
210       work(i)=data(j)
          work(i+1)=data(j+1)
          go to 240
220       work(i)=data(j)
          work(i+1)=0.
240       ifp2=np2
          if=ifmin
250       ifp1=ifp2/ifact(if)
          j=j+ifp1
          if(j-i3-ifp2)260,255,255
255       j=j-ifp2
          ifp2=ifp1
          if=if+1
          if(ifp2-np1)260,260,250
260     continue  ! Enddo i
        i2max=i3+np2-np1
        i=1
        do 270 i2=i3,i2max,np1
          data(i2)=work(i)
          data(i2+1)=work(i+1)
270 i=i+2  ! Enddo i1,i3,i2
    !
    !     MAIN LOOP FOR FACTORS OF TWO.
    !     W=EXP(ISIGN*2*PI*SQRT(-1)*M/(4*MMAX)).  CHECK FOR W=ISIGN*SQRT(-1)
    !     AND REPEAT FOR W=W*(1+ISIGN*SQRT(-1))/SQRT(2).
    !
300 if(ntwo-np1)600,600,305
305 np1tw=np1+np1
    ipar=ntwo/np1
310 if(ipar-2)350,330,320
320 ipar=ipar/4
    go to 310
330 do 340 i1=1,i1rng,2
      do 340 k1=i1,ntot,np1tw
        k2=k1+np1
        tempr=data(k2)
        tempi=data(k2+1)
        data(k2)=data(k1)-tempr
        data(k2+1)=data(k1+1)-tempi
        data(k1)=data(k1)+tempr
340 data(k1+1)=data(k1+1)+tempi  ! Enddo i1,k1
350 mmax=np1
360 if(mmax-ntwo/2)370,600,600
370 lmax=max(np1tw,mmax/2)
    do 570 l=np1,lmax,np1tw
      m=l
      if (mmax-np1) 420,420,380
380   theta=-twopi*float(l)/float(4*mmax)
      if (isign) 400,390,390
390   theta=-theta
400   wr=cos(theta)
      wi=sin(theta)
410   w2r=wr*wr-wi*wi
      w2i=2.*wr*wi
      w3r=w2r*wr-w2i*wi
      w3i=w2r*wi+w2i*wr
420   do 530 i1=1,i1rng,2
        kmin=i1+ipar*m
        if(mmax-np1)430,430,440
430     kmin=i1
440     kdif=ipar*mmax
450     kstep=4*kdif
        if(kstep-ntwo)460,460,530
460     do 520 k1=kmin,ntot,kstep
          k2=k1+kdif
          k3=k2+kdif
          k4=k3+kdif
          if(mmax-np1)470,470,480
470       u1r=data(k1)+data(k2)
          u1i=data(k1+1)+data(k2+1)
          u2r=data(k3)+data(k4)
          u2i=data(k3+1)+data(k4+1)
          u3r=data(k1)-data(k2)
          u3i=data(k1+1)-data(k2+1)
          if (isign) 471,472,472
471       u4r=data(k3+1)-data(k4+1)
          u4i=data(k4)-data(k3)
          go to 510
472       u4r=data(k4+1)-data(k3+1)
          u4i=data(k3)-data(k4)
          go to 510
480       t2r=w2r*data(k2)-w2i*data(k2+1)
          t2i=w2r*data(k2+1)+w2i*data(k2)
          t3r=wr*data(k3)-wi*data(k3+1)
          t3i=wr*data(k3+1)+wi*data(k3)
          t4r=w3r*data(k4)-w3i*data(k4+1)
          t4i=w3r*data(k4+1)+w3i*data(k4)
          u1r=data(k1)+t2r
          u1i=data(k1+1)+t2i
          u2r=t3r+t4r
          u2i=t3i+t4i
          u3r=data(k1)-t2r
          u3i=data(k1+1)-t2i
          if (isign) 490,500,500
490       u4r=t3i-t4i
          u4i=t4r-t3r
          go to 510
500       u4r=t4i-t3i
          u4i=t3r-t4r
510       data(k1)=u1r+u2r
          data(k1+1)=u1i+u2i
          data(k2)=u3r+u4r
          data(k2+1)=u3i+u4i
          data(k3)=u1r-u2r
          data(k3+1)=u1i-u2i
          data(k4)=u3r-u4r
520     data(k4+1)=u3i-u4i  ! Enddo k1
        kdif=kstep
        kmin=4*(kmin-i1)+i1
        go to 450
530   continue  ! Enddo i1
      m=m+lmax
      if (m-mmax) 540,540,570
540   if (isign) 550,560,560
550   tempr=wr
      wr=(wr+wi)*rthlf
      wi=(wi-tempr)*rthlf
      go to 410
560   tempr=wr
      wr=(wr-wi)*rthlf
      wi=(tempr+wi)*rthlf
      go to 410
570 continue  ! Enddo l
    ipar=3-ipar
    mmax=mmax+mmax
    go to 360
    !
    !     MAIN LOOP FOR FACTORS NOT EQUAL TO TWO.
    !     W=EXP(ISIGN*2*PI*SQRT(-1)*(J1+J2-I3-1)/IFP2)
    !
600 if(non2p-1)700,700,601
601 ifp1=ntwo
    if=inon2
610 ifp2=ifact(if)*ifp1
    theta=-twopi/float(ifact(if))
    if (isign) 612,611,611
611 theta=-theta
612 wstpr=cos(theta)
    wstpi=sin(theta)
    do 650 j1=1,ifp1,np1
      thetm=-twopi*float(j1-1)/float(ifp2)
      if (isign) 614,613,613
613   thetm=-thetm
614   wminr=cos(thetm)
      wmini=sin(thetm)
      i1max=j1+i1rng-2
      do 650 i1=j1,i1max,2
        do 650 i3=i1,ntot,np2
          i=1
          wr=wminr
          wi=wmini
          j2max=i3+ifp2-ifp1
          do 640 j2=i3,j2max,ifp1
            twowr=wr+wr
            j3max=j2+np2-ifp2
            do 630 j3=j2,j3max,ifp2
              jmin=j3-j2+i3
              j=jmin+ifp2-ifp1
              sr=data(j)
              si=data(j+1)
              oldsr=0.
              oldsi=0.
              j=j-ifp1
620           stmpr=sr
              stmpi=si
              sr=twowr*sr-oldsr+data(j)
              si=twowr*si-oldsi+data(j+1)
              oldsr=stmpr
              oldsi=stmpi
              j=j-ifp1
              if(j-jmin)621,621,620
621           work(i)=wr*sr-wi*si-oldsr+data(j)
              work(i+1)=wi*sr+wr*si-oldsi+data(j+1)
630         i=i+2  ! Enddo j3
            wtemp=wr*wstpi
            wr=wr*wstpr-wi*wstpi
640       wi=wi*wstpr+wtemp  ! Enddo j2
          i=1
          do 650 j2=i3,j2max,ifp1
            j3max=j2+np2-ifp2
            do 650 j3=j2,j3max,ifp2
              data(j3)=work(i)
              data(j3+1)=work(i+1)
650 i=i+2  ! Enddo j1,i1,i3,j2,j3
    if=if+1
    ifp1=ifp2
    if(ifp1-np2)610,700,700
    !
    !     COMPLETE A REAL TRANSFORM IN THE 1ST DIMENSION, N EVEN, BY CON-
    !     JUGATE SYMMETRIES.
    !
700 go to (900,800,900,701),icase
701 nhalf=n
    n=n+n
    theta=-twopi/float(n)
    if (isign) 703,702,702
702 theta=-theta
703 wstpr=cos(theta)
    wstpi=sin(theta)
    wr=wstpr
    wi=wstpi
    imin=3
    jmin=2*nhalf-1
    go to 725
710 j=jmin
    do 720 i=imin,ntot,np2
      sumr=(data(i)+data(j))/2.
      sumi=(data(i+1)+data(j+1))/2.
      difr=(data(i)-data(j))/2.
      difi=(data(i+1)-data(j+1))/2.
      tempr=wr*sumi+wi*difr
      tempi=wi*sumi-wr*difr
      data(i)=sumr+tempr
      data(i+1)=difi+tempi
      data(j)=sumr-tempr
      data(j+1)=-difi+tempi
720 j=j+np2  ! Enddo i
    imin=imin+2
    jmin=jmin-2
    wtemp=wr*wstpi
    wr=wr*wstpr-wi*wstpi
    wi=wi*wstpr+wtemp
725 if (imin-jmin) 710,730,740
730 if (isign) 731,740,740
731 do 735 i=imin,ntot,np2
735 data(i+1)=-data(i+1)  ! Enddo i
740 np2=np2+np2
    ntot=ntot+ntot
    j=ntot+1
    imax=ntot/2+1
745 imin=imax-2*nhalf
    i=imin
    go to 755
750 data(j)=data(i)
    data(j+1)=-data(i+1)
755 i=i+2
    j=j-2
    if(i-imax)750,760,760
760 data(j)=data(imin)-data(imin+1)
    data(j+1)=0.
    if(i-j)770,780,780
765 data(j)=data(i)
    data(j+1)=data(i+1)
770 i=i-2
    j=j-2
    if(i-imin)775,775,765
775 data(j)=data(imin)+data(imin+1)
    data(j+1)=0.
    imax=imin
    go to 745
780 data(1)=data(1)+data(2)
    data(2)=0.
    go to 900
    !
    !     COMPLETE A REAL TRANSFORM FOR THE 2ND, 3RD, ETC. DIMENSION BY
    !     CONJUGATE SYMMETRIES.
    !
800 if(i1rng-np1)805,900,900
805 do 860 i3=1,ntot,np2
      i2max=i3+np2-np1
      do 860 i2=i3,i2max,np1
        imax=i2+np1-2
        imin=i2+i1rng
        jmax=2*i3+np1-imin
        if(i2-i3)820,820,810
810     jmax=jmax+np2
820     if(idim-2)850,850,830
830     j=jmax+np0
        do 840 i=imin,imax,2
          data(i)=data(j)
          data(i+1)=-data(j+1)
840     j=j-2  ! Enddo i
850     j=jmax
        do 860 i=imin,imax,np0
          data(i)=data(j)
          data(i+1)=-data(j+1)
860 j=j-np0  ! Enddo i3,i2,i
    !
    !     END OF LOOP ON EACH DIMENSION
    !
900 np0=np1
    np1=np2
910 nprev=n  ! Enddo idim
920 return
end subroutine fourct

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetools_flag_types
  use gkernel_interfaces
  use cubetools_parameters
  use cubelist_types
  use cubeheader_messaging
  !---------------------------------------------------------------------
  ! Support module for flags and list of flags
  !---------------------------------------------------------------------
  !
  ! Flag related symbols
  public :: flag_t
  public :: flag_k,dag_flagl
  public :: code_flag_technical,code_flag_action,code_flag_product,code_flag_user
  public :: flag_unknown
  public :: cubetools_flag_ptr,cubetools_flag_init,cubetools_flag_register_user
  public :: operator(.eq.),operator(.ne.)
  ! Flaglist related symbols
  public :: flag_list_t
  public :: cubetools_flaglist_sort
  public :: cubetools_flaglist_tostr,cubetools_flaglist_list_all,cubetools_flag_debug
  public :: cubetools_string_toflaglist
  private
  !
  ! Kinds
  integer(kind=code_k), parameter :: nkinds = 4
  character(len=*), parameter :: kinds(nkinds) = ['technic','action ','product','user   ']
  integer(kind=code_k), parameter :: code_flag_technical = 1
  integer(kind=code_k), parameter :: code_flag_action    = 2
  integer(kind=code_k), parameter :: code_flag_product   = 3
  integer(kind=code_k), parameter :: code_flag_user      = 4
  !
  integer(kind=4), parameter :: flag_k=list_k
  integer(kind=4), parameter :: dag_flagl=24
  character(len=1), parameter :: flagsep_strg=','
  integer(kind=4), parameter :: dag_mflags=10   ! [integer] Maximum number of flags associated to a node
  !
  type, extends(list_object_t) :: flag_t
     character(len=dag_flagl), private :: name
     character(len=dag_flagl), private :: key
     integer(kind=code_k),     private :: kind
     integer(kind=flag_k),     private :: id
   contains
     procedure, public :: register   => cubetools_flag_register_program  ! For program-defined flags only
     procedure, public :: list       => cubetools_flag_list
     procedure, public :: get_id     => cubetools_flag_get_id
     procedure, public :: get_name   => cubetools_flag_get_name
     procedure, public :: get_key    => cubetools_flag_get_key
     procedure, public :: get_kind   => cubetools_flag_get_kind
     procedure, public :: get_suffix => cubetools_flag_get_suffix
     procedure, public :: final      => cubetools_flag_final
  end type flag_t
  !
  interface operator(.eq.)  ! Offers syntax e.g. "myflag.eq.flag_any" to programmers
    module procedure cubetools_flag_eq
  end interface
  !
  interface operator(.ne.)  ! Offers syntax e.g. "myflag.ne.flag_any" to programmers
    module procedure cubetools_flag_ne
  end interface
  !
  ! One technical flag
  type(flag_t), target :: flag_unknown
  !
  type, extends(list_t) :: flag_list_t
  contains
    procedure, private :: insert   => cubetools_flaglist_insert
    procedure, public  :: create   => cubetools_flaglist_create
    procedure, public  :: remove   => cubetools_flaglist_remove
    procedure, public  :: prepend  => cubetools_flaglist_prepend
    procedure, public  :: append   => cubetools_flaglist_append
    procedure, public  :: contains => cubetools_flaglist_contains
    procedure, public  :: repr     => cubetools_flaglist_repr
    procedure, public  :: write    => cubetools_flaglist_write
    procedure, public  :: read     => cubetools_flaglist_read
    procedure, public  :: export   => cubetools_flaglist_export
  end type flag_list_t
  !
  integer(kind=4), parameter :: key_l=24  ! Note the T26 tab below
  character(len=*), parameter :: form_na ='(A,T26,I11,(20(1X,A)))'  ! String array
  character(len=*), parameter :: form_nac='(A,T26,I11,A)'           ! String array (decoding)
  !
  ! The global list of flags
  type(list_t) :: flag_list
  integer(kind=flag_k), allocatable :: flag_list_sort(:)
  !
contains
  !
  !---------------------------------------------------------------------
  ! Support for scalar flags
  !---------------------------------------------------------------------
  !
  subroutine cubetools_flag_init(error)
    !-------------------------------------------------------------------
    ! Register the technical flags
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    call flag_unknown%register('unknown',code_flag_technical,error)
    if (error) return
    !
    call cubetools_flaglist_sort(error)  ! Compute the sorting array
    if (error)  return
  end subroutine cubetools_flag_init
  !
  subroutine cubetools_flag_list(flag,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), target, intent(inout) :: flag
    logical,               intent(inout) :: error
    !
    character(mess_l) :: mess
    !
    write(mess,'(2x,a,i4,2x,3(2a,2x))')  &
      'id=',  flag%id, &
      'name=',flag%name, &
      'key=', flag%key, &
      'kind=',kinds(flag%kind)
    call cubeheader_message(seve%r,'FLAG>LIST',mess)
  end subroutine cubetools_flag_list
  !
  function cubetools_flag_get_id(flag) result(id)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), intent(in) :: flag
    integer(kind=flag_k)      :: id
    !
    id = flag%id
  end function cubetools_flag_get_id
  !
  function cubetools_flag_get_name(flag) result(name)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), intent(in) :: flag
    character(len=dag_flagl)  :: name
    !
    name = flag%name
  end function cubetools_flag_get_name
  !
  function cubetools_flag_get_key(flag) result(key)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), intent(in) :: flag
    character(len=dag_flagl)  :: key
    !
    key = flag%key
  end function cubetools_flag_get_key
  !
  function cubetools_flag_get_kind(flag) result(kind)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), intent(in) :: flag
    integer(kind=code_k)      :: kind
    !
    kind = flag%kind
  end function cubetools_flag_get_kind
  !
  function cubetools_flag_get_suffix(flag) result(suffix)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(flag_t), intent(in)  :: flag
    character(len=dag_flagl+1) :: suffix
    !
    suffix = '-'//flag%name
  end function cubetools_flag_get_suffix
  !
  function cubetools_flag_eq(flag1,flag2)
    logical :: cubetools_flag_eq
    type(flag_t), intent(in) :: flag1,flag2
    cubetools_flag_eq = flag1%id.eq.flag2%id
  end function cubetools_flag_eq
  !
  function cubetools_flag_ne(flag1,flag2)
    logical :: cubetools_flag_ne
    type(flag_t), intent(in) :: flag1,flag2
    cubetools_flag_ne = flag1%id.ne.flag2%id
  end function cubetools_flag_ne
  !
  function cubetools_flag_ptr(tot,error)
    !-------------------------------------------------------------------
    ! Check if the input class is of type(flag_t), and return a
    ! pointer to it if relevant.
    !-------------------------------------------------------------------
    type(flag_t), pointer :: cubetools_flag_ptr
    class(list_object_t), pointer       :: tot
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='FLAG>PTR'
    !
    select type(tot)
    type is (flag_t)
      cubetools_flag_ptr => tot
    class default
      cubetools_flag_ptr => null()
      call cubeheader_message(seve%e,rname,  &
        'Internal error: object is not a flag_t type')
      error = .true.
      return
    end select
  end function cubetools_flag_ptr
  !
  subroutine cubetools_flag_name2flag(name,found,flag)
    use gkernel_interfaces
    !-------------------------------------------------------------------
    ! Resolve the flag given its name. Raising an error or not is the
    ! responsibility of the caller.
    !-------------------------------------------------------------------
    character(len=*), intent(in)  :: name
    logical,          intent(out) :: found
    type(flag_t),     intent(out) :: flag
    ! Local
    character(len=dag_flagl) :: lname
    integer(kind=flag_k) :: iflag
    type(flag_t), pointer :: lflag
    logical :: error
    !
    lname = name
    call sic_lower(lname)
    found = .false.
    flag = flag_unknown
    error = .false.
    !
    if (flag_list%n.le.0)  return
    !
    if (flag_list_gt(1_flag_k) .or. flag_list_lt(flag_list%n)) then
      ! The name we are looking for is before the 1st sorted flag, or
      ! after the last sorted flag: no need for dichotomic search (which
      ! would complain anyway in this case)
      return
    endif
    !
    call gi0_dicho_with_user_ltgt(flag_list%n,.true.,iflag,  &
      flag_list_lt,flag_list_gt,error)
    if (error)  return
    ! In return jflag is the flag lower or equal to the request
    ! in the sorted array (flag_list_sort)
    !
    lflag => cubetools_flag_ptr(flag_list%list(flag_list_sort(iflag))%p,error)
    if (error)  return
    if (lflag%name.eq.lname) then
      found = .true.
      flag = lflag
    endif
    !
  contains
    function flag_list_lt(m)
      logical :: flag_list_lt
      integer(kind=flag_k), intent(in) :: m
      ! 'lname', 'flag', and 'error' shared with main routine
      lflag => cubetools_flag_ptr(flag_list%list(flag_list_sort(m))%p,error)
      if (error)  return
      flag_list_lt = flag_name_lt(lflag%name,lname)
    end function flag_list_lt
    function flag_list_gt(m)
      logical :: flag_list_gt
      integer(kind=flag_k), intent(in) :: m
      ! 'lname', 'flag', and 'error' shared with main routine
      lflag => cubetools_flag_ptr(flag_list%list(flag_list_sort(m))%p,error)
      if (error)  return
      flag_list_gt = flag_name_gt(lflag%name,lname)
    end function flag_list_gt
  end subroutine cubetools_flag_name2flag
  !
  function flag_name_gt(name1,name2)
    !-------------------------------------------------------------------
    ! Compare 2 flag names, i.e. if name1 > name2
    ! Typically used for lexicographical sorting
    !-------------------------------------------------------------------
    logical :: flag_name_gt
    character(len=*), intent(in) :: name1
    character(len=*), intent(in) :: name2
    ! Local
    integer(kind=4) :: len1,len2
    !
    if (isnumeric(name1(1:1)) .and. isnumeric(name2(1:1))) then
      ! Compare numerics as character strings, ensuring "2" < "10".
      ! NB: this won't work if mixing numerics and letters e.g. "123ABC",
      ! but what do we want in this case?
      len1 = len_trim(name1)
      len2 = len_trim(name2)
      if (len1.gt.len2) then
        flag_name_gt = .true.
      elseif (len1.lt.len2) then
        flag_name_gt = .false.
      else
        flag_name_gt = lgt(name1,name2)
      endif
    else
      flag_name_gt = lgt(name1,name2)
    endif
  end function flag_name_gt
  !
  function flag_name_lt(name1,name2)
    !-------------------------------------------------------------------
    ! Compare 2 flag names, i.e. if name1 < name2
    ! Typically used for lexicographical sorting
    !-------------------------------------------------------------------
    logical :: flag_name_lt
    character(len=*), intent(in) :: name1
    character(len=*), intent(in) :: name2
    ! Local
    integer(kind=4) :: len1,len2
    !
    if (isnumeric(name1(1:1)) .and. isnumeric(name2(1:1))) then
      ! Compare numerics as character strings, ensuring "2" < "10".
      ! NB: this won't work if mixing numerics and letters e.g. "123ABC",
      ! but what do we want in this case?
      len1 = len_trim(name1)
      len2 = len_trim(name2)
      if (len1.gt.len2) then
        flag_name_lt = .false.
      elseif (len1.lt.len2) then
        flag_name_lt = .true.
      else
        flag_name_lt = llt(name1,name2)
      endif
    else
      flag_name_lt = llt(name1,name2)
    endif
  end function flag_name_lt
  !
  function flag_name_ge(name1,name2)
    !-------------------------------------------------------------------
    ! Compare 2 flag names, i.e. if name1 >= name2
    ! Typically used for lexicographical sorting
    !-------------------------------------------------------------------
    logical :: flag_name_ge
    character(len=*), intent(in) :: name1
    character(len=*), intent(in) :: name2
    !
    flag_name_ge = .not.flag_name_lt(name1,name2)
  end function flag_name_ge
  !
  function isnumeric(c1)
    !-------------------------------------------------------------------
    ! Return .true. if the given character is an ASCII character in the
    ! range [0-9]
    !-------------------------------------------------------------------
    logical :: isnumeric
    character(len=1), intent(in) :: c1
    ! Local
    integer(kind=4) :: ichara
    !
    ichara = ichar(c1)-ichar('0')
    isnumeric = ichara.ge.0 .and. ichara.le.9
  end function isnumeric
  !
  subroutine cubetools_flag_final(obj,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    class(flag_t), intent(inout) :: obj
    logical,       intent(inout) :: error
    !
  end subroutine cubetools_flag_final
  !
  !---------------------------------------------------------------------
  ! Support for list of flags
  !---------------------------------------------------------------------
  !
  subroutine cubetools_flag_register_program(flag,name,kind,error)
    !----------------------------------------------------------------------
    ! Register a program-defined flag in the global flag list
    !----------------------------------------------------------------------
    class(flag_t), target, intent(inout) :: flag
    character(len=*),      intent(in)    :: name
    integer(kind=code_k),  intent(in)    :: kind
    logical,               intent(inout) :: error
    !
    call cubetools_flag_register(flag,name,kind,error)
    if (error)  return
    ! Sorting is done once by caller
  end subroutine cubetools_flag_register_program
  !
  subroutine cubetools_flag_register_user(name,error)
    !----------------------------------------------------------------------
    ! Create and register a user-defined flag in the global flag list
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: name
    logical,          intent(inout) :: error
    !
    type(flag_t) :: otherflag
    logical :: found
    type(flag_t), pointer :: flag
    character(len=*), parameter :: rname='FLAG>REGISTER>USER'
    !
    ! Sanity (only checked for user inputs)
    if (len_trim(name).gt.dag_flagl) then
      call cubeheader_message(seve%e,rname,'Flag name is too long')
      error = .true.
      return
    endif
    call cubetools_flag_name2flag(name,found,otherflag)
    if (found) then
      call cubeheader_message(seve%w,rname,'Flag named '''//trim(name)//''' already exists')
      return
    endif
    !
    allocate(flag)
    call cubetools_flag_register(flag,name,code_flag_user,error)
    if (error) then
      deallocate(flag)
      return
    endif
    call cubetools_flaglist_sort(error)  ! Compute the sorting array
    if (error)  return
  end subroutine cubetools_flag_register_user
  !
  subroutine cubetools_flag_register(flag,name,kind,error)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Register a flag in the global flag list
    !----------------------------------------------------------------------
    class(flag_t), target, intent(inout) :: flag
    character(len=*),      intent(in)    :: name
    integer(kind=code_k),  intent(in)    :: kind
    logical,               intent(inout) :: error
    !
    ! Attributes
    flag%name = name
    call sic_lower(flag%name)
    flag%key = name
    call sic_upper(flag%key)
    flag%kind = kind
    flag%id = flag_list%n+1
    !
    ! Insert in global flag list
    call flag_list%associate(flag,error)
    if (error)  return
  end subroutine cubetools_flag_register
  !
  subroutine cubetools_flaglist_insert(list,flags,start,error)
    !-------------------------------------------------------------------
    ! Copy an array of flag_t to a tools_list_t, starting at given
    ! position.
    ! This subroutine DOES NOT CARE for list allocation or list%n.
    ! Because of this, it should not be used out of this module.
    !-------------------------------------------------------------------
    class(flag_list_t),   intent(inout) :: list
    type(flag_t),         intent(in)    :: flags(:)
    integer(kind=flag_k), intent(in)    :: start
    logical,              intent(inout) :: error
    !
    character(len=*), parameter :: rname='FLAGLIST>INSERT'
    integer(kind=flag_k) :: iflag,oflag
    type(flag_t), pointer :: flag
    type(flag_t) :: template
    !
    do iflag=1,size(flags)
      oflag = start+iflag-1  ! Position in list
      call list%list(oflag)%allocate(template,error)
      if (error)  return
      flag => cubetools_flag_ptr(list%list(oflag)%p,error)
      if (error)  return
      flag = flags(iflag)
    enddo
  end subroutine cubetools_flaglist_insert
  !
  subroutine cubetools_flaglist_create(list,flags,error)
    !-------------------------------------------------------------------
    ! Create a tools_list_t of flag_t from an array of flag_t
    ! This creates copies of the flags. The list MUST be cleaned with
    ! the list%free() method.
    !-------------------------------------------------------------------
    class(flag_list_t), intent(inout) :: list
    type(flag_t),       intent(in)    :: flags(:)
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FLAGLIST>CREATE'
    integer(kind=flag_k) :: nflag
    !
    nflag = size(flags)
    call list%reallocate(nflag,error)
    if (error)  return
    !
    call list%insert(flags,1_flag_k,error)
    if (error)  return
    !
    list%n = nflag
  end subroutine cubetools_flaglist_create
  !
  subroutine cubetools_flaglist_remove(list,flags,error)
    !-------------------------------------------------------------------
    ! Free and pop the matching flags from a flag_list_t
    !-------------------------------------------------------------------
    class(flag_list_t), intent(inout) :: list
    type(flag_t),       intent(in)    :: flags(:)
    logical,            intent(inout) :: error
    !
    character(len=*), parameter :: rname='FLAGLIST>REMOVE'
    integer(kind=flag_k) :: iflag,jflag
    type(flag_t), pointer :: flag
    !
    ! Start from the end because list%pop() compresses the list from the
    ! right and changes list%n
    iflag = list%n
    do while (iflag.ge.1)
      flag => cubetools_flag_ptr(list%list(iflag)%p,error)
      if (error)  return
      do jflag=1,size(flags)  ! This is a N^2 loop... on small numbers (<10 or so).
        if (flag.eq.flags(jflag)) then
          call list%pop(iflag,error)
          if (error)  return
          exit  ! Matched and removed from the list, go to next iflag in the list
        endif
      enddo
      iflag = iflag-1
    enddo
  end subroutine cubetools_flaglist_remove
  !
  subroutine cubetools_flaglist_prepend(list,flags,error)
    !-------------------------------------------------------------------
    ! Prepend a list of flags to a flag_list_t. Note that duplicates
    ! are allowed.
    !-------------------------------------------------------------------
    class(flag_list_t), intent(inout) :: list
    type(flag_t),       intent(in)    :: flags(:)
    logical,            intent(inout) :: error
    !
    ! Enlarge list to the left
    call list%enlarge(size(flags,kind=flag_k),1_flag_k,error)
    if (error)  return
    !
    ! Insert new ones in front
    call list%insert(flags,1_flag_k,error)
    if (error)  return
    !
    ! Finally update the size
    list%n = list%n+size(flags)
  end subroutine cubetools_flaglist_prepend
  !
  subroutine cubetools_flaglist_append(list,flags,error)
    !-------------------------------------------------------------------
    ! Append a list of flags to a flag_list_t. Note that duplicates are
    ! allowed.
    !-------------------------------------------------------------------
    class(flag_list_t), intent(inout) :: list
    type(flag_t),       intent(in)    :: flags(:)
    logical,            intent(inout) :: error
    !
    ! Enlarge list to the right
    call list%enlarge(size(flags,kind=flag_k),list%n+1,error)
    if (error)  return
    !
    ! Insert new ones to the end
    call list%insert(flags,list%n+1,error)
    if (error)  return
    !
    ! Finally update the size
    list%n = list%n+size(flags)
  end subroutine cubetools_flaglist_append
  !
  function cubetools_flaglist_contains(list,flag)
    !-------------------------------------------------------------------
    ! Return .true. if the flag_list_t contains the named flag.
    !-------------------------------------------------------------------
    logical :: cubetools_flaglist_contains
    class(flag_list_t), intent(in) :: list
    type(flag_t),       intent(in) :: flag
    ! Local
    logical :: error
    integer(kind=4) :: iflag
    type(flag_t), pointer :: pflag
    !
    error = .false.
    cubetools_flaglist_contains = .false.
    do iflag=1,list%n
      pflag => cubetools_flag_ptr(list%list(iflag)%p,error)
      if (error)  return
      if (pflag.eq.flag) then
        cubetools_flaglist_contains = .true.
        return
      endif
    enddo
  end function cubetools_flaglist_contains
  !
  subroutine cubetools_flaglist_tostr(flags,nflag,strflag,lstrflag,error)
    !-------------------------------------------------------------------
    ! Concatenate the flags list into a string.
    ! ---
    ! This version with a flat 'flag_t' array as argument
    !-------------------------------------------------------------------
    type(flag_t),               intent(in)    :: flags(:)
    integer(kind=flag_k),       intent(in)    :: nflag
    character(len=*), optional, intent(out)   :: strflag
    integer(kind=4),  optional, intent(out)   :: lstrflag
    logical,                    intent(inout) :: error
    ! Local
    type(flag_list_t) :: tmp
    !
    call tmp%create(flags(1:nflag),error)
    if (error)  return
    call tmp%repr(strflag=strflag,lstrflag=lstrflag,error=error)
    if (error)  return
    call tmp%final(error)
    if (error)  return
  end subroutine cubetools_flaglist_tostr
  !
  subroutine cubetools_flaglist_repr(list,strflag,lstrflag,error)
    !-------------------------------------------------------------------
    ! Concatenate the flags list into a string. This subroutine can be
    ! used to:
    !   1) concatenate the flags into an output list
    ! AND/OR
    !   2) return the length of the concatenatation
    ! ---
    ! This version with a tools_list_t as argument
    !-------------------------------------------------------------------
    class(flag_list_t),         intent(in)    :: list
    character(len=*), optional, intent(out)   :: strflag
    integer(kind=4),  optional, intent(out)   :: lstrflag
    logical,          optional, intent(inout) :: error
    ! Local
    integer(kind=4) :: iflag,nc,mc
    type(flag_t), pointer :: flag
    !
    if (list%n.le.0) then
      if (present(strflag))   strflag = ''
      if (present(lstrflag))  lstrflag = 0
      return
    endif
    !
    nc = 0
    if (present(strflag)) then
      mc = len(strflag)
    else
      mc = huge(mc)
    endif
    do iflag=1,list%n
      if (nc.gt.0) then
        nc = nc+1
        if (present(strflag)) strflag(nc:nc) = flagsep_strg
      endif
      flag => cubetools_flag_ptr(list%list(iflag)%p,error)
      if (error)  return
      ! ZZZ There used to be a specific support for flag_any
      if (present(strflag)) strflag(nc+1:mc) = flag%name
      nc = nc+len_trim(flag%name)
      if (nc.gt.mc) then
        if (present(strflag)) strflag(mc-1:mc) = '..'
        nc = mc
        exit
      endif
    enddo
    !
    if (present(lstrflag))  lstrflag = nc
    !
  end subroutine cubetools_flaglist_repr
  !
  subroutine cubetools_string_toflaglist(string,allownew,flags,error,sep)
    use gkernel_interfaces
    !----------------------------------------------------------------------
    ! Parse a string (e.g. "flag1,flag2,flag3") into a list of flags
    !----------------------------------------------------------------------
    character(len=*),           intent(in)    :: string
    logical,                    intent(in)    :: allownew  ! Allow creation of new (user-defined) flags?
    type(flag_t), allocatable,  intent(out)   :: flags(:)
    logical,                    intent(inout) :: error
    character(len=*), optional, intent(in)    :: sep       ! Override default separator
    !
    integer(kind=flag_k) :: nflag,iflag
    integer(kind=4) :: ichar,seppos(20),ierr
    character(len=1) :: lsep
    character(len=argu_l) :: oneflag
    character(len=mess_l) :: mess
    logical :: found,lerror
    character(len=*), parameter :: rname='STRING>TOFLAGLIST'
    !
    ! call cubeheader_message(dagseve%trace,rname,'Welcome')
    !
    if (len_trim(string).eq.0) then ! No flags given return
      return
    endif
    !
    if (present(sep)) then
      lsep = sep
    else
      lsep = flagsep_strg
    endif
    !
    nflag = 0
    seppos(:) = -1
    seppos(1) = 0
    do ichar=1,len_trim(string)
      if (string(ichar:ichar).eq.lsep) then
        nflag = nflag+1
        seppos(nflag+1) = ichar
      endif
    enddo
    nflag = nflag+1
    seppos(nflag+1) = len_trim(string)+1
    !
    lerror = .false.
    allocate(flags(nflag),stat=ierr)
    if (failed_allocate(rname,'flags',ierr,error)) return
    do iflag=1,nflag
      oneflag = string(seppos(iflag)+1:seppos(iflag+1)-1)
      if (oneflag.eq.'') then
        write(mess,'(3(a,i0))') 'Flag ',iflag,'/',nflag,' is empty'
        call cubeheader_message(seve%e,rname,mess)
        lerror = .true.
        cycle
      endif
      call cubetools_flag_name2flag(oneflag,found,flags(iflag))
      if (.not.found) then
        if (allownew) then
          call cubetools_flag_register_user(oneflag,error)
          if (error)  return
          call cubetools_flag_name2flag(oneflag,found,flags(iflag))
        else
          write(mess,'(3a)') 'Flag "',trim(oneflag),'" not recognized'
          call cubeheader_message(seve%e,rname,mess)
          lerror = .true.
          cycle
        endif
      endif
    enddo
    if (lerror) then
      call cubeheader_message(seve%e,rname,'Undecipherable flag list: "'//trim(string)//'"')
      error = .true.
      return
    endif
  end subroutine cubetools_string_toflaglist
  !
  subroutine cubetools_flag_debug(error)
    !-------------------------------------------------------------------
    ! Display the full list of flags registered
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    ! Local
    integer(kind=flag_k) :: iflag
    type(flag_t), pointer :: flag
    !
    do iflag=1,flag_list%n
      flag => cubetools_flag_ptr(flag_list%list(iflag)%p,error)
      if (error) return
      call flag%list(error)
      if (error) return
    enddo
  end subroutine cubetools_flag_debug
  !
  subroutine cubetools_flaglist_sort(error)
    !-------------------------------------------------------------------
    ! Compute the sorting array of the flag list (by alphabetical order
    ! of names)
    !-------------------------------------------------------------------
    logical, intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='FLAGLIST>SORT'
    integer(kind=flag_k) :: iflag
    integer(kind=4) :: ier
    !
    if (allocated(flag_list_sort))  deallocate(flag_list_sort)
    allocate(flag_list_sort(flag_list%n),stat=ier)
    if (failed_allocate(rname,'flag_list_sort',ier,error)) return
    do iflag=1,flag_list%n
      flag_list_sort(iflag) = iflag
    enddo
    !
    call gi0_quicksort_index_with_user_gtge(flag_list_sort,flag_list%n,  &
      flag_list_sort_gt,flag_list_sort_ge,error)
    if (error)  return
  end subroutine cubetools_flaglist_sort
  !
  function flag_list_sort_gt(m,l)
    logical :: flag_list_sort_gt
    integer(kind=flag_k), intent(in) :: m,l
    ! Local
    logical :: error
    type(flag_t), pointer :: flagm,flagl
    !
    error = .false.
    flagm => cubetools_flag_ptr(flag_list%list(m)%p,error)
    if (error)  return
    flagl => cubetools_flag_ptr(flag_list%list(l)%p,error)
    if (error)  return
    flag_list_sort_gt = flag_name_gt(flagm%name,flagl%name)
  end function flag_list_sort_gt
  !
  function flag_list_sort_ge(m,l)
    logical :: flag_list_sort_ge
    integer(kind=flag_k), intent(in) :: m,l
    ! Local
    logical :: error
    type(flag_t), pointer :: flagm,flagl
    !
    error = .false.
    flagm => cubetools_flag_ptr(flag_list%list(m)%p,error)
    if (error)  return
    flagl => cubetools_flag_ptr(flag_list%list(l)%p,error)
    if (error)  return
    flag_list_sort_ge = flag_name_ge(flagm%name,flagl%name)
  end function flag_list_sort_ge
  !
  subroutine cubetools_flaglist_list_all(error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    logical, intent(inout) :: error
    !
    integer(kind=flag_k) :: iflag
    integer(kind=4) :: nlp,nla,nlu
    type(flag_t), pointer :: pflag
    character(len=2048) :: products,actions,users
    !
    character(len=*), parameter :: rname='FLAGLIST>LIST>ALL'
    !
    ! call cubeheader_message(dagseve%trace,rname,'Welcome')
    !
    products = ''
    actions  = ''
    users    = ''
    nlp = 0
    nla = 0
    nlu = 0
    do iflag=1,flag_list%n
       pflag => cubetools_flag_ptr(flag_list%list(flag_list_sort(iflag))%p,error)
       if (error) return
       select case(pflag%kind)
       case(code_flag_product)
          call format_line_break(pflag%key,products,nlp)
       case(code_flag_action)
          call format_line_break(pflag%key,actions,nla)
       case(code_flag_user)
          call format_line_break(pflag%key,users,nlu)
       case default
          ! Do nothing
       end select
    enddo
    call cubeheader_message(seve%r,rname,'Product flags:')
    call cubeheader_message(seve%r,rname,products(1:len_trim(products)-1))
    call cubeheader_message(seve%r,rname,blankstr)
    call cubeheader_message(seve%r,rname,'Action flags:')    
    call cubeheader_message(seve%r,rname,actions(1:len_trim(actions)-1))
    call cubeheader_message(seve%r,rname,blankstr)
    call cubeheader_message(seve%r,rname,'User flags:')
    call cubeheader_message(seve%r,rname,users(1:len_trim(users)-1))
  contains
    subroutine format_line_break(key,line,nl)
      use cubetools_terminal_tool
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      character(len=*), intent(in)    :: key
      character(len=*), intent(inout) :: line
      integer(kind=4),  intent(inout) :: nl
      !
      integer(kind=4) :: nc
      character(len=*), parameter :: sep = ','
      !
      nc = len_trim(key)
      if (nl+nc+2.gt.terminal%width()) then
         write(line,'(2a)') trim(line),strg_cr
         nl = 0
      endif
      write(line,'(a,x,2a)') trim(line),trim(key),sep
      nl = nl+nc+2
    end subroutine format_line_break
  end subroutine cubetools_flaglist_list_all

  subroutine cubetools_flaglist_write(fl,lun,error)
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    class(flag_list_t), intent(in)    :: fl
    integer(kind=4),    intent(in)    :: lun
    logical,            intent(inout) :: error
    !
    integer(kind=4) :: iflag,nc
    character(len=dag_flagl), allocatable :: lflags(:)
    character(len=*), parameter :: rname='FLAGLIST>WRITE'
    !
    ! Flags
    call fl%export(lflags,error)
    if (error)  return
    ! Cosmetics: find the smallest length needed
    nc = 0
    do iflag=1,fl%n
      nc = max(nc,len_trim(lflags(iflag)))
    enddo
    write(lun,form_na) 'FLAG',fl%n,(/ (lflags(iflag)(1:nc),iflag=1,fl%n) /)
  end subroutine cubetools_flaglist_write

  subroutine cubetools_flaglist_export(fl,flags,error)
    !-------------------------------------------------------------------
    ! Export the flag list to character array
    !-------------------------------------------------------------------
    class(flag_list_t), intent(in)    :: fl
    character(len=*),   allocatable   :: flags(:)
    logical,            intent(inout) :: error
    !
    integer(kind=4) :: iflag,ier
    type(flag_t), pointer :: flag
    character(len=*), parameter :: rname='FLAGLIST>EXPORT'
    !
    allocate(flags(fl%n),stat=ier)
    if (failed_allocate(rname,'flags',ier,error)) return
    do iflag=1,fl%n
      flag => cubetools_flag_ptr(fl%list(iflag)%p,error)
      if (error)  return
      flags(iflag) = flag%get_name()
    enddo
  end subroutine cubetools_flaglist_export

  subroutine cubetools_flaglist_read(fl,lun,error)
    class(flag_list_t), intent(inout) :: fl
    integer(kind=4),   intent(in)    :: lun
    logical,           intent(inout) :: error
    ! Local
    character(len=*), parameter :: rname='FLAGLIST>READ'
    character(len=dag_flagl) :: chflags(dag_mflags)
    integer(kind=4) :: nflag,iflag
    type(flag_t), pointer :: flag
    class(list_object_t), pointer :: lot
    type(flag_t) :: template
    logical :: found
    !
    call cubetools_read_nch(lun,nflag,chflags,error)
    if (error)  return
    call fl%reallocate(nflag,error)
    if (error)  return
    ! Resolving codes from names below is inefficient. Solutions:
    !  1) Sort the main list, and use dichotomic search, OR
    !  2) Get rid of the integer codes (as we want flexibility
    !     e.g. user-defined flags)
    do iflag=1,nflag
      call fl%allocate(template,lot,error)
      if (error)  return
      flag => cubetools_flag_ptr(lot,error)
      if (error)  return
      call cubetools_flag_name2flag(chflags(iflag),found,flag)
      if (.not.found) then
        ! Implicitly recreate a user-defined flag in the main list
        call cubetools_flag_register_user(chflags(iflag),error)
        if (error)  return
        ! And search for it again. Not efficient but robust.
        call cubetools_flag_name2flag(chflags(iflag),found,flag)
      endif
    enddo
    fl%n = nflag
  end subroutine cubetools_flaglist_read

  subroutine cubetools_read_nch(lun,nch,ch,error)
    !-------------------------------------------------------------------
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: lun
    integer(kind=4),  intent(out)   :: nch
    character(len=*), intent(out)   :: ch(:)
    logical,          intent(inout) :: error
    ! Local
    character(len=key_l) :: key
    character(len=128) :: tmp
    !
    read(lun,form_nac) key,nch,tmp
    if (nch.gt.0) then
      read(tmp,*)  ch(1:nch)
    endif
  end subroutine cubetools_read_nch

end module cubetools_flag_types
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

* DECK sbdsqr.f
      SUBROUTINE SBDSQR( UPLO, N, NCVT, NRU, NCC, D, E, VT, LDVT, U,
     $                   LDU, C, LDC, WORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDC, LDU, LDVT, N, NCC, NCVT, NRU
*     ..
*     .. Array Arguments ..
      REAL               C( LDC, * ), D( * ), E( * ), U( LDU, * ),
     $                   VT( LDVT, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  SBDSQR computes the singular value decomposition (SVD) of a real
*  N-by-N (upper or lower) bidiagonal matrix B:  B = Q * S * P' (P'
*  denotes the transpose of P), where S is a diagonal matrix with
*  non-negative diagonal elements (the singular values of B), and Q
*  and P are orthogonal matrices.
*
*  The routine computes S, and optionally computes U * Q, P' * VT,
*  or Q' * C, for given real input matrices U, VT, and C.
*
*  See "Computing  Small Singular Values of Bidiagonal Matrices With
*  Guaranteed High Relative Accuracy," by J. Demmel and W. Kahan,
*  LAPACK Working Note #3 (or SIAM J. Sci. Statist. Comput. vol. 11,
*  no. 5, pp. 873-912, Sept 1990) and
*  "Accurate singular values and differential qd algorithms," by
*  B. Parlett and V. Fernando, Technical Report CPAM-554, Mathematics
*  Department, University of California at Berkeley, July 1992
*  for a detailed description of the algorithm.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  B is upper bidiagonal;
*          = 'L':  B is lower bidiagonal.
*
*  N       (input) INTEGER
*          The order of the matrix B.  N >= 0.
*
*  NCVT    (input) INTEGER
*          The number of columns of the matrix VT. NCVT >= 0.
*
*  NRU     (input) INTEGER
*          The number of rows of the matrix U. NRU >= 0.
*
*  NCC     (input) INTEGER
*          The number of columns of the matrix C. NCC >= 0.
*
*  D       (input/output) REAL array, dimension (N)
*          On entry, the n diagonal elements of the bidiagonal matrix B.
*          On exit, if INFO=0, the singular values of B in decreasing
*          order.
*
*  E       (input/output) REAL array, dimension (N)
*          On entry, the elements of E contain the
*          offdiagonal elements of the bidiagonal matrix whose SVD
*          is desired. On normal exit (INFO = 0), E is destroyed.
*          If the algorithm does not converge (INFO > 0), D and E
*          will contain the diagonal and superdiagonal elements of a
*          bidiagonal matrix orthogonally equivalent to the one given
*          as input. E(N) is used for workspace.
*
*  VT      (input/output) REAL array, dimension (LDVT, NCVT)
*          On entry, an N-by-NCVT matrix VT.
*          On exit, VT is overwritten by P' * VT.
*          VT is not referenced if NCVT = 0.
*
*  LDVT    (input) INTEGER
*          The leading dimension of the array VT.
*          LDVT >= max(1,N) if NCVT > 0; LDVT >= 1 if NCVT = 0.
*
*  U       (input/output) REAL array, dimension (LDU, N)
*          On entry, an NRU-by-N matrix U.
*          On exit, U is overwritten by U * Q.
*          U is not referenced if NRU = 0.
*
*  LDU     (input) INTEGER
*          The leading dimension of the array U.  LDU >= max(1,NRU).
*
*  C       (input/output) REAL array, dimension (LDC, NCC)
*          On entry, an N-by-NCC matrix C.
*          On exit, C is overwritten by Q' * C.
*          C is not referenced if NCC = 0.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C.
*          LDC >= max(1,N) if NCC > 0; LDC >=1 if NCC = 0.
*
*  WORK    (workspace) REAL array, dimension
*            2*N  if only singular values wanted (NCVT = NRU = NCC = 0)
*            max( 1, 4*N-4 ) otherwise
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  If INFO = -i, the i-th argument had an illegal value
*          > 0:  the algorithm did not converge; D and E contain the
*                elements of a bidiagonal matrix which is orthogonally
*                similar to the input matrix B;  if INFO = i, i
*                elements of E have not converged to zero.
*
*  Internal Parameters
*  ===================
*
*  TOLMUL  REAL, default = max(10,min(100,EPS**(-1/8)))
*          TOLMUL controls the convergence criterion of the QR loop.
*          If it is positive, TOLMUL*EPS is the desired relative
*             precision in the computed singular values.
*          If it is negative, abs(TOLMUL*EPS*sigma_max) is the
*             desired absolute accuracy in the computed singular
*             values (corresponds to relative accuracy
*             abs(TOLMUL*EPS) in the largest singular value.
*          abs(TOLMUL) should be between 1 and 1/EPS, and preferably
*             between 10 (for fast convergence) and .1/EPS
*             (for there to be some accuracy in the results).
*          Default is to lose at either one eighth or 2 of the
*             available decimal digits in each computed singular value
*             (whichever is smaller).
*
*  MAXITR  INTEGER, default = 6
*          MAXITR controls the maximum number of passes of the
*          algorithm through its inner loop. The algorithms stops
*          (and so fails to converge) if the number of passes
*          through the inner loop exceeds MAXITR*N**2.
*
*  =====================================================================
*
*     .. Parameters ..
      REAL               ZERO
      PARAMETER          ( ZERO = 0.0E0 )
      REAL               ONE
      PARAMETER          ( ONE = 1.0E0 )
      REAL               NEGONE
      PARAMETER          ( NEGONE = -1.0E0 )
      REAL               HNDRTH
      PARAMETER          ( HNDRTH = 0.01E0 )
      REAL               TEN
      PARAMETER          ( TEN = 10.0E0 )
      REAL               HNDRD
      PARAMETER          ( HNDRD = 100.0E0 )
      REAL               MEIGTH
      PARAMETER          ( MEIGTH = -0.125E0 )
      INTEGER            MAXITR
      PARAMETER          ( MAXITR = 6 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ROTATE
      INTEGER            I, IDIR, IROT, ISUB, ITER, IUPLO, J, LL, LLL,
     $                   M, MAXIT, NM1, NM12, NM13, OLDLL, OLDM
      REAL               ABSE, ABSS, COSL, COSR, CS, EPS, F, G, H, MU,
     $                   OLDCS, OLDSN, R, SHIFT, SIGMN, SIGMX, SINL,
     $                   SINR, SLL, SMAX, SMIN, SMINL, SMINLO, SMINOA,
     $                   SN, THRESH, TOL, TOLMUL, UNFL
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      REAL               SLAMCH
      EXTERNAL           LSAME, SLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           SLARTG, SLAS2, SLASQ1, SLASR, SLASV2, SROT,
     $                   SSCAL, SSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, REAL, SIGN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IUPLO = 0
      IF( LSAME( UPLO, 'U' ) )
     $   IUPLO = 1
      IF( LSAME( UPLO, 'L' ) )
     $   IUPLO = 2
      IF( IUPLO.EQ.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NCVT.LT.0 ) THEN
         INFO = -3
      ELSE IF( NRU.LT.0 ) THEN
         INFO = -4
      ELSE IF( NCC.LT.0 ) THEN
         INFO = -5
      ELSE IF( ( NCVT.EQ.0 .AND. LDVT.LT.1 ) .OR.
     $         ( NCVT.GT.0 .AND. LDVT.LT.MAX( 1, N ) ) ) THEN
         INFO = -9
      ELSE IF( LDU.LT.MAX( 1, NRU ) ) THEN
         INFO = -11
      ELSE IF( ( NCC.EQ.0 .AND. LDC.LT.1 ) .OR.
     $         ( NCC.GT.0 .AND. LDC.LT.MAX( 1, N ) ) ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'SBDSQR', -INFO )
         RETURN
      END IF
      IF( N.EQ.0 )
     $   RETURN
      IF( N.EQ.1 )
     $   GO TO 150
*
*     ROTATE is true if any singular vectors desired, false otherwise
*
      ROTATE = ( NCVT.GT.0 ) .OR. ( NRU.GT.0 ) .OR. ( NCC.GT.0 )
*
*     If no singular vectors desired, use qd algorithm
*
      IF( .NOT.ROTATE ) THEN
         CALL SLASQ1( N, D, E, WORK, INFO )
         RETURN
      END IF
*
      NM1 = N - 1
      NM12 = NM1 + NM1
      NM13 = NM12 + NM1
*
*     Get machine constants
*
      EPS = SLAMCH( 'Epsilon' )
      UNFL = SLAMCH( 'Safe minimum' )
*
*     If matrix lower bidiagonal, rotate to be upper bidiagonal
*     by applying Givens rotations on the left
*
      IF( IUPLO.EQ.2 ) THEN
         DO 10 I = 1, N - 1
            CALL SLARTG( D( I ), E( I ), CS, SN, R )
            D( I ) = R
            E( I ) = SN*D( I+1 )
            D( I+1 ) = CS*D( I+1 )
            WORK( I ) = CS
            WORK( NM1+I ) = SN
   10    CONTINUE
*
*        Update singular vectors if desired
*
         IF( NRU.GT.0 )
     $      CALL SLASR( 'R', 'V', 'F', NRU, N, WORK( 1 ), WORK( N ), U,
     $                  LDU )
         IF( NCC.GT.0 )
     $      CALL SLASR( 'L', 'V', 'F', N, NCC, WORK( 1 ), WORK( N ), C,
     $                  LDC )
      END IF
*
*     Compute singular values to relative accuracy TOL
*     (By setting TOL to be negative, algorithm will compute
*     singular values to absolute accuracy ABS(TOL)*norm(input matrix))
*
      TOLMUL = MAX( TEN, MIN( HNDRD, EPS**MEIGTH ) )
      TOL = TOLMUL*EPS
*
*     Compute approximate maximum, minimum singular values
*
      SMAX = ABS( D( N ) )
      DO 20 I = 1, N - 1
         SMAX = MAX( SMAX, ABS( D( I ) ), ABS( E( I ) ) )
   20 CONTINUE
      SMINL = ZERO
      IF( TOL.GE.ZERO ) THEN
*
*        Relative accuracy desired
*
         SMINOA = ABS( D( 1 ) )
         IF( SMINOA.EQ.ZERO )
     $      GO TO 40
         MU = SMINOA
         DO 30 I = 2, N
            MU = ABS( D( I ) )*( MU / ( MU+ABS( E( I-1 ) ) ) )
            SMINOA = MIN( SMINOA, MU )
            IF( SMINOA.EQ.ZERO )
     $         GO TO 40
   30    CONTINUE
   40    CONTINUE
         SMINOA = SMINOA / SQRT( REAL( N ) )
         THRESH = MAX( TOL*SMINOA, MAXITR*N*N*UNFL )
      ELSE
*
*        Absolute accuracy desired
*
         THRESH = MAX( ABS( TOL )*SMAX, MAXITR*N*N*UNFL )
      END IF
*
*     Prepare for main iteration loop for the singular values
*     (MAXIT is the maximum number of passes through the inner
*     loop permitted before nonconvergence signalled.)
*
      MAXIT = MAXITR*N*N
      ITER = 0
      OLDLL = -1
      OLDM = -1
*
*     M points to last element of unconverged part of matrix
*
      M = N
*
*     Begin main iteration loop
*
   50 CONTINUE
*
*     Check for convergence or exceeding iteration count
*
      IF( M.LE.1 )
     $   GO TO 150
      IF( ITER.GT.MAXIT )
     $   GO TO 190
*
*     Find diagonal block of matrix to work on
*
      IF( TOL.LT.ZERO .AND. ABS( D( M ) ).LE.THRESH )
     $   D( M ) = ZERO
      SMAX = ABS( D( M ) )
      SMIN = SMAX
      DO 60 LLL = 1, M
         LL = M - LLL
         IF( LL.EQ.0 )
     $      GO TO 80
         ABSS = ABS( D( LL ) )
         ABSE = ABS( E( LL ) )
         IF( TOL.LT.ZERO .AND. ABSS.LE.THRESH )
     $      D( LL ) = ZERO
         IF( ABSE.LE.THRESH )
     $      GO TO 70
         SMIN = MIN( SMIN, ABSS )
         SMAX = MAX( SMAX, ABSS, ABSE )
   60 CONTINUE
   70 CONTINUE
      E( LL ) = ZERO
*
*     Matrix splits since E(LL) = 0
*
      IF( LL.EQ.M-1 ) THEN
*
*        Convergence of bottom singular value, return to top of loop
*
         M = M - 1
         GO TO 50
      END IF
   80 CONTINUE
      LL = LL + 1
*
*     E(LL) through E(M-1) are nonzero, E(LL-1) is zero
*
      IF( LL.EQ.M-1 ) THEN
*
*        2 by 2 block, handle separately
*
         CALL SLASV2( D( M-1 ), E( M-1 ), D( M ), SIGMN, SIGMX, SINR,
     $                COSR, SINL, COSL )
         D( M-1 ) = SIGMX
         E( M-1 ) = ZERO
         D( M ) = SIGMN
*
*        Compute singular vectors, if desired
*
         IF( NCVT.GT.0 )
     $      CALL SROT( NCVT, VT( M-1, 1 ), LDVT, VT( M, 1 ), LDVT, COSR,
     $                 SINR )
         IF( NRU.GT.0 )
     $      CALL SROT( NRU, U( 1, M-1 ), 1, U( 1, M ), 1, COSL, SINL )
         IF( NCC.GT.0 )
     $      CALL SROT( NCC, C( M-1, 1 ), LDC, C( M, 1 ), LDC, COSL,
     $                 SINL )
         M = M - 2
         GO TO 50
      END IF
*
*     If working on new submatrix, choose shift direction
*     (from larger end diagonal element towards smaller)
*
      IF( LL.GT.OLDM .OR. M.LT.OLDLL ) THEN
         IF( ABS( D( LL ) ).GE.ABS( D( M ) ) ) THEN
*
*           Chase bulge from top (big end) to bottom (small end)
*
            IDIR = 1
         ELSE
*
*           Chase bulge from bottom (big end) to top (small end)
*
            IDIR = 2
         END IF
      END IF
*
*     Apply convergence tests
*
      IF( IDIR.EQ.1 ) THEN
*
*        Run convergence test in forward direction
*        First apply standard test to bottom of matrix
*
         IF( ABS( E( M-1 ) ).LE.ABS( TOL )*ABS( D( M ) ) .OR.
     $       ( TOL.LT.ZERO .AND. ABS( E( M-1 ) ).LE.THRESH ) ) THEN
            E( M-1 ) = ZERO
            GO TO 50
         END IF
*
         IF( TOL.GE.ZERO ) THEN
*
*           If relative accuracy desired,
*           apply convergence criterion forward
*
            MU = ABS( D( LL ) )
            SMINL = MU
            DO 90 LLL = LL, M - 1
               IF( ABS( E( LLL ) ).LE.TOL*MU ) THEN
                  E( LLL ) = ZERO
                  GO TO 50
               END IF
               SMINLO = SMINL
               MU = ABS( D( LLL+1 ) )*( MU / ( MU+ABS( E( LLL ) ) ) )
               SMINL = MIN( SMINL, MU )
   90       CONTINUE
         END IF
*
      ELSE
*
*        Run convergence test in backward direction
*        First apply standard test to top of matrix
*
         IF( ABS( E( LL ) ).LE.ABS( TOL )*ABS( D( LL ) ) .OR.
     $       ( TOL.LT.ZERO .AND. ABS( E( LL ) ).LE.THRESH ) ) THEN
            E( LL ) = ZERO
            GO TO 50
         END IF
*
         IF( TOL.GE.ZERO ) THEN
*
*           If relative accuracy desired,
*           apply convergence criterion backward
*
            MU = ABS( D( M ) )
            SMINL = MU
            DO 100 LLL = M - 1, LL, -1
               IF( ABS( E( LLL ) ).LE.TOL*MU ) THEN
                  E( LLL ) = ZERO
                  GO TO 50
               END IF
               SMINLO = SMINL
               MU = ABS( D( LLL ) )*( MU / ( MU+ABS( E( LLL ) ) ) )
               SMINL = MIN( SMINL, MU )
  100       CONTINUE
         END IF
      END IF
      OLDLL = LL
      OLDM = M
*
*     Compute shift.  First, test if shifting would ruin relative
*     accuracy, and if so set the shift to zero.
*
      IF( TOL.GE.ZERO .AND. N*TOL*( SMINL / SMAX ).LE.
     $    MAX( EPS, HNDRTH*TOL ) ) THEN
*
*        Use a zero shift to avoid loss of relative accuracy
*
         SHIFT = ZERO
      ELSE
*
*        Compute the shift from 2-by-2 block at end of matrix
*
         IF( IDIR.EQ.1 ) THEN
            SLL = ABS( D( LL ) )
            CALL SLAS2( D( M-1 ), E( M-1 ), D( M ), SHIFT, R )
         ELSE
            SLL = ABS( D( M ) )
            CALL SLAS2( D( LL ), E( LL ), D( LL+1 ), SHIFT, R )
         END IF
*
*        Test if shift negligible, and if so set to zero
*
         IF( SLL.GT.ZERO ) THEN
            IF( ( SHIFT / SLL )**2.LT.EPS )
     $         SHIFT = ZERO
         END IF
      END IF
*
*     Increment iteration count
*
      ITER = ITER + M - LL
*
*     If SHIFT = 0, do simplified QR iteration
*
      IF( SHIFT.EQ.ZERO ) THEN
         IF( IDIR.EQ.1 ) THEN
*
*           Chase bulge from top to bottom
*           Save cosines and sines for later singular vector updates
*
            CS = ONE
            OLDCS = ONE
            CALL SLARTG( D( LL )*CS, E( LL ), CS, SN, R )
            CALL SLARTG( OLDCS*R, D( LL+1 )*SN, OLDCS, OLDSN, D( LL ) )
            WORK( 1 ) = CS
            WORK( 1+NM1 ) = SN
            WORK( 1+NM12 ) = OLDCS
            WORK( 1+NM13 ) = OLDSN
            IROT = 1
            DO 110 I = LL + 1, M - 1
               CALL SLARTG( D( I )*CS, E( I ), CS, SN, R )
               E( I-1 ) = OLDSN*R
               CALL SLARTG( OLDCS*R, D( I+1 )*SN, OLDCS, OLDSN, D( I ) )
               IROT = IROT + 1
               WORK( IROT ) = CS
               WORK( IROT+NM1 ) = SN
               WORK( IROT+NM12 ) = OLDCS
               WORK( IROT+NM13 ) = OLDSN
  110       CONTINUE
            H = D( M )*CS
            D( M ) = H*OLDCS
            E( M-1 ) = H*OLDSN
*
*           Update singular vectors
*
            IF( NCVT.GT.0 )
     $         CALL SLASR( 'L', 'V', 'F', M-LL+1, NCVT, WORK( 1 ),
     $                     WORK( N ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL SLASR( 'R', 'V', 'F', NRU, M-LL+1, WORK( NM12+1 ),
     $                     WORK( NM13+1 ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL SLASR( 'L', 'V', 'F', M-LL+1, NCC, WORK( NM12+1 ),
     $                     WORK( NM13+1 ), C( LL, 1 ), LDC )
*
*           Test convergence
*
            IF( ABS( E( M-1 ) ).LE.THRESH )
     $         E( M-1 ) = ZERO
*
         ELSE
*
*           Chase bulge from bottom to top
*           Save cosines and sines for later singular vector updates
*
            CS = ONE
            OLDCS = ONE
            CALL SLARTG( D( M )*CS, E( M-1 ), CS, SN, R )
            CALL SLARTG( OLDCS*R, D( M-1 )*SN, OLDCS, OLDSN, D( M ) )
            WORK( M-LL ) = CS
            WORK( M-LL+NM1 ) = -SN
            WORK( M-LL+NM12 ) = OLDCS
            WORK( M-LL+NM13 ) = -OLDSN
            IROT = M - LL
            DO 120 I = M - 1, LL + 1, -1
               CALL SLARTG( D( I )*CS, E( I-1 ), CS, SN, R )
               E( I ) = OLDSN*R
               CALL SLARTG( OLDCS*R, D( I-1 )*SN, OLDCS, OLDSN, D( I ) )
               IROT = IROT - 1
               WORK( IROT ) = CS
               WORK( IROT+NM1 ) = -SN
               WORK( IROT+NM12 ) = OLDCS
               WORK( IROT+NM13 ) = -OLDSN
  120       CONTINUE
            H = D( LL )*CS
            D( LL ) = H*OLDCS
            E( LL ) = H*OLDSN
*
*           Update singular vectors
*
            IF( NCVT.GT.0 )
     $         CALL SLASR( 'L', 'V', 'B', M-LL+1, NCVT, WORK( NM12+1 ),
     $                     WORK( NM13+1 ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL SLASR( 'R', 'V', 'B', NRU, M-LL+1, WORK( 1 ),
     $                     WORK( N ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL SLASR( 'L', 'V', 'B', M-LL+1, NCC, WORK( 1 ),
     $                     WORK( N ), C( LL, 1 ), LDC )
*
*           Test convergence
*
            IF( ABS( E( LL ) ).LE.THRESH )
     $         E( LL ) = ZERO
         END IF
      ELSE
*
*        Use nonzero shift
*
         IF( IDIR.EQ.1 ) THEN
*
*           Chase bulge from top to bottom
*           Save cosines and sines for later singular vector updates
*
            F = ( ABS( D( LL ) )-SHIFT )*
     $          ( SIGN( ONE, D( LL ) )+SHIFT / D( LL ) )
            G = E( LL )
            CALL SLARTG( F, G, COSR, SINR, R )
            F = COSR*D( LL ) + SINR*E( LL )
            E( LL ) = COSR*E( LL ) - SINR*D( LL )
            G = SINR*D( LL+1 )
            D( LL+1 ) = COSR*D( LL+1 )
            CALL SLARTG( F, G, COSL, SINL, R )
            D( LL ) = R
            F = COSL*E( LL ) + SINL*D( LL+1 )
            D( LL+1 ) = COSL*D( LL+1 ) - SINL*E( LL )
            G = SINL*E( LL+1 )
            E( LL+1 ) = COSL*E( LL+1 )
            WORK( 1 ) = COSR
            WORK( 1+NM1 ) = SINR
            WORK( 1+NM12 ) = COSL
            WORK( 1+NM13 ) = SINL
            IROT = 1
            DO 130 I = LL + 1, M - 2
               CALL SLARTG( F, G, COSR, SINR, R )
               E( I-1 ) = R
               F = COSR*D( I ) + SINR*E( I )
               E( I ) = COSR*E( I ) - SINR*D( I )
               G = SINR*D( I+1 )
               D( I+1 ) = COSR*D( I+1 )
               CALL SLARTG( F, G, COSL, SINL, R )
               D( I ) = R
               F = COSL*E( I ) + SINL*D( I+1 )
               D( I+1 ) = COSL*D( I+1 ) - SINL*E( I )
               G = SINL*E( I+1 )
               E( I+1 ) = COSL*E( I+1 )
               IROT = IROT + 1
               WORK( IROT ) = COSR
               WORK( IROT+NM1 ) = SINR
               WORK( IROT+NM12 ) = COSL
               WORK( IROT+NM13 ) = SINL
  130       CONTINUE
            CALL SLARTG( F, G, COSR, SINR, R )
            E( M-2 ) = R
            F = COSR*D( M-1 ) + SINR*E( M-1 )
            E( M-1 ) = COSR*E( M-1 ) - SINR*D( M-1 )
            G = SINR*D( M )
            D( M ) = COSR*D( M )
            CALL SLARTG( F, G, COSL, SINL, R )
            D( M-1 ) = R
            F = COSL*E( M-1 ) + SINL*D( M )
            D( M ) = COSL*D( M ) - SINL*E( M-1 )
            IROT = IROT + 1
            WORK( IROT ) = COSR
            WORK( IROT+NM1 ) = SINR
            WORK( IROT+NM12 ) = COSL
            WORK( IROT+NM13 ) = SINL
            E( M-1 ) = F
*
*           Update singular vectors
*
            IF( NCVT.GT.0 )
     $         CALL SLASR( 'L', 'V', 'F', M-LL+1, NCVT, WORK( 1 ),
     $                     WORK( N ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL SLASR( 'R', 'V', 'F', NRU, M-LL+1, WORK( NM12+1 ),
     $                     WORK( NM13+1 ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL SLASR( 'L', 'V', 'F', M-LL+1, NCC, WORK( NM12+1 ),
     $                     WORK( NM13+1 ), C( LL, 1 ), LDC )
*
*           Test convergence
*
            IF( ABS( E( M-1 ) ).LE.THRESH )
     $         E( M-1 ) = ZERO
*
         ELSE
*
*           Chase bulge from bottom to top
*           Save cosines and sines for later singular vector updates
*
            F = ( ABS( D( M ) )-SHIFT )*( SIGN( ONE, D( M ) )+SHIFT /
     $          D( M ) )
            G = E( M-1 )
            CALL SLARTG( F, G, COSR, SINR, R )
            F = COSR*D( M ) + SINR*E( M-1 )
            E( M-1 ) = COSR*E( M-1 ) - SINR*D( M )
            G = SINR*D( M-1 )
            D( M-1 ) = COSR*D( M-1 )
            CALL SLARTG( F, G, COSL, SINL, R )
            D( M ) = R
            F = COSL*E( M-1 ) + SINL*D( M-1 )
            D( M-1 ) = COSL*D( M-1 ) - SINL*E( M-1 )
            G = SINL*E( M-2 )
            E( M-2 ) = COSL*E( M-2 )
            WORK( M-LL ) = COSR
            WORK( M-LL+NM1 ) = -SINR
            WORK( M-LL+NM12 ) = COSL
            WORK( M-LL+NM13 ) = -SINL
            IROT = M - LL
            DO 140 I = M - 1, LL + 2, -1
               CALL SLARTG( F, G, COSR, SINR, R )
               E( I ) = R
               F = COSR*D( I ) + SINR*E( I-1 )
               E( I-1 ) = COSR*E( I-1 ) - SINR*D( I )
               G = SINR*D( I-1 )
               D( I-1 ) = COSR*D( I-1 )
               CALL SLARTG( F, G, COSL, SINL, R )
               D( I ) = R
               F = COSL*E( I-1 ) + SINL*D( I-1 )
               D( I-1 ) = COSL*D( I-1 ) - SINL*E( I-1 )
               G = SINL*E( I-2 )
               E( I-2 ) = COSL*E( I-2 )
               IROT = IROT - 1
               WORK( IROT ) = COSR
               WORK( IROT+NM1 ) = -SINR
               WORK( IROT+NM12 ) = COSL
               WORK( IROT+NM13 ) = -SINL
  140       CONTINUE
            CALL SLARTG( F, G, COSR, SINR, R )
            E( LL+1 ) = R
            F = COSR*D( LL+1 ) + SINR*E( LL )
            E( LL ) = COSR*E( LL ) - SINR*D( LL+1 )
            G = SINR*D( LL )
            D( LL ) = COSR*D( LL )
            CALL SLARTG( F, G, COSL, SINL, R )
            D( LL+1 ) = R
            F = COSL*E( LL ) + SINL*D( LL )
            D( LL ) = COSL*D( LL ) - SINL*E( LL )
            IROT = IROT - 1
            WORK( IROT ) = COSR
            WORK( IROT+NM1 ) = -SINR
            WORK( IROT+NM12 ) = COSL
            WORK( IROT+NM13 ) = -SINL
            E( LL ) = F
*
*           Test convergence
*
            IF( ABS( E( LL ) ).LE.THRESH )
     $         E( LL ) = ZERO
*
*           Update singular vectors if desired
*
            IF( NCVT.GT.0 )
     $         CALL SLASR( 'L', 'V', 'B', M-LL+1, NCVT, WORK( NM12+1 ),
     $                     WORK( NM13+1 ), VT( LL, 1 ), LDVT )
            IF( NRU.GT.0 )
     $         CALL SLASR( 'R', 'V', 'B', NRU, M-LL+1, WORK( 1 ),
     $                     WORK( N ), U( 1, LL ), LDU )
            IF( NCC.GT.0 )
     $         CALL SLASR( 'L', 'V', 'B', M-LL+1, NCC, WORK( 1 ),
     $                     WORK( N ), C( LL, 1 ), LDC )
         END IF
      END IF
*
*     QR iteration finished, go back and check convergence
*
      GO TO 50
*
*     All singular values converged, so make them positive
*
  150 CONTINUE
      DO 160 I = 1, N
         IF( D( I ).LT.ZERO ) THEN
            D( I ) = -D( I )
*
*           Change sign of singular vectors, if desired
*
            IF( NCVT.GT.0 )
     $         CALL SSCAL( NCVT, NEGONE, VT( I, 1 ), LDVT )
         END IF
  160 CONTINUE
*
*     Sort the singular values into decreasing order (insertion sort on
*     singular values, but only one transposition per singular vector)
*
      DO 180 I = 1, N - 1
*
*        Scan for smallest D(I)
*
         ISUB = 1
         SMIN = D( 1 )
         DO 170 J = 2, N + 1 - I
            IF( D( J ).LE.SMIN ) THEN
               ISUB = J
               SMIN = D( J )
            END IF
  170    CONTINUE
         IF( ISUB.NE.N+1-I ) THEN
*
*           Swap singular values and vectors
*
            D( ISUB ) = D( N+1-I )
            D( N+1-I ) = SMIN
            IF( NCVT.GT.0 )
     $         CALL SSWAP( NCVT, VT( ISUB, 1 ), LDVT, VT( N+1-I, 1 ),
     $                     LDVT )
            IF( NRU.GT.0 )
     $         CALL SSWAP( NRU, U( 1, ISUB ), 1, U( 1, N+1-I ), 1 )
            IF( NCC.GT.0 )
     $         CALL SSWAP( NCC, C( ISUB, 1 ), LDC, C( N+1-I, 1 ), LDC )
         END IF
  180 CONTINUE
      GO TO 210
*
*     Maximum number of iterations exceeded, failure to converge
*
  190 CONTINUE
      INFO = 0
      DO 200 I = 1, N - 1
         IF( E( I ).NE.ZERO )
     $      INFO = INFO + 1
  200 CONTINUE
  210 CONTINUE
      RETURN
*
*     End of SBDSQR
*
      END

!
!     $Id$
!
! TBD:  error handling
! TBD:  for the lists: use linked lists instead of arrays
!
Module results_to_vo
  !
  Use pako_xml
  !
  Implicit None
  Save
  Private
  !
  ! *** Subroutines:
  !
  Public   ::  results_to_VO_writeProlog
  Public   ::  results_to_VO_setOdpHeader
  Public   ::  results_to_VO_writeOdpHeader
  Public   ::  results_to_VO_setMeasurementHeader
  Public   ::  results_to_VO_setScanId
  Public   ::  results_to_VO_writeMeasurementHeader
  Public   ::  results_to_VO_setReceiver
  Public   ::  results_to_VO_writeReceivers
  Public   ::  results_to_VO_setBackend
  Public   ::  results_to_VO_writeBackends
  Public   ::  results_to_VO_setFocusResults
  Public   ::  results_to_VO_writeFocusResults
  Public   ::  results_to_VO_setPointingResults
  Public   ::  results_to_VO_writePointingResults
  Public   ::  results_to_VO_setCalibrationResults
  Public   ::  results_to_VO_writeCalibrationResults
  Public   ::  results_to_VO_writeMeasurementEnd
  Public   ::  results_to_VO_writeEnd
  !
  ! *** Derived Types:
  !
  Public   ::  resultT
  !
  ! *** values representing "not set":
  !
  Character(len=8), Parameter  :: cNone = 'none'
  Integer,          Parameter  :: iNone = 0
  Real,             Parameter  :: rNone = 0.0
  Real*8,           Parameter  :: dNone = 0.0D0
  ! TBD: lNone = .False.
  !
  !
  ! *** for ODP Header in XML file:
  !
  Type     ::  odpHeaderT
     Character(len=128) ::  telescope   = cNone
     Character(len=128) ::  observatory = cNone
     Character(len=128) ::  odpSoftware = cNone
     ! ...
  End Type odpHeaderT
  Type(odpHeaderT)      ::  odpHeader, odpHeaderDefault
  !
  ! *** for "measurement Header in XML file:
  !
  ! first: list of scanID or scan numbers
  !
  Type :: scanIdT
     Character(len=24)  :: scanId              = cNone
     Integer            :: scanN               = iNone
  End Type scanIdT
  Integer, Parameter    :: nDimScans           = 99
  Integer               :: nScans              = 0
  Type(scanIdT), Dimension(nDimScans) :: scans
  Type(scanIdT)                       :: scanDefault
  !
  Type     ::  measurementHeaderT
     Character(len=128) :: measurement         =  cNone
     Character(len=128) :: sourceName          =  cNone
     Character(len=128) :: timeStamp           =  cNone
     Real               :: azimuth             =  rNone
     Real               :: elevation           =  rNone
     Real               :: refraction          =  rNone
     Real               :: pressureAmbient     =  rNone
     Real               :: temperatureAmbient  =  rNone
     Real               :: humidityAmbient     =  rNone
     Logical            :: lAzimuth            = .False.
     Logical            :: lElevation          = .False.
     Logical            :: lRefraction         = .False.
     Logical            :: lPressureAmbient    = .False.
     Logical            :: lTemperatureAmbient = .False.
     Logical            :: lHumidityAmbient    = .False.
     Character(len=128) :: switchingMode       =  cNone
     Character(len=128) :: observingMode       =  cNone
     Character(len=128) :: method              =  cNone
     Character(len=128) :: focusDirection      =  cNone
     Real               :: focusLength         =  rNone
     Real               :: focusCurrent        =  rNone
     Logical            :: lFocusLength        = .False.
     Logical            :: lFocusCurrent       = .False.
     Real               :: pointingLength      =  rNone
     Real               :: pointingP1          =  rNone
     Real               :: pointingP2          =  rNone
     Real               :: pointingP7          =  rNone
     Logical            :: lPointingLength     = .False.
     Logical            :: lPointingP1         = .False.
     Logical            :: lPointingP2         = .False.
     Logical            :: lPointingP7         = .False.
     ! ...
  End Type measurementHeaderT
  Type(measurementHeaderT) ::  mHead
  Type(measurementHeaderT) ::  mHeadDefault
  !
  ! *** list of receivers
  !      consistent with paKo --> some extra variables
  !
  Type :: receiverFrequency
     Character(len=12)       :: name           = cNone
     Character(len=12)       :: kind           = cNone
     Character(len=12)       :: unit           = cNone
     Character(len=12)       :: doppler        = cNone
     Real*8                  :: value          = dNone
  End Type receiverFrequency
  !
  Type :: gainRatio
     Character(len=12)       :: name           = cNone
     Character(len=12)       :: kind           = cNone
     Character(len=12)       :: unit           = cNone
     Real*4                  :: value          = dNone
     Real*4                  :: db             = dNone
  End Type gainRatio
  !
  Type :: varReceiverT
     !
     Character(len=13)       :: name           = cNone
     Logical                 :: isConnected    = .False.
     Logical                 :: gunnOn         = .False.
     Type(receiverFrequency) :: frequency
     Type(receiverFrequency) :: frequencyImage
     Type(receiverFrequency) :: offset
     Type(receiverFrequency) :: centerIF
     !
     Character(len=100)      :: lineName       = cNone
     !
     Character(len=12)       :: sideBand       = cNone
     Character(len=12)       :: doppler        = cNone
     Character(len=12)       :: width          = cNone
     !
     Real*4                  :: effForward     = rNone
     Real*4                  :: effBeam        = rNone
     Character(len=12)       :: scale          = cNone
     Type(gainRatio)         :: gainImage
     Real*4                  :: tempAmbient    = rNone
     Real*4                  :: tempCold       = rNone
     Real*4                  :: xOffsetNasmyth = rNone
     Real*4                  :: yOffsetNasmyth = rNone
     Real*4                  :: lcalof         = rNone
     Real*4                  :: bcalof         = rNone
     Real*4                  :: h2omm          = rNone
     Real*4                  :: trx            = rNone
     Real*4                  :: tsys           = rNone
     Real*4                  :: tcal           = rNone
     Real*4                  :: tatms          = rNone
     Real*4                  :: tatmi          = rNone
     Real*4                  :: tauzen         = rNone
     Real*4                  :: tauzenImage    = rNone
     Real*4                  :: pcold          = rNone
     Real*4                  :: phot           = rNone
     Real*4                  :: psky           = rNone
     !
     Integer                 :: iPixel         = iNone
     !
  End Type varReceiverT
  !
  Integer, Parameter :: nDimReceivers  = 18
  Integer            :: nRec           = 0
  integer            :: ncal           = 0
  Type(varReceiverT) :: receiverDefault  ! Default instance for this type
  Type(varReceiverT) :: receivers(nDimReceivers)   ! Support for setReceiver and writeReceivers
  Type(varReceiverT) :: calresults(nDimReceivers)  ! Support for setCalibrationResults and writeCalibrationResults
  !
  ! *** list of backends
  !      consistent with paKo --> some extra variables
  !
  Type :: varBackendT
     !
     Character(len=12)       :: name           = cNone
     Logical                 :: wasConnected   = .False.
     Logical                 :: isConnected    = .False.
     Integer                 :: nPart          = iNone
     !
     Real*4                  :: resolution     = rNone
     Real*4                  :: bandWidth      = rNone
     Real*4                  :: fShift         = rNone
     !
     Character(len=13)       :: receiverName   = cNone
     !
     Integer                 :: nChannels      = iNone
     !
  End Type varBackendT
  !
  Integer, Parameter         :: nDimBackends   = 99
  Integer                    :: nBack          = 0
  Type(varBackendT), Dimension(nDimBackends)   :: backends
  Type(varBackendT)                            :: backendDefault
  !
  ! *** list of pointing results
  !
  ! most results have a value and an error:
  !
  Type :: resultT
     Real*4                  :: value          = rNone
     Real*4                  :: error          = rNone
  End Type resultT
  !
  Type :: focusResultsT
     Character(len=12)       :: backendName    = cNone
     Integer                 :: backendPart    = iNone
     Type(resultT)           :: focus
     Type(resultT)           :: offset
     Real*4                  :: rmsResidual    = rNone
  End Type focusResultsT
  !
  Integer, Parameter         :: nDimResults      = 99
  Integer                    :: nFocusResults = 0
  Type(focusResultsT), Dimension(nDimResults) :: FocusResults
  Type(focusResultsT)                         :: FocusResultDefault
  !
  Type :: pointingResultsT
     Character(len=12)       :: backendName    = cNone
     Integer                 :: backendPart    = iNone
     character(len=8)        :: recName        = cNone
     Real*4                  :: direction      = rNone
     Type(resultT)           :: correction
     Type(resultT)           :: peak
     Type(resultT)           :: integral
     Type(resultT)           :: offset
     Type(resultT)           :: width
     Real*4                  :: rmsResidual    = rNone
  End Type pointingResultsT
  !
!!$  Integer, Parameter         :: nDimResults      = 99
  Integer                    :: nPointingResults = 0
  Type(pointingResultsT), Dimension(nDimResults) :: PointingResults
  Type(pointingResultsT)                         :: PointingResultDefault
  !
Contains
!!!
!!!
  Subroutine results_to_VO_writeProlog(                             &
       &                                       error,             &
       &                                       errorC             &
       &                            )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Character(len=256) :: c1,c2
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    c1 = ".xml file generated by results_to_vo.f90 (author: Hans Ungerechts)"
    call gag_release(c2)
    !
    Call pakoXMLwriteStartXML("1.0",                              &
                              "VOTABLE", "VOTable.dtd", "1.0",    &
                              comment1=c1,                        &
                              comment2=c2,                        &
                              error=errorXML)
    !
    If (Present(error) .And. errorXML) then
      error=errorXML
      return
    endif
    !
  End Subroutine results_to_VO_writeProlog
!!!
!!!
  Subroutine results_to_VO_setOdpHeader(                            &
       &                                       telescope        , &
       &                                       observatory      , &
       &                                       odpSoftware      , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                             )
    !
    Character(len=*), Intent(IN), Optional  :: telescope
    Character(len=*), Intent(IN), Optional  :: observatory
    Character(len=*), Intent(IN), Optional  :: odpSoftware
    !
    Logical         , Intent(IN), Optional  :: default            ! set default values
    Logical         , Intent(IN), Optional  :: reset              ! re-set values to undefined
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       odpHeader = odpHeaderDefault
    End If
    !
    If (Present(reset).And.reset) Then
       odpHeader = odpHeaderDefault
    End If
    !
    If (Present(telescope))   odpHeader%telescope   = telescope
    If (Present(observatory)) odpHeader%observatory = observatory
    If (Present(odpSoftware)) odpHeader%odpSoftware = odpSoftware
    !
    Return
    !
  End Subroutine results_to_VO_setOdpHeader
!!!
!!!
  Subroutine results_to_VO_writeOdpHeader(                          &
       &                                       error,             &
       &                                       errorC             &
       &                               )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'odpHeader',                    &
         &              error   = errorXML)
    !
    If (odpHeader%telescope.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'telescope',                 &
            &              value   = odpHeader%telescope,         &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (odpHeader%observatory.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'observatory',               &
            &              value   = odpHeader%observatory,       &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (odpHeader%odpSoftware.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'odpSoftware',               &
            &              value   = odpHeader%odpSoftware,       &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'RESOURCE',                     &
         &              name    = 'odpHeader',                    &
         &              error   = errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeOdpHeader
!!!
!!!
  Subroutine results_to_VO_setMeasurementHeader(                     &
       &                                       measurement       , &
       &                                       sourceName        , &
       &                                       timeStamp         , &
       &                                       azimuth           , &
       &                                       elevation         , &
       &                                       refraction        , &
       &                                       pressureAmbient   , &
       &                                       temperatureAmbient, &
       &                                       humidityAmbient   , &
       &                                       switchingMode     , &
       &                                       observingMode     , &
       &                                       method            , &
       &                                       focusDirection    , &
       &                                       focusLength       , &
       &                                       focusCurrent      , &
       &                                       pointingLength    , &
       &                                       pointingP1        , &
       &                                       pointingP2        , &
       &                                       pointingP7        , &
       &                                       default           , &
       &                                       reset             , &
       &                                       error             , &
       &                                       errorC              &
       &                                     )
    !
    Character(len=*), Intent(IN), Optional  :: measurement
    Character(len=*), Intent(IN), Optional  :: sourceName
    Character(len=*), Intent(IN), Optional  :: timeStamp
    Real            , Intent(IN), Optional  :: azimuth
    Real            , Intent(IN), Optional  :: elevation
    Real            , Intent(IN), Optional  :: refraction
    Real            , Intent(IN), Optional  :: pressureAmbient
    Real            , Intent(IN), Optional  :: temperatureAmbient
    Real            , Intent(IN), Optional  :: humidityAmbient
    Character(len=*), Intent(IN), Optional  :: switchingMode
    Character(len=*), Intent(IN), Optional  :: observingMode
    Character(len=*), Intent(IN), Optional  :: method
    Character(len=*), Intent(IN), Optional  :: focusDirection
    Real            , Intent(IN), Optional  :: focusLength
    Real            , Intent(IN), Optional  :: focusCurrent
    Real            , Intent(IN), Optional  :: pointingLength
    Real            , Intent(IN), Optional  :: pointingP1
    Real            , Intent(IN), Optional  :: pointingP2
    Real            , Intent(IN), Optional  :: pointingP7
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       mHead = mHeadDefault
    End If
    !
    If (Present(reset).And.reset) Then
       mHead = mHeadDefault
    End If
    !
    If (Present(measurement )) mHead%measurement = measurement
    If (Present(sourceName  )) mHead%sourceName  = sourceName
    If (Present(timeStamp   )) mHead%timeStamp   = timeStamp
    If (Present(azimuth     )) mHead%azimuth     = azimuth
    !
    If (Present(azimuth           )) Then
       mHead%azimuth            = azimuth
       mHead%lAzimuth           = .True.
    End If
    !
    If (Present(elevation         )) Then
       mHead%elevation          = elevation
       mHead%lElevation         = .True.
    End If
    !
    If (Present(refraction        )) Then
       mHead%refraction         = refraction
       mHead%lRefraction        = .True.
    End If
    !
    If (Present(pressureAmbient   )) Then
       mHead%pressureAmbient    = pressureAmbient
       mHead%lPressureAmbient   = .True.
    End If
    !
    If (Present(temperatureAmbient)) Then
       mHead%temperatureAmbient = temperatureAmbient
       mHead%lTemperatureAmbient= .True.
    End If
    !
    If (Present(humidityAmbient   )) Then
       mHead%humidityAmbient    = humidityAmbient
       mHead%lHumidityAmbient   = .True.
    End If
    !
    If (Present(switchingMode)) mHead%switchingMode = trim(switchingMode)
    If (Present(observingMode)) mHead%observingMode = observingMode
    If (Present(method       )) mHead%method        = method
    !
    If (Present(focusDirection)) mHead%focusDirection = focusDirection
!
    If (Present(focusLength    )) Then
       mHead%focusLength     = focusLength
       mHead%lFocusLength    = .True.
    End If
    !
    If (Present(focusCurrent    )) Then
       mHead%focusCurrent     = focusCurrent
       mHead%lFocusCurrent    = .True.
    End If
    !
    If (Present(pointingLength    )) Then
       mHead%pointingLength     = pointingLength
       mHead%lPointingLength    = .True.
    End If
    !
    If (Present(pointingP1        )) Then
       mHead%pointingP1         = pointingP1
       mHead%lPointingP1        = .True.
    End If
    !
    If (Present(pointingP2        )) Then
       mHead%pointingP2         = pointingP2
       mHead%lPointingP2        = .True.
    End If
    !
    If (Present(pointingP7        )) Then
       mHead%pointingP7         = pointingP7
       mHead%lPointingP7        = .True.
    End If
    !
    Return
    !
  End Subroutine results_to_VO_setMeasurementHeader
!!!
!!!
  Subroutine results_to_VO_setScanId(                               &
       &                                       scanId           , &
       &                                       scanN            , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                          )
    !
    Character(len=*), Intent(IN), Optional  :: scanId
    Integer         , Intent(IN), Optional  :: scanN
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nScans = 0
       scans(:) = scanDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nScans = 0
       scans(:) = scanDefault
    End If
    !
    If ((Present(scanId).Or.Present(scanN)) .And. nScans.Lt.nDimScans) Then
       nScans = nScans+1
    End If
    !
    ! TBD: could do a consistency check to ensure that ther is no
    !      "mixed" scan list, i.e., shoud be all Ids OR numbers!
    !
    If (Present(scanId))      scans(nScans)%scanId = scanId
    If (Present(scanN))       scans(nScans)%scanN  = scanN
    !
    Return
    !
  End Subroutine results_to_VO_setScanId
!!!
!!!
  Subroutine results_to_VO_writeMeasurementHeader(                  &
       &                                       error,             &
       &                                       errorC             &
       &                                       )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurement',                  &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurementHeader',            &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    If (mHead%measurement.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'measurement',               &
            &              value   = mHead%measurement,           &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%sourceName.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'sourceName',                &
            &              value   = mHead%sourceName,            &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    ! TBD: timeStamp could be generated internally
    !
    If (mHead%timeStamp.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'timeStamp',                 &
            &              value   = mHead%timeStamp,             &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%lAzimuth) Then
       Write (valueC,*) mHead%azimuth
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'azimuth',                  &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'deg',                      &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lElevation) Then
       Write (valueC,*) mHead%elevation
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'elevation',                &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'deg',                      &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lRefraction) Then
       Write (valueC,*) mHead%refraction
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'refraction',               &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'arcsec',                   &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lTemperatureAmbient) Then
       Write (valueC,*) mHead%temperatureAmbient
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'temperatureAmbient',       &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = 'K',                        &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lPressureAmbient) Then
       Write (valueC,*) mHead%pressureAmbient
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'pressureAmbient',          &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = '10+2Pa',                   &
            &              error    =  errorXML)
    End If
    !
    If (mHead%lHumidityAmbient) Then
       Write (valueC,*) mHead%humidityAmbient
       Call  pakoXMLwriteElement(                                 &
            &              element  = 'PARAM',                    &
            &              name     = 'humidityAmbient',          &
            &              value    =  valueC,                    &
            &              dataType = 'double',                   &
            &              unit     = '%',                        &
            &              error    =  errorXML)
    End If
    !
    If (mHead%switchingMode.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'switchingMode',             &
            &              value   = mHead%switchingMode,         &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%observingMode.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'observingMode',             &
            &              value   = mHead%observingMode,         &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    !
    If (mHead%method.Ne.cNone) Then
       Call  pakoXMLwriteElement(                                 &
            &              element = 'PARAM',                     &
            &              name    = 'method',                    &
            &              value   = mHead%method,                &
            &              dataType = 'char',                     &
            &              error   = errorXML)
    End If
    ! ***
    !
    ! TBD: parameters for specific mesurements, depending on
    !      "measurement" and "observingMode"
    !
    valueC = mHead%measurement
    Call pakoXMLupper(valueC)
    !
    If (valueC.Eq.'FOCUS') Then                                   ! parameters for FOCUS
       !
       If (mHead%focusDirection.Ne.cNone) Then
          Call  pakoXMLwriteElement(                              &
               &              element = 'PARAM',                  &
               &              name    = 'focusDirection',         &
               &              value   = mHead%focusDirection,     &
               &              dataType = 'char',                  &
               &              error   = errorXML)
       End If
       !
       If (mHead%lFocusLength) Then
          Write (valueC,*) mHead%focusLength
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'focusLength',           &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'mm',                    &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lFocusCurrent) Then
          Write (valueC,*) mHead%focusCurrent
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'focusCurrent',          &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'mm',                    &
               &              error    =  errorXML)
       End If
       !
    End If                                                        ! end of Focus
    ! ***
    !
    If (valueC.Eq.'POINTING') Then                                ! parameters for POINTING
       !
       If (mHead%lPointingLength) Then
          Write (valueC,*) mHead%pointingLength
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingLength',        &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'arcsec',                &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lPointingP1) Then
          Write (valueC,*) mHead%pointingP1
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingP1',            &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'deg',                   &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lPointingP2) Then
          Write (valueC,*) mHead%pointingP2
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingP2',            &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'deg',                   &
               &              error    =  errorXML)
       End If
       !
       If (mHead%lPointingP7) Then
          Write (valueC,*) mHead%pointingP7
          Call  pakoXMLwriteElement(                              &
               &              element  = 'PARAM',                 &
               &              name     = 'pointingP7',            &
               &              value    =  valueC,                 &
               &              dataType = 'double',                &
               &              unit     = 'deg',                   &
               &              error    =  errorXML)
       End If
       !
    End If                                                        ! end of Pointing
    ! ***
    !
    Call pakoXMLwriteStartElement("RESOURCE","scanList",          &
         &                         error=errorXML)
       !
    Call pakoXMLwriteStartElement("TABLE","scanList",             &
         &                         error=errorXML)
    !
    If (scans(1)%scanId .Ne. cNone) then
       Call pakoXMLwriteElement("FIELD","scanId",                 &
            &                         dataType="char",            &
            &                         error=errorXML)
    End If
    !
    If (scans(1)%scanN .Ne. iNone) Then
       Call pakoXMLwriteElement("FIELD","scanNumber",             &
            &                         dataType="int",             &
            &                         error=errorXML)
    End If
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    ! **
    Do ii = 1,nScans,1
       !
       Call pakoXMLwriteStartElement("TR",                        &
            &                         error=errorXML)
       !
       If (scans(ii)%scanId .Ne. cNone) then
          valueC = scans(ii)%scanId
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
       End If
       !
       If (scans(ii)%scanN .Ne. iNone) then
          Write (valueC,*)                                        &
               &                  scans(ii)%scanN
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
       End If
       !
       Call pakoXMLwriteEndElement("TR",                          &
            &                         error=errorXML)
       !
    End Do
    ! **
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","scanList",             &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","scanList",          &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurementHeader',            &
         &              error   = errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeMeasurementHeader
!!!
!!!
  Subroutine results_to_VO_writeMeasurementEnd(                     &
       &                                       error,             &
       &                                       errorC             &
       &                                    )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'RESOURCE',                     &
         &              name    = 'measurement',                  &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeMeasurementEnd
!!!
!!!
  Subroutine results_to_VO_setReceiver(                             &
       &                                       name             , &
       &                                       frequency        , &
       &                                       frequencyImage   , &
       &                                       offset           , &
       &                                       centerIF         , &
       &                                       lineName         , &
       &                                       sideBand         , &
       &                                       doppler          , &
       &                                       width            , &
       &                                       effForward       , &
       &                                       effBeam          , &
       &                                       scale            , &
       &                                       gainImage        , &
       &                                       tempAmbient      , &
       &                                       tempCold         , &
       &                                       xOffsetNasmyth   , &
       &                                       yOffsetNasmyth   , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                            )
    !
    Character(len=*), Intent(IN), Optional  :: name
    Real*8          , Intent(IN), Optional  :: frequency
    Real*8          , Intent(IN), Optional  :: frequencyImage
    Real*8          , Intent(IN), Optional  :: offset
    Real*8          , Intent(IN), Optional  :: centerIF
    Character(len=*), Intent(IN), Optional  :: lineName
    Character(len=*), Intent(IN), Optional  :: sideBand
    Character(len=*), Intent(IN), Optional  :: doppler
    Character(len=*), Intent(IN), Optional  :: width
    Real            , Intent(IN), Optional  :: effForward
    Real            , Intent(IN), Optional  :: effBeam
    Character(len=*), Intent(IN), Optional  :: scale
    Real            , Intent(IN), Optional  :: gainImage
    Real            , Intent(IN), Optional  :: tempAmbient
    Real            , Intent(IN), Optional  :: tempCold
    !
    Real            , Intent(IN), Optional  :: xOffsetNasmyth
    Real            , Intent(IN), Optional  :: yOffsetNasmyth
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nRec = 0
       receivers(:) = receiverDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nRec = 0
       receivers(:) = receiverDefault
    End If
    !
    If (Present(name) .And. nRec.Lt.nDimReceivers) Then
       nRec = nRec+1
       receivers(nRec)%name        = name
       receivers(nRec)%isConnected = .True.
    End If
    !
    If (Present(frequency))      receivers(nRec)%frequency%value      = frequency
    If (Present(frequencyImage)) receivers(nRec)%frequencyImage%value = frequencyImage
    If (Present(offset))         receivers(nRec)%offset%value         = offset
    If (Present(centerIF))       receivers(nRec)%centerIF%value       = centerIF
    If (Present(lineName))       receivers(nRec)%lineName             = lineName
    If (Present(sideBand))       receivers(nRec)%sideBand             = sideBand
    If (Present(doppler))        receivers(nRec)%doppler              = doppler
    If (Present(width))          receivers(nRec)%width                = width
    If (Present(effForward))     receivers(nRec)%effForward           = effForward
    If (Present(effBeam))        receivers(nRec)%effBeam              = effBeam
    If (Present(scale))          receivers(nRec)%scale                = scale
    If (Present(gainImage))      receivers(nRec)%gainImage%value      = gainImage
    If (Present(tempAmbient))    receivers(nRec)%tempAmbient          = tempAmbient
    If (Present(tempCold))       receivers(nRec)%tempCold             = tempCold
    If (Present(xOffsetNasmyth)) receivers(nRec)%xOffsetNasmyth       = xOffsetNasmyth
    If (Present(yOffsetNasmyth)) receivers(nRec)%yOffsetNasmyth       = yOffsetNasmyth
    !
    Return
    !
  End Subroutine results_to_VO_setReceiver
!!!
!!!
  Subroutine results_to_VO_setCalibrationResults(                   &
       &                                       name             , &
       &                                       frequency        , &
       &                                       frequencyImage   , &
       &                                       lineName         , &
       &                                       sideBand         , &
       &                                       effForward       , &
       &                                       effBeam          , &
       &                                       gainImage        , &
       &                                       tempAmbient      , &
       &                                       tempCold         , &
       &                                       xOffsetNasmyth   , &
       &                                       yOffsetNasmyth   , &
       &                                       lcalof           , &
       &                                       bcalof           , &
       &                                       h2omm            , &
       &                                       trx              , &
       &                                       tsys             , &
       &                                       tcal             , &
       &                                       tatms            , &
       &                                       tatmi            , &
       &                                       tauzen           , &
       &                                       tauzenImage      , &
       &                                       pcold            , &
       &                                       phot             , &
       &                                       psky             , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                            )
    !
    Character(len=*), Intent(IN), Optional  :: name
    Real*8          , Intent(IN), Optional  :: frequency
    Real*8          , Intent(IN), Optional  :: frequencyImage
    Character(len=*), Intent(IN), Optional  :: lineName
    Character(len=*), Intent(IN), Optional  :: sideBand
    Real            , Intent(IN), Optional  :: effForward
    Real            , Intent(IN), Optional  :: effBeam
    Real            , Intent(IN), Optional  :: gainImage
    Real            , Intent(IN), Optional  :: tempAmbient
    Real            , Intent(IN), Optional  :: tempCold
    Real            , Intent(IN), Optional  :: xOffsetNasmyth
    Real            , Intent(IN), Optional  :: yOffsetNasmyth
    !
    Real            , Intent(IN), Optional  :: lcalof
    Real            , Intent(IN), Optional  :: bcalof
    Real            , Intent(IN), Optional  :: h2omm
    Real            , Intent(IN), Optional  :: trx
    Real            , Intent(IN), Optional  :: tsys
    Real            , Intent(IN), Optional  :: tcal
    Real            , Intent(IN), Optional  :: tatms
    Real            , Intent(IN), Optional  :: tatmi
    Real            , Intent(IN), Optional  :: tauzen
    Real            , Intent(IN), Optional  :: tauzenImage
    Real            , Intent(IN), Optional  :: pcold
    Real            , Intent(IN), Optional  :: phot
    Real            , Intent(IN), Optional  :: psky
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       ncal = 0
       calresults(:) = receiverDefault
    End If
    !
    If (Present(reset).And.reset) Then
       ncal = 0
       calresults(:) = receiverDefault
    End If
    !
    If (Present(name) .And. nCal.Lt.nDimReceivers) Then
       ncal = ncal+1
       calresults(ncal)%name        = name
       calresults(ncal)%isConnected = .True.
    End If
    !
    If (Present(frequency))      calresults(nCal)%frequency%value      = frequency
    If (Present(frequencyImage)) calresults(nCal)%frequencyImage%value = frequencyImage
    If (Present(lineName))       calresults(nCal)%lineName             = lineName
    If (Present(sideBand))       calresults(nCal)%sideBand             = sideBand
    If (Present(effForward))     calresults(nCal)%effForward           = effForward
    If (Present(effBeam))        calresults(nCal)%effBeam              = effBeam
    If (Present(gainImage))      calresults(nCal)%gainImage%value      = gainImage
    If (Present(tempAmbient))    calresults(nCal)%tempAmbient          = tempAmbient
    If (Present(tempCold))       calresults(nCal)%tempCold             = tempCold
    If (Present(xOffsetNasmyth)) calresults(nCal)%xOffsetNasmyth       = xOffsetNasmyth
    If (Present(yOffsetNasmyth)) calresults(nCal)%yOffsetNasmyth       = yOffsetNasmyth
    If (Present(lcalof))         calresults(nCal)%lcalof          = lcalof
    If (Present(bcalof))         calresults(nCal)%bcalof          = bcalof
    If (Present(h2omm))          calresults(nCal)%h2omm           = h2omm
    If (Present(trx))            calresults(nCal)%trx             = trx
    If (Present(tsys))           calresults(nCal)%tsys            = tsys
    If (Present(tcal))           calresults(nCal)%tcal            = tcal
    If (Present(tatms))          calresults(nCal)%tatms           = tatms
    If (Present(tatmi))          calresults(nCal)%tatmi           = tatmi
    If (Present(tauzen))         calresults(nCal)%tauzen          = tauzen
    If (Present(tauzenImage))    calresults(nCal)%tauzenImage     = tauzenImage
    If (Present(pcold))          calresults(nCal)%pcold           = pcold
    If (Present(phot))           calresults(nCal)%phot            = phot
    If (Present(psky))           calresults(nCal)%psky            = psky

    !
    Return
    !
  End Subroutine results_to_VO_setCalibrationResults
!!!
!!!
  Subroutine results_to_VO_writeReceivers(                          &
       &                                       error,             &
       &                                       errorC             &
       &                               )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'receivers',                    &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'TABLE',                        &
         &              name    = 'receivers',                    &
         &              error   = errorXML)
    !
    Call pakoXMLwriteElement("FIELD","receiverName",              &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","lineName",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","frequency",                 &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","sideBand",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","doppler",                   &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","width",                     &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","gainImage",                 &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tempCold",                  &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tempAmbient",               &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","effForward",                &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","effBeam",                   &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","scale",                     &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offset",                    &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","centerIF",                  &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","frequencyImage",            &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","xOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","yOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    ! **
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nDimReceivers,1
       If (receivers(ii)%isConnected) Then
          Call pakoXMLwriteStartElement("TR",                     &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%name
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%lineName
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%frequency%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%sideBand
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%doppler
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%width
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%gainImage%value
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%tempCold
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%tempAmbient
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%effForward
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%effBeam
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = receivers(ii)%scale
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%offset%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%centerIF%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &        receivers(ii)%frequencyImage%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%xOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   receivers(ii)%yOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Call pakoXMLwriteEndElement("TR",                       &
               &                         error=errorXML)
       End If
    End Do
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","receivers",            &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","receivers",         &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeReceivers
!!!
!!!
  Subroutine results_to_VO_writeCalibrationResults(                 &
       &                                       error,             &
       &                                       errorC             &
       &                                 )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'RESOURCE',                     &
         &              name    = 'calibration',                  &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    Call pakoXMLwriteStartElement(                                &
         &              element = 'TABLE',                        &
         &              name    = 'calibration',                  &
         &              error   = errorXML)
    !
    Call pakoXMLwriteElement("FIELD","receiverName",              &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","lineName",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","frequency",                 &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","sideBand",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","gainImage",                 &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tempCold",                  &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tempAmbient",               &
         &                         dataType="float",              &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","effForward",                &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","effBeam",                   &
         &                         dataType="float",              &
         &                         unit="--",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","frequencyImage",            &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","xOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","yOffsetNasmyth",            &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","lcalof",                    &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","bcalof",                    &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","h2omm",                     &
         &                         dataType="double",             &
         &                         unit="mm",                     &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","trx",                       &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tsys",                      &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tcal",                      &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tatms",                     &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tatmi",                     &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tauzen",                    &
         &                         dataType="double",             &
         &                         unit="Neper",                  &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","tauzenImage",               &
         &                         dataType="double",             &
         &                         unit="Neper",                  &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","pcold",                     &
         &                         dataType="double",             &
         &                         unit="counts",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","phot",                      &
         &                         dataType="double",             &
         &                         unit="counts",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","psky",                      &
         &                         dataType="double",             &
         &                         unit="counts",                 &
         &                         error=errorXML)
    !
    ! **
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nDimReceivers,1
       If (calresults(ii)%isConnected) Then
          Call pakoXMLwriteStartElement("TR",                     &
               &                         error=errorXML)
          !
          valueC = calresults(ii)%name
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          valueC = calresults(ii)%lineName
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%frequency%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          valueC = calresults(ii)%sideBand
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%gainImage%value
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%tempCold
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%tempAmbient
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%effForward
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%effBeam
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &        calresults(ii)%frequencyImage%value
          valueComment = 'GHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%xOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(F20.6)')                                &
               &                   calresults(ii)%yOffsetNasmyth
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%lcalof
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%bcalof
          valueComment = 'arcsec'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%h2omm
          valueComment = 'mm'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%trx
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tsys
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tcal
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tatms
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tatmi
          valueComment = 'K'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tauzen
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%tauzenImage
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%pcold
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%phot
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write(valueC,'(F20.6)')                                 &
               &                  calresults(ii)%psky
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Call pakoXMLwriteEndElement("TR",                       &
               &                         error=errorXML)
       End If
    End Do
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","calibration",          &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","calibration",       &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeCalibrationResults
!!!
!!!
  Subroutine results_to_VO_setBackend(                              &
       &                                       name             , &
       &                                       nPart            , &
       &                                       resolution       , &
       &                                       bandwidth        , &
       &                                       fShift           , &
       &                                       receiver         , &
       &                                       nChannels        , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                           )
    !
    Character(len=*), Intent(IN), Optional  :: name
    Integer         , Intent(IN), Optional  :: nPart
    Real            , Intent(IN), Optional  :: resolution  ! MHz
    Real            , Intent(IN), Optional  :: bandwidth   ! MHz
    Real            , Intent(IN), Optional  :: fShift      ! MHz
    Character(len=*), Intent(IN), Optional  :: receiver
    Integer         , Intent(IN), Optional  :: nChannels
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nBack = 0
       backends(:) = backendDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nBack = 0
       backends(:) = backendDefault
    End If
    !
    If (Present(name) .And. nBack.Lt.nDimBackends) Then
       nBack = nBack+1
       backends(nBack)%name        = name
       backends(nBack)%isConnected = .True.
    End If
    !
    If (Present(nPart))      backends(nBack)%nPart        = nPart
    If (Present(resolution)) backends(nBack)%resolution   = resolution
    If (Present(bandwidth))  backends(nBack)%bandwidth    = bandwidth
    If (Present(fShift))     backends(nBack)%fShift       = fShift
    If (Present(receiver))   backends(nBack)%receiverName = receiver
    If (Present(nChannels))  backends(nBack)%nChannels    = nChannels
    !
    Return
    !
  End Subroutine results_to_VO_setBackend
!!!
!!!
  Subroutine results_to_VO_writeBackends(                           &
       &                                       error,             &
       &                                       errorC             &
       &                              )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement("RESOURCE","backends",          &
         &                         space ="before",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLE","backends",             &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","backendName",               &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nPart",                     &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","resolution",                &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","bandwidth",                 &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","fShift",                    &
         &                         dataType="double",             &
         &                         unit="GHz",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","receiver",                  &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nChannels",                 &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nDimBackends,1
       If (backends(ii)%isConnected) Then
          Call pakoXMLwriteStartElement("TR",                     &
               &                         error=errorXML)
          !
          valueC = backends(ii)%name
          Call pakoXMLcase(valueC,error=errorXML)
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,*)                                        &
               &                  backends(ii)%nPart
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,'(ES20.6)')                               &
               &                  backends(ii)%resolution/1.0D3
          Write (valueComment,*) backends(ii)%resolution,'MHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(ES20.6)')                               &
               &                  backends(ii)%bandwidth/1.0D3
          Write (valueComment,*) backends(ii)%bandwidth,'MHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          Write (valueC,'(ES20.6)')                               &
               &                  backends(ii)%fShift/1.0D3
          Write (valueComment,*) backends(ii)%fShift,'MHz'
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         comment=valueComment,    &
               &                         error=errorXML)
          !
          valueC = backends(ii)%receiverName
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Write (valueC,*)                                        &
               &                  backends(ii)%nChannels
          Call pakoXMLwriteElement("TD",                          &
               &                         content=valueC,          &
               &                         error=errorXML)
          !
          Call pakoXMLwriteEndElement("TR",                       &
               &                         error=errorXML)
       End If
    End Do
    ! ***
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","backends",             &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","backends",          &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeBackends
!!!
!!!
  Subroutine results_to_VO_setFocusResults(                         &
       &                                       backendName      , &
       &                                       nPart            , &
       &                                       focus            , &
       &                                       offset           , &
       &                                       rmsResidual      , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                                   )
    !
    Character(len=*), Intent(IN), Optional  :: backendName
    Integer         , Intent(IN), Optional  :: nPart
    Type(resultT)   , Intent(IN), Optional  :: focus
    Type(resultT)   , Intent(IN), Optional  :: offset
    Real*4          , Intent(IN), Optional  :: rmsResidual
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical         , Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Integer :: ii
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nFocusResults = 0
       FocusResults(:) = FocusResultDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nFocusResults = 0
       FocusResults(:) = FocusResultDefault
    End If
    !
    If (Present(backendName) .And. nBack.Lt.nDimBackends) Then
       nFocusResults = nFocusResults+1
       ii               = nFocusResults
       focusResults(ii)%backendName = backendName
    End If
    !
    If (Present(nPart))       focusResults(ii)%backendPart  = nPart
    If (Present(focus))       focusResults(ii)%focus        = focus
    If (Present(offset))      focusResults(ii)%offset       = offset
    If (Present(rmsResidual)) focusResults(ii)%rmsResidual  = rmsResidual
    !
!!$    write (6,*) '  focusResults(ii)%backendPart   ',  focusResults(ii)%backendPart
!!$    write (6,*) '  focusResults(ii)%focus    ',  focusResults(ii)%focus
!!$    write (6,*) '  focusResults(ii)%offset   ',  focusResults(ii)%offset
!!$    write (6,*) '  focusResults(ii)%rmsResidual   ', focusResults(ii)%rmsResidual
    !
    Return
    !
  End Subroutine results_to_VO_setFocusResults
!!!
!!!
  Subroutine results_to_VO_writeFocusResults(                       &
       &                                       error,             &
       &                                       errorC             &
       &                                     )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement("RESOURCE","results",           &
         &                         space ="before",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","backendName",               &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nPart",                     &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","focus",                &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","focusError",           &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offset",                    &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offsetError",               &
         &                         dataType="double",             &
         &                         unit="mm",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","rmsResidual",               &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nFocusResults,1
       !
       Call pakoXMLwriteStartElement("TR",                        &
            &                         error=errorXML)
       !
       valueC = focusResults(ii)%backendName
       Call pakoXMLcase(valueC,error=errorXML)
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,*)                                           &
            &                  focusResults(ii)%backendPart
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%focus%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%focus%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%offset%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%offset%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  focusResults(ii)%rmsResidual
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Call pakoXMLwriteEndElement("TR",                          &
            &                         error=errorXML)
    End Do
    ! **
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","results",           &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeFocusResults
!!!
!!!
  Subroutine results_to_VO_setPointingResults(                      &
       &                                       backendName      , &
       &                                       nPart            , &
       &                                       recName          , &
       &                                       direction        , &
       &                                       correction       , &
       &                                       peak             , &
       &                                       integral         , &
       &                                       offset           , &
       &                                       width            , &
       &                                       rmsResidual      , &
       &                                       default          , &
       &                                       reset            , &
       &                                       error            , &
       &                                       errorC             &
       &                                   )
    !
    use cal2vo_messaging
    Character(len=*), Intent(IN), Optional  :: backendName
    Integer         , Intent(IN), Optional  :: nPart
    Character(len=*), Intent(IN), Optional  :: recName
    Real*4          , Intent(IN), Optional  :: direction
    Type(resultT)   , Intent(IN), Optional  :: correction
    Type(resultT)   , Intent(IN), Optional  :: peak
    Type(resultT)   , Intent(IN), Optional  :: integral
    Type(resultT)   , Intent(IN), Optional  :: offset
    Type(resultT)   , Intent(IN), Optional  :: width
    Real*4          , Intent(IN), Optional  :: rmsResidual
    !
    Logical         , Intent(IN), Optional  :: default
    Logical         , Intent(IN), Optional  :: reset
    !
    Logical         , Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Integer :: ii
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    If (Present(default).And.default) Then
       nPointingResults = 0
       PointingResults(:) = PointingResultDefault
    End If
    !
    If (Present(reset).And.reset) Then
       nPointingResults = 0
       PointingResults(:) = PointingResultDefault
    End If
    !
    If (Present(backendName) .And. nBack.Lt.nDimBackends) Then
      if (nPointingResults.Lt.nDimResults) Then
        nPointingResults = nPointingResults+1
      else
        ! This is non-sense to write more than 99 results in XML.
        ! => nothing clever done here, overwrite last one
        call cal2vo_message(seve%i,'VOXML',  &
          'Number of pointing results exceeds limit')
      endif
      ii = nPointingResults
      pointingResults(ii)%backendName = backendName
    End If
    !
    If (Present(nPart))       pointingResults(ii)%backendPart  = nPart
    If (Present(recName))     pointingResults(ii)%recName      = recName
    If (Present(direction))   pointingResults(ii)%direction    = direction
    If (Present(correction))  pointingResults(ii)%correction   = correction
    If (Present(peak))        pointingResults(ii)%peak         = peak
    If (Present(integral))    pointingResults(ii)%integral     = integral
    If (Present(offset))      pointingResults(ii)%offset       = offset
    If (Present(width))       pointingResults(ii)%width        = width
    If (Present(rmsResidual)) pointingResults(ii)%rmsResidual  = rmsResidual
    !
    Return
    !
  End Subroutine results_to_VO_setPointingResults
!!!
!!!
  Subroutine results_to_VO_writePointingResults(                    &
       &                                       error,             &
       &                                       errorC             &
       &                                     )
    Use phys_const
    Use mrtindex_sec_pointing
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    Integer            :: ii
    Character(len=64)  :: valueC
    Character(len=64)  :: valueComment
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteStartElement("RESOURCE","results",           &
         &                         space ="before",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","backendName",               &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","nPart",                     &
         &                         dataType="int",                &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","direction",                 &
         &                         dataType="char",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","correction",                &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","correctionError",           &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","peak",                      &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","peakError",                 &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","integral",                  &
         &                         dataType="double",             &
         &                         unit="K.arcsec",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","integralError",             &
         &                         dataType="double",             &
         &                         unit="K.arcsec",               &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offset",                    &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","offsetError",               &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","width",                     &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","widthError",                &
         &                         dataType="double",             &
         &                         unit="arcsec",                 &
         &                         error=errorXML)
    !
    Call pakoXMLwriteElement("FIELD","rmsResidual",               &
         &                         dataType="double",             &
         &                         unit="K",                      &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteStartElement("TABLEDATA",                    &
         &                         error=errorXML)
    !
    ! **
    Do ii = 1,nPointingResults,1
       !
       Call pakoXMLwriteStartElement("TR",                        &
            &                         error=errorXML)
       !
       valueC = pointingResults(ii)%backendName
       Call pakoXMLcase(valueC,error=errorXML)
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,*)                                           &
            &                  pointingResults(ii)%backendPart
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment=trim(pointingResults(ii)%recName), &
            &                         error=errorXML)
       !
       Write (valueComment,'(f6.2,a)') pointingResults(ii)%direction*deg_per_rad,' deg'
       select case (pointing_direction(pointingResults(ii)%direction))
       case (code_pointing_azimuth)
          valueC = 'azimuth'
       case (code_pointing_elevation)
          valueC = 'elevation'
       case default
          valueC = valueComment
       end select
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment=valueComment,       &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &         pointingResults(ii)%correction%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='correction',       &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &         pointingResults(ii)%correction%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%peak%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='peak',             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%peak%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%integral%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='integral',         &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%integral%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%offset%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='offset',           &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%offset%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%width%value
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='width',            &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%width%error
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         error=errorXML)
       !
       Write (valueC,'(ES20.6)')                                  &
            &                  pointingResults(ii)%rmsResidual
       Call pakoXMLwriteElement("TD",                             &
            &                         content=valueC,             &
            &                         comment='rmsResidual',      &
            &                         error=errorXML)
       !
       Call pakoXMLwriteEndElement("TR",                          &
            &                         error=errorXML)
    End Do
    ! **
    !
    Call pakoXMLwriteEndElement  ("TABLEDATA",                    &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("DATA",                         &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("TABLE","results",              &
         &                         error=errorXML)
    !
    Call pakoXMLwriteEndElement  ("RESOURCE","results",           &
         &                         space="after",                 &
         &                         error=errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writePointingResults
!!!
!!!
  Subroutine results_to_VO_writeEnd(                                &
       &                                       error,             &
       &                                       errorC             &
       &                         )
    !
    Logical,          Intent(OUT), Optional :: error              ! errorFlag
    Character(len=*), Intent(OUT), Optional :: errorC             ! errorCode
    !
    Logical            :: errorXML
    !
    If (Present(error))  error  = .False.
    If (Present(errorC)) errorC = ""
    !
    Call pakoXMLwriteEndElement(                                  &
         &              element = 'VOTABLE',                      &
         &              space   = 'before',                       &
         &              error   = errorXML)
    !
    If (Present(error) .And. errorXML) error=errorXML
    Return
    !
  End Subroutine results_to_VO_writeEnd
!!!
!!!
End Module results_to_vo
!!!

subroutine gtemplate_dummy(line,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! Support routine for command DUMMY
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Error flag
  ! Global
  integer, external :: sic_narg
  ! Local
  character(len=*), parameter :: rname='DUMMY'
  character(len=message_length) :: mess
  !
  call gtemplate_message(seve%i,rname,'Entering DUMMY command')
  !
  write(mess,'(I2,A)') sic_narg(0),' argument(s) passed to command'
  call gtemplate_message(seve%i,rname,mess)
  !
end subroutine gtemplate_dummy

module noema_tsys_interpolation
  !---------------------------------------------------------------------
  ! Ad-hoc types and methods which allows to define some models
  !---------------------------------------------------------------------
  !
  public :: model_parabol,model_gaussian,model_parabol_gaussian
  public :: parabol_t,gaussian_t,model_t
  private
  !
  integer(kind=4), parameter :: model_parabol=1
  integer(kind=4), parameter :: model_gaussian=2
  integer(kind=4), parameter :: model_parabol_gaussian=3  ! Both combined
  !
  type :: parabol_t
    ! f(x) = offset+slope*x+factor*x**2
    real(kind=4), public :: offset=0.  ! [K]
    real(kind=4), public :: slope=0.   ! [K/GHz]
    real(kind=4), public :: factor=0.  ! [K/GHz**2]
  contains
    procedure, private :: compute => parabol_compute
  end type parabol_t
  !
  type :: gaussian_t
    ! f(x) = amp*exp(-(x-pos)**2/(2*wid**2))
    real(kind=4), public :: amp=0.  ! [K]
    real(kind=4), public :: pos=0.  ! [GHz]
    real(kind=4), public :: wid=0.  ! [GHz]
  contains
    procedure, private :: compute => gauss_compute
  end type gaussian_t
  !
  type :: model_t
    integer(kind=4),  public :: itype    ! 1=parabol, 2=gaussian
    type(parabol_t),  public :: parabol  ! Used if parabolic
    type(gaussian_t), public :: gauss    ! Used if gaussian
  contains
    procedure, public :: add     => model_add
    procedure, public :: compute => model_compute
  end type model_t
  !
contains
  !
  function parabol_compute(parabol,x)
    !-------------------------------------------------------------------
    ! Compute value at X
    !-------------------------------------------------------------------
    real(kind=4) :: parabol_compute
    class(parabol_t), intent(in) :: parabol
    real(kind=4),     intent(in) :: x
    parabol_compute = parabol%offset + parabol%slope*x  &
                    + parabol%factor*x**2
  end function parabol_compute
  !
  function gauss_compute(gauss,x)
    !-------------------------------------------------------------------
    ! Compute value at X
    !-------------------------------------------------------------------
    real(kind=4) :: gauss_compute
    class(gaussian_t), intent(in) :: gauss
    real(kind=4),      intent(in) :: x
    gauss_compute = gauss%amp * exp( -(x-gauss%pos)**2/(2*gauss%wid**2) )
  end function gauss_compute
  !
  subroutine model_add(model1,model2,error)
    use gbl_message
    !-------------------------------------------------------------------
    ! Add model2 into model1
    !-------------------------------------------------------------------
    class(model_t), intent(inout) :: model1
    type(model_t),  intent(in)    :: model2
    logical,        intent(inout) :: error
    !
    character(len=*), parameter :: rname='TSYS>MODEL>ADD'
    logical :: done
    !
    done = .false.
    if (model1%itype.eq.model_parabol) then
      if (model2%itype.eq.model_parabol) then
        model1%parabol%offset = model1%parabol%offset  &
                              + model2%parabol%offset
        model1%parabol%slope  = model1%parabol%slope  &
                              + model2%parabol%slope
        model1%parabol%factor = model1%parabol%factor  &
                              + model2%parabol%factor
        done = .true.
      elseif (model2%itype.eq.model_gaussian) then
        model1%itype = model_parabol_gaussian
        model1%gauss = model2%gauss
        done = .true.
      endif
    endif
    !
    if (.not.done) then
      call astro_message(seve%e,rname,'Model combination not implemented')
      error = .true.
      return
    endif
  end subroutine model_add
  !
  function model_compute(model,x)
    !-------------------------------------------------------------------
    ! Compute value at X
    !-------------------------------------------------------------------
    real(kind=4) :: model_compute
    class(model_t), intent(in) :: model
    real(kind=4),   intent(in) :: x
    select case (model%itype)
    case (model_parabol)
      model_compute = model%parabol%compute(x)
    case (model_gaussian)
      model_compute = model%gauss%compute(x)
    case (model_parabol_gaussian)
      model_compute = model%parabol%compute(x) + model%gauss%compute(x)
    case default
      model_compute = 0.
    end select
  end function model_compute
end module noema_tsys_interpolation

module noema_tsys_parameters
  use noema_tsys_interpolation
  !---------------------------------------------------------------------
  ! Parameters (and variables deduced from these) which are shared by
  ! the 2 tables produced by the command NOEMA\TSYS
  !---------------------------------------------------------------------
  !
  ! Data format
  integer(kind=4), parameter :: tsysversion=1
  integer(kind=4), parameter :: contversion=2
  !
  ! Physical parameters
  real(kind=4),    parameter :: h0=2.560    ! [km]  NOEMA altitude
  real(kind=4),    parameter :: p0=1013.0   ! [HPa] At sea level
  real(kind=4)               :: p1          ! [HPa] At site altitude
  integer(kind=4), parameter :: nt=2        ! Number of atmosphere temperatures
  real(kind=4),    parameter :: t(nt) = (/ 273.,283. /)  ! [K]
  !
  ! Hardware
  real(kind=4),    parameter :: gim=0.05    ! [   ] Image gain ratio
  integer(kind=4), parameter :: nb=3        !       Number of bands
  !
  type(parabol_t),  parameter :: nullparabol = parabol_t(0.,0.,0.)
  type(gaussian_t), parameter :: nullgauss = gaussian_t(0.,0.,0.)
  ! Trec values: for each band, provide parabola coefficients.
  type(parabol_t), parameter :: trec_band1 = parabol_t(37.1,0.,0.)  ! Flat C.Fischer 26-jun-2026
  type(parabol_t), parameter :: trec_band2 = parabol_t(45.0,0.,0.)  ! Flat
  type(parabol_t), parameter :: trec_band3 = parabol_t(55.0,0.,0.)  ! Flat
  type(model_t), parameter :: trec_receiver(nb) = [   &
      model_t(model_parabol,trec_band1,nullgauss),  &
      model_t(model_parabol,trec_band2,nullgauss),  &
      model_t(model_parabol,trec_band3,nullgauss) ]
  ! Dichroic contribution if DBR mode:
  type(parabol_t),  parameter :: tdic_band1 = parabol_t(291.9,-5.45,0.0267)  ! C.Fischer 26-jun-2026
  type(parabol_t),  parameter :: tdic_band2 = parabol_t(0.,0.,0.)
  type(gaussian_t), parameter :: tdic_band3 = gaussian_t(13.798,241.938,2.824)
  type(model_t),    parameter :: trec_dichroic(nb) = [  &
      model_t(model_parabol, tdic_band1, nullgauss),  &
      model_t(model_parabol, tdic_band2, nullgauss),  &
      model_t(model_gaussian,nullparabol,tdic_band3) ]
  !
  real(kind=4),    parameter :: trec_blank=1e4  ! [K] Very bad Trec (but valid in computations)
  ! Feff values: for each band, provide parabola coefficients.
  type(parabol_t), parameter :: feff_band1 = parabol_t(0.96,0.,0.)  ! Flat
  type(parabol_t), parameter :: feff_band2 = parabol_t(0.94,0.,0.)  ! Flat
  type(parabol_t), parameter :: feff_band3 = parabol_t(0.90,0.,0.)  ! Flat
  type(model_t),   save      :: feff(nb) = [  &
      model_t(model_parabol,feff_band1,nullgauss),  &
      model_t(model_parabol,feff_band2,nullgauss),  &
      model_t(model_parabol,feff_band3,nullgauss) ]
  real(kind=4),    parameter :: feff_blank=1e-4 ! [ ] Very bad Feff (but valid in computations)
  !
  ! Frequencies. The ranges are defined at run time thanks to
  ! the subroutine 'rec_define_noema'
  real(kind=4)                 :: rf_step      ! [GHz]
  real(kind=4)                 :: rf_min(nb)   ! [GHz]
  real(kind=4)                 :: rf_max(nb)   ! [GHz]
  integer(kind=4)              :: nrf          !
  real(kind=4),    allocatable :: rf(:)        ! [GHz]
  real(kind=4)                 :: lof_step     ! [GHz]
  real(kind=4)                 :: lof_min(nb)  ! [GHz]
  real(kind=4)                 :: lof_max(nb)  ! [GHz]
  integer(kind=4)              :: nlof         !
  real(kind=4),    allocatable :: lof(:)       ! [GHz]
  !
  ! Airmass
  real(kind=4),    parameter   :: a_step=0.5  ! [Neper]
  real(kind=4),    parameter   :: a_min=1.    ! [Neper] Elevation 90 deg
  real(kind=4),    parameter   :: a_max=6.    ! [Neper] Elevation ~9.5 deg
  integer(kind=4)              :: na          !
  real(kind=4),    allocatable :: a(:)        !
  !
  ! PWV
  real(kind=4),    parameter   :: w_step=0.5  ! [mm]
  real(kind=4),    parameter   :: w_min=2.    ! [mm]
  real(kind=4),    parameter   :: w_max=7.    ! [mm]
  integer(kind=4)              :: nw          !
  real(kind=4),    allocatable :: w(:)        !
  !
end module noema_tsys_parameters
!
subroutine noema_tsys(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_tsys
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   NOEMA\TSYS TableName [/CONTINUUM] [/DBR]
  ! Compute the Tsys  binary table
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  integer(kind=4), parameter :: optcont=1
  integer(kind=4), parameter :: optdbr=2
  character(len=filename_length) :: tsysfile
  integer(kind=4) :: nc
  logical :: docont,dodbr
  !
  call sic_ch(line,0,1,tsysfile,nc,.true.,error)
  if (error)  return
  !
  if (gag_inquire(tsysfile,nc).eq.0) then
    call astro_message(seve%e,rname,  &
      'File '//tsysfile(1:nc)//' already exists. Remove it first.')
    error = .true.
    if (error)  return
  endif
  !
  docont = sic_present(optcont,0)
  dodbr = sic_present(optdbr,0)
  !
  if (docont) then
    call noema_tsys_continuum(tsysfile,dodbr,error)
    if (error)  continue
  else
    call noema_tsys_table(tsysfile,dodbr,error)
    if (error)  continue
  endif
  !
  call noema_tsys_clean()
  !
end subroutine noema_tsys
!
subroutine noema_tsys_setup(rfstep,lofstep,dbr,trec,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces
  use astro_types
  use ast_line
  use noema_tsys_parameters
  use noema_tsys_interpolation
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Set up the parameters
  !---------------------------------------------------------------------
  real(kind=4),  intent(in)    :: rfstep   !
  real(kind=4),  intent(in)    :: lofstep  !
  logical,       intent(in)    :: dbr      ! DBR mode active?
  type(model_t), intent(out)   :: trec(nb) !
  logical,       intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='TSYS'
  type(receiver_desc_t) :: rdesc
  integer(kind=4) :: ib,ia,iw,irf,ilof,ier
  !
  p1 = p0*2.0**(-h0/5.5)  ! [HPa] Pressure at altitude h0
  !
  ! Get receiver parameters
  call rec_define_noema(rdesc,noema_mode,error)
  if (error)  return
  !
  if (rdesc%n_rbands.ne.nb) then
    ! If error, adapt Trec and Feff arrays
    call astro_message(seve%e,rname,'Number of bands not supported')
    error = .true.
    return
  endif
  !
  ! Frequency ranges
  do ib=1,rdesc%n_rbands
    ! Compute our frequency range. Be conservative (floor/ceiling) + align
    ! to the nearest GHz (purely cosmetic) + 1 more GHz at boundary because
    ! in some cases (e.g. Doppler effect) one has to explore slightly beyond
    ! the usual limits.
    lof_min(ib) = floor(rdesc%lohard(1,ib)/1000.)-1
    lof_max(ib) = ceiling(rdesc%lohard(2,ib)/1000.)+1
    rf_min(ib) = floor(rdesc%rflim(1,ib)/1000.)-1
    rf_max(ib) = ceiling(rdesc%rflim(2,ib)/1000.)+1
  enddo
  !
  rf_step = rfstep
  lof_step = lofstep
  !
  ! Number of RF/IF frequencies
  nrf = (rf_max(rdesc%n_rbands)-rf_min(1))/rf_step+1  ! Assume that bands are ordered increasingly
  ! Number of LO frequencies: the whole range is sampled with no gap between
  ! bands. Beware this feature is used by PMS.
  nlof = (lof_max(rdesc%n_rbands)-lof_min(1))/lof_step+1  ! Assume that bands are ordered increasingly
  ! Number of airmasses: easy
  na = (a_max-a_min)/a_step+1
  ! Number of pwv: easy
  nw = (w_max-w_min)/w_step+1
  !
  ! Define the vectors
  allocate(rf(nrf),lof(nlof),a(na),w(nw),stat=ier)
  if (failed_allocate(rname,'dimension buffers',ier,error))  return
  ! RF frequencies
  do irf=1,nrf
    rf(irf) = rf_min(1)+(irf-1)*rf_step
  enddo
  ! LO frequencies
  do ilof=1,nlof
    lof(ilof) = lof_min(1)+(ilof-1)*lof_step
  enddo
  ! Airmasses
  do ia=1,na
    a(ia) = a_min+(ia-1)*a_step
  enddo
  ! PWV
  do iw=1,nw
    w(iw) = w_min+(iw-1)*w_step
  enddo
  !
  ! Trec: prepare parabola coefficients for each band
  do ib=1,nb
    ! Receiver temperature: always
    trec(ib) = trec_receiver(ib)
    ! Dichroic temperature: if dbr mode
    if (dbr) then
      call trec(ib)%add(trec_dichroic(ib),error)
      if (error)  return
    endif
  enddo
  !
end subroutine noema_tsys_setup
!
subroutine noema_tsys_clean()
  use noema_tsys_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Deallocate the global buffers. There is no need to keep them
  ! allocated after the command has ended
  !---------------------------------------------------------------------
  !
  if (allocated(rf))   deallocate(rf)
  if (allocated(lof))  deallocate(lof)
  if (allocated(a))    deallocate(a)
  if (allocated(w))    deallocate(w)
  !
end subroutine noema_tsys_clean
!
subroutine noema_tsys_table(file,dbr,error)
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use atm_interfaces_public
  use astro_interfaces, except_this=>noema_tsys_table
  use astro_types
  use noema_tsys_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the Tsys + Opacity table
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: file
  logical,          intent(in)    :: dbr
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  character(len=message_length) :: mess
  integer(kind=4) :: if,ia,iw,it,ier,ib
  real(kind=4) :: temis,temii,tatm,tauox,tauw,dummy,taut
  integer(kind=4), allocatable :: band(:)  ! Band number for each RF
  type(model_t) :: trec(nb)
  real(kind=4), allocatable :: vtrec(:),vfeff(:)
  real(kind=4), allocatable :: tsys(:,:,:,:)
  type(time_t) :: time
  !
  ! Parameters
  real(kind=4), parameter :: intfreq=0.  ! [GHz] Intermediate frequency
  ! IF (used to compute the image frequency) is set to 0 because:
  ! 1) typical values show a Tsys difference near 0% at the center of
  !    the bands (where Tsys is flat), and less than 2% at the band
  !    sides (where Tsys varies faster in one sideband than in the
  !    other). => NB: probably not true anymore now that gim is 0.05
  ! 2) it is quite difficult/impossible to produce a generic Tsys table
  !    which would know in advance what is the image frequency distance
  !    and side (lower or upper). In other words we can not know what is
  !    the image frequency associated to a given signal frequency.
  !
  !
  ! Set up the parameters and define the frequency sampling. The RF is
  ! sampled every GHz (this produces a table of reasonable size). LO
  ! sampling is actually unused here.
  call noema_tsys_setup(1.,1.,dbr,trec,error)
  if (error)  return
  !
  ! Vectorized Trec and Feff:
  allocate(band(nrf),vtrec(nrf),vfeff(nrf),stat=ier)
  if (failed_allocate(rname,'Trec & Feff buffers',ier,error))  return
  ! Band number for each RF freq (side product, not in data)
  band(:) = 0
  do ib=1,nb
    where (rf.ge.rf_min(ib) .and. rf.le.rf_max(ib))
      band = ib
    end where
  enddo
  vtrec(:) = trec_blank
  vfeff(:) = feff_blank
  do if=1,nrf
    if (band(if).eq.0)  cycle
    vtrec(if) = trec(band(if))%compute(rf(if))
    vfeff(if) = feff(band(if))%compute(rf(if))
  enddo
  !
  call astro_message(seve%i,rname,'Computing Tsys table with')
  write (mess,10)  nrf,' frequencies  from ',rf(1),' to ',rf(nrf),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  na,' airmasses    from ',a(1),' to ',a(na),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nw,' pwv          from ',w(1),' to ',w(nw),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nt,' temperatures from ',t(1),' to ',t(nt)
  call astro_message(seve%i,rname,mess)
10 format(I5,A,F6.2,A,F6.2,A)
  !
  ! Now compute Tsys
  allocate(tsys(nrf,na,nw,nt),stat=ier)
  if (failed_allocate(rname,'tsys buffers',ier,error))  return
  !
  call gtime_init(time,nt*nw*na*nrf,error)
  if (error)  return
  !
  do it=1,nt
    call atm_atmosp(t(it),p1,h0)
    do iw=1,nw
      do ia=1,na
        do if=1,nrf
          ! Signal
          call atm_transm(w(iw),a(ia),rf(if),temis,tatm,tauox,tauw,taut,ier)
          ! Image
          if (intfreq.eq.0.) then
            temii = temis
          else
            call atm_transm(w(iw),a(ia),rf(if)+2.*intfreq,temii,tatm,tauox,tauw,dummy,ier)
          endif
          ! Store Tsys at current airmass
          tsys(if,ia,iw,it) = ( gim * (vfeff(if)*temii+(1.0-vfeff(if))*t(it) + vtrec(if)) +  &
                                      (vfeff(if)*temis+(1.0-vfeff(if))*t(it) + vtrec(if))    &
                              ) / vfeff(if) * exp(taut*a(ia))
          !
          call gtime_current(time)
          if (sic_ctrlc()) then
            call astro_message(seve%e,rname,'Aborted')
            error = .true.
            return
          endif
          !
        enddo
      enddo
    enddo
  enddo
  !
  call noema_tsys_write_bintable(file,error)
  if (error)  return
  !
contains
  subroutine noema_tsys_write_bintable(file,error)
    use gildas_def
    use gbl_format
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: file
    logical,          intent(inout) :: error
    ! Local
    integer(kind=4) :: ier,nfile,lun,currec,recpos
    character(len=message_length) :: mess
    character(len=4) :: tab_code
    integer(kind=4), parameter :: reclen=128  ! Words
    integer(kind=4) :: buffer(reclen)
    !
    ier = sic_getlun(lun)
    nfile = len_trim(file)
    open(unit=lun,file=file(1:nfile),status='NEW',access='DIRECT',   &
        form='UNFORMATTED',iostat=ier,recl=reclen*facunf)
    if (ier.ne.0) then
      call astro_message(seve%e,rname,'Filename: '//file)
      call putios('E-ATM, Open error: ',ier)
      error = .true.
      goto 99
    endif
    !
    call gdf_getcod(tab_code)
    call chtoby(tab_code,buffer(1),4)
    call i4toi4(tsysversion,buffer(2),1)
    call r4tor4(p1,buffer(3),1)
    call r4tor4(gim,buffer(4),1)
    call r4tor4(intfreq,buffer(5),1)
    call i4toi4(nrf,buffer(6),1)
    call i4toi4(na,buffer(7),1)
    call i4toi4(nw,buffer(8),1)
    call i4toi4(nt,buffer(9),1)
    currec = 1
    recpos = 10
    !
    call noema_tsys_write_binarray(lun,rf,nrf,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,a,na,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,w,nw,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,t,nt,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vtrec,nrf,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vfeff,nrf,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    call noema_tsys_write_binarray(lun,tsys,nrf*na*nw*nt,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    if (recpos.ne.1) then
      ! Flush last record
      write(lun,rec=currec,iostat=ier)  buffer
      if (ier.ne.0) then
        write(mess,'(A,I0)') 'Error writing record ',currec
        call astro_message(seve%e,rname,mess)
        error = .true.
        goto 98
      endif
    endif
    !
    write(mess,'(I0,A)') currec,' records written'
    call astro_message(seve%i,rname,mess)
    !
98  close(lun)
99  call sic_frelun(lun)
  end subroutine noema_tsys_write_bintable
  !
end subroutine noema_tsys_table
!
subroutine noema_tsys_continuum(file,dbr,error)
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use atm_interfaces_public
  use astro_interfaces, except_this=>noema_tsys_continuum
  use astro_types
  use ast_line
  use noema_tsys_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the Tsys + Opacity table
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: file
  logical,          intent(in)    :: dbr
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  character(len=message_length) :: mess
  integer(kind=4) :: irf,ilof,ia,iw,it,ier,ib
  real(kind=4) :: tatm,tauox,tauw
  integer(kind=4), allocatable :: band(:)  ! Band number for each LOF
  type(model_t) :: trec(nb)
  real(kind=4), allocatable :: vtrec(:),vfeff(:),temi(:),taut(:)
  real(kind=4), allocatable :: tsys(:,:,:,:,:)
  type(time_t) :: time
  type(receiver_desc_t) :: rdesc
  !
  ! Elements
  integer(kind=4), parameter :: ne=3  ! Number of elements stored (Tsys_aver, Tsys_min, Tsys_max)
  integer(kind=4), parameter :: imin=1   ! Index for Tsys_min
  integer(kind=4), parameter :: iaver=2  ! Index for Tsys_aver
  integer(kind=4), parameter :: imax=3   ! Index for Tsys_max
  !
  !
  ! Set up the parameters and define the frequency sampling. The RF is
  ! sampled every 0.1 GHz (this gives good estimation of the average Tsys
  ! over the side band (and this parameter does not influence the table
  ! size). The LO frequency is sampled every GHz (this produces a table
  ! of reasonable size).
  call noema_tsys_setup(0.1,1.0,dbr,trec,error)
  if (error)  return
  !
  ! Get receiver parameters
  call rec_define_noema(rdesc,noema_mode,error)
  if (error)  return
  !
  ! Vectorized Trec and Feff. There are just defined for bookkeeping in the
  ! output table.
  allocate(band(nlof),vtrec(nlof),vfeff(nlof),stat=ier)
  if (failed_allocate(rname,'Trec & Feff buffers',ier,error))  return
  ! Band number for each RF freq (side product, not in data)
  band(:) = 0
  do ib=1,nb
    where (lof.ge.rf_min(ib) .and. lof.le.rf_max(ib))
      band = ib
    end where
  enddo
  vtrec(:) = trec_blank
  vfeff(:) = feff_blank
  do ilof=1,nlof
    if (band(ilof).eq.0)  cycle
    vtrec(ilof) = trec(band(ilof))%compute(lof(ilof))
    vfeff(ilof) = feff(band(ilof))%compute(lof(ilof))
  enddo
  !
  call astro_message(seve%i,rname,'Computing Tsys continuum table with')
  write (mess,10)  ne,  ' elements                              x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nlof,' LO frequencies  from ',lof(1),' to ',lof(nlof),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  na,  ' airmasses       from ',a(1),  ' to ',a(na),    ' x '
  call astro_message(seve%i,rname,mess) 
  write (mess,10)  nw,  ' pwv             from ',w(1),  ' to ',w(nw),    ' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nt,  ' temperatures    from ',t(1),  ' to ',t(nt)
  call astro_message(seve%i,rname,mess)
10 format(I5,A,F6.2,A,F6.2,A)
  !
  ! Now compute Tsys
  allocate(temi(nrf),taut(nrf),tsys(ne,nlof,na,nw,nt),stat=ier)
  if (failed_allocate(rname,'tsys buffers',ier,error))  return
  !
  call gtime_init(time,nt*nw*na,error)
  if (error)  return
  !
  do it=1,nt
    call atm_atmosp(t(it),p1,h0)
    do iw=1,nw
      do ia=1,na
        ! Compute Temi and Tau for each frequency. They will be used to compute
        ! the Tsys in the 2 sidebands. The sampling is done at 'if_step'
        do irf=1,nrf
          ! Signal
          call atm_transm(w(iw),a(ia),rf(irf),temi(irf),tatm,tauox,tauw,taut(irf),ier)
        enddo
        do ilof=1,nlof
          call tsys_at_lof(t(it),a(ia),lof(ilof),  &
                           tsys(iaver,ilof,ia,iw,it),   &
                           tsys(imin, ilof,ia,iw,it),   &
                           tsys(imax, ilof,ia,iw,it))
          !
          if (sic_ctrlc()) then
            call astro_message(seve%e,rname,'Aborted')
            error = .true.
            return
          endif
          !
        enddo
        call gtime_current(time)
      enddo
    enddo
  enddo
  !
  call noema_tsys_write_bintable(file,error)
  if (error)  return
  !
contains
  subroutine tsys_at_lof(temp,air,lof,tsys_aver,tsys_min,tsys_max)
    !-------------------------------------------------------------------
    ! Compute the average, minimum, and maximum Tsys for the input Flo
    !-------------------------------------------------------------------
    real(kind=4), intent(in)  :: temp
    real(kind=4), intent(in)  :: air
    real(kind=4), intent(in)  :: lof
    real(kind=4), intent(out) :: tsys_aver
    real(kind=4), intent(out) :: tsys_min
    real(kind=4), intent(out) :: tsys_max
    ! Local
    integer(kind=4) :: isb,isig,iima,ntsys
    integer(kind=size_length) :: ilof
    real(kind=4) :: fmin,fmax,foreff,temrec,tsys,tsys_sum,if_min,if_max
    ! Parameters
    integer(kind=4), parameter :: nsb=2  ! LSB+USB
    !
    ! Position of lof in the RF array
    call gr4_dicho(int(nrf,kind=size_length),rf,lof,ilof)
    if (rf(ilof).ne.lof) then
      ! It is better to have it aligned so that the signal and
      ! image frequencies are exact mirrors w/t the LO freq
      call astro_message(seve%w,rname,'LOF not on RF grid')
    endif
    !
    if_min = rdesc%iflim(1)/1e3  ! [GHz] IF range
    if_max = rdesc%iflim(2)/1e3  ! [GHz] IF range
    ntsys = 0
    tsys_sum = 0.
    tsys_min = 1e10
    tsys_max = 0.
    do isb=1,nsb
      if (isb.eq.1) then
        fmin = lof - if_max
        fmax = lof - if_min
      else
        fmin = lof + if_min
        fmax = lof + if_max
      endif
      do irf=1,nrf
        if (rf(irf).lt.fmin .or. rf(irf).gt.fmax)  cycle
        !
        ! Position of signal and image frequencies in RF array
        isig = irf
        iima = ilof + (ilof-isig)
        !
        ! Feff and Trec at signal frequency
        foreff = foeff(rf(isig))
        temrec = terec(rf(isig))
        !
        ntsys = ntsys+1
        tsys = ( gim * (foreff*temi(iima)+(1.0-foreff)*temp + temrec) +  &
                       (foreff*temi(isig)+(1.0-foreff)*temp + temrec)    &
               ) / foreff * exp(taut(isig)*air)
        ! tsys_sum = tsys_sum + tsys**2
        tsys_sum = tsys_sum + 1./tsys**2
        if (tsys.lt.tsys_min)  tsys_min = tsys
        if (tsys.gt.tsys_max)  tsys_max = tsys
      enddo
    enddo
    !
    ! Post-processing
    if (ntsys.eq.0) then
      tsys_aver = 0.
    elseif (gag_isreal(tsys_sum).eq.0) then
      ! tsys_aver = sqrt(tsys_sum/ntsys)
      tsys_aver = 1./sqrt(tsys_sum/ntsys)
    else
      tsys_aver = 1e10  ! Avoid +Inf in table
    endif
    if (gag_isreal(tsys_max).eq.1)  tsys_max = 1e10  ! Trap +Inf too
    !
  end subroutine tsys_at_lof
  !
  function foeff(rf)
    real(kind=4) :: foeff
    real(kind=4), intent(in) :: rf
    ! Local
    integer(kind=4) :: ib
    !
    do ib=1,nb
      if (rf.ge.rf_min(ib) .and. rf.le.rf_max(ib)) then
        foeff = feff(ib)%compute(rf)
        return
      endif
    enddo
    foeff = feff_blank
  end function foeff
  !
  function terec(rf)
    real(kind=4) :: terec
    real(kind=4), intent(in) :: rf
    ! Local
    integer(kind=4) :: ib
    !
    do ib=1,nb
      if (rf.ge.rf_min(ib) .and. rf.le.rf_max(ib)) then
        terec = trec(ib)%compute(rf)
        return
      endif
    enddo
    terec = trec_blank
  end function terec
  !
  subroutine noema_tsys_write_bintable(file,error)
    use gildas_def
    use gbl_format
    !-------------------------------------------------------------------
    ! Specific to the continuum table
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: file
    logical,          intent(inout) :: error
    ! Local
    integer(kind=4) :: ier,nfile,lun,currec,recpos
    character(len=message_length) :: mess
    character(len=4) :: tab_code
    integer(kind=4), parameter :: reclen=128  ! Words
    integer(kind=4) :: buffer(reclen)
    !
    ier = sic_getlun(lun)
    nfile = len_trim(file)
    open(unit=lun,file=file(1:nfile),status='NEW',access='DIRECT',   &
        form='UNFORMATTED',iostat=ier,recl=reclen*facunf)
    if (ier.ne.0) then
      call astro_message(seve%e,rname,'Filename: '//file)
      call putios('E-ATM, Open error: ',ier)
      error = .true.
      goto 99
    endif
    !
    call gdf_getcod(tab_code)
    call chtoby(tab_code,buffer(1),4)
    call i4toi4(contversion,buffer(2),1)
    call r4tor4(p1,buffer(3),1)
    call r4tor4(gim,buffer(4),1)
    call i4toi4(ne,buffer(5),1)
    call i4toi4(nlof,buffer(6),1)
    call i4toi4(na,buffer(7),1)
    call i4toi4(nw,buffer(8),1)
    call i4toi4(nt,buffer(9),1)
    currec = 1
    recpos = 10
    !
    ! NB: There is no description of the 'elements' which are stored.
    call noema_tsys_write_binarray(lun,lof,nlof,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,a,na,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,w,nw,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,t,nt,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vtrec,nlof,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vfeff,nlof,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    call noema_tsys_write_binarray(lun,tsys,ne*nlof*na*nw*nt,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    if (recpos.ne.1) then
      ! Flush last record
      write(lun,rec=currec,iostat=ier)  buffer
      if (ier.ne.0) then
        write(mess,'(A,I0)') 'Error writing record ',currec
        call astro_message(seve%e,rname,mess)
        error = .true.
        goto 98
      endif
    endif
    !
    write(mess,'(I0,A)') currec,' records written'
    call astro_message(seve%i,rname,mess)
    !
98  close(lun)
99  call sic_frelun(lun)
  end subroutine noema_tsys_write_bintable
  !
end subroutine noema_tsys_continuum
!
subroutine noema_tsys_write_binarray(lun,array,n,buffer,currec,recpos,error)
  use gbl_message
  use astro_interfaces, except_this=>noema_tsys_write_binarray
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: lun
  integer(kind=4), intent(in)    :: n
  real(kind=4),    intent(in)    :: array(n)
  integer(kind=4), intent(inout) :: buffer(:)
  integer(kind=4), intent(inout) :: currec
  integer(kind=4), intent(inout) :: recpos
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  integer(kind=4), parameter :: reclen=128
  character(len=message_length) :: mess
  integer(kind=4) :: nwritetot,nwritecur,ier
  !
  nwritetot = 0
  do while (nwritetot.lt.n)
    !
    nwritecur = min(n-nwritetot,reclen-recpos+1)
    call r4tor4(array(nwritetot+1),buffer(recpos),nwritecur)
    nwritetot = nwritetot+nwritecur
    recpos = recpos+nwritecur
    !
    if (recpos.gt.reclen) then
      ! print *,"Writing record ",currec
      write(lun,rec=currec,iostat=ier)  buffer
      if (ier.ne.0) then
        write(mess,'(A,I0)') 'Error writing record ',currec
        call astro_message(seve%e,rname,mess)
        error = .true.
        return
      endif
      currec = currec+1
      recpos = 1
    endif
    !
  enddo
end subroutine noema_tsys_write_binarray

subroutine modify(set,line,r,error)
  use gildas_def
  use gbl_message
  use gbl_constant
  use phys_const
  use classcore_dependencies_interfaces
  use classcore_interfaces
  use class_setup_new
  use class_types
  !---------------------------------------------------------------------
  ! @ no-interface (name is too generic, conflicts with local variables)
  ! CLASS Support routine for commande MODIFY
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Command line
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  ! Status flag
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  integer(kind=4), parameter :: nterm=22
  character(len=17) :: term(nterm),chain,key
  integer(kind=4) :: iterm,i,nc,iarg
  real(kind=8) :: r8
  real(kind=4) :: newblank
  character(len=80) :: ch
  character(len=24) :: arg,proja0,projd0,projang
  character(len=13) :: projarg,projunit
  data term /'BANDS',    'BEAM_EFF',         'BLANKING',   'DOPPLER',      &
             'FREQUENCY','ELEVATION_GAIN',   'IMAGE',      'LINENAME',     &
             'OFFSETS',  'PARALLACTIC_ANGLE','POSITION',   'PROJECTION',   &
             'RECENTER', 'SCALE',            'SOURCE',     'SWITCH_MODE',  &
             'SYSTEM',   'TELESCOPE',        'VCONVENTION','VDIRECTION',   &
             'VELOCITY', 'WIDTH'/
  !
  ! Parse for modify kind
  call sic_ke(line,0,1,chain,nc,.true.,error)
  if (error) return
  call sic_ambigs(rname,chain,key,iterm,term,nterm,error)
  if (error) return
  !
  if (sic_present(1,0) .and. key.ne.'BEAM_EFF') then
    call class_message(seve%e,rname,'Option /RUZE is not compatible with '//key)
    error = .true.
    return
  endif
  !
  ! Sanity checks
  if (r%head%xnum.eq.0) then
    call class_message(seve%e,rname,'No spectrum in memory')
    error = .true.
    return
  endif
  !
  select case (key)
  case ('FREQUENCY')
     ! Modify velocity scale according to new rest frequency [MHz]
     call sic_r8(line,0,2,r8,.true.,error)
     if (error) return
     call modify_frequency(r,r8,error)
     if (error) return
     call newdat(set,r,error)
     if (error) return
     !
  case ('VELOCITY')
     ! Modify image and rest frequency according to new reference velocity [km/s]
     call sic_r8(line,0,2,r8,.true.,error)
     if (error) return
     call modify_velocity(r,r8,error)
     if (error)  return
     call newdat(set,r,error)
     if (error) return
     !
  case ('DOPPLER')
     ! Modify the Doppler factor (in the CLASS convention: Dopp = -V/c)
     arg = ''
     call sic_ke(line,0,2,arg,nc,.false.,error)
     if (error) return
     call modify_doppler(set,arg,r%head,error)
     if (error)  return
     !
  case ('RECENTER')
     ! SG: Confidentiel pour corriger erreurs frequences
     call sic_r8(line,0,2,r8,.true.,error)
     if (error) return
     if (r%head%gen%kind.eq.kind_spec) then
        r%head%spe%rchan = r8
     elseif (r%head%gen%kind.eq.kind_cont) then
        r%head%dri%rpoin = r8
     endif
     write(ch,'(A,1PG13.6)') 'Reference channel set to ',r8
     call class_message(seve%w,rname,ch)
     call newdat(set,r,error)
     if (error) return
     !
  case ('BANDS')
     ! Exchange signal and image bands
     if (r%head%spe%image.eq.image_null) then
       call class_message(seve%e,rname,'Spectrum has no image band defined')
       error = .true.
       return
     endif
     r%head%spe%fres = -r%head%spe%fres
     r8 = r%head%spe%image
     r%head%spe%image= r%head%spe%restf
     r%head%spe%restf= r8
     r%head%spe%vres = -clight_kms*r%head%spe%fres/r%head%spe%restf
     call newdat(set,r,error)
     if (error) return
     !
  case ('LINENAME')
     ! Modify line name
     call sic_ch (line,0,2,arg,nc,.true.,error)
     if (error) then
       if (nc.eq.12) then
         call class_message(seve%w,rname,'Line name truncated to 12 char.')
         error = .false.
       else
         return
       endif
     endif
     r%head%spe%line = arg(1:12)
     !
  case ('WIDTH')
     ! Modify channel width [MHz]
     call sic_r8 (line,0,2,r8,.true.,error)
     if (error) return
     if (r%head%gen%kind.eq.kind_spec) then
        r%head%spe%fres = r8
        ! The velocity resolution should actually be computed from the sky frequency
        ! (not available in present header; will have to be added).
        r%head%spe%vres = -clight_kms*r%head%spe%fres/r%head%spe%restf
     elseif (r%head%gen%kind.eq.kind_cont) then
        r%head%dri%tres = r8*r%head%dri%tres/r%head%dri%ares
        r%head%dri%ares = r8
     endif
     call newdat(set,r,error)
     if (error) return
     !
  case ('IMAGE')
     ! Modify the velocity scale corresponding to a new rest frequency [MHz]
     call sic_r8 (line,0,2,r8,.true.,error)
     if (error) return
     r%head%spe%image = r8
     write (ch,'(A,1X,F19.6)') 'Image frequency set to ',r%head%spe%image
     call class_message(seve%i,rname,ch)
     call newdat(set,r,error)
     if (error) return
     !
  case ('TELESCOPE')
     ! Modify telescope name
     call sic_ch (line,0,2,arg,nc,.true.,error)
     if (error) then
       if (nc.eq.12) then
         call class_message(seve%w,rname,'Telescope name truncated to 12 char.')
         error = .false.
       else
         return
       endif
     endif
     r%head%gen%teles = arg(1:12)
     !
  case ('BEAM_EFF')
     ! Modified the beam efficiency.
     call modify_beeff(set,line,r,error)
     if (error)  return
     !
  case ('SOURCE')
     ! Modify source name
     call sic_ch (line,0,2,arg,nc,.true.,error)
     if (error) then
       if (nc.eq.12) then
         call class_message(seve%w,rname,'Source name truncated to 12 char.')
         error = .false.
       else
         return
       endif
     endif
     r%head%pos%sourc = arg(1:12)
     !
  case ('SYSTEM')
     ! Change the System in which the center of projection has  been defined
     call sic_ke(line,0,2,arg,nc,.true.,error)
     if (error) return
     if (arg(1:2).eq.'GA') then
        r%head%pos%system = sign(type_ga,r%head%pos%system)
     elseif (arg(1:2).eq.'EQ') then
        r%head%pos%system = sign(type_eq,r%head%pos%system)
     elseif (arg(1:2).eq.'HO') then
        r%head%pos%system = sign(type_ho,r%head%pos%system)
     elseif (arg(1:2).eq.'IC') then
        r%head%pos%system = sign(type_ic,r%head%pos%system)
     elseif (arg(1:2).eq.'UN') then
        r%head%pos%system = sign(type_un,r%head%pos%system)
     else
        call class_message(seve%e,rname,'Unknown SYSTEM')
        error = .true.
        return
     endif
     !
  case ('OFFSETS') ! MODIFY OFFSET O1 O2 [Unit]
     arg = ' '  ! Default current angle unit
     call sic_ke(line,0,4,arg,nc,.false.,error)
     if (error) return
     call sic_ch(line,0,2,ch,nc,.true.,error)
     if (error) return
     call coffse(set,rname,ch,arg,r%head%pos%lamof,error)
     if (error) return
     call sic_ch(line,0,3,ch,nc,.true.,error)
     if (error) return
     call coffse(set,rname,ch,arg,r%head%pos%betof,error)
     if (error) return
     r%head%pos%rx_off = class_setup_get_fangle()*r%head%pos%lamof
     r%head%pos%ry_off = class_setup_get_fangle()*r%head%pos%betof
     write(ch,'(A,1X,2(1PG10.3,1X),A)') 'Offsets set to ',  &
       r%head%pos%rx_off,r%head%pos%ry_off,obs_system(r%head%pos%system)
     call class_message(seve%i,rname,ch)
     !
  case ('PROJECTION')
     ! Modify the kind of projection (RADIO, AZIMUTHAL, etc) and
     ! optionally the projection center and angle
     call sic_ke(line,0,2,projarg,nc,.true.,error)
     if (error) return
     proja0 = '='  ! Means unchanged by default
     call sic_ch(line,0,3,proja0,nc,.false.,error)
     if (error)  return
     projd0 = '='  ! Means unchanged by default. Must be present if A0 is present
     call sic_ch(line,0,4,projd0,nc,sic_present(0,3),error)
     if (error)  return
     projang = '='  ! Means unchanged by default
     call sic_ch(line,0,5,projang,nc,.false.,error)
     if (error) return
     projunit = 'D'  ! Default degree
     call sic_ke(line,0,6,projunit,nc,.false.,error)
     if (error) return
     !
     call modify_projection(set,r%head,projarg,proja0,projd0,projang,projunit,error)
     if (error)  return
     !
  case ('POSITION')
     ! Modify center of projection
     call sic_ch(line,0,2,proja0,nc,.true.,error)
     if (error)  return
     call sic_ch(line,0,3,projd0,nc,.true.,error)
     if (error)  return
     !
     call modify_projection(set,r%head,'=',proja0,projd0,'=','',error)
     if (error)  return
     !
  case ('SWITCH_MODE')
     ! Modify the description of the switching mode (typically
     ! for foreign data)
     call sic_i4 (line,0,3,nc,.true.,error)
     if (error) return
     if (nc.gt.mxphas) then
        write(chain,'(I2)') mxphas
        ch = 'Too many phases. Only '//chain(1:2)   &
             &        //' supported.'
        call class_message(seve%e,rname,ch)
        error = .true.
        return
     elseif (nc.lt.1) then
        ch = 'Invalid number of phases. Must be positive.'
        call class_message(seve%e,rname,ch)
        error = .true.
        return
     endif
     r%head%swi%nphas = nc
     call sic_ke (line,0,2,chain,nc,.true.,error)
     if (error) return
     if (chain(1:1).eq.'F') then
        do i =1,r%head%swi%nphas
           call sic_r8 (line,0,3*i+1,r%head%swi%decal(i),.true.,error)
           if (error) return
           call sic_r4 (line,0,3*i+2,r%head%swi%duree(i),.true.,error)
           if (error) return
           call sic_r4 (line,0,3*i+3,r%head%swi%poids(i),.true.,error)
           if (error) return
        enddo
        r%head%swi%swmod = mod_freq
        r%head%presec(class_sec_swi_id) = .true.
     elseif (chain(1:1).eq.'P') then
        do i =1,r%head%swi%nphas
           call sic_r4 (line,0,4*i,r%head%swi%ldecal(i),.true.,error)
           if (error) return
           call sic_r4 (line,0,4*i+1,r%head%swi%bdecal(i),.true.,error)
           if (error) return
           call sic_r4 (line,0,4*i+2,r%head%swi%duree(i),.true.,error)
           if (error) return
           call sic_r4 (line,0,4*i+3,r%head%swi%poids(i),.true.,error)
           if (error) return
        enddo
        r%head%swi%swmod = mod_pos
        r%head%presec(class_sec_swi_id) = .true.
     else
        ch = chain//' Switching not yet supported in this command'
        call class_message(seve%e,rname,ch)
        error = .true.
        return
     endif
     !
  case ('BLANKING')
     ! Modify blanking value in both header and data
     call sic_r4 (line,0,2,newblank,.true.,error)
     if (error) return
     call modify_blanking(r,newblank)
     !
  case ('SCALE')  ! MODIFY SCALE ToUnit
     ! Modify Y scale unit (i.e. RY values)
     call sic_ch(line,0,2,chain,nc,.true.,error)
     if (error)  return
     call sic_upper(chain)
     call sic_ambigs(rname,chain,arg,iarg,yunit_keys(1:myunit),myunit,error)
     if (error) return
     call modify_scale(r,iarg,.true.,error)
     if (error)  return
     !
  case ('VCONVENTION')
     call modify_vconvention(set,r%head,error)
     if (error)  return
     call newdat(set,r,error)
     if (error) return
     !
  case ('VDIRECTION')
     call modify_vdirection(set,r%head,error)
     if (error)  return
     call newdat(set,r,error)
     if (error) return
     !
  case ('ELEVATION_GAIN')
     call modify_elevationgain(r,error)
     if (error)  return
     !
  case ('PARALLACTIC_ANGLE')
     call modify_parang(r,error)
     if (error)  return
     !
  case default
     call class_message(seve%e,rname,'Keyword '//trim(key)//' not implemented')
     error = .true.
     return
  end select
  !
end subroutine modify
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine modify_frequency(obs,new_restf,error)
  use phys_const
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Modify velocity scale according to new rest frequency [MHz]
  ! The axes are assumed to be linear in Frequency.
  ! It will also work properly for the RADIO definition of the velocity,
  ! but not for the others
  ! See IRAM Memo "Description of the frequency/velocity axes in CLASS"
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs        !
  real(kind=8),      intent(in)    :: new_restf  !
  logical,           intent(inout) :: error      !
  !
  if (obs%head%spe%restf.eq.new_restf)  return
  !
  ! Update Resolution section
  call modify_resolution(obs,obs%head%spe%restf,new_restf,error)
  if (error)  return
  !
  ! Update Spectroscopic section
  if (obs%head%spe%doppler.ne.-1.d0) then
    obs%head%spe%rchan = obs%head%spe%rchan + &
      (new_restf-obs%head%spe%restf)/obs%head%spe%fres * (1d0+obs%head%spe%doppler)
  else
    obs%head%spe%rchan = obs%head%spe%rchan + &
      (new_restf-obs%head%spe%restf)/obs%head%spe%fres
  endif
  if (obs%head%spe%image.ne.image_null) then
    obs%head%spe%image = (obs%head%spe%image+obs%head%spe%restf) - new_restf
  endif
  obs%head%spe%vres = -clight_kms*obs%head%spe%fres/new_restf
  obs%head%spe%restf = new_restf
  !
end subroutine modify_frequency
!
subroutine modify_velocity(obs,velo_new,error)
  use gbl_message
  use class_types
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   MODIFY VELOCITY
  ! See IRAM Memo "Description of the frequency/velocity axes in CLASS"
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs       !
  real(kind=8),      intent(in)    :: velo_new  !
  logical,           intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  real(kind=8) :: dop_old,dop_new
  !
  if (obs%head%spe%voff.eq.velo_new)  return
  !
  if (obs%head%spe%doppler.eq.-1.d0) then
    call class_message(seve%e,rname,  &
      'Can not compute new Doppler: initial Doppler factor absent')
    call class_message(seve%e,rname,  &
      'You can compute it with MODIFY DOPPLER, see HELP for details')
    error = .true.
    return
  endif
  !
  dop_old = obs%head%spe%doppler
  dop_new = dop_old + (obs%head%spe%voff-velo_new)/clight_kms
  !
  if (obs%head%spe%image.ne.image_null) then
    obs%head%spe%image = obs%head%spe%image*(1.d0+dop_old)/(1.d0+dop_new) -  &
                         obs%head%spe%restf*(dop_new-dop_old)/(1.d0+dop_new)
  endif
  obs%head%spe%rchan   = obs%head%spe%rchan +  &
                         obs%head%spe%restf/obs%head%spe%fres*(dop_new-dop_old)
  obs%head%spe%voff    = velo_new
  obs%head%spe%doppler = dop_new
  !
end subroutine modify_velocity
!
subroutine modify_resolution(obs,old_freq,new_freq,error)
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Recompute the resolution according to the new frequency at
  ! reference channel (= rest frequency)
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  real(kind=8),      intent(in)    :: old_freq
  real(kind=8),      intent(in)    :: new_freq
  logical,           intent(inout) :: error
  ! Local
  real(kind=8) :: factor
  !
  if (.not.obs%head%presec(class_sec_res_id))  return
  if (old_freq.eq.new_freq)  return
  !
  factor = old_freq/new_freq
  obs%head%res%major = obs%head%res%major*factor
  obs%head%res%minor = obs%head%res%minor*factor
  !
end subroutine modify_resolution
!
subroutine modify_projection_charval(set,head,newproj_c,newa0_c,newd0_c,  &
  newang_c,newaunit_c,error)
  use gbl_constant
  use phys_const
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>modify_projection_charval
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic modify_projection
  !   Modify the kind of projection (RADIO, AZIMUTHAL, etc), the
  ! projection center, and the projection angle
  ! ---
  !  Entry point with char*(*) proj, A0, and D0. If head%pos%system is
  ! Equatorial or ICRS, A0 is assumed an hour angle. Arguments with
  ! value '=' mean unchanged.
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set         !
  type(header),        intent(inout) :: head        ! Header to be modified
  character(len=*),    intent(in)    :: newproj_c   ! New projection name
  character(len=*),    intent(in)    :: newa0_c     ! New proj. center A0 (sexagesimal)
  character(len=*),    intent(in)    :: newd0_c     ! New proj. center D0 (sexagesimal)
  character(len=*),    intent(in)    :: newang_c    ! New projection angle
  character(len=*),    intent(in)    :: newaunit_c  ! Projection angle unit
  logical,             intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  character(len=13) :: projkey,projnam_array(0:mproj)
  integer(kind=4) :: newproj
  real(kind=8) :: newa0,newd0,newang
  !
  if (newproj_c.eq.'=') then
    newproj = head%pos%proj
  else
    call projnam_list(projnam_array)  ! Fill with the projection names
    call sic_ambigs(rname,newproj_c,projkey,newproj,projnam_array,mproj+1,error)
    if (error) return
    newproj = newproj-1  ! Because projnam_array numbering starts at 0
  endif
  !
  if (newa0_c.eq.'=') then
    ! Unchanged projection center
    newa0 = head%pos%lam
  else
    ! Decode sexagesimal string
    call sic_sexa(newa0_c,len_trim(newa0_c),newa0,error)
    if (error)  return
    if (head%pos%system.eq.type_eq .or. &
        head%pos%system.eq.type_ic) then
      newa0 = newa0*rad_per_hang
    else
      newa0 = newa0*rad_per_deg
    endif
  endif
  !
  if (newd0_c.eq.'=') then
    ! Unchanged projection center
    newd0 = head%pos%bet
  else
    ! Decode sexagesimal string
    call sic_sexa(newd0_c,len_trim(newd0_c),newd0,error)
    if (error)  return
    newd0 = newd0*rad_per_deg
  endif
  !
  if (newang_c.eq.'=') then
    newang = head%pos%projang
  else
    call sic_math_dble(newang_c,len_trim(newang_c),newang,error)
    if (error)  return
    if (newaunit_c(1:1).eq.'R') then
      continue  ! Unchanged
    elseif (newaunit_c(1:1).eq.'D') then
      newang = newang*rad_per_deg
    else
      call class_message(seve%e,rname,'Angle unit not understood: '//newaunit_c)
      error = .true.
      return
    endif
  endif
  !
  call modify_projection_numval(set,head,newproj,newa0,newd0,newang,error)
  if (error)  return
  !
end subroutine modify_projection_charval
!
subroutine modify_projection_numval(set,head,newproj,newa0,newd0,newang,error)
  use gbl_constant
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use class_setup_new
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic modify_projection
  !   Modify the kind of projection (RADIO, AZIMUTHAL, etc), the
  ! projection center, and the projection angle
  ! ---
  !  Entry point with integer code for proj, and real*8 a0, d0, pang
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set      !
  type(header),        intent(inout) :: head     !
  integer(kind=4),     intent(in)    :: newproj  ! [code] New proj. code
  real(kind=8),        intent(in)    :: newa0    ! [rad ] New proj. center A0
  real(kind=8),        intent(in)    :: newd0    ! [rad ] New proj. center D0
  real(kind=8),        intent(in)    :: newang   ! [rad ] New proj. angle
  logical,             intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='PROJECTION'
  real(kind=8) :: rxoff,ryoff,axoff,ayoff
  type(projection_t) :: proj
  !
  if (newproj.lt.0 .or. newproj.gt.mproj) then
    call class_message(seve%e,rname,'Invalid projection code')
    error = .true.
    return
  endif
  !
  ! Setup Input projection
  call gwcs_projec(head%pos%lam,head%pos%bet,head%pos%projang,head%pos%proj,  &
    proj,error)
  if (error)  return
  !
  ! Convert to absolute coordinates
  rxoff = head%pos%lamof
  ryoff = head%pos%betof
  call rel_to_abs(proj,rxoff,ryoff,axoff,ayoff,1)
  !
  ! Setup Output projection
  call gwcs_projec(newa0,newd0,newang,newproj,proj,error)
  if (error)  return
  !
  ! Convert to new projection
  call abs_to_rel(proj,axoff,ayoff,rxoff,ryoff,1)
  !
  ! Update header
  head%pos%proj = newproj
  head%pos%lam = newa0
  head%pos%bet = newd0
  head%pos%projang = newang
  head%pos%lamof = rxoff
  head%pos%betof = ryoff
  head%pos%rx_off = class_setup_get_fangle()*rxoff
  head%pos%ry_off = class_setup_get_fangle()*ryoff
  !
end subroutine modify_projection_numval
!
subroutine modify_beeff(set,line,r,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>modify_beeff
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   MODIFY BEAM_EFF Beeff
  !   MODIFY BEAM_EFF /RUZE [B0 Sigma]
  ! The spectrum is rescaled according to the new value only if the beam
  ! efficiency previously was non zero valued
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: line   ! Input command line
  type(observation),   intent(inout) :: r      !
  logical,             intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  integer(kind=4), parameter :: optruze=1
  real(kind=4) :: r4,r5,beeff_old
  character(len=message_length) :: mess
  !
  beeff_old = r%head%cal%beeff
  if (beeff_old.eq.0.) then
    call class_message(seve%w,rname,  &
      'Former beam efficiency is 0.0, no correction applied to intensities')
  endif
  !
  if (sic_present(optruze,0)) then  ! /RUZE option
    ! Get values
    if (sic_present(optruze,2)) then
      ! User provides the 2 values
      call sic_r4(line,optruze,1,r4,.true.,error)
      if (error)  return
      call sic_r4(line,optruze,2,r5,.true.,error)
      if (error)  return
    elseif (sic_present(optruze,1)) then
      ! 1 value provided
      call class_message(seve%e,rname,'/RUZE option takes 2 values or none')
      error = .true.
      return
    else
      ! 0 values. Use defaults if known, else error
      call get_ruze_parameters(r,r4,r5,error)
      if (error)  return
    endif
    !
    ! Sanity
    if (r4.le.0. .or. r4.gt.1.) then
        write (mess,'(A,1X,1PG10.3)') 'Invalid B0 in Ruze''s equation: ',r4
        call class_message(seve%e,rname,mess)
        error = .true.
    endif
    if (r5.le.1. .or. r5.gt.1e3) then  ! Sigma in microns
        write (mess,'(A,1X,1PG10.3)')  &
          'Invalid sigma in Ruze''s equation (microns): ',r5
        call class_message(seve%e,rname,mess)
        error = .true.
    endif
    if (error) return
    !
    ! Apply value
    if (r%head%cal%beeff.ne.0.) then
      call modify_beeff_ruze(r,r4,r5)
    else
      r%head%cal%beeff = r4
    endif
    !
  else
    ! No /RUZE option
    call sic_r4 (line,0,2,r4,.true.,error)
    if (error) return
    if (r4.le.0. .or. r4.gt.1.0) then
        write (mess,'(A,1X,1PG10.3)') 'Invalid beam efficiency ',r4
        call class_message(seve%e,rname,mess)
        error = .true.
        return
    endif
    if (r%head%cal%beeff.ne.0.) then
        ! Known beam_eff: rescale
        r5 = r%head%cal%beeff/r4
        call rescale_data (r,r5)
        call rescale_header(r%head,r5)
    else
        ! No known beam_eff: just set the value
    endif
    r%head%cal%beeff = r4
    !
  endif
  !
  write(mess,'(2(A,1X,F6.4))')  &
    'Former beam efficiency:',beeff_old,', new:',r%head%cal%beeff
  call class_message(seve%i,rname,mess)
  !
  call newlimy(set,r,error)
  if (error) return
  !
contains
  !
  subroutine get_ruze_parameters(obs,b0,sigma,error)
    !-------------------------------------------------------------------
    ! Get the known Ruze paramters for the given telescope, observing
    ! date and observing frequency.
    !-------------------------------------------------------------------
    type(observation), intent(in)    :: obs
    real(kind=4),      intent(out)   :: b0
    real(kind=4),      intent(out)   :: sigma
    logical,           intent(inout) :: error
    ! Local
    character(len=24) :: teles
    integer(kind=4) :: ilimit,iband
    character(len=message_length) :: mess
    ! 30m bands
    character(len=2), parameter :: band(4) = (/ 'E0', 'E1', 'E2', 'E3' /)
    real(kind=4), parameter :: flimits(5) = (/ 70.,120.,190.,275.,380. /) ! [GHz] Band limits
    ! Defaults for 30m: after EMIR installation
    integer(kind=4), parameter :: dobs1=-5627  ! 01-APR-2009
    real(kind=4), parameter :: b01=0.863    ! [---] B0 since dobs1
    real(kind=4), parameter :: sigma1=65.6  ! [um] Sigma since dobs1
    ! Defaults for 30m: after surface painting
    integer(kind=4), parameter :: dobs2=5 ! 01-SEP-2024
    real(kind=4), parameter :: b02(4) = (/ 0.65,0.57,0.65,0.57 /)  ! [---] Per band
    real(kind=4), parameter :: sigma2(4) = (/ 71.,78.,71.,78. /) ! [um] Per band
    !
    ! Sanity checks
    call my_get_teles(rname,obs%head%gen%teles,.true.,teles,error)
    if (error) then
      call class_message(seve%e,rname,'/RUZE option knows no measured values for unknown telescope')
      error = .true.
      return
    endif
    if (teles.ne.'30M') then
      call class_message(seve%e,rname,'/RUZE option knows no measured values for telescope '//teles)
      error = .true.
      return
    endif
    !
    ! Fetch the observing band
    if (obs%head%spe%restf.lt.flimits(1)*1.e3 .or. &
        obs%head%spe%restf.gt.flimits(5)*1.e3) then
      write(mess,'(a,1pg14.7,a)')  'Rest frequency ',obs%head%spe%restf/1.e3,  &
        ' GHz out of 30M bands: no /RUZE values available'
      call class_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    do ilimit=1,4
      if (obs%head%spe%restf.gt.flimits(ilimit)*1.e3)  iband = ilimit
    enddo
    !
    if (obs%head%gen%dobs.ge.dobs2) then
      b0 = b02(iband)
      sigma = sigma2(iband)
    elseif (obs%head%gen%dobs.ge.dobs1) then
      b0 = b01
      sigma = sigma1
    else
      call class_message(seve%e,rname,'/RUZE knows no measured values for 30M before 01-APR-2009')
      error = .true.
      return
    endif
    !
    ! Feedback
    write(mess,'(a,f5.3,a,f0.1,3a)') 'Using 30M measured values B0=',b0,  &
      ' and Sigma=',sigma,' in band ',band(iband),' for Ruze''s equation'
    call class_message(seve%i,rname,mess)
  end subroutine get_ruze_parameters
  !
  subroutine modify_beeff_ruze(obs,b0,sigma)
    use phys_const
    !---------------------------------------------------------------------
    !  Modify the observation intensities, channel per channel, according
    ! to the Ruze's equation:
    !   Beeff(lambda) = B0*exp(-(4*pi*sigma/lambda)**2)
    !                 = B0*exp(-(4*pi*sigma*freq/c)**2)
    !---------------------------------------------------------------------
    type(observation), intent(inout) :: obs    !
    real(kind=4),      intent(in)    :: b0     ! [] Scaling factor in Ruze's equation
    real(kind=4),      intent(in)    :: sigma  ! [microns] Width factor in Ruze's equation
    ! Local
    integer(kind=4) :: ichan
    real(kind=4) :: fact1,fact2,bf,bc,bl
    real(kind=8) :: freq
    character(len=message_length) :: mess
    !
    fact2 = -(4.*pis*sigma/clight)**2  ! Sigma converted to meters (* 1.e-6),
                                      ! freq (hereafter) converted to Hz (* 1.e6)
    !
    ! Rescale DATA
    if (obs%head%cal%beeff.ne.0.) then
      fact1 = obs%head%cal%beeff/b0
      !
      do ichan=1,obs%head%spe%nchan
        if (obs%spectre(ichan).eq.obs%cbad)  cycle
        !
        ! Observatory frequency at channel #ichan
        call abscissa_chan2obsfre(obs%head,real(ichan,kind=8),freq)
        !
        obs%spectre(ichan) = obs%spectre(ichan)*fact1/exp(fact2*freq*freq)
      enddo
      !
    endif
    !
    ! User feedback
    ! At left of spectrum
    call abscissa_obsfre_left(obs%head,freq)
    bf = b0*exp(fact2*freq*freq)
    ! At center channel
    call abscissa_obsfre_middle(obs%head,freq)
    bc = b0*exp(fact2*freq*freq)
    ! At right of spectrum
    call abscissa_obsfre_right(obs%head,freq)
    bl = b0*exp(fact2*freq*freq)
    !
    write (mess,'(A,3(2X,F6.4),A,F4.1,A)')  &
      'Beam efficiencies at first, center, and last channels:',bf,bc,bl,  &
      ' (',abs(bl-bf)/bf*100.,'% variation)'
    call class_message(seve%i,rname,mess)
    !
    ! Rescale HEADER. Use new efficiency at central channel
    call rescale_header(obs%head,obs%head%cal%beeff/bc)
    obs%head%cal%beeff = bc
  end subroutine modify_beeff_ruze
end subroutine modify_beeff
!
subroutine modify_blanking_obs(obs,newbad)
  use classcore_interfaces, except_this=>modify_blanking_obs
  use class_types
  !---------------------------------------------------------------------
  ! @ private-generic modify_blanking
  !  Modify blank values (bad and NaN) from the spectrum, and update
  ! the header accordingly
  ! ---
  ! This version for a type(observation) as argument
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  real(kind=4),      intent(in)    :: newbad
  ! Local
  real(kind=4) :: oldbad
  integer(kind=4) :: nchan
  !
  oldbad = obs_bad(obs%head)
  nchan = obs_nchan(obs%head)
  call modify_blanking_nv4(obs%data1,nchan,oldbad,newbad)
  !
  call modify_blanking_head(obs,newbad)
  !
end subroutine modify_blanking_obs
!
subroutine modify_blanking_head(obs,newbad)
  use gbl_constant
  use classcore_interfaces, except_this=>modify_blanking_head
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Modify the blank value in a header
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  real(kind=4),      intent(in)    :: newbad
  !
  if (obs%head%gen%kind.eq.kind_spec) then
    obs%head%spe%bad = newbad
  else
    obs%head%dri%bad = newbad
  endif
  obs%cbad = newbad
  !
end subroutine modify_blanking_head
!
subroutine modify_blanking_nv4(val,nv4,oldbad,newbad)
  use classcore_interfaces, except_this=>modify_blanking_nv4
  !---------------------------------------------------------------------
  ! @ private-generic modify_blanking
  ! Modify blank values (bad and NaN) from the spectrum
  ! ---
  ! This version for I*4 number of values
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: nv4
  real(kind=4),    intent(inout) :: val(nv4)
  real(kind=4),    intent(in)    :: oldbad
  real(kind=4),    intent(in)    :: newbad
  ! Local
  integer(kind=8) :: nv8
  !
  nv8 = nv4
  call modify_blanking_nv8(val,nv8,oldbad,newbad)
  !
end subroutine modify_blanking_nv4
!
subroutine modify_blanking_nv8(val,nv8,oldbad,newbad)
  !---------------------------------------------------------------------
  ! @ private-generic modify_blanking
  ! Modify blank values (bad and NaN) from the spectrum
  ! ---
  ! This version for I*8 number of values
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: nv8
  real(kind=4),    intent(inout) :: val(nv8)
  real(kind=4),    intent(in)    :: oldbad
  real(kind=4),    intent(in)    :: newbad
  ! Local
  integer(kind=8) :: i
  !
  do i=1,nv8
    if (val(i).ne.val(i)) then
      ! Normal compilers: NaN are not even equal to themselves
      val(i) = newbad
    elseif (val(i).eq.oldbad) then
      ! Patch old bad +
      ! also gfortran -O3 case... NaN are equal to everything
      val(i) = newbad
    endif
  enddo
end subroutine modify_blanking_nv8
!
subroutine modify_scale(obs,tocode,verbose,error)
  use phys_const
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>modify_scale
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Modify the Y scale unit
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs      !
  integer(kind=4),   intent(in)    :: tocode   ! Class internal code for new Y unit
  logical,           intent(in)    :: verbose  ! Verbose warnings and infos?
  logical,           intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='SCALE'
  real(kind=4) :: factor
  character(len=message_length) :: mess
  !
  ! Fast exit
  if (obs%head%gen%yunit.eq.tocode .and. verbose) then
    ! Nothing to be done
    call class_message(seve%w,rname,'Y scale unit is already '//  &
      trim(obs_yunit(tocode))//', nothing done')
    return
  endif
  !
  ! Sanity checks
  if (obs%head%gen%yunit.eq.yunit_unknown) then
    call class_message(seve%e,rname,'Can not modify Y unit from Unknown')
    error = .true.
    return
  endif
  if (tocode.eq.yunit_unknown) then
    call class_message(seve%e,rname,'Can not modify Y unit to Unknown')
    error = .true.
    return
  endif
  !
  if (obs%head%gen%yunit.eq.yunit_Jyperbeam  .or. tocode.eq.yunit_Jyperbeam .or.  &
      obs%head%gen%yunit.eq.yunit_mJyperbeam .or. tocode.eq.yunit_mJyperbeam) then
    ! To/from Jansky
    call modify_scale_jy(factor,error)
  else
    ! Tmb to/from Ta*
    call modify_scale_t(factor,error)
  endif
  if (error)  return
  !
  if (verbose) then
    write(mess,'(5A,F0.3)')  'Scaling factor from ',obs_yunit(obs%head%gen%yunit),  &
      ' to ',obs_yunit(tocode),': ',factor
    call class_message(seve%i,rname,mess)
  endif
  !
  call rescale_header(obs%head,factor)
  call rescale_data(obs,factor)
  obs%head%gen%yunit = tocode
  !
contains
  subroutine modify_scale_jy(factor,error)
    !-------------------------------------------------------------------
    ! Specific conversion to/from Jansky
    !-------------------------------------------------------------------
    real(kind=4), intent(out)   :: factor
    logical,      intent(inout) :: error
    ! Local
    real(kind=8) :: lambda,jyperbeam_per_ktmb
    real(kind=4) :: major,minor
    !
    ! Sanity checks
    if (.not.obs%head%presec(class_sec_res_id)) then
      call class_message(seve%e,rname,'Observation has no Resolution section')
      error = .true.
      return
    endif
    major = obs%head%res%major
    minor = obs%head%res%minor
    if (major.eq.0. .and. minor.eq.0.)  then
      ! Section is defined but resolution is null...
      call class_message(seve%e,rname,'Resolution has null size')
      error = .true.
      return
    endif
    if (major.eq.0. .and. verbose) then
      call class_message(seve%w,rname,'Null major axis resolution defaults to minor axis')
      major = minor
    endif
    if (minor.eq.0. .and. verbose) then
      call class_message(seve%w,rname,'Null minor axis resolution defaults to major axis')
      major = minor
    endif
    !
    lambda = clight_mhz/obs%head%spe%restf  ! [m]
    jyperbeam_per_ktmb = 2.d0*kbolt*1.e26*pi*major*minor/(4.d0*log(2.d0)*lambda**2)
    !
    ! Convert from current scale to K (Tmb)
    select case (obs%head%gen%yunit)
    case (yunit_K_Tmb)
      factor = 1.
    case (yunit_Jyperbeam)
      factor = 1./jyperbeam_per_ktmb
    case (yunit_mJyperbeam)
      factor = 1.e-3/jyperbeam_per_ktmb
    case default
      call modify_scale_notimplemented(error)
      return
    end select
    !
    ! Convert from K (Tmb) to new scale
    select case (tocode)
    case (yunit_K_Tmb)
      continue  ! factor = factor*1.
    case (yunit_Jyperbeam)
      factor = factor*jyperbeam_per_ktmb
    case (yunit_mJyperbeam)
      factor = factor*1.e3*jyperbeam_per_ktmb
    case default
      call modify_scale_notimplemented(error)
      return
    end select
    !
  end subroutine modify_scale_jy
  !
  subroutine modify_scale_t(factor,error)
    !-------------------------------------------------------------------
    ! Specific conversion between temperatures
    !-------------------------------------------------------------------
    real(kind=4), intent(out)   :: factor
    logical,      intent(inout) :: error
    ! Local
    !
    ! Sanity checks
    if (.not.obs%head%presec(class_sec_cal_id)) then
      call class_message(seve%e,rname,'Observation has no Calibration section')
      error = .true.
      return
    endif
    if (obs%head%cal%beeff.le.0.) then
      call class_message(seve%e,rname,'Current beam efficiency is null')
      error = .true.
      return
    endif
    if (obs%head%cal%foeff.le.0.) then
      call class_message(seve%e,rname,'Current forward efficiency is null')
      error = .true.
      return
    endif
    if (obs%head%gen%yunit.ne.yunit_K_Tmb .or.  &
        tocode.ne.yunit_K_Tas) then
      ! Only Tmb to Ta* implemented here
      call modify_scale_notimplemented(error)
      return
    endif
    !
    factor = obs%head%cal%beeff/obs%head%cal%foeff
    !
  end subroutine modify_scale_t
  !
  subroutine modify_scale_notimplemented(error)
    logical, intent(inout) :: error
    call class_message(seve%e,rname,'Modifying Y unit scale from '//  &
      trim(obs_yunit(obs%head%gen%yunit))//' to '//trim(obs_yunit(tocode))//  &
      ' is not implemented')
    error = .true.
  end subroutine modify_scale_notimplemented
  !
end subroutine modify_scale
!
subroutine modify_doppler(set,code,head,error)
  use phys_const
  use gbl_message
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>modify_doppler
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !  MODIFY DOPPLER [SIGN|*|Value]
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  character(len=*),    intent(in)    :: code   !
  type(header),        intent(inout) :: head   ! head%pos%doppler modified in return
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  character(len=message_length) :: mess
  real(kind=8) :: dop0,dop1
  logical, save :: doppler_pb
  logical, save :: first = .true.
  !
  dop0 = head%spe%doppler
  select case (code)
  case ('')
    if (first) then
      call sic_def_logi('DOPPLER_PB',doppler_pb,.true.,error)
      first = .false.
    endif
    !*  Test the likelyhood of a sign error for the Doppler factor (-V/c),
    !   by comparing the stored Doppler factor to the computed
    !   Doppler correction in the source direction.
    ! * Compare Doppler factor down to 0.6m/s change in V
    !   (LO precision is 10Hz @ 5GHz)
    ! * SIC variable DOPPLER_PB is created and set to correct state
    ! * Doppler factor is NOT changed
    call compute_doppler(set,head,.true.,error)
    if (error) return
    dop1 = head%spe%doppler
    head%spe%doppler = dop0 ! reset the Doppler correction
    if (abs(dop1-dop0)*clight.gt.6.d-1.and.dop0*dop1.lt.0.d0) then
      write(mess,'(a,g14.8,a,g14.8)') &
          'Sign problem for Doppler factor: Old ',dop0,' New ',dop1
      doppler_pb = .true.
    else
      doppler_pb = .false.
      write(mess,'(a,1pg14.8)') 'Doppler factor agree ',dop0
    endif
    !
  case ('SIGN')
    ! Reverse the sign of the Doppler factor (patch)
    head%spe%doppler = -dop0
    write(mess,*) 'Swap doppler factor sign. New value is: ',head%spe%doppler
    !
  case ('*')
    ! Compute Doppler factor
    call compute_doppler(set,head,.true.,error)
    write(mess,*) 'Doppler factor set to: ',head%spe%doppler
    !
  case default
    ! Change Doppler value from user value
    call sic_math_dble(code,len_trim(code),dop1,error)
    if (error) return
    head%spe%doppler = dop1
    write(mess,*) 'Doppler factor set to: ',head%spe%doppler
  end select
  !
  call class_message(seve%i,rname,mess)
  !
end subroutine modify_doppler
!
subroutine modify_vconvention(set,head,error)
  use gbl_message
  use classcore_interfaces, except_this=>modify_vconvention
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Support routine for command:
  !  MODIFY VCONVENTION
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(header),        intent(inout) :: head   !
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  real(kind=8) :: dop_rad,dop_opt
  !
  dop_rad = 1.d0+head%spe%doppler
  dop_opt = 1.d0/(1.d0-head%spe%doppler)
  !
  head%spe%rchan = head%spe%rchan +  &
                   (dop_opt-dop_rad) * head%spe%restf/head%spe%fres
  !
  ! head%spe%vconv = ZZZ should be changed when the definition of vconv
  !                      is clarified
  !
end subroutine modify_vconvention
!
subroutine modify_vdirection(set,head,error)
  use gbl_message
  use classcore_interfaces, except_this=>modify_vdirection
  use class_types
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Support routine for command:
  !  MODIFY VDIRECTION
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set    !
  type(header),        intent(inout) :: head   !
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='MODIFY'
  real(kind=8) :: dop_old,dop_new
  !
  if (head%spe%vdire.eq.vdire_act)  return
  !
  dop_old = head%spe%doppler
  ! write (*,*) ">>> Doppler old : ",dop_old
  !
  ! Recompute Doppler at reference position
  ! call compute_doppler(set,head,.true.,error)
  ! if (error)  return
  ! d1 = head%spe%doppler
  ! write (*,*)  ">>> At reference: ",d1,(dop_old-d1)/dop_old*head%spe%restf
  !
  ! Recompute Doppler at the offset position
  call compute_doppler(set,head,.false.,error)
  if (error)  return
  dop_new = head%spe%doppler
  ! write (*,*)  ">>> At offset   : ",dop_new,(d1-dop_new)/d1*head%spe%restf
  !
  if (head%spe%image.ne.image_null) then
    head%spe%image = head%spe%image*(1.d0+dop_old)/(1.d0+dop_new) -  &
                     head%spe%restf*(dop_new-dop_old)/(1.d0+dop_new)
  endif
  head%spe%rchan   = head%spe%rchan +  &
                     head%spe%restf/head%spe%fres*(dop_new-dop_old)
  !
  head%spe%vdire = vdire_act
  !
end subroutine modify_vdirection
!
subroutine modify_elevationgain(obs,error)
  use phys_const
  use gbl_message
  use classcore_interfaces, except_this=>modify_elevationgain
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Apply elevation gain correction for 30M data (see Juan Penalver memo
  ! 16-Apr-2012).
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='ELEVATION_GAIN'
  character(len=24) :: teles
  real(kind=4) :: gain,el,fghz
  character(len=message_length) :: mess
  !
  call my_get_teles(rname,obs%head%gen%teles,.true.,teles,error)
  if (error) then
    call class_message(seve%e,rname,'Can not correct for unknown telescope')
    error = .true.
    return
  endif
  if (teles.ne.'30M') then
    call class_message(seve%e,rname,'Correction is not available for telescope '//teles)
    error = .true.
    return
  endif
  !
  fghz = obs%head%spe%restf/1e3
  el = obs%head%gen%el*deg_per_rad
  gain = elevationgain(fghz,el)
  !
  write(mess,'(A,F5.3,A,F0.3,A,F0.1,A)')  'Applying gain ',gain,  &
    ' at freq ',fghz,' GHz elevation ',el,' deg.'
  call class_message(seve%i,rname,mess)
  !
  call rescale_header(obs%head,1/gain)
  call rescale_data(obs,1/gain)
  !
contains
  function elevationgain(freq,elobs)
    real(kind=4) :: elevationgain
    real(kind=4), intent(in) :: freq   ! [GHz]
    real(kind=4), intent(in) :: elobs  ! [deg]
    ! Local
    real(kind=4) :: lambdamu,elmax
    !
    lambdamu = clight_kms/freq  ! km/s / GHz => microns
    elmax = 1.567e-6*freq**3 - 1.233e-3*freq**2 + 3.194e-1*freq+2.203e+1
    elevationgain = aeff(lambdamu,elobs)/aeff(lambdamu,elmax)
    !
  end function elevationgain
  !
  function aeff(lambdamu,el)
    real(kind=4) :: aeff
    real(kind=4), intent(in) :: lambdamu  ! [microns]
    real(kind=4), intent(in) :: el        ! [deg]
    ! Local
    real(kind=4) :: aeff0,rms
    !
    aeff0 = 8.8466e-6*el**2 - 1.2523e-3*el + 6.9608e-1
    rms   = 2.5523e-2*el**2 - 2.5534*el + 1.1937e+2
    aeff  = aeff0 * exp(-1*((4*pi*rms)/(lambdamu))**2)
    !
  end function aeff
  !
end subroutine modify_elevationgain
!
subroutine modify_parang(obs,error)
  use phys_const
  use gbl_message
  use gkernel_interfaces
  use classcore_interfaces, except_this=>modify_parang
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! Recompute the parallactic angle from latitude + azimuth + elevation
  !---------------------------------------------------------------------
  type(observation), intent(inout) :: obs
  logical,           intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='PARALLACTIC_ANGLE'
  character(len=24) :: teles
  real(kind=8) :: lonlat(2),alti,slimit
  real(kind=4) :: diam
  real(kind=8) :: lat,az,el
  character(len=message_length) :: mess
  !
  call my_get_teles(rname,obs%head%gen%teles,.false.,teles,error)
  if (error)  return
  if (teles.ne.'30M') then
    call class_message(seve%w,rname,  &
      'Assuming azimuth convention South at 180 degrees for telescope '//teles)
    error = .true.
    return
  endif
  !
  call gwcs_observatory(teles,lonlat,alti,slimit,diam,error)
  if (error)  return
  lat = lonlat(2)*rad_per_deg
  az = obs%head%gen%az  ! Is this the azimuth of the spectrum or the projection center?
  el = obs%head%gen%el  ! Same
  call gwcs_azel2pa(lat,az,el,obs%head%gen%parang)
  !
  !---------------------------------------------------------------------
  ! This version of the code uses the traditional parallactic angle
  ! formula, but needs to precess the exact position of the spectrum.
  !
  !  ! Need the equinox at observation date
  !  call gag_gagut2mjd(obs%head%gen%dobs,obs%head%gen%ut,mjd,error)
  !  if (error)  return
  !  call gag_mjd2gregorian(mjd,iy,im,id,error)
  !  if (error)  return
  !  newequinox = iy  ! ZZZ To be improved for fractional part
  !  !
  !  ! Precess the RA/DEC coordinates at observation date
  !  if (obs%head%pos%system.ne.type_eq) then
  !    call class_message(seve%e,rname,  &
  !      'Computing parallactic angle from non-equatorial system is not implemented')
  !    ! Actually we could go from any system to EQ.XXXX
  !    error = .true.
  !    return
  !  endif
  !  call equ_to_equ(  &
  !    obs%head%pos%lam,obs%head%pos%bet,obs%head%pos%lamof,obs%head%pos%betof,obs%head%pos%equinox,  &
  !    newra,           newdec,          lamof,             betof,             newequinox,  &
  !    error)
  !  if (error)  return
  !  ! ZZZ This is new (RA,DEC) at projection center, not spectrum position!
  !  !
  !  ! Compute parallactic angle
  !  ha = obs%head%gen%st-newra
  !  obs%head%gen%parang = atan2(sin(ha),tan(lat)*cos(newdec)-sin(newdec)*cos(ha))
  !---------------------------------------------------------------------
  !
  write(mess,'(A,F0.3,A)')  &
    'Parallactic angle set to ',obs%head%gen%parang*deg_per_rad,' degrees'
  call class_message(seve%i,rname,mess)
  !
end subroutine modify_parang

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CUBE messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cube_messaging
  use gpack_def
  use gbl_message
  use cubetools_parameters
  !
  public :: seve,mess_l
  public :: cube_message_set_id,cube_message
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: cube_message_id = gpack_global_id  ! Default value for startup message
  !
contains
  !
  subroutine cube_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    !
    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='MESSAGE>SET>ID'
    !
    cube_message_id = id
    write (mess,'(A,I3)') 'Now use id #',cube_message_id
    call cube_message(seve%d,rname,mess)
  end subroutine cube_message_set_id
  !
  subroutine cube_message(mkind,procname,message)
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind    ! Message kind
    character(len=*), intent(in) :: procname ! Name of calling procedure
    character(len=*), intent(in) :: message  ! Message string
    !
    call cubetools_cmessage(cube_message_id,mkind,'CUBE>'//procname,message)
  end subroutine cube_message
end module cube_messaging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gag_diff_char(caller,secname,secwarned,elemname,a,b)
  use gbl_message
  use gmath_interfaces, except_this=>gag_diff_char
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ.
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  character(len=*), intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (a.eq.b)  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,A,T52,A)
end subroutine gag_diff_char
!
subroutine gag_diff_inte(caller,secname,secwarned,elemname,a,b)
  use gbl_message
  use gmath_interfaces, except_this=>gag_diff_inte
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ.
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  integer(kind=4),  intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (a.eq.b)  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,I0,T52,I0)
end subroutine gag_diff_inte
!
subroutine gag_diff_long(caller,secname,secwarned,elemname,a,b)
  use gbl_message
  use gmath_interfaces, except_this=>gag_diff_long
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ.
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  integer(kind=8),  intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (a.eq.b)  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,I0,T52,I0)
end subroutine gag_diff_long
!
subroutine gag_diff_real(caller,secname,secwarned,elemname,a,b)
  use gbl_message
  use gmath_interfaces, except_this=>gag_diff_real
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ (with some
  ! machine tolerance).
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  real(kind=4),     intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (nearly_equal(a,b,1.e-6))  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,1PG12.5,T52,1PG12.5)
  !
end subroutine gag_diff_real
!
subroutine gag_diff_dble(caller,secname,secwarned,elemname,a,b)
  use gbl_message
  use gmath_interfaces, except_this=>gag_diff_dble
  !---------------------------------------------------------------------
  ! @ public-generic gag_diff_elem
  ! Returns a message if the two elements a and b differ (with some
  ! machine tolerance).
  ! If the elements are part of a larger section (name section), a
  ! warning about the section is also issued if not yet done.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: caller
  character(len=*), intent(in)    :: secname
  logical,          intent(inout) :: secwarned
  character(len=*), intent(in)    :: elemname
  real(kind=8),     intent(in)    :: a,b
  ! Local
  character(len=message_length) :: mess
  !
  if (nearly_equal(a,b,1.d-14))  return
  !
  if (.not.secwarned) then
    call gmath_message(seve%r,caller,secname//' sections differ')
    secwarned = .true.
  endif
  !
  write(mess,10)  elemname,a,b
  call gmath_message(seve%r,caller,mess)
  !
10 format(2X,A,T32,1PG19.12,T52,1PG19.12)
  !
end subroutine gag_diff_dble
!
subroutine gag_diff_datar4(caller,a,b,ndata,same)
  use gildas_def
  use gbl_message
  use gmath_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Returns a message if the two flat arrays a and b differ (with some
  ! machine tolerance).
  !---------------------------------------------------------------------
  character(len=*),          intent(in)  :: caller
  integer(kind=size_length), intent(in)  :: ndata
  real(kind=4),              intent(in)  :: a(ndata),b(ndata)
  logical,                   intent(out) :: same
  ! Local
  character(len=message_length) :: mess
  real(kind=4), parameter :: eps=1.e-6
  !
  same = nearly_equal(a,b,ndata,eps)
  !
  if (.not.same) then
    write (mess,'(A,1PG7.1,A)')  'Data differ by ',eps,' relative difference at least'
    call gmath_message(seve%r,caller,mess)
  endif
  !
end subroutine gag_diff_datar4
!
function nearly_equal_r4_0d(a,b,eps)
  !---------------------------------------------------------------------
  ! @ public-generic nearly_equal
  !---------------------------------------------------------------------
  logical :: nearly_equal_r4_0d
  real(kind=4), intent(in) :: a,b
  real(kind=4), intent(in) :: eps  ! Acceptable relative difference
  ! Local
  real(kind=4) :: diff
  !
  if (a.ne.a .and. b.ne.b) then  ! Both are NaN => equal
    nearly_equal_r4_0d = .true.
    return
  endif
  !
  if (a.eq.b) then  ! Strictly equal
    nearly_equal_r4_0d = .true.
    return
  endif
  !
  diff = abs(a-b)
  if (a.eq.0. .or. b.eq.0. .or. diff.lt.tiny(a)) then
    ! a or b is zero or both are extremely close to it. Note the use
    ! of tiny() which returns the smallest floating point number
    ! representable without being a denormal number.
    ! Relative error is less meaningful here
    nearly_equal_r4_0d = diff.lt.eps*tiny(a)
    return
  endif
  !
  ! Use relative error. Note this test is commutative
  nearly_equal_r4_0d = diff/(abs(a)+abs(b)).lt.eps
  !
end function nearly_equal_r4_0d
!
function nearly_equal_r8_0d(a,b,eps)
  !---------------------------------------------------------------------
  ! @ public-generic nearly_equal
  !---------------------------------------------------------------------
  logical :: nearly_equal_r8_0d
  real(kind=8), intent(in) :: a,b
  real(kind=8), intent(in) :: eps  ! Acceptable relative difference
  ! Local
  real(kind=8) :: diff
  !
  if (a.ne.a .and. b.ne.b) then  ! Both are NaN => equal
    nearly_equal_r8_0d = .true.
    return
  endif
  !
  if (a.eq.b) then  ! Strictly equal
    nearly_equal_r8_0d = .true.
    return
  endif
  !
  diff = abs(a-b)
  if (a.eq.0. .or. b.eq.0. .or. diff.lt.tiny(a)) then
    ! a or b is zero or both are extremely close to it. Note the use
    ! of tiny() which returns the smallest floating point number
    ! representable without being a denormal number.
    ! Relative error is less meaningful here
    nearly_equal_r8_0d = diff.lt.eps*tiny(a)
    return
  endif
  !
  ! Use relative error. Note this test is commutative
  nearly_equal_r8_0d = diff/(abs(a)+abs(b)).lt.eps
  !
end function nearly_equal_r8_0d
!
function nearly_equal_r4_1d(a,b,ndata,eps)
  use gildas_def
  use gmath_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ public-generic nearly_equal
  !---------------------------------------------------------------------
  logical :: nearly_equal_r4_1d
  integer(kind=size_length), intent(in) :: ndata
  real(kind=4),              intent(in) :: a(ndata),b(ndata)
  real(kind=4),              intent(in) :: eps  ! Acceptable relative difference
  ! Local
  real(kind=4), allocatable :: diff(:)
  logical :: error
  integer(kind=4) :: ier
  integer(kind=size_length) :: idata
  !
  nearly_equal_r4_1d = .true.
  !
  do idata=1,ndata
    if (a(idata).ne.a(idata) .and. b(idata).ne.b(idata))  cycle  ! Both are NaN => equal
    if (a(idata).eq.b(idata))  cycle  ! Strictly equal
    nearly_equal_r4_1d = .false.  ! Not strictly equal, need comparison with tolerance
    exit
  enddo
  if (nearly_equal_r4_1d)  return
  !
  error = .false.
  allocate(diff(ndata),stat=ier)
  if (failed_allocate('DIFF','diff',ier,error)) return
  diff(:) = abs(a-b)
  !
  ! Can I write a vectorized form of this test?
!     if (a.eq.0. .or. b.eq.0. .or. diff.lt.tiny(a)) then
!       ! a or b is zero or both are extremely close to it. Note the use
!       ! of tiny() which returns the smallest floating point number
!       ! representable without being a denormal number.
!       ! Relative error is less meaningful here
!       nearly_equal_r4_1d = diff.lt.eps*tiny(a)
!       return
!     endif
  !
  ! Use relative error. Note this test is commutative
  nearly_equal_r4_1d = all(diff/(abs(a)+abs(b)).lt.eps)
  !
  deallocate(diff)
  !
end function nearly_equal_r4_1d

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CLASS messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module class_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer :: class_message_id = gpack_global_id  ! Default value for startup message
  !
end module class_message_private
!
subroutine class_message_set_id(id)
  use class_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer, intent(in) :: id         !
  ! Local
  character(len=message_length) :: mess
  !
  class_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',class_message_id
  call class_message(seve%d,'class_message_set_id',mess)
  !
end subroutine class_message_set_id
!
subroutine class_message(mkind,procname,message)
  use gkernel_interfaces
  use class_message_private
  !---------------------------------------------------------------------
  ! @ public (for libclass only)
  ! Messaging facility for the current library. Calls the low-level
  ! (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(class_message_id,mkind,procname,message)
  !
end subroutine class_message
!
subroutine class_iostat(mkind,procname,ier)
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Output system message corresponding to IO error code IER, and
  ! using the MESSAGE routine
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message severity
  character(len=*), intent(in) :: procname  ! Calling routine name
  integer,          intent(in) :: ier       ! IO error number
  ! Local
  character(len=message_length) :: msg
  !
  if (ier.eq.0) return
  call gag_iostat(msg,ier)
  call class_message(mkind,procname,msg)
  !
end subroutine class_iostat
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

function sic_hasins(rname,mdim,pf,pn,dict,var,in)
  use gbl_message
  use sic_interfaces, except_this=>sic_hasins
  use sic_dependencies_interfaces
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Insert a new name or replace an existing name
  !       in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASINS      0       E  Invalid name
  !                       1       S  Successfully inserted
  !                       2       E  Too many names
  !                       3       S  Successfully replaced
  !
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input/Output
  !                       PF(27) is the number of symbols
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input/Output
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasins  ! Function value on return
  character(len=*),       intent(in)    :: rname       ! Calling routine name
  integer(kind=4),        intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),        intent(inout) :: pf(0:27)    !
  integer(kind=4),        intent(inout) :: pn(mdim)    !
  type(sic_variable_t),   intent(inout) :: dict(mdim)  ! Dictionnary array of size MDIM
  type(sic_identifier_t), intent(inout) :: var         ! Variable to be inserted
  integer(kind=4),        intent(out)   :: in          ! Address of this variable
  ! Local
  integer(kind=4) :: j,k
  character(len=message_length) :: mess
  !
  in = 0
  sic_hasins = 0
  !
  ! Find the place in PF
  call sic_upper(var%name)
  j = ichar(var%name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) then
    call sic_message(seve%e,rname,'Invalid variable name '//var%name)
    return
  endif
  !
  ! Find if it exits already
  k = pf(j)
  do while (k.gt.0)
    if (var%level.eq.dict(k)%id%level .and. var%lname.eq.dict(k)%id%lname) then
      if (var%name(1:var%lname).eq.dict(k)%id%name(1:var%lname)) then
        in = k
        sic_hasins = 3
        return
      endif
    endif
    k = pn(k)
  enddo
  !
  ! Find if place left
  if (pf(26).eq.0) then
    write(mess,'(A,I0,A)')  'Too many variables, set SIC_MAXVAR to more than ',  &
      mdim,' in your $HOME/.gag.dico'
    call sic_message(seve%e,rname,mess)
    sic_hasins = 2
    return
  endif
  !
  ! Insert NAME in place and set pointers
  k = pf(26)
  pf(26) = pn(k)
  pn(k) = pf(j)
  pf(j) = k
  dict(k)%id = var
  in = k
  pf(27) = pf(27)+1
  sic_hasins = 1
  !
end function sic_hasins
!
function sic_hasdel(mdim,pf,pn,dict,var)
  use sic_dependencies_interfaces
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Delete a name in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASDEL      1       Name deleted
  !                       3       Name does not exist
  !
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input/Output
  !                       PF(27) is the number of symbols
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input/Output
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasdel  ! Function value on return
  integer(kind=4),        intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),        intent(inout) :: pf(0:27)    !
  integer(kind=4),        intent(inout) :: pn(mdim)    !
  type(sic_variable_t),   intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
  type(sic_identifier_t), intent(inout) :: var         ! Variable to be deleted
  ! Local
  integer(kind=4) :: j,kl,k
  !
  sic_hasdel = 3
  ! Find the place in PF
  call sic_upper(var%name)
  j = ichar(var%name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Now examine if it is a known symbol
  kl = 0
  k = pf(j)
  do while (k.ne.0)
    if (var%level.eq.dict(k)%id%level .and. var%lname.eq.dict(k)%id%lname) then
      if (var%name(1:var%lname).eq.dict(k)%id%name(1:var%lname)) then
        exit
      endif
    endif
    kl = k
    k = pn(k)
  enddo
  if (k.eq.0)  return  ! Nothing found (reached end of dictionary with no matching
                       ! variable)
  !
  ! Now delete it
  sic_hasdel = 1
  if (kl.ne.0) then
    pn(kl) = pn(k)
  else
    pf(j) = pn(k)
  endif
  pn(k) = pf(26)
  pf(26) = k
  pf(27) = pf(27)-1
end function sic_hasdel
!
function sic_hasfin(mdim,pf,pn,dict,var,in)
  use sic_dependencies_interfaces
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Find a name in a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASFIN      0       No such name
  !                       1       Name found
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasfin                          ! Function value on return
  integer(kind=4),        intent(in)    :: mdim        ! Size of dictionnary
  integer(kind=4),        intent(in)    :: pf(0:27)    !
  integer(kind=4),        intent(in)    :: pn(mdim)    !
  type(sic_variable_t),   intent(in)    :: dict(mdim)  ! Dictionnary array of size MDIM
  type(sic_identifier_t), intent(inout) :: var         ! Variable to be found
  integer(kind=4),        intent(out)   :: in          ! Address of this variable
  ! Local
  integer(kind=4) :: j
  !
  ! If no symbol return
  in = 0
  sic_hasfin = 0
  if (pf(27).eq.0) return
  !
  ! Find the place in PF
  call sic_upper(var%name)
  j = ichar(var%name(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  !
  ! Now examine the chained structure from this point
  j = pf(j)
  do while (j.ne.0)
    if (var%level.eq.dict(j)%id%level .and. var%lname.eq.dict(j)%id%lname) then
      if (var%name(1:var%lname).eq.dict(j)%id%name(1:var%lname)) then
        in = j
        sic_hasfin = 1
        return
      endif
    endif
    j = pn(j)
  enddo
  !
end function sic_hasfin
!
function sic_hasambigs(mdim,pf,pn,dict,name,if,il)
  use sic_dependencies_interfaces
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !       Find all names beginning with the letters of NAME
  !       in  a dictionnary using a hashing structure
  !       and a list of pointers.
  !
  !       SIC_HASAMBIGS   0       No such name
  !                       n       N Names found
  !       PF      I(0:27) PF(J) Address of first name beginning
  !                       with CHAR(J-ICHAR('A')) in dictionnary.
  !                       PF(26) is the address of the first
  !                       available place.                        Input
  !       PN      I(MDIM) Address of next name with same first
  !                       letter. If PN(J)=0, no more such name.  Input
  !---------------------------------------------------------------------
  integer(kind=4) :: sic_hasambigs                     ! Value on return
  integer(kind=4),      intent(in)  :: mdim        ! Size of dictionary
  integer(kind=4),      intent(in)  :: pf(0:27)    !
  integer(kind=4),      intent(in)  :: pn(mdim)    !
  type(sic_variable_t), intent(in)  :: dict(mdim)  ! Dictionary array
  character(len=*),     intent(in)  :: name        ! Name against whom search
  integer(kind=4),      intent(out) :: if          ! Adress of first Match
  integer(kind=4),      intent(out) :: il          ! Adress of  last Match
  ! Local
  integer(kind=4) :: j,l
  character(len=varname_length) :: uname
  !
  ! If no symbol return
  if = 0
  il = 0
  sic_hasambigs = 0
  !
  ! Find the place in PF
  l = len_trim(name)
  uname = name
  call sic_upper(uname)
  j = ichar(uname(1:1))-ichar('A')
  if (j.lt.0 .or. j.gt.25) return
  if (pf(27).eq.0) return
  !
  ! Now examine the chained structure from this point
  j = pf(j)
  do while (j.ne.0)
    if (uname(1:l).eq.dict(j)%id%name(1:l)) then
      if (if.eq.0) if = j
      il = j
      sic_hasambigs = sic_hasambigs+1
    endif
    j = pn(j)
  enddo
  if (if.eq.0) return
  !
  if (if.eq.il .and. uname.eq.dict(if)%id%name) return
  !
  call sic_message(seve%w,'SIC','Ambiguous Name, Could be:')
  j = ichar(uname(1:1))-ichar('A')
  j = pf(j)
  !
  do while (j.ne.0)
    if (uname(1:l).eq.dict(j)%id%name(1:l)) then
      write (*,'(A)') trim(dict(j)%id%name)
    endif
    j = pn(j)
  enddo
  !
end function sic_hasambigs
!
subroutine sic_hassort(mdim,pf,pn,dict,list,leng)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_hassort
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as type(sic_variable_t) arrays ***
  !
  !  List alphabetically a dictionnary using a hashing structure and a
  ! list of pointers. This routine just builds the list of pointers to
  ! current entries.
  !
  !   PF(0:27)   PF(0:25) Address of first name beginning with
  !                       CHAR(J-ICHAR('A')) in dictionnary.
  !              PF(26)   is the address of the first available place.
  !              PF(27)   the number of symbols
  !   PN(MDIM)            Address of next name with same first letter.
  !                       If PN(J)=0, no more such name.
  !---------------------------------------------------------------------
  integer(kind=4),      intent(in)  :: mdim        ! Size of dictionnary
  integer(kind=4),      intent(in)  :: pf(0:27)    !
  integer(kind=4),      intent(in)  :: pn(mdim)    !
  type(sic_variable_t), intent(in)  :: dict(mdim)  ! Dictionary array
  integer(kind=4),      intent(out) :: list(mdim)  ! List of entries in dictionnary
  integer(kind=4),      intent(out) :: leng        ! Current number of entries
  ! Local
  integer(kind=4) :: i,j,first,last
  logical :: error
  !
  leng = 0
  if (pf(27).eq.0)  return  ! Empty dictionnary
  !
  error = .false.
  !
  do i=0,25
    if (pf(i).le.0)  cycle  ! Next letter
    !
    j = pf(i)
    leng = leng+1
    list(leng) = j
    first = leng  ! First index for the current letter
    do while (pn(j).gt.0)
      j = pn(j)
      leng = leng+1
      list(leng) = j
    enddo
    last = leng  ! Last index for the current letter
    !
    ! Now sort the list for this letter
    call gi0_quicksort_index_with_user_gtge(list(first:last),last-first+1,  &
      hassort_gt,hassort_ge,error)
    if (error)  return
    !
  enddo
  !
contains
  !
  ! Sorting functions: just sort by variable names
  function hassort_gt(m,l)
    logical :: hassort_gt
    integer(kind=4), intent(in) :: m,l
    hassort_gt = lgt(dict(m)%id%name,dict(l)%id%name)
  end function hassort_gt
  !
  function hassort_ge(m,l)
    logical :: hassort_ge
    integer(kind=4), intent(in) :: m,l
    hassort_ge = lge(dict(m)%id%name,dict(l)%id%name)
  end function hassort_ge
  !
end subroutine sic_hassort
!
subroutine gag_hassort(mdim,pf,pn,dict,list,leng)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>gag_hassort
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  *** This version for dictionaries as character string arrays ***
  !  (This subroutine should go in kernel/lib/gsys/hashing.f90 but
  !   the subroutine gi0_quicksort_index_with_user_gtge is needed.)
  !
  !  List alphabetically a dictionnary using a hashing structure and a
  ! list of pointers. This routine just builds the list of pointers to
  ! current entries.
  !
  !   PF(0:27)   PF(0:25) Address of first name beginning with
  !                       CHAR(J-ICHAR('A')) in dictionnary.
  !              PF(26)   is the address of the first available place.
  !              PF(27)   the number of symbols
  !   PN(MDIM)            Address of next name with same first letter.
  !                       If PN(J)=0, no more such name.
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)  :: mdim        ! Size of dictionnary
  integer(kind=4),  intent(in)  :: pf(0:27)    !
  integer(kind=4),  intent(in)  :: pn(mdim)    !
  character(len=*), intent(in)  :: dict(mdim)  ! Dictionnary array of size MDIM
  integer(kind=4),  intent(out) :: list(mdim)  ! List of entries in dictionnary
  integer(kind=4),  intent(out) :: leng        ! Current number of entries
  ! Local
  integer(kind=4) :: i,j,first,last
  logical :: error
  !
  leng = 0
  if (pf(27).eq.0)  return  ! Empty dictionary
  !
  error = .false.
  !
  do i=0,25
    if (pf(i).le.0)  cycle  ! Next letter
    !
    j = pf(i)
    leng = leng+1
    list(leng) = j
    first = leng  ! First index for the current letter
    do while (pn(j).gt.0)
      j = pn(j)
      leng = leng+1
      list(leng) = j
    enddo
    last = leng  ! Last index for the current letter
    !
    ! Now sort the list for this letter
    call gi0_quicksort_index_with_user_gtge(list(first:last),last-first+1,  &
      hassort_gt,hassort_ge,error)
    if (error)  return
    !
  enddo
  !
contains
  !
  ! Sorting functions: just sort by variable names
  function hassort_gt(m,l)
    logical :: hassort_gt
    integer(kind=4), intent(in) :: m,l
    hassort_gt = lgt(dict(m),dict(l))
  end function hassort_gt
  !
  function hassort_ge(m,l)
    logical :: hassort_ge
    integer(kind=4), intent(in) :: m,l
    hassort_ge = lge(dict(m),dict(l))
  end function hassort_ge
  !
end subroutine gag_hassort

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubesyntax_keyval_dble_types
  use cubetools_parameters
  use cubetools_structure
  use cubesyntax_value_dble_types
  use cubesyntax_messaging
  !
  public :: keyval_dble_comm_t,keyval_dble_user_t,keyval_dble_prog_t
  private
  !
  type keyval_dble_comm_t
     type(option_t), pointer :: key
     type(value_dble_comm_t) :: value
   contains
     procedure, public :: register => cubesyntax_keyval_dble_comm_register
     procedure, public :: parse    => cubesyntax_keyval_dble_comm_parse
  end type keyval_dble_comm_t
  !
  type keyval_dble_user_t
     logical               :: do = .false.
     character(len=argu_l) :: val = strg_star
   contains
     procedure, public :: toprog => cubesyntax_keyval_dble_user_toprog
     procedure, public :: list   => cubesyntax_keyval_dble_user_list
  end type keyval_dble_user_t
  !
  type keyval_dble_prog_t
   contains
     procedure, public :: list   => cubesyntax_keyval_dble_prog_list
  end type keyval_dble_prog_t
  !
contains
  !
  subroutine cubesyntax_keyval_dble_comm_register(comm,&
       keyname,keyabstract,keyhelp,valdefault,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(keyval_dble_comm_t), intent(inout) :: comm
    character(len=*),          intent(in)    :: keyname
    character(len=*),          intent(in)    :: keyabstract
    character(len=*),          intent(in)    :: keyhelp
    real(kind=dble_k),         intent(in)    :: valdefault
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>DBLE>COMM>REGISTER'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call cubetools_register_option(&
         keyname,&
         'value',&
         keyabstract,&
         keyhelp,&
         comm%key,&
         error)
    if (error) return
    call comm%value%register(&
         keyname,&
         valdefault,&
         strg_emp,&
         error)
    if (error) return
  end subroutine cubesyntax_keyval_dble_comm_register
  !
  subroutine cubesyntax_keyval_dble_comm_parse(comm,line,user,error)
    use cubetools_structure
    !----------------------------------------------------------------------
    ! /KEY value
    !----------------------------------------------------------------------
    class(keyval_dble_comm_t), intent(in)    :: comm
    character(len=*),          intent(in)    :: line
    type(keyval_dble_user_t),  intent(out)   :: user ! => Initialized!
    logical,                   intent(inout) :: error
    !
    integer(kind=argu_k), parameter :: ival=1
    character(len=*), parameter :: rname='KEYVAL>DBLE>COMM>PARSE'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call comm%key%present(line,user%do,error)
    if (error) return
    if (user%do) then
       call cubetools_getarg(line,comm%key,ival,user%val,mandatory,error)
       if (error) return
    endif
  end subroutine cubesyntax_keyval_dble_comm_parse
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesyntax_keyval_dble_user_toprog(user,comm,prog,error)
    use cubetools_unit
    use cubetools_user2prog
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(keyval_dble_user_t), intent(in)    :: user
    type(keyval_dble_comm_t),  intent(in)    :: comm
    real(kind=dble_k),         intent(inout) :: prog
    logical,                   intent(inout) :: error
    !
    type(unit_user_t) :: nounit
    character(len=*), parameter :: rname='KEYVAL>DBLE>USER>TOPROG'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    ! *** JP This syntax seems very strange to me because we transfer a
    ! *** JP constant object named nounit!
    call nounit%get_from_code(code_unit_unk,error)
    if (error) return
    call cubetools_user2prog_resolve_star(user%val,nounit,comm%value%default,prog,error)
    if (error) return
  end subroutine cubesyntax_keyval_dble_user_toprog
  !
  subroutine cubesyntax_keyval_dble_user_list(user,error)
    !----------------------------------------------------------------------
    ! Mostly for debugging purpose
    !----------------------------------------------------------------------
    class(keyval_dble_user_t), intent(in)    :: user 
    logical,                       intent(inout) :: error
    !
!    character(len=mess_l) :: mess
    character(len=*), parameter :: rname='KEYVAL>DBLE>USER>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
  end subroutine cubesyntax_keyval_dble_user_list
  !
  !------------------------------------------------------------------------
  !
  subroutine cubesyntax_keyval_dble_prog_list(prog,comm,value,error)
    use cubesyntax_keyval_list_tool
    !-------------------------------------------------------------------
    ! List the information in a user friendly way
    !-------------------------------------------------------------------
    class(keyval_dble_prog_t), intent(in)    :: prog
    type(keyval_dble_comm_t),  intent(in)    :: comm
    real(kind=dble_k),         intent(in)    :: value
    logical,                   intent(inout) :: error
    !
    character(len=*), parameter :: rname='KEYVAL>DBLE>PROG>LIST'
    !
    call cubesyntax_message(syntaxseve%trace,rname,'Welcome')
    !
    call keyval%list(comm%key%name,value,error)
    if (error) return
  end subroutine cubesyntax_keyval_dble_prog_list
end module cubesyntax_keyval_dble_types
! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine greg_write(line,error)
  use gbl_format
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_write
  use greg_kernel
  use greg_poly
  use greg_rg
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Support routine for command
  !
  !   WRITE
  !     COLUMN Filename [NEW [Format]] /TABLE X Nx Y Ny z Nz
  !     IMAGE
  !     RGDATA Filename "Comment X" "Comment Y"
  !     POLYGON
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  character(len=*), parameter :: rname='WRITE'
  integer(kind=4) :: nkey,nc
  character(len=filename_length) :: fname,ffile
  character(len=12) :: argum,keywor
  integer(kind=4), parameter :: mvoc=4
  character(len=7), parameter :: vocab(mvoc)=(/'COLUMN ','RGDATA ','POLYGON','IMAGE  '/)
  !
  ! Argument
  call sic_ke(line,0,1,argum,nc,.true.,error)
  if (error) return
  call sic_ambigs(rname,argum,keywor,nkey,vocab,mvoc,error)
  if (error) return
  !
  ! File name
  call sic_ch (line,0,2,fname,nc,.true.,error)
  if (error) return
  !
  ! Option /TABLE
  if (nkey.ne.1 .and. sic_present(1,0)) then
    call greg_message(seve%e,rname,'Option /TABLE valid only with COLUMN argument')
    error = .true.
    return
  endif
  !
  select case (keywor)
  case ('COLUMN')
    if (nxy.le.0) then
      call greg_message(seve%e,rname,'No column loaded')
      error = .true.
      return
    endif
    if (sic_present(1,0)) then ! WRITE COLUMN /TABLE (binary table)
      call greg_write_column(line,fname,error)
      if (error)  return
    else                       ! WRITE COLUMN (formatted table)
      call sic_parsef(fname,ffile,' ','.dat')
      open(unit=jtmp,file=ffile,status='NEW',err=98)
      call greg_message(seve%i,rname,'Creating '//ffile)
      if (.not.associated(column_z)) then
        call wrcol2(jtmp,nxy,column_x,column_y)
      else
        call wrcol3(jtmp,nxy,column_x,column_y,column_z)
      endif
      close(unit=jtmp)
    endif
    !
  case ('RGDATA')
    if (rg%status.eq.code_pointer_null) then
      call greg_message(seve%e,rname,'No map loaded')
      error=.true.
      return
    endif
    call sic_parsef(fname,ffile,' ','.dat')
    open(unit=jtmp,file=ffile,status='NEW',err=98)
    call greg_message(seve%i,rname,'Creating '//ffile)
    call greg_write_rgdata(line,jtmp,rg%data,rg%nx*rg%ny,error)
    close(unit=jtmp)
    !
  case ('POLYGON')
    call greg_poly_write(rname,gpoly,fname,error)
    if (error) return
    !
  case ('IMAGE')
    if (rg%status.eq.code_pointer_null) then
      call greg_message(seve%e,rname,'No map loaded')
      error=.true.
      return
    endif
    call sic_parsef(fname,ffile,' ','.gdf')
    call greg_message(seve%i,rname,'Creating '//ffile)
    call greg_write_image(ffile,rg%data,error)
    !
  end select
  return
  !
  ! Error opening file
98 continue
  call greg_message(seve%e,rname,'Cannot open file '//ffile)
  error = .true.
end subroutine greg_write
!
subroutine greg_write_column(line,fname,error)
  use image_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_write_column
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   WRITE COLUMN Filename [NEW [Format]] /TABLE X Nx Y Ny z Nz
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  character(len=*), intent(in)    :: fname
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='WRITE>COLUMN'
  integer(kind=4) :: ncx,ncy,ncz,iarg,nc
  integer(kind=index_length) :: ncn,odim2
  character(len=2) :: code  ! len=2 so that we trap syntax error with 2 letters
  type(gildas) :: t
  character(len=16) :: argum,keywor
  integer(kind=4), parameter :: matype=2  ! Access type
  character(len=3), parameter :: atype(matype) = (/'OLD','NEW'/)
  integer(kind=4), parameter :: mforms=3  ! Formats
  character(len=7), parameter :: forms(mforms) = (/'REAL   ','DOUBLE ','INTEGER'/)
  !
  ncx = 0
  ncy = 0
  ncz = 0
  !
  do iarg=1,max(1,sic_narg(1)),2  ! At least 1 argument is needed!
    ! X, Y, or Z
    call sic_ke(line,1,iarg,code,nc,.true.,error)
    if (error) return
    if (code.eq.'X') then
      call sic_i4(line,1,iarg+1,ncx,.true.,error)
    elseif (code.eq.'Y') then
      call sic_i4(line,1,iarg+1,ncy,.true.,error)
    elseif (code.eq.'Z') then
      call sic_i4(line,1,iarg+1,ncz,.true.,error)
    else
      call greg_message(seve%e,rname,'Unknown column code '//code)
      error = .true.
    endif
    if (error) return
  enddo
  !
  ! New or old table?
  argum = 'OLD'
  call sic_ke(line,0,3,argum,nc,.false.,error)
  if (error) return
  call sic_ambigs(rname,argum,keywor,nc,atype,matype,error)
  if (error) return
  !
  call gildas_null(t, type='TABLE')
  if (keywor.eq.'NEW') then
    ! Create new file
    call sic_parse_file(fname,' ','.gdf',t%file)
    call greg_message(seve%i,rname,'Creating '//t%file)
    !
    ! Table format?
    argum = 'REAL'
    call sic_ke (line,0,4,argum,nc,.false.,error)
    if (error) return
    call sic_ambigs(rname,argum,keywor,nc,forms,mforms,error)
    if (error) return
    !
    t%gil%dim(1) = nxy
    t%gil%dim(2)  = max(ncx,ncy,ncz)
    if (keywor.eq.forms(1)) t%gil%form=fmt_r4
    if (keywor.eq.forms(2)) t%gil%form=fmt_r8
    if (keywor.eq.forms(3)) t%gil%form=fmt_i4
    call gdf_create_image (t, error)
    call gdf_allocate (t, error)
    !
  else
    ! Fill an existing file
    t%gil%form = 0  ! i.e. accept any format
    call gdf_read_gildas(t,fname,'.gdf',error,data=.false.)
    if (error) then
      call greg_message(seve%e,rname,'Error reading table')
      error = .true.
      return
    endif
    if (t%gil%dim(1).ne.nxy) then
      call greg_message(seve%e,rname,  &
        'Output table has incompatible number of lines')
      call gdf_close_image(t,error)
      error = .true.
      return
    endif
    if (t%gil%dim(2).lt.max(ncx,ncy,ncz)) then
      odim2 = t%gil%dim(2)
      call gdf_close_image (t, error)
      call greg_message(seve%w,rname,'Extending number of columns')
      ncn = max(ncx,ncy,ncz)
      call gdf_extend_image(t,ncn,error)
      if (error) return
    endif
    call gdf_allocate(t,error)  ! Allocate to new dimensions
    if (error) return
    ! Read only the old dimensions from disk
    t%blc(:) = 0
    t%blc(2) = 1
    t%trc(:) = 0
    t%trc(2) = odim2
    ! Damn why do I have to say where I want to read the data!?
    if (t%gil%form.eq.fmt_r4) then
      call gdf_read_data(t,t%r2d,error)
    elseif (t%gil%form.eq.fmt_r8) then
      call gdf_read_data(t,t%d2d,error)
    elseif (t%gil%form.eq.fmt_i4) then
      call gdf_read_data(t,t%i2d,error)
    endif
    t%blc(:) = 0
    t%trc(:) = 0
    if (error) then
      call my_close_image(t,error)
      return
    endif
  endif
  !
  ! OK now fill the requested columns
  if (t%gil%form.eq.fmt_r4) then
    !!Print *,'Real*4 ',t%gil%form,ncx,ncy,ncz
    if (ncx.ne.0)                             call r8tor4(column_x,t%r2d(1,ncx),nxy)
    if (ncy.ne.0)                             call r8tor4(column_y,t%r2d(1,ncy),nxy)
    if (ncz.ne.0 .and. associated(column_z))  call r8tor4(column_z,t%r2d(1,ncz),nxy)
    call gdf_write_data(t,t%r2d,error)
    !
  elseif (t%gil%form.eq.fmt_r8) then
    if (ncx.ne.0)                             call r8tor8(column_x,t%d2d(1,ncx),nxy)
    if (ncy.ne.0)                             call r8tor8(column_y,t%d2d(1,ncy),nxy)
    if (ncz.ne.0 .and. associated(column_z))  call r8tor8(column_z,t%d2d(1,ncz),nxy)
    call gdf_write_data(t,t%d2d,error)
    !
  elseif (t%gil%form.eq.fmt_i4) then
    if (ncx.ne.0)                             call r8toi4_fini(column_x,t%i2d(1,ncx),nxy,error)
    if (ncy.ne.0)                             call r8toi4_fini(column_y,t%i2d(1,ncy),nxy,error)
    if (ncz.ne.0 .and. associated(column_z))  call r8toi4_fini(column_z,t%i2d(1,ncz),nxy,error)
    if (.not.error)  &
      call gdf_write_data(t,t%i2d,error)
  else
    call greg_message(seve%e,rname,'Table format not supported')
    error = .true.
  endif
  call my_close_image(t,error)
  !
contains
  subroutine my_close_image(t,error)
    use image_def
    !-------------------------------------------------------------------
    ! Close the image and deallocate the data buffer. This subroutine
    ! is because we do not want to loose the error in case of error 
    ! recovery (status is reset by gdf_close_image...)
    !-------------------------------------------------------------------
    type(gildas), intent(inout) :: t
    logical,      intent(inout) :: error
    ! 
    logical :: err
    !
    err = .false.
    call gdf_close_image(t,err)
    if (associated(t%r2d)) deallocate(t%r2d)
    if (associated(t%d2d)) deallocate(t%d2d)
    if (associated(t%i2d)) deallocate(t%i2d)
    error = error.or.err  ! Propagate previous error
  end subroutine my_close_image
  !
end subroutine greg_write_column
!
subroutine greg_write_rgdata(line,jtmp,regmap,mreg,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_write_rgdata
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !  Writes a RGDATA like file from the Regular_Grid array
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line          ! Input command line
  integer(kind=4),  intent(in)    :: jtmp          ! Logical unit number
  integer(kind=4),  intent(in)    :: mreg          ! Size of array
  real(kind=4),     intent(in)    :: regmap(mreg)  ! Array to write
  logical,          intent(inout) :: error         ! Logical error flag
  ! Local
  character(len=80) :: fname
  integer(kind=4) :: nc
  !
  write (jtmp,*) rg%nx,rg%xref,rg%xval,rg%xinc
  if (sic_present(0,3)) then
    call sic_ch (line,0,3,fname,nc,.false.,error)
    write (jtmp,'(A)') fname
  else
    write (jtmp,'(A)') ' '
  endif
  write (jtmp,*) rg%ny,rg%yref,rg%yval,rg%yinc
  if (sic_present(0,4)) then
    call sic_ch (line,0,4,fname,nc,.false.,error)
    write (jtmp,'(A)') fname
  else
    write (jtmp,'(A)') ' '
  endif
  !
  ! Write the map
  write (jtmp,'(10Z8.8)') regmap
end subroutine greg_write_rgdata
!
subroutine greg_poly_write(rname,poly,fname,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_poly_write
  use greg_kernel  ! For jtmp
  use greg_types
  !---------------------------------------------------------------------
  ! @ public
  !  Write the given polygon into the output file
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: rname
  type(polygon_t),  intent(in)    :: poly
  character(len=*), intent(in)    :: fname
  logical,          intent(inout) :: error
  ! Local
  character(len=filename_length) :: ffile
  integer(kind=4) :: ier
  !
  if (poly%ngon.le.2) then
    call greg_message(seve%e,rname,'No polygon defined')
    error = .true.
    return
  endif
  !
  call sic_parse_file(fname,' ','.pol',ffile)
  ier = sic_open(jtmp,ffile,'NEW',.false.)
  if (ier.ne.0) then
    call putios('E-'//trim(rname)//',  ',ier)
    error = .true.
    return
  endif
  call greg_message(seve%i,rname,'Creating '//ffile)
  call wrcol2(jtmp,poly%ngon,poly%xgon,poly%ygon)
  ier = sic_close(jtmp)
  !
end subroutine greg_poly_write
!
subroutine wrcol2(jun,n,x,y)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: jun   !
  integer(kind=4), intent(in) :: n     !
  real(kind=8),    intent(in) :: x(*)  !
  real(kind=8),    intent(in) :: y(*)  !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    write(jun,*) x(i),y(i)
  enddo
end subroutine wrcol2
!
subroutine wrcol3(jun,n,x,y,z)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: jun   !
  integer(kind=4), intent(in) :: n     !
  real(kind=8),    intent(in) :: x(*)  !
  real(kind=8),    intent(in) :: y(*)  !
  real(kind=8),    intent(in) :: z(*)  !
  ! Local
  integer(kind=4) :: i
  do i=1,n
    write(jun,*) x(i),y(i),z(i)
  enddo
end subroutine wrcol3
!
subroutine greg_write_image(name,array,error)
  use gildas_def
  use gbl_message
  use gbl_format
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_write_image
  use greg_wcs
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name      ! File name
  real(kind=4),     intent(in)    :: array(*)  ! Data array
  logical,          intent(inout) :: error     ! Error flag
  !
  call gildas_null(rg%imag)
  !
  rg%imag%gil%ndim = 2
  rg%imag%gil%dim(1) = rg%nx
  rg%imag%gil%dim(2) = rg%ny
  rg%imag%gil%dim(3) = 1
  rg%imag%gil%dim(4) = 1
  rg%imag%gil%convert(:,1) = (/rg%xref,rg%xval,rg%xinc/)
  rg%imag%gil%convert(:,2) = (/rg%yref,rg%yval,rg%yinc/)
  !
  ! Blanking
  rg%imag%gil%blan_words = 2
  rg%imag%gil%bval = cblank
  rg%imag%gil%eval = eblank
  !
  ! Extrema
  if (rg%minmax) then
    rg%imag%gil%rmin = rg%zmin
    rg%imag%gil%rmax = rg%zmax
    rg%imag%gil%minloc(:) = 0
    rg%imag%gil%minloc(1) = nint((rg%zxmin-rg%xval)/rg%xinc+rg%xref)
    rg%imag%gil%minloc(2) = nint((rg%zymin-rg%yval)/rg%yinc+rg%yref)
    rg%imag%gil%maxloc(:) = 0
    rg%imag%gil%maxloc(1) = nint((rg%zxmax-rg%xval)/rg%xinc+rg%xref)
    rg%imag%gil%maxloc(2) = nint((rg%zymax-rg%yval)/rg%yinc+rg%yref)
    rg%imag%gil%extr_words = 6
  else
    rg%imag%gil%extr_words = 0
  endif
  !
  ! Section 4 DESCRIPTION
  rg%imag%char%unit = 'UNKNOWN'
  rg%imag%gil%posi_words = 12
  if (i_system.eq.type_ic) then
    call greg_message(seve%w,'WRITE',  &
      'Computing galactic coordinates of source from ICRS coordinates is not implemented')
    rg%imag%gil%lii = 0.d0
    rg%imag%gil%bii = 0.d0
    rg%imag%gil%ra = gproj%a0
    rg%imag%gil%dec = gproj%d0
    rg%imag%char%syst = 'ICRS'
    rg%imag%gil%epoc = equinox_null
  elseif (i_system.eq.type_eq) then
    ! Compute alternate coordinates in galactic system
    if (i_equinox.eq.equinox_null) then
      call greg_message(seve%w,'WRITE',  &
        'Unknown equinox, could not compute galactic coordinates of source')
      rg%imag%gil%lii = 0.
      rg%imag%gil%bii = 0.
    else
      call equ_gal(gproj%a0,gproj%d0,i_equinox,rg%imag%gil%lii,rg%imag%gil%bii,error)
      if (error)  return
    endif
    rg%imag%gil%ra = gproj%a0
    rg%imag%gil%dec = gproj%d0
    rg%imag%char%syst = 'EQUATORIAL'
    rg%imag%gil%epoc = i_equinox
  elseif (i_system.eq.type_ga) then
    ! Compute alternate coordinates in equatorial system, use an arbitrary
    ! equinox
    call gal_equ(gproj%a0,gproj%d0,rg%imag%gil%ra,rg%imag%gil%dec,i_equinox_def,error)
    if (error)  return
    rg%imag%gil%lii = gproj%a0
    rg%imag%gil%bii = gproj%d0
    rg%imag%char%syst = 'GALACTIC'
    rg%imag%gil%epoc = i_equinox_def
  else
    rg%imag%gil%posi_words = 0
    rg%imag%char%syst = 'UNKNOWN'
  endif
  rg%imag%gil%desc_words = 18
  !
  ! Section 5 POSITION
  !
  ! Section 6 PROJECTION
  if (gproj%type.ne.p_none) then
    rg%imag%gil%ptyp = gproj%type
    rg%imag%gil%a0 = gproj%a0
    rg%imag%gil%d0 = gproj%d0
    rg%imag%gil%xaxi = 1
    rg%imag%gil%yaxi = 2
    rg%imag%gil%pang = gproj%angle
    rg%imag%gil%proj_words = 9
    if (u_angle.eq.u_second) then
      rg%imag%gil%convert(2:3,1:2)  = pi/3600d0/180d0 * rg%imag%gil%convert(2:3,1:2)
    elseif (u_angle.eq.u_minute) then
      rg%imag%gil%convert(2:3,1:2)  = pi/60d0/180d0 * rg%imag%gil%convert(2:3,1:2)
    elseif (u_angle.eq.u_degree) then
      rg%imag%gil%convert(2:3,1:2)  = pi/180d0 * rg%imag%gil%convert(2:3,1:2)
    endif
  endif
  !
  ! Now write the image, using the new interface
  rg%imag%file = name
  call gdf_write_image(rg%imag,array,error)
  !
end subroutine greg_write_image

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage GCHAR messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gchar_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer :: gchar_message_id = gpack_global_id  ! Default value for startup message
  !
end module gchar_message_private
!
subroutine gchar_message_set_id(id)
  use gchar_interfaces, except_this=>gchar_message_set_id
  use gchar_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer, intent(in) :: id
  ! Local
  character(len=message_length) :: mess
  !
  gchar_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',gchar_message_id
  call gchar_message(seve%d,'gchar_message_set_id',mess)
  !
end subroutine gchar_message_set_id
!
subroutine gchar_message(mkind,procname,message)
  use gchar_dependencies_interfaces
  use gchar_interfaces, except_this=>gchar_message
  use gchar_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Messaging facility for the current library. Calls the low-level
  ! (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(gchar_message_id,mkind,procname,message)
  !
end subroutine gchar_message

function s_gaussian1d(x,xcent,fwhm)
  !---------------------------------------------------------------------
  ! @ public
  ! Compute gaussian value at X, peaks at 1 (single precision)
  !---------------------------------------------------------------------
  real(kind=4) :: s_gaussian1d
  real(kind=4), intent(in) :: x
  real(kind=4), intent(in) :: xcent
  real(kind=4), intent(in) :: fwhm
  ! Local
  real(kind=4) :: sigma
  !
  sigma = fwhm/(2.0*sqrt(2.0*log(2.0)))
  !
  s_gaussian1d = exp(-(x-xcent)**2/(2.0*sigma*sigma))
  !
end function s_gaussian1d
!
function d_gaussian1d(x,xcent,fwhm)
  use phys_const
  !---------------------------------------------------------------------
  ! @ public
  ! Compute gaussian value at X, peaks at 1 (double precision)
  !---------------------------------------------------------------------
  real(kind=8) :: d_gaussian1d
  real(kind=8), intent(in) :: x
  real(kind=8), intent(in) :: xcent
  real(kind=8), intent(in) :: fwhm
  ! Local
  real(kind=8) :: sigma
  !
  sigma = fwhm/(2.d0*sqrt(2.d0*log(2.d0)))
  !
  d_gaussian1d = exp(-(x-xcent)**2/(2.d0*sigma*sigma))
  !
end function d_gaussian1d
!
function s_normal1d(x,xcent,sigma)
  use phys_const
  !---------------------------------------------------------------------
  ! @ public
  ! Compute normal distribution value at X, area is 1 (single precision)
  !---------------------------------------------------------------------
  real(kind=4) :: s_normal1d
  real(kind=4), intent(in) :: x
  real(kind=4), intent(in) :: xcent
  real(kind=4), intent(in) :: sigma
  !
  s_normal1d = exp(-(x-xcent)**2/(2.d0*sigma*sigma)) / (sigma*sqrt(2*pi))
  !
end function s_normal1d
!
function d_normal1d(x,xcent,sigma)
  use phys_const
  !---------------------------------------------------------------------
  ! @ public
  ! Compute normal distribution value at X, area is 1 (double precision)
  !---------------------------------------------------------------------
  real(kind=8) :: d_normal1d
  real(kind=8), intent(in) :: x
  real(kind=8), intent(in) :: xcent
  real(kind=8), intent(in) :: sigma
  !
  d_normal1d = exp(-(x-xcent)**2/(2.d0*sigma*sigma)) / (sigma*sqrt(2*pi))
  !
end function d_normal1d
!
subroutine gauss2d_convolution(a1,b1,t1,a2,b2,t2,a3,b3,t3,error)
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the parameters of the 2D gaussian resulting from the
  ! convolution of 2 2D gaussians:
  !   1 * 2 => 3
  ! Knowing 1 and 2 find 3.
  !---------------------------------------------------------------------
  real(kind=4), intent(in)    :: a1    ! [same] First gaussian major axis
  real(kind=4), intent(in)    :: b1    ! [same] First gaussian minor axis
  real(kind=4), intent(in)    :: t1    ! [rad]  First gaussian position angle
  real(kind=4), intent(in)    :: a2    ! [same] Second gaussian major axis
  real(kind=4), intent(in)    :: b2    ! [same] Second gaussian minor axis
  real(kind=4), intent(in)    :: t2    ! [rad]  Second gaussian position angle
  real(kind=4), intent(out)   :: a3    ! [same] Result major axis
  real(kind=4), intent(out)   :: b3    ! [same] Result minor axis
  real(kind=4), intent(out)   :: t3    ! [rad]  Result position angle
  logical,      intent(inout) :: error ! Logical error flag
  ! Local
  real(kind=4) :: c1,s1,c2,s2
  real(kind=4) :: alpha,beta,gamma,s,t,u
  !
  c1 = cos(t1)
  s1 = sin(t1)
  c2 = cos(t2)
  s2 = sin(t2)
  !
  alpha = (a1*c1)**2 + (b1*s1)**2 + (a2*c2)**2 + (b2*s2)**2
  beta  = (a1*s1)**2 + (b1*c1)**2 + (a2*s2)**2 + (b2*c2)**2
  gamma = 2.0*( (a1**2-b1**2)*s1*c1 +  (a2**2-b2**2)*s2*c2 )
  !
  s = alpha+beta
  u = alpha-beta
  t = sqrt(u**2+gamma**2)
  !
  ! New values updated in place
  a3 = sqrt(0.5*(s+t))
  b3 = sqrt(0.5*(s-t))
  t3 = 0.5 * atan2(gamma,u)  ! No issue here, except the very extreme case where
                             ! we convolve a Dirac by a Dirac
  !
end subroutine gauss2d_convolution
!
subroutine gauss2d_deconvolution(a1,b1,t1,a3,b3,t3,a2,b2,t2,error)
  use gbl_message
  use gmath_interfaces, except_this=>gauss2d_deconvolution
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the parameters of the 2D gaussian resulting from the
  ! deconvolution of 2 2D gaussians:
  !   1 * 2 => 3
  ! Knowing 1 and 3 find 2.
  !---------------------------------------------------------------------
  real(kind=4), intent(in)    :: a1    ! [same] First gaussian major axis
  real(kind=4), intent(in)    :: b1    ! [same] First gaussian minor axis
  real(kind=4), intent(in)    :: t1    ! [rad]  First gaussian position angle
  real(kind=4), intent(in)    :: a3    ! [same] Result major axis
  real(kind=4), intent(in)    :: b3    ! [same] Result minor axis
  real(kind=4), intent(in)    :: t3    ! [rad]  Result position angle
  real(kind=4), intent(out)   :: a2    ! [same] Second gaussian major axis
  real(kind=4), intent(out)   :: b2    ! [same] Second gaussian minor axis
  real(kind=4), intent(out)   :: t2    ! [rad]  Second gaussian position angle
  logical,      intent(inout) :: error ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GAUSS2D'
  real(kind=4) :: c1,s1,c3,s3
  real(kind=4) :: alpha,beta,gamma,s,t,u
  !
  c1 = cos(t1)
  s1 = sin(t1)
  c3 = cos(t3)
  s3 = sin(t3)
  !
  alpha = (a3*c3)**2 + (b3*s3)**2 - (a1*c1)**2 - (b1*s1)**2
  beta  = (a3*s3)**2 + (b3*c3)**2 - (a1*s1)**2 - (b1*c1)**2
  gamma = 2.0*( (a3**2-b3**2)*s3*c3 - (a1**2-b1**2)*s1*c1 )
  !
  s = alpha+beta
  u = alpha-beta
  t = sqrt(u**2+gamma**2)
  !
  ! Sanity check
  if (t.gt.s) then
    call gmath_message(seve%e,rname,'Final resolution is not reachable from input resolution')
    error = .true.
    return
  endif
  !
  ! New values updated in place
  a2 = sqrt(0.5*(s+t))
  b2 = sqrt(0.5*(s-t))
  t2 = 0.5 * atan2(gamma,u)
  !
end subroutine gauss2d_deconvolution

subroutine write_fits_gain(unit, nsubant, subant, error)
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  ! Write the optional GAIN calibration fits table.
  ! assumes NO_POL=1
  !---------------------------------------------------------------------
  integer :: unit                   !
  integer :: nsubant                !
  integer :: subant(nsubant)        ! selected antennas in table
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  ! Local
  integer :: naxis, naxes(4), mf, status, nrows, tfields, varidat
  integer :: i, j, r_npol, r_nfeed, r_nside, mdigit2, mdigit1, isub
  parameter(r_npol = 1, r_nfeed = 1, r_nside=2, mdigit2=13,   &
    mdigit1=8)
  parameter (mf = 3)
  character(len=16) :: ttype(mf),tform(mf),tunit(mf), extname
  data ttype/'ANTENNID',   'AMPLGAIN',   'PHASGAIN'/
  data tform/'1J',         '*E',         '*E'/
  data tunit/' ',          'K/Jy',       'radian'/
  !---------------------------------------------------------------------
  !
  !  Append/create a new empty HDU onto the end of the file and move to it.
  status = 0
  call ftcrhd(unit,status)
  if (status .gt. 0) goto 99
  !
  !  Define parameters for the binary table (see the above data statements)
  nrows = r_nant
  tfields = mf
  extname = 'GAIN-ALMATI'
  varidat = 0
  ! columns in datapar
  do i = 2, 3
    call f_tform(tform(i),r_nside*(r_aicdeg+1),'E')
  enddo
  !      CALL F_TFORM(TFORM(4),2*2,'E')
  call ftphbn(unit,nrows,tfields,ttype,tform,tunit,   &
    extname,varidat,status)
  if (status .gt. 0) goto 99
  do i=2, 3
    naxis = 2
    naxes(1) = r_nside
    naxes(2) = r_aicdeg+1
    call ftptdm(unit, i, naxis, naxes, status)
  enddo
  !      NAXES(1) = 2
  !      NAXES(2) = r_nside
  !      CALL FTPTDM(UNIT, I, NAXIS, NAXES, STATUS)
  ! Other header keywords
  call ftpkys(unit,'TABLEREV','v1.0 2001-07-03',   &
    extname//' release',status)
  if (status .gt. 0) goto 99
  !      CALL FTPKYJ(UNIT,'NO_ANT',R_NANT,'Number of Antennas',STATUS)
  call ftpkyj(unit,'NO_ANT',nsubant,'Number of Antennas',status)
  if (status .gt. 0) goto 99
  call write_fits_dobs(unit,error)
  if (error) return
  call ftpkyj(unit,'NO_BAND',r_lband,'Number of base bands',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'NO_SIDE',r_nside,'Number of side bands',status)
  if (status .gt. 0) goto 99
  call ftpkyj(unit,'NO_GAIN',r_aicdeg+1,'Number of gain values',   &
    status)
  if (status .gt. 0) goto 99
  !
  status = 0
  !
  ! Fill in the columns.
  !
  !      DO I=1, R_NANT
  do isub =1, nsubant
    i = subant(isub)
    ! ANNAME
    call ftpclj(unit,1,i,1,1,r_kant(i),status)
    if (status .gt. 0) goto 99
    ! AMPLGAIN
    do j=0, r_aicdeg
      call ftpcle(unit,2,i,1+2*j,2,r_aicamp(1,1,i,j),status)
      if (status .gt. 0) goto 99
    enddo
    ! PHASGAIN
    do j=0, r_aicdeg
      call ftpcle(unit,3,i,1+2*j,2,r_aicpha(1,1,i,j),status)
      if (status .gt. 0) goto 99
    enddo
  enddo
  return
  !
99 call printerror('WRITE_FITS_GAIN',     status)
  error = .true.
end subroutine write_fits_gain

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the SIC package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine sic_pack_set(pack)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_pack_set
  use gpack_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack
  !
  pack%name='sic'
  pack%ext='.sic'
  pack%authors="S.Bardeau, J.Pety"
  pack%init=locwrd(sic_pack_init)
  pack%clean=locwrd(sic_pack_clean)
  pack%exec_on_child=locwrd(sic_pack_exec_on_child)
  !
end subroutine sic_pack_set
!
subroutine sic_pack_init(gpack_id,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_pack_init
  use sic_def
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  integer, intent(in) :: gpack_id  !
  logical, intent(inout) :: error  ! Error flag
  !
  ! Set libraries id's
  call gsys_message_set_id(gpack_id)
  call gsys_c_message_set_id(gpack_id)
  call gmath_message_set_id(gpack_id)
  call gwcs_message_set_id(gpack_id)
  call gfits_message_set_id(gpack_id)
  call gio_message_set_id(gpack_id)
  call sic_message_set_id(gpack_id)
  call sic_c_message_set_id(gpack_id)
  !
  call sic_build()
  !
  ! Set default procedure extension
  call exec_program('sic'//backslash//'sic extension .pro')
  !
end subroutine sic_pack_init
!
subroutine sic_pack_exec_on_child(building_pack,error)
  use gpack_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_pack_exec_on_child
  use sic_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Load package and user procedure initializations.
  !---------------------------------------------------------------------
  type(gpack_info_t), intent(inout) :: building_pack  ! Package properties
  logical,            intent(inout) :: error          ! Error flag
  ! Local
  character(len=filename_length) :: file
  !
  ! Call initialization procedures
  if (building_pack%ext.eq.'') return
  !
  call exec_program('sic'//backslash//'sic extension '//building_pack%ext)
  !
  ! Execute default initialization macro
  if (sic_query_file('define'//trim(building_pack%pro_suffix)//building_pack%ext,'macro#dir:',building_pack%ext,file)) then
     call exec_program('@ "'//trim(file)//'"')
  endif
  !
  ! Execute user initialization macro
  if (sic_query_file('init','gag_init:',building_pack%ext,file)) then
     call exec_program('@ "'//trim(file)//'"')
  endif
  !
end subroutine sic_pack_exec_on_child
!
subroutine sic_pack_clean(error)
  use gbl_message
  use sic_interfaces, except_this=>sic_pack_clean
  use sic_dependencies_interfaces
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Error flag
  ! Local
  integer(kind=4) :: i,nmacro2,ier
  character(len=filename_length) :: file
  !
  ! Close the procedures at each execution level
  nmacro2 = nmacro
  do i=1,nmacro2
    call endmac
  enddo
  !
  ! Delete all image variables to ensure updating
  call del_ima_var
  !
  ! Delete temporary directories (unique per session)
  call end_procedure  ! GAG_PROC: support files for procedures (begin/end procedure blocks)
  file = 'GAG_SCRATCH:'
  ier = sic_getlog(file)
  ier = gag_rmdir(file)
  if (ier.ne.0)  call sic_message(seve%w,'SIC','Error removing directory '//file)
  !
#ifndef CYGWIN
  ! Kill sub-process if any
  call end_dialog
#endif
  !
  ! Deallocate the SIC variables arrays
  call sic_free_variable
  !
  call sic_freesymbol(error)
  ! if (error)  continue
  !
  call sic_free_languages(error)
  ! if (error)  continue
  !
  call sic_lunmac_exit(error)
  ! if (error)  continue
  !
  call sic_output_close(error)
  ! if (error)  continue
  !
  call exit_task(error)
  ! if (error)  continue
  !
end subroutine sic_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CUBE messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubefit_messaging
  use gpack_def
  use gbl_message
  use cubetools_parameters
  !
  public :: fitseve,seve,mess_l
  public :: cubefit_message_set_id,cubefit_message
  public :: cubefit_message_set_alloc,cubefit_message_get_alloc
  public :: cubefit_message_set_trace,cubefit_message_get_trace
  public :: cubefit_message_set_others,cubefit_message_get_others
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: cubefit_message_id = gpack_global_id  ! Default value for startup message
  !
  type :: cubefit_messaging_debug_t
     integer(kind=code_k) :: alloc = seve%d
     integer(kind=code_k) :: trace = seve%t
     integer(kind=code_k) :: others = seve%d
  end type cubefit_messaging_debug_t
  !
  type(cubefit_messaging_debug_t) :: fitseve
  !
contains
  !
  subroutine cubefit_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='MESSAGE>SET>ID'
    !
    cubefit_message_id = id
    write (mess,'(A,I0)') 'Now use id #',cubefit_message_id
    call cubefit_message(seve%d,rname,mess)
  end subroutine cubefit_message_set_id
  !
  subroutine cubefit_message(mkind,procname,message)
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call cubetools_cmessage(cubefit_message_id,mkind,'FIT>'//procname,message)
  end subroutine cubefit_message
  !
  subroutine cubefit_message_set_alloc(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       fitseve%alloc = seve%i
    else
       fitseve%alloc = seve%d
    endif
  end subroutine cubefit_message_set_alloc
  !
  subroutine cubefit_message_set_trace(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       fitseve%trace = seve%i
    else
       fitseve%trace = seve%t
    endif
  end subroutine cubefit_message_set_trace
  !
  subroutine cubefit_message_set_others(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       fitseve%others = seve%i
    else
       fitseve%others = seve%d
    endif
  end subroutine cubefit_message_set_others
  !
  function cubefit_message_get_alloc()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefit_message_get_alloc
    !
    cubefit_message_get_alloc = fitseve%alloc.eq.seve%i
    !
  end function cubefit_message_get_alloc
  !
  function cubefit_message_get_trace()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefit_message_get_trace
    !
    cubefit_message_get_trace = fitseve%trace.eq.seve%i
    !
  end function cubefit_message_get_trace
  !
  function cubefit_message_get_others()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubefit_message_get_others
    !
    cubefit_message_get_others = fitseve%others.eq.seve%i
    !
  end function cubefit_message_get_others
end module cubefit_messaging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage CUBEHISTOGRAM messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubehistogram_messaging
  use gpack_def
  use gbl_message
  use cubetools_parameters
  !
  public :: histogramseve,seve,mess_l
  public :: cubehistogram_message_set_id,cubehistogram_message
  public :: cubehistogram_message_set_alloc,cubehistogram_message_get_alloc
  public :: cubehistogram_message_set_trace,cubehistogram_message_get_trace
  public :: cubehistogram_message_set_others,cubehistogram_message_get_others
  private
  !
  ! Identifier used for message identification
  integer(kind=4) :: cubehistogram_message_id = gpack_global_id  ! Default value for startup message
  !
  type :: cubehistogram_messaging_debug_t
     integer(kind=code_k) :: alloc = seve%d
     integer(kind=code_k) :: trace = seve%t
     integer(kind=code_k) :: others = seve%d
  end type cubehistogram_messaging_debug_t
  !
  type(cubehistogram_messaging_debug_t) :: histogramseve
  !
contains
  !
  subroutine cubehistogram_message_set_id(id)
    !---------------------------------------------------------------------
    ! Alter library id into input id. Should be called by the library
    ! which wants to share its id with the current one.
    !---------------------------------------------------------------------
    integer(kind=4), intent(in) :: id
    !
    character(len=message_length) :: mess
    character(len=*), parameter :: rname='MESSAGE>SET>ID'
    !
    cubehistogram_message_id = id
    write (mess,'(A,I0)') 'Now use id #',cubehistogram_message_id
    call cubehistogram_message(seve%d,rname,mess)
  end subroutine cubehistogram_message_set_id
  !
  subroutine cubehistogram_message(mkind,procname,message)
    use cubetools_cmessaging
    !---------------------------------------------------------------------
    ! Messaging facility for the current library. Calls the low-level
    ! (internal) messaging routine with its own identifier.
    !---------------------------------------------------------------------
    integer(kind=4),  intent(in) :: mkind     ! Message kind
    character(len=*), intent(in) :: procname  ! Name of calling procedure
    character(len=*), intent(in) :: message   ! Message string
    !
    call cubetools_cmessage(cubehistogram_message_id,mkind,'IMA>'//procname,message)
  end subroutine cubehistogram_message
  !
  subroutine cubehistogram_message_set_alloc(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       histogramseve%alloc = seve%i
    else
       histogramseve%alloc = seve%d
    endif
  end subroutine cubehistogram_message_set_alloc
  !
  subroutine cubehistogram_message_set_trace(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       histogramseve%trace = seve%i
    else
       histogramseve%trace = seve%t
    endif
  end subroutine cubehistogram_message_set_trace
  !
  subroutine cubehistogram_message_set_others(on)
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical, intent(in) :: on
    !
    if (on) then
       histogramseve%others = seve%i
    else
       histogramseve%others = seve%d
    endif
  end subroutine cubehistogram_message_set_others
  !
  function cubehistogram_message_get_alloc()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubehistogram_message_get_alloc
    !
    cubehistogram_message_get_alloc = histogramseve%alloc.eq.seve%i
    !
  end function cubehistogram_message_get_alloc
  !
  function cubehistogram_message_get_trace()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubehistogram_message_get_trace
    !
    cubehistogram_message_get_trace = histogramseve%trace.eq.seve%i
    !
  end function cubehistogram_message_get_trace
  !
  function cubehistogram_message_get_others()
    !---------------------------------------------------------------------
    !
    !---------------------------------------------------------------------
    logical :: cubehistogram_message_get_others
    !
    cubehistogram_message_get_others = histogramseve%others.eq.seve%i
    !
  end function cubehistogram_message_get_others
end module cubehistogram_messaging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gr4_extrema (nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is renamed elsewhere)
  ! Find extrema of a (Real*4) array.
  ! +/- Infinity are considered as valid extrema is this routine
  ! See GR4_MINMAX for a version which ignores Infinity
  !
  !     Ignore NaNs and all "blanked" values.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy     ! Number of values
  real(kind=4),              intent(in)    :: z(nxy)  ! Values
  real(kind=4),              intent(in)    :: bval    ! Blanking
  real(kind=4),              intent(in)    :: eval    ! Tolerance
  real(kind=4),              intent(inout) :: zmin    ! Unchanged if no valid value
  real(kind=4),              intent(inout) :: zmax    ! Unchanged if no valid value
  integer(kind=size_length), intent(out)   :: nmin    ! Set to 0 if no valid value
  integer(kind=size_length), intent(out)   :: nmax    ! Set to 0 if no valid value
  ! Local
  character(len=*), parameter :: rname='EXTREMA'
  integer(kind=size_length) :: i,j
  !
  j = nxy+1
  nmin = 0
  nmax = 0
  if (eval.lt.0.0) then
    do i=1,nxy
      if (z(i).eq.z(i)) then
        zmin = z(i)
        zmax = z(i)
        nmin = i
        nmax = i
        j = i
        exit
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      endif
    enddo
  else
    do i=1,nxy
      if (z(i).eq.z(i)) then
        !
        !     Tests are not equivalent if BVAL is a NaN!
        !     IF (ABS(Z(I)-BVAL).GT.EVAL) THEN
        if (.not.(abs(z(i)-bval).le.eval)) then
          zmin = z(i)
          zmax = z(i)
          nmin = i
          nmax = i
          j = i
          exit
        endif
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (.not.(abs(z(i)-bval).le.eval)) then
          if (z(i).lt.zmin) then
            zmin = z(i)
            nmin = i
          elseif (z(i).gt.zmax) then
            zmax = z(i)
            nmax = i
          endif
        endif
      endif
    enddo
  endif
end subroutine gr4_extrema
!
subroutine gr8_extrema (nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is renamed elsewhere)
  ! Find extrema of a (Real*8) array
  ! +/- Infinity are considered as valid extrema is this routine
  ! See GR8_MINMAX for a version which ignores Infinity
  !!
  !     Ignore NaNs and all "blanked" values.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: nxy     ! Number of values
  real(kind=8),              intent(in)    :: z(nxy)  ! Values
  real(kind=4),              intent(in)    :: bval    ! Blanking
  real(kind=4),              intent(in)    :: eval    ! Tolerance
  real(kind=4),              intent(inout) :: zmin    ! Unchanged if no valid value
  real(kind=4),              intent(inout) :: zmax    ! Unchanged if no valid value
  integer(kind=size_length), intent(out)   :: nmin    ! Set to 0 if no valid value
  integer(kind=size_length), intent(out)   :: nmax    ! Set to 0 if no valid value
  ! Local
  character(len=*), parameter :: rname='EXTREMA'
  integer(kind=size_length) :: i,j
  !
  j = nxy+1
  nmin = 0
  nmax = 0
  if (eval.lt.0.0) then
    do i=1,nxy
      if (z(i).eq.z(i)) then
        zmin = z(i)
        zmax = z(i)
        nmin = i
        nmax = i
        j = i
        exit
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      endif
    enddo
  else
    do i=1,nxy
      if (z(i).eq.z(i)) then
        !
        !     Tests are not equivalent if BVAL is a NaN!
        !     IF (ABS(Z(I)-BVAL).GT.EVAL) THEN
        if (.not.(abs(z(i)-bval).le.eval)) then
          zmin = z(i)
          zmax = z(i)
          nmin = i
          nmax = i
          j = i
          exit
        endif
      endif
    enddo
    !
    do i=j,nxy
      if (z(i).eq.z(i)) then
        if (.not.(abs(z(i)-bval).le.eval)) then
          if (z(i).lt.zmin) then
            zmin = z(i)
            nmin = i
          elseif (z(i).gt.zmax) then
            zmax = z(i)
            nmax = i
          endif
        endif
      endif
    enddo
  endif
end subroutine gr8_extrema
!
subroutine gr4_minmax(nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr4_minmax
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Protect against NaN and INFs even without blanking
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nxy     !
  real(kind=4),              intent(in)  :: z(nxy)  !
  real(kind=4),              intent(in)  :: bval    !
  real(kind=4),              intent(in)  :: eval    !
  real(kind=4),              intent(out) :: zmin    !
  real(kind=4),              intent(out) :: zmax    !
  integer(kind=size_length), intent(out) :: nmin    !
  integer(kind=size_length), intent(out) :: nmax    !
  ! Local
  character(len=*), parameter :: rname='MINMAX'
  integer(kind=size_length) :: i,j,cnt_nan,cnt_inf,cnt_bla
  character(len=message_length) :: chain
  !
  ! Default values if no valid data found
  zmin = bval
  zmax = bval
  nmin = 1
  nmax = 1
  !
  cnt_nan=0
  cnt_inf=0
  cnt_bla=0
  do j=1,nxy
    if (sic_fini4(z(j)))then
      if(abs(z(j)-bval).gt.eval) then
        zmin = z(j)
        zmax = z(j)
        nmin = j
        nmax = j
        goto 10
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(j).eq.z(j))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  !
10 continue
  do i=j+1,nxy
    if (sic_fini4(z(i)))then
      if (abs(z(i)-bval).gt.eval) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(i).eq.z(i))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  if (cnt_nan+cnt_inf+cnt_bla.eq.0) return
  !
  ! Debug (these messages are too much verbose for a daily use)
  if (cnt_nan.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_nan,' NaNs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_inf.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_inf,' INFs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_bla.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_bla,' blanks'
    call gmath_message(seve%d,rname,chain)
  endif
  !
  if (cnt_nan+cnt_inf+cnt_bla.eq.nxy)  &
    call gmath_message(seve%w,rname,'No valid data found')
  !
end subroutine gr4_minmax
!
subroutine gr8_minmax(nxy,z,bval,eval,zmin,zmax,nmin,nmax)
  use gildas_def
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr8_minmax
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Protect against NaN and INFs even without blanking
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nxy     !
  real(kind=8),              intent(in)  :: z(nxy)  !
  real(kind=8),              intent(in)  :: bval    !
  real(kind=8),              intent(in)  :: eval    !
  real(kind=8),              intent(out) :: zmin    !
  real(kind=8),              intent(out) :: zmax    !
  integer(kind=size_length), intent(out) :: nmin    !
  integer(kind=size_length), intent(out) :: nmax    !
  ! Local
  character(len=*), parameter :: rname='MINMAX'
  integer(kind=size_length) :: i,j,cnt_nan,cnt_inf,cnt_bla
  character(len=message_length) :: chain
  !
  ! Default values if no valid data found
  zmin = bval
  zmax = bval
  nmin = 1
  nmax = 1
  !
  cnt_nan=0
  cnt_inf=0
  cnt_bla=0
  do j=1,nxy
    if (sic_fini8(z(j)))then
      if (abs(z(j)-bval).gt.eval) then
        zmin = z(j)
        zmax = z(j)
        nmin = j
        nmax = j
        goto 10
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(j).eq.z(j))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  !
10 continue
  do i=j,nxy
    if (sic_fini8(z(i)))then
      if (abs(z(i)-bval).gt.eval) then
        if (z(i).lt.zmin) then
          zmin = z(i)
          nmin = i
        elseif (z(i).gt.zmax) then
          zmax = z(i)
          nmax = i
        endif
      else
        cnt_bla=cnt_bla+1
      endif
    elseif (.not.(z(i).eq.z(i))) then
      cnt_nan=cnt_nan+1
    else
      cnt_inf=cnt_inf+1
    endif
  enddo
  if (cnt_nan+cnt_inf+cnt_bla.eq.0) return
  !
  ! Debug (these messages are too much verbose for a daily use)
  if (cnt_nan.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_nan,' NaNs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_inf.gt.0) then
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_inf,' INFs'
    call gmath_message(seve%d,rname,chain)
  endif
  if (cnt_bla.gt.0) then
    ! Debug (message is too much verbose for a daily use)
    write(chain,'(A,1X,I0,A)')  'Array has ',cnt_bla,' blanks'
    call gmath_message(seve%d,rname,chain)
  endif
  !
  if (cnt_nan+cnt_inf+cnt_bla.eq.nxy)  &
    call gmath_message(seve%w,rname,'No valid data found')
  !
end subroutine gr8_minmax
!
subroutine gr4_load(in,out,n,bval,eval,m)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Copy input array into output array, but remove blanked values if
  ! any. Return the number of elements kept accordingly. Real*4 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n       ! Number of elements to copy
  real(kind=4),              intent(in)  :: in(n)   ! Input array
  real(kind=4),              intent(out) :: out(n)  ! Output array
  real(kind=4),              intent(in)  :: bval    ! Blanking value
  real(kind=4),              intent(in)  :: eval    ! Error value for blanking
  integer(kind=size_length), intent(out) :: m       ! Number elements kept
  ! Local
  integer(kind=size_length) :: i
  !
  if (eval.lt.0.) then
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      m = m+1
      out(m) = in(i)
    enddo
  else
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      if (abs(in(i)-bval).le.eval) cycle
      m = m+1
      out(m) = in(i)
    enddo
  endif
end subroutine gr4_load
!
subroutine gr8_load(in,out,n,bval,eval,m)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Copy input array into output array, but remove blanked values if
  ! any. Return the number of elements kept accordingly. Real*8 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n       !
  real(kind=8),              intent(in)  :: in(n)   !
  real(kind=8),              intent(out) :: out(n)  !
  real(kind=8),              intent(in)  :: bval    !
  real(kind=8),              intent(in)  :: eval    !
  integer(kind=size_length), intent(out) :: m       !
  ! Local
  integer(kind=size_length) :: i
  !
  if (eval.lt.0.d0) then
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      m = m+1
      out(m) = in(i)
    enddo
  else
    m = 0
    do i=1,n
      if (in(i).ne.in(i)) cycle
      if (abs(in(i)-bval).le.eval) cycle
      m = m+1
      out(m) = in(i)
    enddo
  endif
end subroutine gr8_load
!
subroutine gr4_median(data,ndata,bval,eval,median,error)
  use gildas_def
  use gbl_message
  use gmath_interfaces, except_this=>gr4_median
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: ndata        ! Array size
  real(kind=4),              intent(in)    :: data(ndata)  ! Data
  real(kind=4),              intent(in)    :: bval         ! Blanking value
  real(kind=4),              intent(in)    :: eval         ! Tolerance
  real(kind=4),              intent(inout) :: median       ! Median of input array
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MEDIAN'
  integer(kind=4) :: ier
  integer(kind=size_length) :: nwork
  real(kind=4), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  !
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr4_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr4_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output median value unmodified on return
    goto 10
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  call gr4_trie(work,indices,int(nwork,kind=4),error)
  if (error) goto 10
  !
  if (mod(nwork,2).eq.0) then
    median = (work(nwork/2)+work((nwork/2)+1))/2.0
  else
    median = work((nwork+1)/2)
  endif
  !
10 continue
  if (allocated(work)) deallocate(work)
  if (allocated(indices)) deallocate(indices)
  !
end subroutine gr4_median
!
subroutine gr8_median(data,ndata,bval,eval,median,error)
  use gildas_def
  use gbl_message
  use gmath_interfaces, except_this=>gr8_median
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: ndata        ! Array size
  real(kind=8),              intent(in)    :: data(ndata)  ! Data
  real(kind=8),              intent(in)    :: bval         ! Blanking value
  real(kind=8),              intent(in)    :: eval         ! Tolerance
  real(kind=8),              intent(inout) :: median       ! Median of input array
  logical,                   intent(inout) :: error        ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MEDIAN'
  integer(kind=4) :: ier
  integer(kind=size_length) :: nwork
  real(kind=8), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  !
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr8_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr8_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output median value unmodified on return
    goto 10
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (ier.ne.0) then
    call gmath_message(seve%e,rname,'Could not allocate working arrays')
    error = .true.
    goto 10
  endif
  !
  call gr8_trie(work,indices,int(nwork,kind=4),error)
  if (error) goto 10
  !
  if (mod(nwork,2).eq.0) then
    median = (work(nwork/2)+work((nwork/2)+1))/2.d0
  else
    median = work((nwork+1)/2)
  endif
  !
10 continue
  if (allocated(work)) deallocate(work)
  if (allocated(indices)) deallocate(indices)
  !
end subroutine gr8_median
!
subroutine gr4_dicho(np,x,xval,ival)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: np     ! Number of input points
  real(kind=4),              intent(in)  :: x(np)  ! Input ordered Values
  real(kind=4),              intent(in)  :: xval   ! The value we search for
  integer(kind=size_length), intent(out) :: ival   ! Position in the array
  ! Local
  integer(kind=size_length) :: iinf,isup,imid
  !
  if (x(1).gt.xval) then
    ival = 0
    return
  elseif (x(1).eq.xval) then
    ival = 1
    return
  elseif (x(np).lt.xval) then
    ival = np
    return
  endif
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)
    imid = (isup + iinf)/2
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ival = isup
  !
end subroutine gr4_dicho
!
subroutine gr8_dicho(np,x,xval,ceil,ival,error)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: np     ! Number of input points
  real(kind=8),              intent(in)    :: x(np)  ! Input ordered Values
  real(kind=8),              intent(in)    :: xval   ! The value we search for
  logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
  integer(kind=size_length), intent(out)   :: ival   ! Position in the array
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=size_length) :: iinf,isup,imid
  character(len=message_length) :: mess
  !
  if (x(1).gt.xval .or. x(np).lt.xval) then
    write(mess,'(A,F0.8,A,F0.8,A,F0.8,A)')  &
      'Input value (',xval,') out of array range (',x(1),' to ',x(np),')'
    call gmath_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  ! The specification inequalities (see subroutine header) say that exact
  ! match is returned if available:
  if (xval.eq.x(isup)) then
    ival = isup
  elseif (xval.eq.x(iinf)) then
    ival = iinf
    !
  ! If no exact match, the requested value is in between. Returned value
  ! depends on ceiling or floor mode
  elseif (ceil) then  ! Ceiling mode
    ival = isup
  else                ! Floor mode
    ival = iinf
  endif
  !
end subroutine gr8_dicho
!
subroutine gi4_dicho(np,x,xval,ceil,ival,error)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: np     ! Number of input points
  integer(kind=4),           intent(in)    :: x(np)  ! Input ordered Values
  integer(kind=4),           intent(in)    :: xval   ! The value we search for
  logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
  integer(kind=size_length), intent(out)   :: ival   ! Position in the array
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=size_length) :: iinf,isup,imid
  character(len=message_length) :: mess
  !
  if (x(1).gt.xval .or. x(np).lt.xval) then
    write(mess,'(A,I0,A,I0,A,I0,A)')  &
      'Input value (',xval,') out of array range (',x(1),' to ',x(np),')'
    call gmath_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  ! The specification inequalities (see subroutine header) say that exact
  ! match is returned if available:
  if (xval.eq.x(isup)) then
    ival = isup
  elseif (xval.eq.x(iinf)) then
    ival = iinf
    !
    ! If no exact match, the requested value is in between. Returned value
    ! depends on ceiling or floor mode
  elseif (ceil) then  ! Ceiling mode
    ival = isup
  else                ! Floor mode
    ival = iinf
  endif
  !
end subroutine gi4_dicho
!
subroutine gi8_dicho(np,x,xval,ceil,ival,error)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: np     ! Number of input points
  integer(kind=8),           intent(in)    :: x(np)  ! Input ordered Values
  integer(kind=8),           intent(in)    :: xval   ! The value we search for
  logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
  integer(kind=size_length), intent(out)   :: ival   ! Position in the array
  logical,                   intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=size_length) :: iinf,isup,imid
  character(len=message_length) :: mess
  !
  if (x(1).gt.xval .or. x(np).lt.xval) then
    write(mess,'(A,I0,A,I0,A,I0,A)')  &
      'Input value (',xval,') out of array range (',x(1),' to ',x(np),')'
    call gmath_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (x(imid).lt.xval) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  ! The specification inequalities (see subroutine header) say that exact
  ! match is returned if available:
  if (xval.eq.x(isup)) then
    ival = isup
  elseif (xval.eq.x(iinf)) then
    ival = iinf
    !
  ! If no exact match, the requested value is in between. Returned value
  ! depends on ceiling or floor mode
  elseif (ceil) then  ! Ceiling mode
    ival = isup
  else                ! Floor mode
    ival = iinf
  endif
  !
end subroutine gi8_dicho
!
subroutine gi4_dicho_with_user_ltgt(np,ceil,ival,ult,ugt,error)
  use gildas_def
  use gbl_message
  use gmath_interfaces, except_this=>gi4_dicho_with_user_ltgt
  !---------------------------------------------------------------------
  ! @ public-generic gi0_dicho_with_user_ltgt
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: np     ! Number of elements in array
  logical,         intent(in)    :: ceil   ! Ceiling mode?
  integer(kind=4), intent(out)   :: ival   ! Deduced position in the array
  logical,         external      :: ult    ! User lower than
  logical,         external      :: ugt    ! User greater than
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=4) :: iinf,isup,imid
  !
  if (ugt(1) .or. ult(np)) then
    call gmath_message(seve%e,rname,'Input value is out of range')
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (ult(imid)) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  if (ult(iinf).and.ugt(isup)) then
    ! We are in between (boundaries excluded), output depends on ceiling or
    ! floor mode
    if (ceil) then
      ival = isup
    else
      ival = iinf
    endif
    !
  else
    ! Not in between: we match one of the 2 boundaries
    if (ult(iinf)) then
      ival = isup
    else
      ival = iinf
    endif
  endif
  !
end subroutine gi4_dicho_with_user_ltgt
!
subroutine gi8_dicho_with_user_ltgt(np,ceil,ival,ult,ugt,error)
  use gildas_def
  use gbl_message
  use gmath_interfaces, except_this=>gi8_dicho_with_user_ltgt
  !---------------------------------------------------------------------
  ! @ public-generic gi0_dicho_with_user_ltgt
  !  Find ival such as
  !    X(ival-1) < xval <= X(ival)     (ceiling mode)
  !  or
  !    X(ival) <= xval < X(ival+1)     (floor mode)
  ! for input data ordered. Use a dichotomic search for that.
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)    :: np     ! Number of elements in array
  logical,         intent(in)    :: ceil   ! Ceiling mode?
  integer(kind=8), intent(out)   :: ival   ! Deduced position in the array
  logical,         external      :: ult    ! User lower than
  logical,         external      :: ugt    ! User greater than
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DICHO'
  integer(kind=8) :: iinf,isup,imid
  !
  if (ugt(1_8) .or. ult(np)) then
    call gmath_message(seve%e,rname,'Input value is out of range')
    error = .true.
    return
  endif
  !
  iinf = 1
  isup = np
  !
  do while (isup.gt.iinf+1)  ! As long as we are considering more than 2 values in range
    imid = floor((isup + iinf)/2.)
    if (ult(imid)) then
      iinf = imid
    else
      isup = imid
    endif
  enddo
  ! From now on the range has been reduced to the 2 consecutive values
  ! x(iinf) and x(isup) with isup = iinf+1
  !
  if (ult(iinf).and.ugt(isup)) then
    ! We are in between (boundaries excluded), output depends on ceiling or
    ! floor mode
    if (ceil) then
      ival = isup
    else
      ival = iinf
    endif
    !
  else
    ! Not in between: we match one of the 2 boundaries
    if (ult(iinf)) then
      ival = isup
    else
      ival = iinf
    endif
  endif
  !
end subroutine gi8_dicho_with_user_ltgt
!
subroutine gr4_mean(x,nelem,bval,eval,out)
  !$ use omp_lib
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr4_mean
  !---------------------------------------------------------------------
  ! @ public
  !   Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !   R*4 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nelem     ! Number of data values
  real(kind=4),              intent(in)  :: x(nelem)  ! Data values to compute
  real(kind=4),              intent(in)  :: bval      ! Blanking value
  real(kind=4),              intent(in)  :: eval      ! Blanking tolerance
  real(kind=4),              intent(out) :: out       ! Output scalar value
  ! Local
  integer(kind=size_length) :: ielem,nvalid
  real(kind=4) :: nan,lastchanceretval
  ! We need an intermediate real*8 array to avoid precision loss
  ! in case of a very large number of values...
  real(kind=8) :: dout
  !
  if (eval.ge.0.) then
    lastchanceretval = bval
  else
    call gag_notanum(nan)
    lastchanceretval = nan
  endif
  out = lastchanceretval
  if (nelem.lt.1) return
  !
  ! Now we can compute
  dout = 0.
  nvalid = 0
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(nelem,x,bval,eval,nvalid,dout) &
  !$OMP PRIVATE(ielem)
  !$OMP DO REDUCTION(+:dout,nvalid)
  do ielem=1,nelem
    if (x(ielem).eq.x(ielem)) then
      if (eval.lt.0.) then
        dout = dout + x(ielem)
        nvalid = nvalid+1
      else
        if (abs(x(ielem)-bval).gt.eval) then
          dout = dout + x(ielem)
          nvalid = nvalid+1
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (nvalid.gt.0) then
    out = dout/real(nvalid)
  else
    out = lastchanceretval
  endif
  !
end subroutine gr4_mean
!
subroutine gr8_mean(x,nelem,bval,eval,out)
  !$ use omp_lib
  use gildas_def
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr8_mean
  !---------------------------------------------------------------------
  ! @ public
  !   Protected against NaNs and Using Blanking Values. If Blanking
  ! enabled, will return blanking value if no valid result. If Blanking
  ! is not enabled, will return NaN if no valid result.
  !   R*8 version.
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nelem     ! Number of data values
  real(kind=8),              intent(in)  :: x(nelem)  ! Data values to compute
  real(kind=8),              intent(in)  :: bval      ! Blanking value
  real(kind=8),              intent(in)  :: eval      ! Blanking tolerance
  real(kind=8),              intent(out) :: out       ! Output scalar value
  ! Local
  integer(kind=size_length) :: ielem,nvalid
  real(kind=8) :: nan,lastchanceretval
  !
  if (eval.ge.0.d0) then
    lastchanceretval = bval
  else
    call gag_notanum(nan)
    lastchanceretval = nan
  endif
  out = lastchanceretval
  if (nelem.lt.1) return
  !
  ! Now we can compute
  out = 0.d0
  nvalid = 0
  !$OMP PARALLEL IF(.not.OMP_IN_PARALLEL()) &
  !$OMP DEFAULT(NONE) &
  !$OMP SHARED(nelem,x,bval,eval,nvalid,out) &
  !$OMP PRIVATE(ielem)
  !$OMP DO REDUCTION(+:out,nvalid)
  do ielem=1,nelem
    if (x(ielem).eq.x(ielem)) then
      if (eval.lt.0.d0) then
        out = out + x(ielem)
        nvalid = nvalid+1
      else
        if (abs(x(ielem)-bval).gt.eval) then
          out = out + x(ielem)
          nvalid = nvalid+1
        endif
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  if (nvalid.gt.0) then
    out = out/nvalid
  else
    out = lastchanceretval
  endif
  !
end subroutine gr8_mean
!
subroutine gr4_quantile(data,ndata,bval,eval,quant,nquant,error)
  use gildas_def
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr4_quantile
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the k-quantiles (i.e. the k-1 values which split the data in
  ! k subsets of equal or almost-equal sizes) of the input data array in
  ! quant(nquant).
  ! For convenience the 0-th (minimum value) and the k-th (maximum
  ! value) quantiles of the data are also returned. Which means:
  ! - the median (2-quantile) needs nquant=3
  ! - quartiles               need  nquant=5
  ! and so on.
  ! - nquant = 2 will return only the min-max values
  ! - nquant = 1 will return only the min value
  !---------------------------------------------------------------------
  integer(kind=size_length),  intent(in)    :: ndata          ! Array size
  real(kind=4),               intent(in)    :: data(ndata)    ! Data
  real(kind=4),               intent(in)    :: bval           ! Blanking value
  real(kind=4),               intent(in)    :: eval           ! Tolerance
  integer(kind=index_length), intent(in)    :: nquant         ! Number of quantiles
  real(kind=4),               intent(inout) :: quant(nquant)  ! Quantiles of input array
  logical,                    intent(inout) :: error          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='QUANTILE'
  integer(kind=4) :: ier,iquant
  integer(kind=size_length) :: nwork,fwork,cwork
  real(kind=4), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  real(kind=8) :: rwork
  !
  ! Sanity check
  if (nquant.le.0) then
    call gmath_message(seve%e,rname,'Null or negative quantile count')
    error = .true.
    return
  endif
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (failed_allocate(rname,'work',ier,error))  return
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr4_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr4_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output quantile values unmodified on return
    return
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (failed_allocate(rname,'indices',ier,error))  return
  !
  call gr4_trie(work,indices,int(nwork,kind=4),error)
  if (error)  return
  !
  ! Fill the quantile. Be careful for the stupid cases where nquant>=ndata.
  ! Also works for boundaries:
  !   quant(1) = work(1)
  !   quant(nquant) = work(nwork)
  if (nquant.eq.1) then
    quant(1) = work(1)
  else
    do iquant=1,nquant
      rwork = 1+(nwork-1)*real(iquant-1,kind=8)/real(nquant-1,kind=8)
      fwork = floor(rwork,kind=size_length)
      cwork = ceiling(rwork,kind=size_length)
      if (fwork.eq.cwork) then
        quant(iquant) = work(fwork)
      else
        quant(iquant) = work(fwork)*(cwork-rwork) + &
                        work(cwork)*(rwork-fwork)
      endif
    enddo
  endif
end subroutine gr4_quantile
!
subroutine gr8_quantile(data,ndata,bval,eval,quant,nquant,error)
  use gildas_def
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gr8_quantile
  !---------------------------------------------------------------------
  ! @ public
  ! Compute the k-quantiles (i.e. the k-1 values which split the data in
  ! k subsets of equal or almost-equal sizes) of the input data array in
  ! quant(nquant).
  ! For convenience the 0-th (minimum value) and the k-th (maximum
  ! value) quantiles of the data are also returned. Which means:
  ! - the median (2-quantile) needs nquant=3
  ! - quartiles               need  nquant=5
  ! and so on.
  ! - nquant = 2 will return only the min-max values
  ! - nquant = 1 will return only the min value
  !---------------------------------------------------------------------
  integer(kind=size_length),  intent(in)    :: ndata          ! Array size
  real(kind=8),               intent(in)    :: data(ndata)    ! Data
  real(kind=8),               intent(in)    :: bval           ! Blanking value
  real(kind=8),               intent(in)    :: eval           ! Tolerance
  integer(kind=index_length), intent(in)    :: nquant         ! Number of quantiles
  real(kind=8),               intent(inout) :: quant(nquant)  ! Quantiles of input array
  logical,                    intent(inout) :: error          ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='QUANTILE'
  integer(kind=4) :: ier,iquant
  integer(kind=size_length) :: nwork,fwork,cwork
  real(kind=8), allocatable :: work(:)
  integer(kind=4), allocatable :: indices(:)
  real(kind=8) :: rwork
  !
  ! Sanity check
  if (nquant.le.0) then
    call gmath_message(seve%e,rname,'Null or negative quantile count')
    error = .true.
    return
  endif
  if (ndata.le.0) then
    call gmath_message(seve%e,rname,'Null or negative array size')
    error = .true.
    return
  endif
  !
  allocate(work(ndata),stat=ier)
  if (failed_allocate(rname,'work',ier,error))  return
  !
  ! Copy the data (in every case we want a copy of the input data since
  ! gr8_trie modifies its input data array, which is annoying in most of
  ! our usecases), and remove the blanked values by the way.
  call gr8_load(data,work,ndata,bval,eval,nwork)
  if (nwork.eq.0) then
    call gmath_message(seve%w,rname,'No valid data found')
    ! Let output quantile values unmodified on return
    return
  endif
  !
  allocate(indices(nwork),stat=ier)
  if (failed_allocate(rname,'indices',ier,error))  return
  !
  call gr8_trie(work,indices,int(nwork,kind=4),error)
  if (error)  return
  !
  ! Fill the quantile. Be careful for the stupid cases where nquant>=ndata.
  ! Also works for boundaries:
  !   quant(1) = work(1)
  !   quant(nquant) = work(nwork)
  if (nquant.eq.1) then
    quant(1) = work(1)
  else
    do iquant=1,nquant
      rwork = 1+(nwork-1)*real(iquant-1,kind=8)/real(nquant-1,kind=8)
      fwork = floor(rwork,kind=size_length)
      cwork = ceiling(rwork,kind=size_length)
      if (fwork.eq.cwork) then
        quant(iquant) = work(fwork)
      else
        quant(iquant) = work(fwork)*(cwork-rwork) + &
                        work(cwork)*(rwork-fwork)
      endif
    enddo
  endif
end subroutine gr8_quantile

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module cubetemplate_format2format
  use cubetools_parameters
  use cubetuple_format_class
  use cubetools_structure
  use cubeadm_cubeid_types
  use cubeadm_cubeprod_types
  use cubetemplate_factor_types
  use cubetopology_cuberegion_types
  use cubetemplate_messaging
  !
  public :: format2format
  private
  !
  type :: format2format_comm_t
     type(option_t),     pointer :: comm
     type(factor_comm_t)         :: factor
     type(cuberegion_comm_t)     :: region
     type(cubeid_arg_t), pointer :: incube
     type(cube_prod_t),  pointer :: oucube
   contains
     procedure, public  :: register => cubetemplate_format2format_comm_register
     procedure, private :: parse    => cubetemplate_format2format_comm_parse
     procedure, private :: main     => cubetemplate_format2format_comm_main
  end type format2format_comm_t
  type(format2format_comm_t) :: format2format
  !
  type format2format_user_t
     type(cubeid_user_t)     :: cubeids
     type(factor_user_t)     :: factor
     type(cuberegion_user_t) :: region
   contains
     procedure, private :: toprog => cubetemplate_format2format_user_toprog
  end type format2format_user_t
  !
  type format2format_prog_t
     type(cuberegion_prog_t)  :: region
     type(factor_prog_t)      :: factor
     class(format_t), pointer :: incube
     class(format_t), pointer :: oucube
   contains
     procedure, private :: header => cubetemplate_format2format_prog_header
     procedure, private :: data   => cubetemplate_format2format_prog_data
     procedure, private :: loop   => cubetemplate_format2format_prog_loop
     procedure, private :: act    => cubetemplate_format2format_prog_act
  end type format2format_prog_t
  !
contains
  !
  subroutine cubetemplate_format2format_command(line,error)
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    type(format2format_user_t) :: user
    character(len=*), parameter :: rname='FORMAT2FORMAT>COMMAND'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call format2format%parse(line,user,error)
    if (error) return
    call format2format%main(user,error)
    if (error) continue
  end subroutine cubetemplate_format2format_command
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_format2format_comm_register(comm,error)
    use cubedag_allflags
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(format2format_comm_t), intent(inout) :: comm
    logical,                     intent(inout) :: error
    !
    type(cubeid_arg_t) :: incube
    type(cube_prod_t) :: oucube
    character(len=*), parameter :: rname='FORMAT2FORMAT>COMM>REGISTER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    ! Syntax
    call cubetools_register_command(&
         'FORMAT2FORMAT','[cubeid]',&
         'Template command with a per-imaage input and output access',&
         'Input cube must be real and output cube will be real.',&
         cubetemplate_format2format_command,&
         comm%comm,&
         error)
    if (error) return
    call incube%register(&
         'INPUT',&
         'Input cube',&
         strg_emp,&
         code_arg_optional,&
         [flag_any],&
         code_read,&
         code_access_imaset,&
         comm%incube,&
         error)
    if (error) return
    call comm%factor%register(error)
    if (error) return
    call comm%region%register(error)
    if (error) return
    !
    ! Products
    call oucube%register(&
         'OUTPUT',&
         'Output cube',&
         strg_emp,&
         [flag_template],&
         comm%oucube,&
         error)
    if (error)  return
  end subroutine cubetemplate_format2format_comm_register
  !
  subroutine cubetemplate_format2format_comm_parse(comm,line,user,error)
    !----------------------------------------------------------------------
    ! format2format cubname
    !----------------------------------------------------------------------
    class(format2format_comm_t), intent(in)    :: comm
    character(len=*),            intent(in)    :: line
    type(format2format_user_t),  intent(out)   :: user
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='FORMAT2FORMAT>COMM>PARSE'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_cubeid_parse(line,comm%comm,user%cubeids,error)
    if (error) return
    call comm%region%parse(line,user%region,error)
    if (error) return
    call comm%factor%parse(line,user%factor,error)
    if (error) return
  end subroutine cubetemplate_format2format_comm_parse
  !
  subroutine cubetemplate_format2format_comm_main(comm,user,error)
    use cubeadm_timing
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(format2format_comm_t), intent(in)    :: comm
    type(format2format_user_t),  intent(inout) :: user
    logical,                     intent(inout) :: error
    !
    type(format2format_prog_t) :: prog
    character(len=*), parameter :: rname='FORMAT2FORMAT>MAIN'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call user%toprog(comm,prog,error)
    if (error) return
    call prog%header(comm,error)
    if (error) return
    call cubeadm_timing_prepro2process()
    call prog%data(error)
    if (error) return
    call cubeadm_timing_process2postpro()
  end subroutine cubetemplate_format2format_comm_main
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_format2format_user_toprog(user,comm,prog,error)
    use cubeadm_get
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(format2format_user_t), intent(in)    :: user
    type(format2format_comm_t),  intent(in)    :: comm
    type(format2format_prog_t),  intent(out)   :: prog
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='FORMAT2FORMAT>USER>TOPROG'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_get_fheader(comm%incube,user%cubeids,prog%incube,error)
    if (error) return
    call user%factor%toprog(prog%factor,error)
    if (error) return
    call user%region%toprog(prog%incube,prog%region,error)
    if (error) return
    ! User feedback about the interpretation of his command line
    call prog%factor%list(error)
    if (error) return
    call prog%region%list(error)
    if (error) return
  end subroutine cubetemplate_format2format_user_toprog
  !
  !----------------------------------------------------------------------
  !
  subroutine cubetemplate_format2format_prog_header(prog,comm,error)
    use cubeadm_clone
    use cubetools_header_methods
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(format2format_prog_t), intent(inout) :: prog
    type(format2format_comm_t),  intent(in)    :: comm
    logical,                     intent(inout) :: error
    !
    character(len=*), parameter :: rname='FORMAT2FORMAT>PROG>HEADER'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_clone_fheader_with_region(comm%oucube,  &
      prog%incube,prog%region,prog%oucube,error)
    if (error) return
    call prog%factor%header(prog%oucube,error)
    if (error) return
  end subroutine cubetemplate_format2format_prog_header
  !
  subroutine cubetemplate_format2format_prog_data(prog,error)
    use cubeadm_opened
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(format2format_prog_t), intent(inout) :: prog
    logical,                     intent(inout) :: error
    !
    type(cubeadm_iterator_t) :: iter
    character(len=*), parameter :: rname='FORMAT2FORMAT>PROG>DATA'
    !
    call cubetemplate_message(templateseve%trace,rname,'Welcome')
    !
    call cubeadm_datainit_all(iter,prog%region,error)
    if (error) return
    !$OMP PARALLEL DEFAULT(none) SHARED(prog,error) FIRSTPRIVATE(iter)
    !$OMP SINGLE
    do while (cubeadm_dataiterate_all(iter,error))
       if (error) exit
       !$OMP TASK SHARED(prog,error) FIRSTPRIVATE(iter)
       if (.not.error) &
         call prog%loop(iter,error)
       !$OMP END TASK
    enddo
    !$OMP END SINGLE
    !$OMP END PARALLEL
  end subroutine cubetemplate_format2format_prog_data
  !
  subroutine cubetemplate_format2format_prog_loop(prog,iter,error)
    use cubeadm_taskloop
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(format2format_prog_t), intent(inout) :: prog
    type(cubeadm_iterator_t),    intent(inout) :: iter
    logical,                     intent(inout) :: error
    !
    type(image_t) :: inima
    type(image_t) :: ouima
    character(len=*), parameter :: rname='FORMAT2FORMAT>PROG>LOOP'
    !
    call inima%associate('inima',prog%incube,iter,error)
    if (error) return
    call ouima%allocate('ouima',prog%oucube,iter,error)
    if (error) return
    !
    do while (iter%iterate_entry(error))
      call prog%act(iter%ie,inima,ouima,error)
      if (error) return
    enddo ! ie
  end subroutine cubetemplate_format2format_prog_loop
  !
  subroutine cubetemplate_format2format_prog_act(prog,ie,inima,ouima,error)
    use cubeadm_image_types
    !----------------------------------------------------------------------
    !
    !----------------------------------------------------------------------
    class(format2format_prog_t), intent(inout) :: prog
    integer(kind=entr_k),        intent(in)    :: ie
    type(image_t),               intent(inout) :: inima
    type(image_t),               intent(inout) :: ouima
    logical,                     intent(inout) :: error
    !
    integer(kind=pixe_k) :: ix,iy
    character(len=*), parameter :: rname='FORMAT2FORMAT>PROG>ACT'
    !
    call inima%get(ie,error)
    if (error) return
    do iy=1,inima%ny
       do ix=1,inima%nx
          ouima%val(ix,iy) = prog%factor%val*cmplx(inima%val(ix,iy),ix+iy+ie)
       enddo ! ix
    enddo ! iy
    call ouima%put(ie,error)
    if (error) return
  end subroutine cubetemplate_format2format_prog_act
end module cubetemplate_format2format
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage MAPPING messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module map_message_private
  use gpack_def
  !
  ! Identifier used for message identification
  integer :: map_message_id = gpack_global_id  ! Default value for startup message
  !
end module map_message_private
!
subroutine map_message_set_id(id)
  use map_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer, intent(in) :: id
  ! Local
  character(len=message_length) :: mess
  !
  map_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',map_message_id
  call map_message(seve%d,'map_message_set_id',mess)
  !
end subroutine map_message_set_id
!
subroutine map_message(mkind,procname,message)
  use gkernel_interfaces
  use map_message_private
  !---------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   Messaging facility for the current library. Calls the low-level
  !   (internal) messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(map_message_id,mkind,procname,message)
  !
end subroutine map_message
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage SIC messages
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module sic_message_private
  use gpack_def
  !---------------------------------------------------------------------
  ! @private
  ! Identifier used for message identification
  !---------------------------------------------------------------------
  integer :: sic_message_id = gpack_global_id  ! Default@startup
  !
end module sic_message_private
!
subroutine sic_message_set_id(id)
  use sic_interfaces, except_this=>sic_message_set_id
  use sic_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @private
  ! Alter library id into input id. Should be called by the library
  ! which wants to share its id with the current one.
  !---------------------------------------------------------------------
  integer, intent(in) :: id
  ! Local
  character(len=message_length) :: mess
  !
  sic_message_id = id
  !
  write (mess,'(A,I3)') 'Now use id #',sic_message_id
  call sic_message(seve%d,'sic_message_set_id',mess)
  !
end subroutine sic_message_set_id
!
subroutine sic_message(mkind,procname,message)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_message
  use sic_message_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @private
  ! Messaging facility for the current library. Calls the low-level
  ! messaging routine with its own identifier.
  !---------------------------------------------------------------------
  integer,          intent(in) :: mkind     ! Message kind
  character(len=*), intent(in) :: procname  ! Name of calling procedure
  character(len=*), intent(in) :: message   ! Message string
  !
  call gmessage_write(sic_message_id,mkind,procname,message)
  !
end subroutine sic_message
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Routines to manage the GTEMPLATE package
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine gtemplate_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !
  type(gpack_info_t), intent(out) :: pack
  !
  external :: gtemplate_pack_init
  external :: gtemplate_pack_clean
  !
  pack%name='template'
  pack%ext='.gtemplate'
  pack%depend(1:1) = (/ locwrd(sic_pack_set) /) ! List here dependencies
  pack%init=locwrd(gtemplate_pack_init)
  pack%clean=locwrd(gtemplate_pack_clean)
  !
end subroutine gtemplate_pack_set
!
subroutine gtemplate_pack_init(gpack_id,error)
  !----------------------------------------------------------------------
  ! 
  !----------------------------------------------------------------------
  integer :: gpack_id
  logical :: error
  ! Global
  integer :: sic_setlog
  ! Local
  integer :: ier
  !
  call gtemplate_message_set_id(gpack_id)
  !
  ! Specific variables
  ier = sic_setlog('gag_help_gtemplate','gag_doc:hlp/gtemplate-help-template.hlp')
  if (ier.eq.0) then
    error=.true.
    return
  endif
  !
  ! Load local language
  call gtemplate_load
  !
  ! Specific initializations
  !
end subroutine gtemplate_pack_init
!
subroutine gtemplate_pack_clean(error)
  !----------------------------------------------------------------------
  ! Called at end of session. Might clean here for example global buffers
  ! allocated during the session
  !----------------------------------------------------------------------
  logical :: error
  !
  print *,"Called gtemplate_pack_clean"
  !
end subroutine gtemplate_pack_clean
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module gtemplate_interfaces_none
  interface
    subroutine gtemplate_pack_set(pack)
      use gpack_def
      !
      type(gpack_info_t), intent(out) :: pack
    end subroutine gtemplate_pack_set
  end interface
  !
  interface
    subroutine gtemplate_pack_init(gpack_id,error)
      !----------------------------------------------------------------------
      ! 
      !----------------------------------------------------------------------
      integer :: gpack_id
      logical :: error
    end subroutine gtemplate_pack_init
  end interface
  !
  interface
    subroutine gtemplate_pack_clean(error)
      !----------------------------------------------------------------------
      ! Called at end of session. Might clean here for example global buffers
      ! allocated during the session
      !----------------------------------------------------------------------
      logical :: error
    end subroutine gtemplate_pack_clean
  end interface
  !
  interface
    subroutine gtemplate_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine gtemplate_message_set_id
  end interface
  !
  interface
    subroutine gtemplate_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gtemplate_message
  end interface
  !
  interface
    subroutine gtemplate_load
      !---------------------------------------------------------------------
      ! Define and load languages of the package.
      !---------------------------------------------------------------------
      ! Global
    end subroutine gtemplate_load
  end interface
  !
  interface
    subroutine gtemplate_run(line,comm,error)
      !---------------------------------------------------------------------
      ! Support routine for the language GTEMPLATE.
      ! This routine is able to call the routines associated to each
      ! command of the language GTEMPLATE
      !---------------------------------------------------------------------
      use gbl_message
      character(len=*),  intent(in)    :: line   ! Command line to send to support routines
      character(len=12), intent(in)    :: comm   ! Command resolved by the SIC interpreter
      logical,           intent(inout) :: error  ! Logical error flag
    end subroutine gtemplate_run
  end interface
  !
  interface
    function gtemplate_error()
      !---------------------------------------------------------------------
      ! Support routine for the error status of the library. Does nothing
      ! here.
      !---------------------------------------------------------------------
      logical :: gtemplate_error
    end function gtemplate_error
  end interface
  !
  interface
    subroutine gtemplate_void(line,error)
      !---------------------------------------------------------------------
      ! Does nothing more than returning asap
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Error flag
    end subroutine gtemplate_void
  end interface
  !
  interface
    subroutine gtemplate_dummy(line,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! Support routine for command DUMMY
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! Command line
      logical,          intent(inout) :: error  ! Error flag
    end subroutine gtemplate_dummy
  end interface
  !
end module gtemplate_interfaces_none

module gfits_interfaces_public
#if defined(VAX)
  interface
    subroutine gdf_setblnk4(bval)
      !---------------------------------------------------------------------
      ! @ public
      !   Set the blanking for automatic conversions
      !---------------------------------------------------------------------
      real(4), intent(in) :: bval
    end subroutine gdf_setblnk4
  end interface
  !
  interface
    subroutine gdf_setblnk8(bval)
      !---------------------------------------------------------------------
      ! @ public
      !   Set the blanking for automatic conversions
      !---------------------------------------------------------------------
      real(8), intent(in) :: bval
    end subroutine gdf_setblnk8
  end interface
  !
#endif
#if defined(EEEI)
  interface
    subroutine gdf_setblnk4(bval)
      !---------------------------------------------------------------------
      ! @ public
      !   Set the blanking for automatic conversions
      !---------------------------------------------------------------------
      real(4), intent(in) :: bval
    end subroutine gdf_setblnk4
  end interface
  !
#endif
  interface
    subroutine fitreal(fd,ndat,array,scale,zero,error)
      use gbl_message
      use gfits_buf
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Write NDAT data values in FITS data area,
      ! with scaling SCALE and offset ZERO
      !---------------------------------------------------------------------
      type(gfits_hdesc_t), intent(inout) :: fd           !
      integer(kind=4),     intent(in)    :: ndat         ! Number of data elements
      real(kind=4),        intent(in)    :: array(ndat)  ! Data array
      real(kind=4),        intent(in)    :: scale        ! Scaling factor
      real(kind=4),        intent(in)    :: zero         ! Zero offset
      logical,             intent(inout) :: error        ! Error flag
    end subroutine fitreal
  end interface
  !
  interface
    subroutine fitreal_end(fd,error)
      use gfits_buf
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(gfits_hdesc_t), intent(inout) :: fd     !
      logical,             intent(inout) :: error  ! Error flag
    end subroutine fitreal_end
  end interface
  !
  interface
    subroutine gfits_getreal(fd,ndat,array,scal,zero,error)
      use gildas_def
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Read NDAT data values from FITS data area, with scaling SCALE and
      ! offset ZERO
      !---------------------------------------------------------------------
      type(gfits_hdesc_t),       intent(in)    :: fd           !
      integer(kind=size_length), intent(in)    :: ndat         ! Number of desired data values
      real(kind=4),              intent(inout) :: array(ndat)  ! Data values
      real(kind=4),              intent(in)    :: scal         ! Scale factor
      real(kind=4),              intent(in)    :: zero         ! Offset
      logical,                   intent(inout) :: error        ! Error flag
    end subroutine gfits_getreal
  end interface
  !
  interface
    subroutine gfits_putbuf(int1,nr,error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Write one row of a binary table to a FITS logical record
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: nr        ! Length of buffer
      integer(kind=1), intent(in)    :: int1(nr)  ! Buffer
      logical,         intent(inout) :: error     ! Error flag
    end subroutine gfits_putbuf
  end interface
  !
  interface
    subroutine gfits_getbuf(int1,nr,error)
      use gildas_def
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public-mandatory
      ! Get one row of a binary table from a FITS logical record
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: nr        ! Length of buffer
      integer(kind=1),           intent(inout) :: int1(nr)  ! Buffer
      logical,                   intent(inout) :: error     ! Error flag
    end subroutine gfits_getbuf
  end interface
  !
  interface
    subroutine gfits_skibuf(nb,error)
      use gildas_def
      use gfits_buf
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Skip NB bytes on input file
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: nb     ! Bytes to skip
      logical,                   intent(inout) :: error  ! Error flag
    end subroutine gfits_skibuf
  end interface
  !
  interface
    subroutine gfits_skidat(fd,ndat,error)
      use gildas_def
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      !  Skip NDAT data values from FITS data area,
      !---------------------------------------------------------------------
      type(gfits_hdesc_t),       intent(in)    :: fd     !
      integer(kind=size_length), intent(in)    :: ndat   ! Number of desired data values
      logical,                   intent(inout) :: error  ! Error flag
    end subroutine gfits_skidat
  end interface
  !
  interface
    subroutine gfits_goto_hdu(fd,khdu,error)
      use gildas_def
      use gbl_message
      use gfits_types
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Go to the requested HDU
      !---------------------------------------------------------------------
      type(gfits_hdesc_t), intent(inout) :: fd     !
      integer(kind=4),     intent(in)    :: khdu   ! Requested HDU (1=Primary)
      logical,             intent(inout) :: error  ! Error flag
    end subroutine gfits_goto_hdu
  end interface
  !
  interface
    subroutine gfits_list_hdus(name,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Go to the requested HDU
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: name   ! File name
      logical,          intent(inout) :: error  ! Error flag
    end subroutine gfits_list_hdus
  end interface
  !
  interface
    subroutine gfits_get(comm,argu,check,error,quiet,continue,comment,eof)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      !  Retrieve the next line of the FITS header
      !---------------------------------------------------------------------
      character(len=*), intent(out)           :: comm      ! Returned FITS keyword
      character(len=*), intent(out)           :: argu      ! Returned keyword value
      logical,          intent(in)            :: check     ! Printout FITS card
      logical,          intent(out)           :: error     ! Logical error flag
      logical,          intent(in),  optional :: quiet     ! Verbosity flag
      logical,          intent(in),  optional :: continue  ! Merge CONTINUE'd lines?
      character(len=*), intent(out), optional :: comment   !
      logical,          intent(out), optional :: eof       !
    end subroutine gfits_get
  end interface
  !
  interface
    subroutine gfits_put(line,check,error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      !       Write a FITS line of the header
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   ! FITS card image
      logical,          intent(in)    :: check  ! Verbose flag
      logical,          intent(inout) :: error  ! Error flag
    end subroutine gfits_put
  end interface
  !
  interface
    subroutine gfits_flush_data(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Write current FITS buffer to disk. It the buffer is not full, DATA
      ! is padded with ZEROES (Wells et al, A&A Sup. Ser 44, P.364, line 47)
      !---------------------------------------------------------------------
      logical, intent(out) :: error                 ! Error flag
    end subroutine gfits_flush_data
  end interface
  !
  interface
    subroutine gfits_flush_header(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Write current FITS buffer to disk. It the buffer is not full, HEADER
      ! is padded with BLANKS (Wells et al, A&A Sup. Ser 44, P.365, line 57)
      !---------------------------------------------------------------------
      logical, intent(out) :: error                 ! Error flag
    end subroutine gfits_flush_header
  end interface
  !
  interface
    subroutine gfits_hierarch(key,value,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Decode the 'value' as 'key' + new 'value' if input 'key' is
      ! HIERARCH.
      ! ---
      !  HIERARCH keyword convention is described here:
      !    http://fits.gsfc.nasa.gov/registry/hierarch_keyword.html
      !  Note that this is only a convention.
      !---------------------------------------------------------------------
      character(len=*), intent(out)   :: key    ! Output key
      character(len=*), intent(inout) :: value  ! Input/Output value
      logical,          intent(inout) :: error  ! Logical error flag
    end subroutine gfits_hierarch
  end interface
  !
  interface
    function gfits_unquote(value)
      !---------------------------------------------------------------------
      ! @ public
      !  Unquote the input string (if any quotes) and return the value.
      ! Useful in the context of FITS headers where the strings are often
      ! single-quoted.
      !---------------------------------------------------------------------
      character(len=80) :: gfits_unquote  ! Function value on return
      character(len=*), intent(in) :: value
    end function gfits_unquote
  end interface
  !
  interface
    subroutine gfits_load_header(hdict,check,getsymbol,error)
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Load the FITS header in the dictionary structure.
      !  COMMENT lines are ignored
      !  HISTORY lines are ignored
      !  HIERARCH lines are interpreted as appropriate
      ! This could be customized
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(out)   :: hdict      !
      logical,             intent(in)    :: check      !
      external                           :: getsymbol  ! Symbol translation routine
      logical,             intent(inout) :: error      !
    end subroutine gfits_load_header
  end interface
  !
  interface
    subroutine gfits_check_simple(card,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Sanity check of the SIMPLE card in FITS header. This is generic for
      ! any FITS file.
      !---------------------------------------------------------------------
      type(fits_unkn_0d_t), intent(in)    :: card   !
      logical,              intent(inout) :: error  !
    end subroutine gfits_check_simple
  end interface
  !
  interface
    subroutine gfits_check_xtension(card,error,xkind)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Sanity check of the XTENSION card in FITS header. This is generic
      ! for any FITS file. Optionally check for the XTENSION kind.
      !---------------------------------------------------------------------
      type(fits_unkn_0d_t),       intent(in)    :: card   !
      logical,                    intent(inout) :: error  !
      character(len=*), optional, intent(in)    :: xkind  ! Desired XTENSION kind
    end subroutine gfits_check_xtension
  end interface
  !
  interface
    subroutine gfits_check_format(card,nbit,fmt,error)
      use gbl_format
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Translate BITPIX to internal format code. This is generic for any
      ! FITS file.
      !---------------------------------------------------------------------
      type(fits_unkn_0d_t), intent(in)    :: card   !
      integer(kind=4),      intent(out)   :: nbit   !
      integer(kind=4),      intent(out)   :: fmt    !
      logical,              intent(inout) :: error  !
    end subroutine gfits_check_format
  end interface
  !
  interface
    subroutine gfits_check_naxis(card,naxis,error)
      use gildas_def
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Translate NAXIS. This is generic for any FITS extension.
      !---------------------------------------------------------------------
      type(fits_unkn_0d_t), intent(in)    :: card   !
      integer(kind=4),      intent(out)   :: naxis  !
      logical,              intent(inout) :: error  !
    end subroutine gfits_check_naxis
  end interface
  !
  interface
    subroutine gfits_check_naxisi(fhdict,dims,error)
      use gildas_def
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public
      ! Translate all the NAXISi. This is generic for any FITS extension.
      !---------------------------------------------------------------------
      type(gfits_hdict_t),        intent(in)    :: fhdict   !
      integer(kind=index_length), intent(out)   :: dims(:)  !
      logical,                    intent(inout) :: error    !
    end subroutine gfits_check_naxisi
  end interface
  !
  interface
    subroutine gfits_getnosymbol(symb,tran,error)
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      ! No symbol translation. 2 main use cases:
      ! - no symbol dictionary available in the current context, or
      ! - user should not be able to modify the critical elements (e.g.
      !   NAXIS*) needed in the context
      !---------------------------------------------------------------------
      character(len=*), intent(in)  :: symb   ! Symbol name
      character(len=*), intent(in)  :: tran   ! Symbol translation
      logical,          intent(out) :: error  ! Logical error flag
    end subroutine gfits_getnosymbol
  end interface
  !
  interface gfits_get_value
    subroutine gfits_get_char(fh,key,found,value,error)
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as character string. Quotes are removed if any. The output value is
      ! not modified if its key is not found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      character(len=*),    intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_char
    subroutine gfits_get_inte(fh,key,found,value,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as an integer. The output value is not modified if its key is not
      ! found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      integer(kind=4),     intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_inte
    subroutine gfits_get_long(fh,key,found,value,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as long integer. The output value is not modified if its key is not
      ! found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      integer(kind=8),     intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_long
    subroutine gfits_get_real(fh,key,found,value,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as single precision float. The output value is not modified if its
      ! key is not found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      real(kind=4),        intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_real
    subroutine gfits_get_dble(fh,key,found,value,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as double precision float. The output value is not modified if its
      ! key is not found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      real(kind=8),        intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_dble
    subroutine gfits_get_logi(fh,key,found,value,error)
      use gbl_message
      use gfits_types
      !---------------------------------------------------------------------
      ! @ public-generic gfits_get_value
      ! Get the value in the dictionary from the given key, and evaluate it
      ! as a logical. The output value is not modified if its key is not
      ! found.
      !---------------------------------------------------------------------
      type(gfits_hdict_t), intent(in)    :: fh
      character(len=*),    intent(in)    :: key
      logical,             intent(out)   :: found
      logical,             intent(inout) :: value
      logical,             intent(inout) :: error
    end subroutine gfits_get_logi
  end interface gfits_get_value
  !
  interface
    subroutine gfits_open(file,status,error,overwrite)
      use gfits_buf
      use gbl_message
      use gbl_format
      !---------------------------------------------------------------------
      ! @ public
      ! FITS API routine
      !       Connect with a FITS file on disk.
      !---------------------------------------------------------------------
      character(len=*),  intent(in)    :: file       ! FITS file name
      character(len=*),  intent(in)    :: status     ! Read (IN) or Write (OUT) status
      logical,           intent(inout) :: error      ! Error flag
      logical, optional, intent(in)    :: overwrite  ! Overwrite in case of OUT status?
    end subroutine gfits_open
  end interface
  !
  interface
    subroutine gfits_close(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS API routine
      !       Disconnect from a FITS file, after flushing the data if needed
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Error flag
    end subroutine gfits_close
  end interface
  !
  interface
    subroutine gfits_skirec(nrec,error)
      use gildas_def
      use gfits_buf
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API routine
      !       Skips a (positive or negative) number of FITS logical records
      !---------------------------------------------------------------------
      integer(kind=record_length), intent(in)    :: nrec   ! Number of records to skip
      logical,                     intent(inout) :: error  ! Error flag
    end subroutine gfits_skirec
  end interface
  !
  interface
    subroutine gfits_getrecnum(irecnum)
      use gildas_def
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API routine
      !       Returns the number of the present FITS 2880-bytes record.
      !---------------------------------------------------------------------
      integer(kind=record_length), intent(out) :: irecnum  ! Current record number
    end subroutine gfits_getrecnum
  end interface
  !
  interface
    subroutine gfits_setrecnum(irecnum)
      use gildas_def
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API Routine
      !       Sets the number of the FITS 2880-bytes record.
      !---------------------------------------------------------------------
      integer(kind=record_length), intent(in) :: irecnum  ! Current record number
    end subroutine gfits_setrecnum
  end interface
  !
  interface
    subroutine gfits_getrecoffset(ioffset)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API routine
      !       Returns the offset (in bytes) of the next data to be read
      !       inside the present 2880-bytes record.
      !---------------------------------------------------------------------
      integer(kind=4), intent(out) :: ioffset        ! Offset in current record
    end subroutine gfits_getrecoffset
  end interface
  !
  interface
    subroutine gfits_setrecoffset(ioffset)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API routine
      !       Sets the offset (in bytes) of the next data to be read inside
      !       the present 2880-bytes record.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: ioffset          ! Offset in current record
    end subroutine gfits_setrecoffset
  end interface
  !
  interface
    subroutine gfits_getstdrec(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS  API routine
      !     Get the next buffer internally
      !     Only used by CLASS 3dfits.f90
      !---------------------------------------------------------------------
      logical, intent(inout) :: error  ! Error flag
    end subroutine gfits_getstdrec
  end interface
  !
  interface
    function gfits_iseof()
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! FITS API routine
      !     Tells if the FITS file has reached EOF
      !---------------------------------------------------------------------
      logical :: gfits_iseof                 ! intent(out)
    end function gfits_iseof
  end interface
  !
  interface
    subroutine gfits_rewind_file(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Rewind the pointers to start of file
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine gfits_rewind_file
  end interface
  !
  interface
    subroutine gfits_rewind_hdu(error)
      use gfits_buf
      !---------------------------------------------------------------------
      ! @ public
      ! Rewind the pointers to start of current HDU
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine gfits_rewind_hdu
  end interface
  !
  interface
    subroutine gfits_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine gfits_message_set_id
  end interface
  !
end module gfits_interfaces_public

subroutine clic_set (line,error)
  use gildas_def
  use gkernel_interfaces
  use gkernel_types
  use clic_index
  use clic_find
  use clic_file,except=>i
  use clic_virtual
  use gio_params
  !---------------------------------------------------------------------
  ! CLIC Support routine for command
  !      SET Something [value1, value2, ...]
  ! Arguments :
  !	LINE	C*(*)	Command line		Input
  !	ERROR	L	Logical error flag	Output
  !----------------------------------------------------------------------
  !
  ! Options:
  !   1 	/LIMITS
  !   2 	/WINDOW
  !   3 	/ANTENNA
  !   4 	/DEFAULT
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_constant.inc'
  include 'gbl_pi.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'clic_xy_code.inc'
  ! Local
  logical :: ante_data,base_data
  logical :: ante_switched, base_switched, fr_ok, d_ok, more
  common /switched/ ante_switched, base_switched
  real*8 :: test, ff
  real :: f1, f2, ftry(2,mwin_out)
  real :: rarg, freq
  integer :: iant, iarg, if, ic, iv, lch
  integer :: l_savb(mbox),i_savb(mbands,mbox), n_savb, i1, nn, l
  integer :: iso(mbands), ier, ia(mnant), na, phys_log(mnant)
  integer :: k, n_save, i_save(mbox), isb, isbb, narg
  integer :: i, j, nkey, nl, nla, nch, dayf
  logical :: and, to, reset, old_degrees
  logical :: default, bad, angle_data
  logical :: first,second
  integer :: first_quarter, second_quarter, factor, lc
  character(len=80) :: ch, fich
  character(len=12) :: argum,argum1,argum2,argum3,kw,keywor,keywor2
  character(len=12) :: nombre
  real :: frtol, frmhz
  parameter (frtol=1e3)        ! 1 GHz ...
  character(len=10) :: qw
  integer :: q, old_do_polar, n, old_narrow_input
  type(sic_listi4_t) :: list
  integer, save :: prio_save
  !
  ! Vocabularies:
  integer :: mvocab, mvband, mvsub, mvsub2
  integer :: mvoc1, mvoc2, mvoc3, mvoc4, mvoc5, mvoc6, mvoc7, mvoc8
  integer :: mvoc9, mvoc10, mvoc11, mvoc12, mvoc13, mvoc14, mvoc15
  integer :: mvoc16, mvoc17, mvoc18,mvoc19, mvoc20,mvoc21,mvoc22,mvoc23
  integer :: mvoc24
  integer :: mamp, mpha, mrf
  parameter (mvocab=81, mvband=5, mvsub=6, mvsub2=15,   &
    mvoc1=4, mvoc2=2, mvoc3=3, mvoc4=2, mvoc5=4, mvoc6=2,   &
    mvoc7=6, mvoc8=2, mvoc9=8, mvoc10=4, mvoc11=10, mvoc12=22,   &
    mvoc13=4, mvoc14=2, mvoc15=2, mvoc16=3, mvoc17=3, mvoc18=2,  &
    mvoc19=2,mvoc20=5,mvoc21=2,mvoc22=2,mvoc23=3,mvoc24=5,       &
    mamp=13, mpha=20, mrf=11)
  character*12 vamp(mamp), vpha(mpha), vrf(mrf), vocab(mvocab),   &
    vband(mvband), vsub(mvsub), vsub2(mvsub2),   &
    voc1(mvoc1), voc2(mvoc2), voc3(mvoc3),   &
    voc4(mvoc4), voc5(mvoc5), voc6(mvoc6), voc7(mvoc7),   &
    voc8(mvoc8), voc9(mvoc9), voc10(mvoc10), voc11(mvoc11),   &
    voc12(mvoc12), voc13(mvoc13), voc14(mvoc14), voc15(mvoc15),   &
    voc16(mvoc16), voc17(mvoc17), voc18(mvoc18), voc19(mvoc19),   &
    voc20(mvoc20), voc21(mvoc21), voc22(mvoc22), voc23(mvoc23),   &
    voc24(mvoc24)
  !
  ! Datas
  data voc1/'DEGREE','MINUTE','SECOND','RADIAN'/
  data voc2/'YES','NO'/
  data voc3/'PHYSICAL','LOGICAL','ALL'/
  data voc4/'ATMOSPHERE','NOISE'/
  data voc5/'OBJECT','PHASE','RF_PASSBAND','*'/
  data voc6/'EXACT','AUTO'/
  data voc7/'NONE','SCAN','TIME','METHOD','CONT','LINE'/
  data voc8/'VECTOR','SCALAR'/
  data voc9/'LINE','POINTS','HISTOGRAMS','BARS','PHYSICAL','LOGICAL', &
     'HEADER','IPB'/
  data voc10/'TIME','SPECTRAL','LOWRES','FULL'/
  data voc11/'AUTO','MANUAL','TREC','FILE',   &
    'OLD','NEW','1985','2003','2009','INTERPOLATE'/
  data voc12/'CORRELATION','AUTOCORR','GAIN','DELAY','FOCUS',   &
    'POINTING','CALIBRATE','IFPB','ONOFF','HOLOGRAPHY',   &
    'FIVE_POINT','PSEUDO_CONT','FLUX','STABILITY','CWVR',   &
    'VLBI','VLBG','OTF','BANDPASS','MONITORING','SKYDIP','*'/
  data voc13/'TSYS','INSTRUMENTAL','CALIBRATION','BANDPASS'/
  data voc14/'ON','OFF'/
  data voc15/'UPDATE','NOUPDATE'/
  data voc16/'*','PRIMARY','FILE'/
  data voc17/'RECEIVER','SCAN','NUM'/
  data voc18/'DATA','NODATA'/
  data voc19/'OLD','NEW'/
  data voc20/'OFF','HORIZONTAL','VERTICAL','BOTH','EACH'/
  data voc21/'RAW','PHYSICAL'/
  data voc22/'STANDARD','PROTOTYPE'/
  data voc23/'NATIVE','LEAKAGE','CORRECTED'/
  data voc24/'SOURCE','POINTING','PHASE','EPOCH','SCAN'/
  !
  ! SET X|Y keywords --> moved to clic_xy_code.inc
  !
  ! SET SUBBANDS
  data vsub/'TO','AND','ALL','EACH','LINE','CONTINUUM'   &
    /
  data vsub2/'ALL','TO','AND','LINE','CONTINUUM','FREQUENCY',   &
    'UPPER','USB','LOWER','LSB','AVERAGE','DSB','AUTO','SSB','WIDEX'/
  data vband /'UPPER','LOWER','AVERAG','RATIO','DIFFER'/
  !
  ! SET AMPLITUDE|PHASE|RF
  data vamp/'ABSOLUTE','RELATIVE','SCALED','UNSCALED',   &
    'KELVIN','JANSKY','ANTENNA','BASELINE','RAW',        &
    'SIZED','UNSIZED','SPIDX','NOSPIDX'/
  data vpha/'ABSOLUTE','RELATIVE','ANTENNA','BASELINE',   &
    'DEGREES','RADIANS','JUMPY','CONTINUOUS',   &
    'ATMOSPHERE','NOATMOSPHERE', 'EXTERNAL','INTERNAL',   &
    'FILE','NOFILE','WVR','NOWVR','MODEL','EMPIRICAL',   &
    'TOTAL_POWER','NOTOTAL_POWE'/
  data  vrf/'ANTENNA','BASELINE','CHANNEL','FREQUENCY',   &
    'FILE','MEMORY','OFF','ON','SPECTRUM','DOPPLER','NODOPPLER'/
  !
  ! List of SET keywords
  data vocab /   &
    'PROJECT',   &             !1  H
    'ANGLE',   &               !2  H
    'APC',   &                 !3  H obsolete
    'IC',   &                  !4  H
    'PC',   &                  !5  H
    'TRIANGLE',   &            !6  H
    'ERRORS',   &              !7  H
    'DEFAULT',   &             !8  H
    'EXTENSION',   &           !9  H
    'FORMAT',   &              !10 H
    'HOUR_ANGLE',   &          !11 H
    'LEVEL',   &               !12 H
    'LINE',   &                !13 H
    'CORRECTION',   &          !14 no help (will not get one)
    'NUMBER',   &              !15 H
    'OBSERVED',   &            !16 H
    'OFFSET',   &              !17 H
    'RANGE',   &               !18 H
    'REDUCED',   &             !19 H
    'SOURCE',   &              !20 H
    'TELESCOPE',   &           !21 H
    'TYPE',   &                !22 H
    'QUALITY',   &             !23 H
    'SCAN',   &                !24 H
    'BASELINES',   &           !25 H
    'BANDS',   &               !26 H
    'SUBBANDS',   &            !27 H
    'X',   &                   !28 H
    'Y',   &                   !29 H
    'ASPECT_RATIO',   &        !30 H
    'AVERAGING',   &           !31 H
    'PLOT',   &                !32 H
    'STEP',   &                !33 H
    'PHASE',   &               !34 H
    'MODE',   &                !35 H obsolete
    'ATMOSPHERE',   &          !36 H
    'REFERENCE',   &           !37 H
    'FREQUENCY',   &           !38 H
    'PROCEDURE',   &           !39 H
    'CLOSURE',   &             !40 H obsolete
    'AMPLITUDE',   &           !41 H
    'RF_PASSBAND',   &         !42 H
    'FLUX',   &                !43 H
    'WATER',   &               !44 H
    'TREC',   &                !45 H
    'VIRTUAL',   &             !46 obsolete
    'SELECTION',   &           !47 H
    'ANTENNAS',   &            !48 H
    'SPECTRUM',   &            !49 obsolete
    'BINNING',   &             !50 H
    'WEIGHTS',   &             !51 H
    'DATA',   &                !52 H
    'RECORD',   &              !53 H
    'CRITERIA',   &            !54 H
    'GAIN_IMAGE',   &          !55 H
    'DROP_FRACTIO',   &        !56 H
    'GIBBS',   &               !57 H
    'FIND',   &                !58 no help
    'PLANET',   &              !59 H
    'RECEIVER',   &            !60 H
    'UV_RANGE',   &            !61 H
    'TIME_ORIGIN',   &         !62 H
    'SORT',   &                !63 H
    'COPY',   &                !64 no help
    'GAIN_METHOD',   &         !65 H 
    'POLARIZATION',   &        !66 H
    'FAKE',   &                !67 no help (will not get one)
    'TOTAL_POWER',   &         !68 H
    'NARROW_INPUT',  &         !69 H
    'WIDEX_UNIT',    &         !70 H
    'BBAND',         &         !71 no help
    'IF',            &         !72
    'SPW',           &         !73
    'SKIP',          &         !74
    'EXCLUDE',       &         !75
    'SPIDX',         &         !76
    'VERSION',       &         !77
    'STOKES',        &         !78
    'TABLE',         &         !79
    'FINDPOL',       &         !80
    'NOCHECK'/                 !81
  !
  !------------------------------------------------------------------------
  !
  ! Code:
  reset = .false.
  default = sic_present(4,0)
  if (default .and. .not.sic_present(0,1)) then
    call setdef(line,error)
    goto 90
  endif
  call sic_ke(line,0,1,argum,nch,.true.,error)
  if (error) return
  error = .false.
  call sic_ambigs('SET',argum,keywor,nkey,vocab,mvocab,error)
  if (error) return
  narg = sic_narg(0)
  !
  ! SET PROJECT
  if (nkey.eq.1) then
    sproject = '*'
    call sic_ke(line,0,2,sproject,nch,.true.,error)
    if (error) return
    !
    ! Reset RF Pass Band also...
    do_pass = .false.
    find_needed = .true.
    change_display = .true.
    call show_criteria('PROJECT',.false.,error)
    call show_general('RF_PASSBAND',.false.,line,error)
  !
  ! SET ANGLE
  elseif (nkey.eq.2) then
    argum1='SECOND'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET ANGLE',argum1,kw,nkey,voc1,mvoc1,error)
    if (error) return
    sangle=kw(1:1)
    if (sangle.eq.'R') then
      fangle = 1
    elseif (sangle.eq.'D') then
      fangle = 180.d0/pi
    elseif (sangle.eq.'M') then
      fangle = 180.d0*60.d0/pi
    elseif (sangle.eq.'S') then
      fangle = 180.d0*60.d0*60.d0/pi
    endif
  !
  ! SET APC **OBSOLETE**
  elseif (nkey.eq.3) then
    sapc = -1
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET APC',argum1,kw,nkey,voc2,mvoc2,error)
    if (error) return
    if (kw.eq.'YES') then
      sapc = 1
    elseif (kw.eq.'NO') then
      sapc = 0
    endif
    find_needed = .true.
    call show_criteria('APC',.false.,error)
  !
  ! SET IC
  elseif (nkey.eq.4) then
    setic = -1
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET IC',argum1,kw,nkey,voc2,mvoc2,error)
    if (error) return
    if (kw.eq.'YES') then
      setic = 1
    elseif (kw.eq.'NO') then
      setic = 0
    endif
    call show_criteria('IC',.false.,error)
    find_needed = .true.
  !
  ! SET BPC
  elseif (nkey.eq.5) then
    sbpc = -1
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET BPC',argum1,kw,nkey,voc2,mvoc2,error)
    if (error) return
    if (kw.eq.'YES') then
      sbpc = 1
    elseif (kw.eq.'NO') then
      sbpc = 0
    endif
    call show_criteria('BPC',.false.,error)
    find_needed = .true.
  !
  ! SET TRIANGLE				! internally coded as mnbas+1, ..
  elseif (nkey.eq.6) then
    if (narg.le.1) goto 90
    n_save = n_base
    do i=1, n_save
      i_save(i) = i_base(i)
    enddo
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) goto 69
    call sic_ambigs('SET TRIANGLE',argum1,kw,nkey,voc3,mvoc3,error)
!    if (error) goto 69
    if (kw.eq.'PHYSICAL') then
      phys_base = .true.
      i1 = 3
    elseif (kw.eq.'LOGICAL') then
      phys_base = .false.
      i1 = 3
    else
      i1 = 2
    endif
    if (narg.lt.i1) goto 69
    n_base = 0
    do i = i1, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 69
      call sic_ambigs('SET',argum1,kw,nkey,ctri,mntri,error)
      if (error) goto 69
      n_base = n_base+1
      i_base(n_base) = mnbas + nkey
    enddo
    if (n_base.gt.0) call set_display(error)
69  continue
    if (error) then
      n_base = n_save
      do i=1, n_save
        i_base(i) = i_save(i)
      enddo
    else
      call show_display('TRIANGLE',.false.,error)
      change_display = .true.
    endif
  !
  ! SET ERRORS
  elseif (nkey.eq.7) then
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET ERRORS',argum1,kw,nkey,voc4,mvoc4,error)
    if (error) return
    if (kw.eq.'A') then
      do_bar_atm = .true.
    else
      do_bar_atm = .false.
    endif
  !
  ! SET DEFAULT
  elseif (nkey.eq.8) then
    call setdef(line,error)
    find_needed = .true.
  !
  ! SET EXTENSION e1 e2 ...
  elseif (nkey.eq.9) then
    ndefext = 0
    do i=2, sic_narg(0)
      argum1 = '.hpb'
      call sic_ch(line,0,i,argum1,nch,.false.,error)
      if (error) return
      if (argum1(1:1).ne.'.') argum1 = '.'//argum1
      call check_extension (argum1, lenc(argum1), error)
      if (error) return
      ndefext = ndefext+1
      defext(ndefext) = argum1
    enddo
    write(ch,*) 'Default file extensions set to ',   &
      (defext(i),i=1,ndefext)
    lch = lenc(ch)
    call message(2,1,'SET',ch(1:lch))
  !
  ! SET FORMAT
  elseif (nkey.eq.10) then
    call setfor(line,error)
  !
  ! SET HOUR_ANGLE
  elseif (nkey.eq.11) then
    argum1  = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    if (argum1(1:1).ne.'*') then
      call sic_sexa(argum1,lenc(argum1),test,error)
      if (error) return
      if (test.gt.12. .or. test.lt.-12.) then
        call message(6,3,'SET HOUR','Invalid Hour Angle')
        error = .true.
        return
      endif
      shoura1 = pi / 12. * test
    else
      shoura1 = -pi
    endif
    argum2  = '*'
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    if (argum1.ne.'*') then
      call sic_sexa(argum2,lenc(argum2),test,error)
      if (error) return
      if (test.gt.12. .or. test.lt.-12.) then
        call message(6,3,'SET HOUR','Invalid Hour Angle')
        error = .true.
        return
      endif
      shoura2 = pi / 12. * test
    else
      shoura2 = pi
    endif
    call show_criteria('HOUR',.false.,error)
    find_needed = .true.
  !
  ! SET LEVEL
  elseif (nkey.eq.12) then
    i = 2
    call sic_i4(line,0,2,i,.false.,error)
    if (error) return
    if (i.lt.0) then
      i = prio_save
    else
      i = min(8,i)
      i = max(0,i)
    endif
    write(nombre,'(I12)') i
    call message_level(i)
    prio_save = i
    call message(4,1,'SET','Message display level set to '//nombre)
  !
  ! SET LINE
  elseif (nkey.eq.13) then
    sline = '*'
    !         CALL SIC_CH(LINE,0,2,SLINE,NCH,.FALSE.,ERROR)
    call sic_ke(line,0,2,sline,nch,.false.,error)
    if (error) return
    call show_criteria('LINE',.false.,error)
    find_needed = .true.
  !
  ! SET CORRECTION
  elseif (nkey.eq.14) then
    phase_corr(1,1) = 50.
    do i=1, mnant
      phase_corr(1,i) = phase_corr(1,1)
      call sic_r4(line,0,1+i,phase_corr(1,i),.false.,error)
      phase_corr(2,i) = phase_corr(1,i)
    enddo
    call show_general('CORRECTION',.false.,line,error)
  !
  ! SET NUMBER
  elseif (nkey.eq.15) then
    argum1='*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    if (argum1(1:1).eq.'*') then
      snume1=0
    else
      call sic_i4(line,0,2,snume1,.false.,error)
      if (error) return
    endif
    argum2='*'
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    if (argum2(1:1).eq.'*') then
      snume2=2147483647
    else
      call sic_i4(line,0,3,snume2,.false.,error)
      if (error) return
    endif
    call show_criteria('NUMBER',.false.,error)
    find_needed = .true.
  !
  ! SET OBSERVED_DATE
  elseif (nkey.eq.16) then
    argum1  = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    argum2 = argum1
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    read(argum1,'(i6)',iostat=ier) sobse1
    if (abs(sobse1).gt.32768 .or. ier.ne.0) then
      sobse1 = -32768
      call cdate(argum1,sobse1,error)
    endif
    read(argum2,'(i6)',iostat=ier) sobse2
    if (abs(sobse2).gt.32768 .or. ier.ne.0) then
      sobse2 = 32767
      call cdate(argum2,sobse2,error)
    endif
    call show_criteria('OBSERVED',.false.,error)
    find_needed = .true.
  !
  ! SET OFFSET
  elseif (nkey.eq.17) then
    argum1  = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    argum2 = '*'
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    soffs1 = 4.0*pi
    call coffse(argum1,soffs1,error)
    soffl1  = soffs1
    soffs2 = 4.0*pi
    call coffse(argum2,soffs2,error)
    soffl2  = soffs2
    call show_criteria('OFFSETS',.false.,error)
    find_needed = .true.
  !
  ! SET RANGE
  elseif (nkey.eq.18) then
    argum1='*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    soffs1= 4.0*pi
    call coffse(argum1,soffs1,error)
    argum2='*'
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    soffl1= 4.0*pi
    call coffse(argum2,soffl1,error)
    argum1='*'
    call sic_ke(line,0,4,argum1,nch,.false.,error)
    if (error) return
    soffs2= 4.0*pi
    call coffse(argum1,soffs2,error)
    argum2='*'
    call sic_ke(line,0,5,argum2,nch,.false.,error)
    if (error) return
    soffl2= 4.0*pi
    call coffse(argum2,soffl2,error)
    call show_criteria('RANGE',.false.,error)
    find_needed = .true.
  !
  ! SET REDUCED_DATE
  elseif (nkey.eq.19) then
    argum1  = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    argum2 = argum1
    call sic_ke(line,0,3,argum2,nch,.false.,error)
    if (error) return
    sredu1 = -32768
    call cdate(argum1,sredu1,error)
    sredu2 = 32767
    call cdate(argum2,sredu2,error)
    call show_criteria('REDUCED',.false.,error)
    find_needed = .true.
  !
  ! SET SOURCE
  elseif (nkey.eq.20) then
    nsour = narg-1
    find_needed = .true.
    if (nsour.gt.10) then
      call message(6,2,'SET SOURCES','Only 10 sources retained')
      nsour = 10
    endif
    do i=1,nsour
      !            CALL SIC_CH(LINE,0,I+1,ARGUM1,NCH,.TRUE.,ERROR)
      call sic_ke(line,0,i+1,argum1,nch,.true.,error)
      if (error) return
      j = index(argum1,'*')
      if (j.eq.0) then
        sisour(i) = 12
      elseif (j.ne.1) then
        sisour(i) = j-1
      else
        nsour = 0
        goto 90
      endif
      sssour(i) = argum1
    enddo
    call show_criteria('SOURCE',.false.,error)
  !
  ! SET TELESCOPE
  elseif (nkey.eq.21) then
    steles = '*'
    call sic_ke(line,0,2,steles,nch,.false.,error)
    if (error) return
    call show_criteria('TELESCOPE',.false.,error)
    find_needed = .true.
  !
  ! SET TYPE Source|Phase|RF_Passband
  elseif (nkey.eq.22) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET TYPE',argum1,kw,nkey,voc5,mvoc5,error)
    if (error) return
    if (kw.eq.'OBJECT') then
      sitype = 1
    elseif (kw.eq.'PHASE') then
      sitype = 2
    elseif (kw.eq.'RF_PASSBAND') then
      sitype = 3
    elseif (kw.eq.'*') then
      sitype = -1
    endif
    call show_criteria('TYPE',.false.,error)
    find_needed = .true.
  !
  ! SET QUALITY
  elseif (nkey.eq.23) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call get_quality(argum1,squal,qw,error)
    if (error) return
    call show_criteria('QUALITY',.false.,error)
    find_needed = .true.
  !
  ! SET SCAN
  elseif (nkey.eq.24) then
    argum1='*'
    snscan = 0
    do i=2, sic_narg(0)-1, 2
      call sic_ke(line,0,i,argum1,nch,.false.,error)
      if (error) return
      argum2='*'
      call sic_ke(line,0,i+1,argum2,nch,.false.,error)
      if (error) return
      snscan = snscan+1
      if (argum1(1:1).eq.'*') then
        sscan1(snscan)=0
      else
        call sic_i4(line,0,i,sscan1(snscan),.false.,error)
        if (error) return
      endif
      if (argum2(1:1).eq.'*') then
        sscan2(snscan)=2147483647
      else
        call sic_i4(line,0,i+1,sscan2(snscan),.false.,error)
        if (error) return
      endif
    enddo
    call show_criteria('SCAN',.false.,error)
    find_needed = .true.
  !
  ! SET BASELINES
  elseif (nkey.eq.25) then
    if (narg.le.1) then
      call switch_baseline
      change_display = .true.
      call set_display(error)
      goto 90
    endif
    n_save = n_base
    do i=1, n_save
      i_save(i) = i_base(i)
    enddo
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) goto 259
    all_base = .false.
    nch = ichar(argum1(1:1))
    if (nch.gt.ichar('9')) then
      call sic_ambigs('SET BASELINE',argum1,kw,nkey,voc3,mvoc3,   &
        error)
      if (error) goto 259
      if (kw.eq.'PHYSICAL') then
        phys_base = .true.
        if ((narg.ge.3).and.(r_nant.eq.0)) then
          call message(6,3,'SET BASELINE PHYSICAL',   &
            'NO DATA READ')
          error=.true.
          goto 259
        endif
        do i=1,mnant
          phys_log(i) = mnant+1
        enddo
        do i=1,r_nant
          phys_log(r_kant(i)) = i
        enddo
        i1 = 3
      elseif (kw.eq.'LOGICAL') then
        phys_base = .false.
        i1 = 3
      elseif (kw.eq.'ALL') then
        all_base = .true.
        i_base(1) = 1
        call set_all_baselines
        i1 = 3
      endif
    else
      i1 = 2
    endif
    if (narg.lt.i1) goto 259
    n_base = 0
    error = .true.
    do i = i1, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 259
      if (phys_base) then
        ! Decode physical baseline label into a logical baseline index.
        ! Accept either "12" (when MNANT<10) or "01-02"/"1-2"/"1 2".
        argum2 = argum1
        ier = 0
        if (index(argum2,'-').gt.0 .or. index(argum2,',').gt.0) then
          do j=1, len(argum2)
            if (argum2(j:j).eq.'-'.or.argum2(j:j).eq.',') argum2(j:j) = ' '
          enddo
          read(argum2,*,iostat=ier) k, j
        elseif (len_trim(argum2).eq.2   &
          .and. argum2(1:1).ge.'0' .and. argum2(1:1).le.'9'   &
          .and. argum2(2:2).ge.'0' .and. argum2(2:2).le.'9') then
          k = iachar(argum2(1:1)) - iachar('0')
          j = iachar(argum2(2:2)) - iachar('0')
        else
          read(argum2,*,iostat=ier) k, j
        endif
        if (ier.ne.0) goto 259
        if (k.le.0 .or. j.le.0 .or. k.gt.mnant .or. j.gt.mnant .or. k.eq.j) then
          call message(6,3,'SET BASELINE PHYSICAL',   &
            'Invalid physical baseline')
          error = .true.
          goto 259
        endif
        if (phys_log(k).gt.r_nant .or. phys_log(j).gt.r_nant) then
          call message(6,3,'SET BASELINE PHYSICAL',   &
            'Invalid physical baseline')
          error = .true.
          goto 259
        endif
        if (mnant.le.9) then
          write(argum2,'(2i1)') min(phys_log(k),phys_log(j)),   &
            max(phys_log(k),phys_log(j))
        else
          write(argum2,'(i2.2,1h-,i2.2)') min(phys_log(k),phys_log(j)),   &
            max(phys_log(k),phys_log(j))
        endif
        call sic_ambigs('SET',argum2,kw,nkey,cbas,mnbas,error)
      else
        call sic_ambigs('SET',argum1,kw,nkey,cbas,mnbas,error)
      endif
      if (error) goto 259
      n_base = n_base+1
      i_base(n_base) = nkey
    enddo
    error = .false.
    if (n_base.gt.0) call set_display(error)
259 continue
    if (error) then
      n_base = n_save
      do i=1, n_save
        i_base(i) = i_save(i)
      enddo
    else
      call show_display('BASELINES',.false.,error)
      change_display = .true.
    endif
  !
  ! SET BANDS
  elseif (nkey.eq.26) then
    if (narg.le.1) goto 90
    bad = .true.
    n_save = n_band
    do i=1, n_save
      i_save(i) = i_band(i)
    enddo
    n_band = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 269
      if (argum1(1:2).eq.'US') then
        argum1 = 'UPPER'
      elseif (argum1(1:2).eq.'LS') then
        argum1 = 'LOWER'
      elseif (argum1(1:2).eq.'DS') then
        argum1 = 'AVER'
      endif
      call sic_ambigs('SET',argum1,kw,nkey,vband,mvband,error)
      if (error) goto 269
      n_band = n_band+1
      i_band(n_band) = nkey
    enddo
    error = .false.
    if (n_band.gt.0) call set_display(error)
    bad = error
269 continue
    if (bad) then
      n_band = n_save
      do i=1, n_save
        i_band(i) = i_save(i)
      enddo
    else
      change_display = .true.
      call show_display('BAND',.false.,error)
    endif
  !
  ! SET SUBBANDS
  elseif (nkey.eq.27) then
    if (narg.le.1) goto 90
    bad = .true.
    n_savb = n_subb
    do i=1, n_savb
      l_savb(i) = l_subb(i)
      do j=1, l_savb(i)
        i_savb(j,i) = i_subb(j,i)
      enddo
    enddo
    n_subb = 0
    to = .false.
    and = .false.
    k = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 279
      call sic_ambigs(' ',argum1,kw,nkey,csub,mcsub,more)
      if (more) call sic_ambigs('SET SUBBANDS',argum1,kw,nkey,   &
        vsub, mvsub, error)
      if (error) goto 279
      !
      if (kw.eq.'TO') then
        to = .true.
      elseif (kw.eq.'AND') then
        and = .true.
      !
      elseif (kw.eq.'ALL') then
        n_subb = n_savb
        all_subb = .true.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        call set_all_subbands
      elseif (kw.eq.'EACH') then
        n_subb = n_savb
        all_subb = .false.
        each_subb = .true.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        call set_each_subband
      elseif (kw.eq.'LINE') then
        n_subb = n_savb
        do j=1, n_subb
          if (i_subb(1,j).le.mbands) then
            do k=1, l_subb(j)
              i_subb(k,j) = i_subb(k,j)+mbands
            enddo
          endif
        enddo
      elseif (kw.eq.'CONTINUUM') then
        n_subb = n_savb
        do j=1, n_subb
          if (i_subb(1,j).gt.mbands) then
            do k=1, l_subb(j)
              i_subb(k,j) = i_subb(k,j)-mbands
            enddo
          endif
        enddo
      else
        all_subb = .false.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        if (to) then
          if (k.eq.0 .or. nkey.le.k) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
            goto 279
          endif
          do j = k+1, nkey
            l_subb(n_subb) = l_subb(n_subb) + 1
            i_subb(l_subb(n_subb),n_subb) = j
          enddo
          k = nkey
          to = .false.
        elseif (and) then
          if (k.eq.0) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
            goto 279
          endif
          l_subb(n_subb) = l_subb(n_subb) + 1
          i_subb(l_subb(n_subb),n_subb) = nkey
          k = nkey
          and = .false.
        else
          n_subb = n_subb+1
          k = nkey
          i_subb(1,n_subb) = nkey
          l_subb(n_subb) = 1
        endif
        !
        if (sic_present(2,0)) then
          argum1 = sw1(n_subb)
          call sic_ke(line,2,2*n_subb-1,argum1,nch,.true.,error)
          if (error) goto 279
          if (argum1.eq.'*') then
            sw1(n_subb) = '*'
            iw1(n_subb) = 0
          elseif (argum1.ne.'=') then
            call sic_i4(line,2,2*n_subb-1,iw1(n_subb),.true.,   &
              error)
            if (error) goto 279
            sw1(n_subb) = 'F'
          endif
          argum1 = sw2(n_subb)
          call sic_ke(line,2,2*n_subb,argum1,nch,.true.,error)
          if (error) goto 279
          if (argum1.eq.'*') then
            sw2(n_subb) = '*'
            iw2(n_subb) = 0
          elseif (argum1.ne.'=') then
            call sic_i4(line,2,2*n_subb, iw2(n_subb),.true.,   &
              error)
            if (error) goto 279
            sw2(n_subb) = 'F'
          endif
        else
          sw1(n_subb) = '*'
          iw1(n_subb) = 0
          sw2(n_subb) = '*'
          iw2(n_subb) = 0
        endif
      endif
    enddo
    !
    error = .false.
    if (.not.sic_present(6,0)) call select_subb
    !
    ! Now check/switch polarization mode
    !
    if ((new_receivers).and.(narrow_input.eq.0).and.(widex_unit.eq.0)) then
      old_do_polar = do_polar
      call check_pol_subbands(error)
      kw = voc20(do_polar+1)
      n = lenc(kw)
      if (do_polar.ne.old_do_polar) then
        call message(6,1,'CLIC_SET',   &
          'Switching to polarization mode: '//kw(1:n))
      else
        call message(6,1,'CLIC_SET',   &
          'Polarization mode: '//kw(1:n))
      endif
    endif
    !
    ! Now check/switch narrow band correlator input
    !
    if ((new_receivers).and.(narrow_input.ne.0)) then
      old_narrow_input = narrow_input
      call check_nbc_subbands(error)
      if (narrow_input.ne.old_narrow_input) then
        write (ch, '(A,I1)')   &
          'Switching to narrow-band correlator input ',   &
          narrow_input
        call message(6,1,'CLIC_SET',ch)
      else
        write (ch, '(A,I1)')   &
          'Narrow-band correlator input ',   &
          narrow_input
        call message(6,1,'CLIC_SET',ch)
      endif
    endif
    !
    call set_display(error)
    bad = error
279 continue
    if (bad) then
      n_subb = n_savb
      do i=1, n_savb
        l_subb(i) = l_savb(i)
        do j=1, l_savb(i)
          i_subb(j,i) = i_savb(j,i)
        enddo
      enddo
    else
      change_display = .true.
      call show_display('SUBBAND',.false.,error)
    endif
  !
  ! SET X
  elseif (nkey.eq.28) then
    if (narg.le.1) goto 90
    bad = .true.
    n_save = n_x
    do i=1, n_save
      i_save(i) = i_x(i)
    enddo
    n_x = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 289
      call sic_ambigs('SET',argum1,kw,nkey,vxy,mxy,error)
      if (error) goto 289
      n_x = n_x+1
      i_x(n_x) = nkey
      if (.not.new_receivers.and.nkey.eq.xy_i_fre3) then
        print *,"E-SET THERE IS NO IF3 IN OLD RECEIVERS"
        error = .false.
        goto 289
      endif
    enddo
    if (n_x.le.0) goto 289
    do i=1, n_x
      if (sic_present(1,2*i-1)) then
        call sic_ke(line,1,2*i-1,argum1,nch,.true.,error)
        if (error) goto 289
        if (argum1.eq.'*') then
          sm_x1(i) = '*'
        elseif (argum1.eq.'=') then
          sm_x1(i) = '='
        else
          call sic_r4(line,1,2*i-1,gu1_x(i),.true.,error)
          if (error) goto 289
          sm_x1(i) = 'F'
        endif
      elseif (i_x(i).eq.1) then
        sm_x1(i) = 'F'
        gu1_x(i) = 0.
      elseif (angle_data(i_x(i)) .and. .not.continuous) then
        sm_x1(i) = 'F'
        if (degrees) then
          gu1_x(i) = -180.
        else
          gu1_x(i) = -pi
        endif
      elseif (i_x(i).eq.xy_i_fre) then
        sm_x1(i) = '='         ! LIMITS DEFAULT TO = FOR IF.
      else
        sm_x1(i) = '*'
      endif
      if (sic_present(1,2*i)) then
        call sic_ke(line,1,2*i,argum1,nch,.true.,error)
        if (error) goto 289
        if (argum1.eq.'*') then
          sm_x2(i) = '*'
        elseif (argum1.eq.'=') then
          sm_x2(i) = '='
        else
          call sic_r4(line,1,2*i,gu2_x(i),.true.,error)
          if (error) goto 289
          sm_x2(i) = 'F'
        endif
      elseif (angle_data(i_x(i)) .and. .not.continuous) then
        sm_x2(i) = 'F'
        if (degrees) then
          gu2_x(i) = +180.
        else
          gu2_x(i) = +pi
        endif
      elseif (i_x(i).eq.xy_i_fre) then
        sm_x2(i) = '='         ! LIMITS DEFAULT TO = FOR IF.
      else
        sm_x2(i) = '*'
      endif
    enddo
    error = .false.
    call set_display(error)
    bad = error
289 continue
    if (bad) then
      n_x = n_save
      do i=1, n_save
        i_x(i) = i_save(i)
      enddo
    else
      change_display = change_display.or.n_save.ne.n_x
      if (.not.change_display) then
        do i=1, n_save
          change_display = change_display   &
            .or. i_x(i).ne.i_save(i)
        enddo
      endif
      call show_display('X   ',.false.,error)
      if (do_bin .and. i_x(1).ne.i_save(1)) then
        do_bin = .false.
        call message(4,1,'CLIC_SET','BINNING IS OFF')
      endif
    endif
  !
  ! SET Y
  elseif (nkey.eq.29) then
if (narg.le.1) goto 90
    bad = .true.
    n_save = n_y
    do i=1, n_save
      i_save(i) = i_y(i)
    enddo
    n_y = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 299
      call sic_ambigs('SET',argum1,kw,nkey,vxy,mxy,error)
      if (error) goto 299
      n_y = n_y+1
      i_y(n_y) = nkey
    enddo
    if (n_y.le.0) goto 299
    do i=1, n_y
      if (sic_present(1,2*i-1)) then
        call sic_ke(line,1,2*i-1,argum1,nch,.true.,error)
        if (error) goto 299
        if (argum1.eq.'*') then
          sm_y1(i) = '*'
        elseif (argum1.eq.'=') then
          sm_y1(i) = '='
        else
          call sic_r4(line,1,2*i-1,gu1_y(i),.true.,error)
          if (error) goto 299
          sm_y1(i) = 'F'
        endif
      elseif (i_y(i).eq.1) then
        sm_y1(i) = 'F'
        gu1_y(i) = 0.
      elseif (angle_data(i_y(i)) .and. .not.continuous) then
        sm_y1(i) = 'F'
        if (degrees) then
          gu1_y(i) = -180.
        else
          gu1_y(i) = -pi
        endif
      else
        sm_y1(i) = '*'
      endif
      if (sic_present(1,2*i)) then
        call sic_ke(line,1,2*i,argum1,nch,.true.,error)
        if (error) goto 299
        if (argum1.eq.'*') then
          sm_y2(i) = '*'
        elseif (argum1.eq.'=') then
          sm_y2(i) = '='
        else
          call sic_r4(line,1,2*i,gu2_y(i),.true.,error)
          if (error) goto 299
          sm_y2(i) = 'F'
        endif
      elseif (angle_data(i_y(i)) .and. .not.continuous) then
        sm_y2(i) = 'F'
        if (degrees) then
          gu2_y(i) = +180.
        else
          gu2_y(i) = +pi
        endif
      else
        sm_y2(i) = '*'
      endif
    enddo
    i = i_y(1)
    if (ante_data(i)) then
      call switch_antenna
    !            ANTE_SWITCHED = .TRUE.
    !         ELSEIF (ANTE_SWITCHED) THEN
    !            CALL SWITCH_BASELINE
    !            ANTE_SWITCHED = .FALSE.
    endif
    if (base_data(i)) then
      call switch_baseline
    !           BASE_SWITCHED = .TRUE.
    !         ELSEIF (BASE_SWITCHED) THEN
    !            CALL SWITCH_ANTENNA
    !            BASE_SWITCHED = .FALSE.
    endif
    error = .false.
    call set_display(error)
    bad = error
299 continue
    if (bad) then
      n_y = n_save
      do i=1, n_save
        i_y(i)  = i_save(i)
      enddo
    else
      change_display = change_display.or.n_save.ne.n_y
      if (.not.change_display) then
        do i=1, n_save
          change_display = change_display   &
            .or. i_y(i).ne.i_save(i)
        enddo
      endif
      call show_display('Y    ',.false.,error)
    endif
  !
  ! SET ASPECT_RATIO
  elseif (nkey.eq.30) then
    call sic_r4(line,0,2,rarg,.true.,error)
    if (error) return
    if (rarg .le.0) then
      call message(6,3,'CLIC_SET','INVALID ASPECT RATIO')
      error = .true.
      return
    endif
    argum1 = 'EXACT'
    call sic_ke(line,0,3,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET ASPECT_RATIO',argum1,kw,nkey,voc6,mvoc6,   &
      error)
    if (error) return
    if (kw.eq.'AUTO') then
      aratio = - rarg
    else
      aratio = rarg
    endif
    call set_display(error)
    call show_display('ASPECT_RATIO',.false.,error)
  !
  ! SET AVERAGING
  elseif (nkey.eq.31) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET AVERAGING',argum1,kw,nkey,voc7,mvoc7,   &
      error)
    if (error) return
    if (kw.eq.'NONE') then
      i_average = 0
      s_average = 0
    elseif (kw.eq.'SCAN') then
      i_average = 1
      s_average = 0
      if (sic_narg(0).gt.2) then
        call sic_i4(line,0,3,iarg,.false.,error)
        if (iarg.gt.0) s_average = iarg
      endif
    elseif (kw.eq.'TIME') then
      i_average = 2
      s_average = 0
      call sic_r4(line,0,3,rarg,.true.,error)
      if (error) return
      if (rarg.lt.0) then
        call message(6,3,'CLIC_SET','INVALID AVERAGING TIME')
        error = .true.
        return
      endif
      t_average = rarg
    elseif (kw.eq.'METHOD') then
      call sic_ke(line,0,3,argum2,nch,.true.,error)
      if (error) return
      call sic_ambigs('SET AVERAGING METHOD',argum2,kw,nkey,   &
        voc8,mvoc8, error)
      if (error) return
      if (kw.eq.'VECTOR') then
        j_average = 1
      elseif (kw.eq.'SCALAR') then
        j_average = 0
      else
        call message(6,3,'CLIC_SET',   &
          'INVALID AVERAGING METHOD '//argum2)
      endif
    elseif (kw.eq.'CONT') then
      k_average = 0
    elseif (kw.eq.'LINE') then
      k_average = 1  
    else
      call message(6,3,'CLIC_SET',   &
        'INVALID AVERAGING MODE '//argum1)
      error = .true.
      return
    endif
    call show_display('AVERAGE',.false.,error)
    change_display = .true.
  !
  ! SET PLOT
  elseif (nkey.eq.32) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET PLOT',argum1,kw,nkey,voc9,mvoc9,error)
    if (error) return
    if (kw.eq.'PHYSICAL') then
      do_physical = .true.
    elseif(kw.eq.'LOGICAL') then
      do_physical = .false.
    elseif(kw.eq.'HEADER') then
      skip_flag = .true.
    elseif(kw.eq.'IPB') then
      skip_flag = .false.
    else
      plot_type = kw(1:4)
    endif
    call show_display('PLOT',.false.,error)
  !
  ! SET STEP
  elseif (nkey.eq.33) then
    call sic_r4(line,0,2,rarg,.true.,error)
    if (error) return
    if (rarg .le.0) then
      call message(6,3,'CLIC_SET','INVALID TIME STEP')
      error = .true.
      return
    endif
    t_step = rarg
    call show_display('STEP',.false.,error)
  !
  ! SET PHASE RELATIVE|ABSOLUTE ANTENNA|BASELINE DEGREE|RADIAN JUMPY|CONT N
  ! SET PHASE INTERNAL|EXTERNAL
  ! SET PHASE ATM|NOATM /ANTENNA ALL|{1 3 ...}
  ! SET PHASE WVR|NOWVR [MODEL|EMPIRICAL] /ANTENNA ALL|{1 3 ...}
  ! SET PHASE TOTAL|NOTOTAL /ANTENNA ALL|{1 3 ...}
  elseif (nkey.eq.34) then
    do i=2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) return
      if (ichar(argum1(1:1)).ge.ichar('0')   &
        .and. ichar(argum1(1:1)).le.ichar('9')   &
        .and. continuous) then
        read(argum1(1:lenc(argum1)),*) n_cont
        n_cont = max(0,n_cont)
        n_cont = min(n_cont,30)
        reset = .true.
      else
        old_degrees = degrees
        call sic_ambigs('SET',argum1,keywor2,nkey,vpha,mpha,   &
          error)
        if (error) return
        ! ABSOLUTE
        if (nkey.eq.1) then
          do_phase = .false.
          change_display = .true.
        ! RELATIVE
        elseif (nkey.eq.2) then
          do_phase = .true.
          change_display = .true.
        ! ATMOSPHERE|NOATMOPSHERE
        elseif (nkey.eq.9) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_atm(ia(j)) = .true.
          enddo
          if (i_average.ne.1) then
            i_average = 1
            call message(6,1,'CLIC_SET',   &
              'SWITCHING ON SET AVERAGE SCAN METHOD')
          endif
        elseif (nkey.eq.10) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_atm(ia(j)) = .false.
          enddo
        !
        ! CAUTION: IT IS POSSIBLE TO HAVE CORRECTION BASED ON WVR FOR SOME
        ! ANTENNAS, AND ON 1.3 MM TOTAL POWER MONITOR FOR OTHERS
        !
        ! WVR
        elseif (nkey.eq.15) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            if (r_wvrnch(ia(j)).eq.3) then
              do_phase_wvr(ia(j)) = .true.
              do_phase_mon(ia(j)) = .false.
            else
              do_phase_wvr(ia(j)) = .false.
            endif
          enddo
        elseif (nkey.eq.16) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_wvr(ia(j)) = .false.
          enddo
        elseif (nkey.eq.17) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_wvr_e(ia(j)) = .false.
          enddo
        elseif (nkey.eq.18) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_wvr_e(ia(j)) = .true.
          enddo
        ! TOTAL POWER MONITOR
        elseif (nkey.eq.19) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_mon(ia(j)) = .true.
            do_phase_wvr(ia(j)) = .false.
          enddo
        elseif (nkey.eq.20) then
          call get_antennas(line,3,na,ia,.false.,error)
          do j=1, na
            do_phase_mon(ia(j)) = .false.
          enddo
        ! EXTERNAL/INTERNAL
        elseif (nkey.eq.11) then
          do_phase_ext = .true.
        elseif (nkey.eq.12) then
          do_phase_ext = .false.
        ! FILE/NOFILE
        elseif (nkey.eq.13) then
          do_phase_nofile = .false.
        elseif (nkey.eq.14) then
          do_phase_nofile = .true.
        ! ANTENNA
        elseif (nkey.eq.3) then
          do_phase_antenna = .true.
        ! BASELINE
        elseif (nkey.eq.4) then
          do_phase_antenna = .false.
        ! DEGREES
        elseif (nkey.eq.5) then
          reset = .not.degrees
          degrees = .true.
          do k=1, n_x
            if (i_x(k).eq.xy_phase .and. reset) then
              if (sm_x1(k).eq.'F') then
                gu1_x(k) = 180./pi*gu1_x(k)
                gu2_x(k) = 180./pi*gu2_x(k)
              endif
            endif
          enddo
          do k=1, n_y
            if (i_y(k).eq.xy_phase .and. reset) then
              if (sm_y1(k).eq.'F') then
                gu1_y(k) = 180./pi*gu1_y(k)
                gu2_y(k) = 180./pi*gu2_y(k)
              endif
            endif
          enddo
        ! RADIANS
        elseif (nkey.eq.6) then
          reset = degrees
          degrees = .false.
          do k=1, n_x
            if (i_x(k).eq.xy_phase .and. reset) then
              if (sm_x1(k).eq.'F') then
                gu1_x(k) = pi/180.*gu1_x(k)
                gu2_x(k) = pi/180.*gu2_x(k)
              endif
            endif
          enddo
          do k=1, n_y
            if (i_y(k).eq.xy_phase .and. reset) then
              if (sm_y1(k).eq.'F') then
                gu1_y(k) = pi/180.*gu1_y(k)
                gu2_y(k) = pi/180.*gu2_y(k)
              endif
            endif
          enddo
        ! CONTINUOUS
        elseif (argum1(1:1).eq.'C') then
          reset = .not.continuous
          do k = 1, n_x
            if (i_x(k).eq.xy_phase .and. .not.continuous) then
              sm_x1(k) = '*'
              sm_x2(k) = '*'
            endif
          enddo
          do k=1, n_y
            if (i_y(k).eq.xy_phase .and. .not.continuous) then
              sm_y1(k) = '*'
              sm_y2(k) = '*'
            endif
          enddo
          continuous = .true.
        ! JUMPY
        elseif (nkey.eq.7) then
          reset = continuous
          do k=1, n_x
            if (i_x(k).eq.2 .and. continuous) then
              sm_x1(k) = 'F'
              sm_x2(k) = 'F'
              if (degrees) then
                gu1_x(k) = -180.
                gu2_x(k) = +180.
              else
                gu1_x(k) = -pi
                gu2_x(k) = +pi
              endif
            endif
          enddo
          do k=1, n_y
            if (i_y(k).eq.xy_phase .and. .not.continuous) then
              sm_y1(k) = 'F'
              sm_y2(k) = 'F'
              if (degrees) then
                gu1_y(k) = -180.
                gu2_y(k) = +180.
              else
                gu1_y(k) = -pi
                gu2_y(k) = +pi
              endif
            endif
          enddo
          continuous = .false.
        endif
      endif
    enddo
    call set_display(error)
    call show_display('PHASES',.false.,error)
    call show_general('PHASE',.false.,line,error)
    change_display = .true.
    if (reset) call reset_phases
  !
  ! SET MODE
  elseif (nkey.eq.35) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET MODE',argum1,kw,nkey,voc10,mvoc10,error)
    if (error) return
    if (kw.eq.'LOWRES') then
      lowres = .true.
      call loose_data
      call free_memory
      bp_spectrum_memory = .false.
      bp_spectrum_memory_pol = .false.
    elseif (kw.eq.'FULL') then
      lowres = .false.
      call loose_data
      call free_memory
      bp_spectrum_memory = .false.
      bp_spectrum_memory_pol = .false.
    else
      if (kw.eq.'TIME') then
        call message (8,3,'CLIC_SET','This command is obsolete')
      elseif (kw.eq.'SPECTRAL') then
        call message (8,3,'CLIC_SET','This command is obsolete')
      endif
    endif
  !
  ! SET ATMOSPHERE
  elseif (nkey.eq.36) then
    argum1 = '*'
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET ATM',argum1,kw,nkey,voc11,mvoc11,error)
    if (error) return
    !
    ! ANTENNA INDEPENDENT ATM MODE (MODEL VERSION):
    if (kw.eq.'1985' .or. kw.eq.'2003' .or.kw.eq.'2009' .or.  &
        kw.eq.'OLD'  .or. kw.eq.'NEW') then
      if (atmmodel.ne.kw) then
        call atm_setup(kw,error)
        if (.not.error) then
          atmmodel = kw
          atm_interpolate = .false.
        endif
      endif
    endif
    !
    ! USE TABLE
    if (kw.eq.'INTERPOLATE') then
       call atm_read_table(error)
       if (error) then
         call message(6,3,'CLIC_SET','Cannot find atmospheric model table')
         atm_interpolate = .false.
         return
       else
         atm_interpolate = .true.
       endif
    endif
    !
    ! ANTENNA DEPENDENT ATM MODE:
    if (kw.eq.'AUTO' .or. kw.eq.'TREC') then
      call get_antennas(line,3,na,ia,.true.,error)
      if (error) return
      do j=1, na
        atm_mode(ia(j)) = kw(1:4)
      enddo
      if (kw.eq.'AUTO') then
        call sic_r4(line,0,3,atm_water,.false.,error)
        if (error) return
      elseif (kw.eq.'TREC') then
        call sic_r4(line,0,3,rarg,.false.,error)
        if (error) return
        do j=1, na
          atm_trec(ia(j)) = rarg
        enddo
      endif
    endif
    call show_general('ATMOSPHERE',.false.,line,error)
  !
  ! SET REFERENCE
  elseif (nkey.eq.37) then
    call sic_i4(line,0,2,iant,.true.,error)
    if (error) return
    if (iant.lt.1 .or. iant.gt.mnant) then
      call message(6,3,'CLIC_SET','INVALID ANTENNA NUMBER')
      error = .true.
      return
    endif
    ref_ant = iant
    call show_general('REFERENCE',.false.,line,error)
  !
  ! SET FREQUENCY {C|L01..} {U|L} NAME FREQ
  elseif (nkey.eq.38) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1(1:1).eq.'C') then
      call message(6,4,'CLIC_SET','Operation not allowed')
      error =  .true.
      return
      call sic_ke(line,0,3,argum2,nch,.true.,error)
      if (error) return
      if (argum2(1:1).eq.'U') then
        isb = 1
      elseif (argum2(1:1).eq.'L') then
        isb = 2
      else
        call message(6,3,'CLIC_SET','INVALID SIDEBAND')
        error = .true.
        return
      endif
      call sic_ch(line,0,4,c_line(isb),nch,.true.,error)
      call sic_r8(line,0,5,ff,.true.,error)
      if (error) return
      if (ff.le.0 .or. ff.gt.500000.) then
        call message(6,3,'CLIC_SET','INVALID FREQUENCY')
        error = .true.
        return
      endif
      c_freq(isb) = ff
    elseif (argum1(1:1).eq.'L') then
      call message(6,4,'CLIC_SET','Operation not allowed')
      error =  .true.
      return
      read (argum1(2:3),'(I2)',err=98) isbb
      if (isbb.le.0 .or. isbb.gt.mrlband) then
        call message(6,3,'CLIC_SET','INVALID SIDEBAND//ARGUM1')
        error = .true.
        return
      endif
      call sic_ke(line,0,3,argum2,nch,.true.,error)
      if (error) return
      if (argum2(1:1).eq.'U') then
        isb = 1
      elseif (argum2(1:1).eq.'L') then
        isb = 2
      else
        call message(6,3,'CLIC_SET','INVALID SIDEBAND')
        error = .true.
        return
      endif
      call sic_ch(line,0,4,l_line(isbb,isb),nch,.true.,error)
      call sic_r8(line,0,5,ff,.true.,error)
      if (error) return
      if (ff.le.0 .or. ff.gt.500000.) then
        call message(6,3,'CLIC_SET','INVALID FREQUENCY')
        error = .true.
        return
      endif
      l_freq(isbb,isb) = ff
    elseif (argum1(1:3).eq.'ALL') then
      call sic_ch(line,0,3,argum2,nch,.true.,error)
      call sic_r8(line,0,4,ff,.true.,error)
      if (error) return
      if (ff.le.0 .or. ff.gt.500000.) then
        call message(6,3,'CLIC_SET','INVALID FREQUENCY')
        error = .true.
        return
      endif
      do isb = 1, 2
        c_line(isb) = argum2
        c_freq(isb) = ff
        do isbb = 1, mrlband
          l_freq(isbb,isb) = ff
          l_line(isbb, isb) = argum2
        enddo
      enddo
    else
      call message(6,3,'CLIC_SET','INVALID ARGUMENT'//argum1)
      error = .true.
      return
    endif
    call show_general('FREQUENCY',.false.,line,error)
  !
  ! SET PROCEDURE
  elseif (nkey.eq.39) then
    nproc = narg-1
    if (nproc.gt.10) then
      call message(6,2,'SET PROCEDURE',   &
        'ONLY 10 PROCEDURES RETAINED')
      nproc = min(nproc,10)
    endif
    do i=1,nproc
      call sic_ke(line,0,i+1,argum1,nch,.true.,error)
      if (error) return
      call sic_ambigs('SET MODE',argum1,kw,nkey,voc12,mvoc12,   &
        error)
      if (error) then
        nproc = 0
        return
      endif
      if (nkey.le.mvoc12-2) then
        ssproc(i) = nkey+10
      elseif (kw.eq.'SKYDIP') then
        ssproc(i) = 6
      elseif (kw.eq.'*') then
        nproc = 0
      endif
    enddo
    call show_criteria('PROCEDURE',.false.,error)
    find_needed = .true.
  !
  ! SET CLOSURE B1 W1 ... **OBSOLETE**
  elseif (nkey.eq.40) then
    do i = 2, narg,2
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 98
      call sic_ambigs('SET',argum1,kw,nkey,cbas,mnbas,error)
      if (error) return
      call sic_r4(line,0,i+1,w_c(nkey),.true.,error)
      if (error) return
      w_c(nkey) = abs(w_c(nkey))
    enddo
  !
  ! SET AMPLITUDE ABS:REL SCALED|UNSCALED  KELVIN|KANSKY|RAW ANTENNA|BASELINE
  elseif (nkey.eq.41) then
    do i=2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) return
      call sic_ambigs('SET ',argum1,keywor2,nkey,vamp,mamp,error)
      if (error) return
      ! ABSOLUTE
      if (nkey.eq.1) then
        do_amplitude = .false.
        do_scale = .false.
        do_flux = .false.      ! DEFAULT
        do_raw = .false.
        change_display = .true.
      ! RELATIVE
      elseif (nkey.eq.2) then  ! RELATIVE AMPLITUDE CAL.
        do_amplitude = .true.
        do_flux = .true.       ! DEFAULT
        do_raw = .false.
        change_display = .true.
      ! SCALED
      elseif (nkey.eq.3) then
        do_scale = .true.
        do_raw = .false.
        change_display = .true.
      ! UN SCALED
      elseif (nkey.eq.4) then
        do_scale = .false.
        do_raw = .false.
        change_display = .true.
      ! KELVIN
      elseif (nkey.eq.5) then
        do_flux = .false.
        do_raw = .false.
        change_display = .true.
      ! JANSKY
      elseif (nkey.eq.6) then
        do_flux = .true.
        do_raw = .false.
        change_display = .true.
      ! ANTENNA
      elseif (nkey.eq.7) then
        do_amplitude_antenna = .true.
      ! BASELINE
      elseif (nkey.eq.8) then
        do_amplitude_antenna = .false.
      ! RAW
      elseif (nkey.eq.9) then
        do_raw = .true.
        do_scale = .false.
        do_flux = .false.
        do_amplitude = .false.
      ! SIZED
      elseif (nkey.eq.10) then
        do_size = .true.
        do_scale = .false.
        change_display = .true.
      ! UNSIZED
      elseif (nkey.eq.11) then
        do_size = .false.
        change_display = .true.
      ! SPIDX
      elseif (nkey.eq.12) then
        do_spidx = .true.
        change_display = .true.
      ! NOSPIDX
      elseif (nkey.eq.13) then
        do_spidx = .false.
        change_display = .true.
      endif
    enddo
    call set_display(error)
    change_display = .true.
    call show_general('AMPLITUDE',.false.,line,error)
  !
  ! SET RF_PASSBAND ON|OFF|FREQ|CHANNEL|MEMORY|FILE|ANTENNA|BASELINE
  elseif (nkey.eq.42) then
    do i=2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) return
      call sic_ambigs(' ',argum1,keywor2,nkey,vrf,mrf,more)
      if (more) then
         call sic_i4(line,0,i,bp_file_id,.true.,error)
         if (error) return
         nkey = 0
         bp_spectrum_memory = .false.
      endif
      ! OFF
      if (nkey.eq.11) then
        do_pass_doppler = .false.
      elseif (nkey.eq.10) then
        do_pass_doppler = .true.
      elseif (nkey.eq.9) then
        do_pass_spectrum = .true.
      elseif (nkey.eq.7) then
        do_pass = .false.
      ! ON
      elseif (nkey.eq.8) then
        do_pass = .true.
      ! CHANNEL
      elseif (nkey.eq.3) then
        do_pass_spectrum = .false.
        do_pass_freq = .false.
      ! FREQUENCY
      elseif (nkey.eq.4) then
        do_pass_spectrum = .false.
        do_pass_freq = .true.
      ! FILE
      elseif (nkey.eq.5) then
        do_pass_memory = .false.
      ! MEMORY
      elseif (nkey.eq.6) then
        do_pass_memory = .true.
        if (do_pass_spectrum) bp_spectrum_memory = .false.
      ! BASELINE
      elseif (nkey.eq.2) then
        do_pass_antenna = .false.
      ! ANTENNA
      elseif (nkey.eq.1) then
        do_pass_antenna = .true.
      elseif (nkey.eq.0) then
      else
        goto 98
      endif
    enddo
    if (bp_file_id.ne.0.and.(.not.do_pass_spectrum.or.do_pass_memory)) then
      call message(8,1,'CLIC_SET',&
                   'Not in SPECTRUM file mode. Resetting solution number')
      bp_file_id = 0
    endif
    change_display = .true.
    call show_general('RF_PASSBAND',.false.,line,error)
  !
  ! SET FLUX NAME [VALUE] [FREQUENCY] ([DATE]?) [/RESET]
  elseif (nkey.eq.43) then
    if (sic_present(5,0)) then
      call sic_ke(line,0,2,argum1,nch,.true.,error)
      ! WITH /RESET THE 3RD AND 4TH  ARGUMENTS ARE OPTIONALLY FREQUENCY AND DATE
      freq = -1e6
      call sic_r4(line,0,3,freq,.false.,error)
      if (error) return
      dayf = -1000000
      argum3 = '*'
      call sic_ke(line,0,4,argum3,nch,.false.,error)
      if (argum3.ne.'*') call cdate(argum3,dayf,error)
      if (error) return
      frmhz = freq*1000.
      if ((argum1.eq.'ALL').or.(argum1.eq.'all')) then
        n_flux = 0
      else
        do i=1, n_flux
          if (argum1.eq.c_flux(i)) then
            fr_ok = (frmhz.le.0)   &
              .or. (abs(frmhz-freq_flux(i)).lt.frtol)
            d_ok = (dayf.lt.-100000)   &
              .or. (abs(date_flux(i)-dayf).le.1)
            if (fr_ok .and. d_ok) c_flux(i) = '~'
          endif
        enddo
      endif
    else
      call sic_ke(line,0,2,argum1,nch,.true.,error)
      call sic_ke(line,0,3,argum2,nch,.true.,error)
      if (error) return
      if (argum2.eq.'*') then
        rarg = 0
      else
        call sic_r4(line,0,3,rarg,.true.,error)
        if (error) return
      endif
      freq = -1e6
      call sic_r4(line,0,4,freq,.false.,error)
      if (error) return
      dayf = -1000000
      argum3 = '*'
      call sic_ke(line,0,5,argum3,nch,.false.,error)
      if (argum3.ne.'*') call cdate(argum3,dayf,error)
      if (error) return
      frmhz = freq*1000.
      if = 0
      do i=1, n_flux
        if (argum1.eq.c_flux(i)) then
          ! WAS FIXED:
          if (f_flux(i).and.(rarg.le.0)) then
            c_flux(i) = '~'
            if = -1
          elseif (rarg.le.0) then
            if = -1
          else
            fr_ok = (freq_flux(i).le.0)   &
              .or. (abs(frmhz-freq_flux(i)).lt.frtol)
            d_ok = (date_flux(i).lt.-100000)   &
              .or. (abs(date_flux(i)-dayf).le.1)
            if (fr_ok .and. d_ok) then
              if (if.eq.0) then
                if = i
              else
                c_flux(i) = '~'
              endif
            endif
          endif
        endif
      enddo
      ! NEW ONE
      if (if.eq.0) then
        if (n_flux.lt.m_flux) then
          n_flux = n_flux+1
          c_flux(n_flux) = argum1
          f_flux(n_flux) = rarg.ne.0
          freq_flux(n_flux) = frmhz
          date_flux(n_flux) = dayf ! THE OBSERVATION DATE
          flux(n_flux) = rarg
        else
          call message(8,3,'CLIC_SET','TOO MANY FLUXES')
          error = .true.
        endif
      elseif (rarg.ne.0) then
        f_flux(if) = rarg.ne.0
        date_flux(if) = dayf   ! THE OBSERVATION DATE
        freq_flux(if) = max(freq_flux(if),frmhz)
        if (rarg.ne.0) flux(if) = rarg
      endif
    endif
    call sort_fluxes(error)
  !
  ! SET WATER *|VALUE
  elseif (nkey.eq.44) then
    argum1 = '*'
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1(1:1).eq.'*') then
      atm_water = -100.
    else
      call sic_r4(line,0,2,rarg,.true.,error)
      if (error) return
      if (rarg.gt.0.) then
        atm_water = rarg
      else
        call message(6,3,'CLIC_SET','POSITIVE VALUE, PLEASE')
        error = .true.
        return
      endif
    endif
  !
  ! SET TREC *|VALUE /ANTENNA I|ALL
  elseif (nkey.eq.45) then
    argum1 = '*'
    call get_antennas(line,3,na,ia,.true.,error)
    if (error) return
    iant = ia(1)
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1(1:1).eq.'*') then
      do j=1, na
        atm_trec(ia(j)) = -100.
      enddo
    else
      call sic_r4(line,0,2,rarg,.true.,error)
      if (error) return
      if (rarg.gt.0.) then
        do j=1, na
          atm_trec(ia(j)) = rarg
        enddo
      else
        call message(6,3,'CLIC_SET','POSITIVE VALUE, PLEASE')
        error = .true.
        return
      endif
    endif
  !
  ! SET VIRTUAL **OBSOLETE**
  elseif (nkey.eq.46) then
    call message (8,2,'CLIC_SET',   &
      'CLIC\SET VIRTUAL IS NOW OBSOLETE')
  !
  ! SET SELECTION CO|LI  UP|LO|AV|AU SUBBAND-CODE FR FREQ /WINDOW
  elseif (nkey.eq.47) then
    i = 2
    k = 0
    to = .false.
    and = .false.
    l = 0
    widex_select = .false.
    do while (i.le.narg)
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 479
      call sic_ambigs(' ',argum1,kw,nkey,vsub2, mvsub2, more)
      if (more) then
        lc = len_trim(argum1)  ! ou la sortie de sic_ch
        if (lc.le.1) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (argum1(1:1).eq."C") then
          factor = 0
        elseif (argum1(1:1).eq."L") then
          factor = 1
        else
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (lc.gt.4) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        read(argum1(2:lc),'(I3)',iostat=ier) nkey
        if (ier.ne.0)  then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (nkey.lt.1 .or. nkey.gt.mbands) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif  
        nkey = nkey + factor * mbands
      endif
      i = i+1
      if (kw.eq.'CONTINUUM') then
        cont_select = .true.
      elseif (kw.eq.'LINE') then
        cont_select = .false.
      elseif (kw.eq.'UPPER' .or. kw.eq.'USB') then
        isideb_out = 1
      elseif (kw.eq.'LOWER' .or. kw.eq.'LSB') then
        isideb_out = 2
      elseif (kw.eq.'AVERAGE' .or. kw.eq.'DSB') then
        isideb_out = 3
        if (.not. cont_select) then
          call message(6,2,'CLIC_SET',   &
            'AUTOMATIC SIDEBAND SELECTION IN LINE  MODE')
        endif
      elseif (kw.eq.'WIDEX') then
        widex_select = .true.
      elseif (kw.eq.'AUTO') then
        isideb_out = 4
      elseif (kw.eq.'SSB') then
        isideb_out = 5
      elseif (kw.eq.'TO') then
        to = .true.
      elseif (kw.eq.'AND') then
        and = .true.
      elseif (kw.eq.'ALL') then
        all_select = .true.
      elseif (kw.eq.'FREQUENCY') then
        call sic_r4(line,0,i,freq_out,.true.,error)
        if (error) goto 98
        i = i+1
      else
        all_select = .false.
        if (to) then
          if (k.le.0 .or. nkey.le.k .or. nkey.gt.2*mbands) then
            call message(6,3,'CLIC_SET',   &
              'INVALID SUBBAND RANGE')
            error = .true.
            return
          endif
          do j = k+1, nkey
            l = l + 1
            iso(l) = j
          enddo
          k = nkey
          to = .false.
        elseif (and) then
          if (k.eq.0) then
            call message(6,3,'CLIC_SET',   &
              'INVALID SUBBAND RANGE')
            goto 479
          endif
          l = l  + 1
          iso(l) = nkey
          k = nkey
          and = .false.
        elseif (k.eq.0) then
          l = 1
          k = nkey
          iso(1) =  nkey
        endif
      endif
    enddo
    if (l.ne.0) then
      if (widex_select.and..not.all_select) then
         call message(8,3,'SELECT','SET SELECTION WIDEX can only be &
                      used with SET SELECTION ALL')
         error = .true.
         return
      endif
      lsubb_out = l
      do i=1, l
          isubb_out(i) = iso(i)
      enddo
      if (widex_select.and..not.all_select) then
         call message(8,3,'SELECT','SET SELECTION WIDEX can only be &
                      used with SET SELECTION ALL')
         error = .true.
         return
      endif
    endif
    !
    if (sic_present(2,0)) then
      nn = sic_narg(2)
      if (nn.lt.2) go to 478
      if (nn/2 .gt. mwin_out) then
        call message(6,3,'CLIC_SET','TOO MANY WINDOWS')
        error = .true.
        return
      endif
      do i=1, nn/2
        argum1 = '*'
        call sic_ke(line,2,2*i-1,argum1,nch,.true.,error)
        if (error) goto 478
        if (argum1.eq.'*') then
          f1  = 0.0
        else
          call sic_r4(line,2,2*i-1,f1,.true.,error)
          if (error) goto 478
        endif
        argum1 = '*'
        call sic_ke(line,2,2*i,argum1,nch,.true.,error)
        if (error) goto 478
        if (argum1.eq.'*') then
          f2  = 1e30
        else
          call sic_r4(line,2,2*i,f2,.true.,error)
          if (error) goto 478
        endif
        if (f1.lt.f2) then
          ftry (1,i) = f1
          ftry (2,i) = f2
        else
          goto 478
        endif
      enddo
      nwin_out = nn/2
      do i=1, nwin_out
        window_out(1,i) = ftry(1,i)
        window_out(2,i) = ftry(2,i)
      enddo
    endif
    call show_general('SELECTION',.false.,line,error)
    goto 90
478 call message(6,3,'CLIC_SET','INVALID SELECTION WINDOW')
    error = .true.
    return
479 call message(6,3,'CLIC_SET','INVALID SELECTION '//argum1)
    error = .true.
    return
  !
  ! SET ANTENNAS [P..] A1 A2 A3
  elseif (nkey.eq.48) then
    if (narg.le.1) then
      call switch_antenna
      change_display = .true.
      call set_display(error)
      goto 90
    endif
    n_save = n_base
    do i=1, n_save
      i_save(i) = i_base(i)
    enddo
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) goto 489
    all_base = .false.
    phys_base = .false.
    nch = ichar(argum1(1:1))
    if (nch.gt.ichar('9')) then
      call sic_ambigs('SET ANTENNAS',argum1,kw,nkey,voc3,mvoc3,   &
        error)
      if (kw.eq.'PHYSICAL') then
        i1 = 3
        if ((narg.ge.i1).and.(r_nant.eq.0)) then
          call message(6,3,'SET ANTENNA PHYSICAL',   &
            'NO DATA READ')
          error=.true.
          goto 489
        endif
        phys_base = .true.
        do i=1,mnant
          phys_log(i) = mnant+1
        enddo
        do i=1,r_nant
          phys_log(r_kant(i)) = i
        enddo
      elseif (kw.eq.'LOGICAL') then
        i1 = 3
      elseif (kw.eq.'ALL') then
        all_base = .true.
        i_base(1) = -1
        call set_all_baselines
        i1 = 3
        if (skip_flag) then
          do i=1, mnant
            i_ant(i) = i
          enddo
          n_base = mnant
        endif
      endif
    else
      i1 = 2
    endif
    if (narg.lt.i1) goto 489
    error = .true.
    n_base = 0
    do i = i1, narg
      call sic_i4(line,0,i,iarg,.false.,error)
      if (iarg.gt.mnant .or. iarg.le.0) error = .true.
      if (error) goto 489
      if(phys_base) then
        n_base = n_base+1
        if (phys_log(iarg).le.r_nant) then
          i_base(n_base) = -phys_log(iarg)
        else
          ! IF PHYSICAL ANTENNA IS NOT IN THE
          ! ARRAY, THEN USE FAKE LOGICAL ANTENNA
          ! = PHYSICAL + 10 (TO BE DECODED BY
          ! SHOW COMMAND)
          i_base(n_base) = -(iarg+mnant)
        endif
      else
        n_base = n_base+1
        i_base(n_base) = -iarg
      endif
      i_ant(n_base) = iarg
    enddo
    error = .false.
    if (n_base.gt.0) call set_display(error)
489 continue
    if (error) then
      n_base = n_save
      do i=1, n_save
        i_base(i) = i_save(i)
      enddo
    else
      if (n_base.gt.0) then
        call show_display('ANTENNAS',.false.,error)
        change_display = .true.
      endif
    endif
  !
  ! SET SPECTRUM ON|OFF
  elseif (nkey.eq.49) then
    call message (8,2,'CLIC_SET',   &
      'CLIC\SET SPECTRUM ON|OFF IS NOW OBSOLETE')
  !
  ! SET BINNING OFF:SISE [POS]
  elseif (nkey.eq.50) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1(1:3).eq.'OFF') then
      do_bin = .false.
      call message(4,1,'CLIC_SET','BINNING IS OFF')
    else
      call sic_r4(line,0,2,rarg,.true.,error)
      if (error) return
      bin_pos = 0.
      call sic_r4(line,0,3,bin_pos,.false.,error)
      if (error) return
      if (rarg.gt.0.) then
        do_bin = .true.
        bin_size = rarg
        write(ch,'(A,2(1X,1PG11.4))')   &
          'SIZE AND POSITION OF BINS ',bin_size, bin_pos
        call message(4,1,'CLIC_SET',ch(1:lenc(ch)))
      else
        call message(6,3,'CLIC_SET','INVALID BIN SIZE')
      endif
    endif
    change_display = .true.
  !
  ! SET WEIGHTS ON|OFF
  elseif (nkey.eq.51) then
    i = 2
    do while (sic_present(0,i))
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) return
      call sic_ambigs('SET WEIGHTS',argum1,kw,nkey,   &
        voc13,mvoc13,error)
      if (error) return
      if (kw.eq.'TSYS') then
        call sic_ke(line,0,i+1,argum1,nch,.true.,error)
        if (error) return
        call sic_ambigs('SET WEIGHTS TSYS',argum1,kw,nkey,   &
          voc14,mvoc14,error)
        if (error) return
        if (kw.eq.'ON') then
          weight_tsys =  .true.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY 1/TSYS**2 APPLIED IN TABLE')
        else
          weight_tsys = .false.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY 1/TSYS**2 NOT APPLIED IN TABLE')
        endif
      elseif (kw.eq.'INSTRUMENTAL' .or. kw.eq.'CALIBRATION') then
        call sic_ke(line,0,i+1,argum1,nch,.true.,error)
        if (error) return
        call sic_ambigs('SET WEIGHTS CALIBRATION',argum1,kw,nkey,   &
          voc14,mvoc14,error)
        if (error) return
        if (kw.eq.'ON') then
          weight_cal =  .true.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY CALIBRATION FUNCTION APPLIED IN TABLE')
        else
          weight_cal = .false.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY CALIBRATION FUNCTION '//   &
            'NOT APPLIED IN TABLE')
        endif
      elseif (kw.eq.'BANDPASS') then
        call sic_ke(line,0,i+1,argum1,nch,.true.,error)
        if (error) return
        call sic_ambigs('SET WEIGHTS BANDPASS',argum1,kw,nkey,   &
          voc14,mvoc14,error)
        if (error) return
        if (kw.eq.'ON') then
          weight_pass =  .true.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY BANDPASS FUNCTION APPLIED IN TABLE')
        else
          weight_pass = .false.
          call message(4,1,'CLIC_SET',   &
            'WEIGHTING BY BANDPASS FUNCTION '//   &
            'NOT APPLIED IN TABLE')
        endif
      endif
      i = i + 2
    enddo
  !
  ! SET DATA NP NB
  elseif (nkey.eq.52) then
    call sic_i4(line,0,2,i,.true.,error)
    if (error) return
    i = max(2,i)
    j = m_boxes
    call sic_i4(line,0,3,j,.false.,error)
    if (error) return
    j = max(1,min(j,mbox))
    call set_data(i,j)
    call set_display(error)
  !
  ! SET RECORD LIST
  elseif (nkey.eq.53) then
    ic = sic_start(0,2)
    if (line(ic:ic).eq.'*') then
      n_loop = 1
      rec_1(1) = 1
      rec_2(1) = 1000000
      rec_3(1) = 1
      goto 90
    endif
    iv = sic_end(0,narg)
    call sic_parse_listi4('CLIC_SET',line(ic:iv),list,m_loop,error)
    if (error) return
    n_loop = list%nlist
    rec_1(:) = list%i1(:)
    rec_2(:) = list%i2(:)
    rec_3(:) = list%i3(:)
  !
  ! SET CRITERIA /DEFAULT
  elseif (nkey.eq.54) then
    if (default) then
      call setdef(line, error)
    else
      argum1 = 'CRITERIA'
      goto 98
    endif
  !
  ! SET GAIN_IMAGE
  elseif (nkey.eq.55) then
    argum1 = '*'
    call get_antennas(line,3,na,ia,.true.,error)
    if (error) return
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1(1:1).eq.'*') then
      do j=1, na
        atm_gim(ia(j)) = -1.
      enddo
    else
      call sic_r4(line,0,2,rarg,.true.,error)
      if (error) return
      if (rarg.gt.0.) then
        do j=1, na
          atm_gim(ia(j)) = rarg
        enddo
      else
        call message(6,3,'CLIC_SET','POSITIVE VALUE, PLEASE')
        error = .true.
        return
      endif
    endif
  !
  ! SET DROP_FRACTION
  elseif (nkey.eq.56) then
    rarg = fdrop(1)
    call sic_r4(line,0,2,rarg,.true.,error)
    if (error) return
    if (rarg.ge.0. .and. rarg.le.0.5) then
      fdrop(1) = rarg
    else
      call message(6,3,'CLIC_SET','INVALID BANDWIDTH FRACTION')
      error = .true.
      return
    endif
    rarg = fdrop(2)
    call sic_r4(line,0,3,rarg,.true.,error)
    if (error) return
    if (rarg.ge.0. .and. rarg.le.0.5) then
      fdrop(2) = rarg
    else
      call message(6,3,'CLIC_SET','INVALID BANDWIDTH FRACTION')
      error = .true.
      return
    endif
  !
  ! SET GIBBS
  elseif (nkey.eq.57) then
    iarg = ngibbs
    call sic_i4(line,0,2,iarg,.true.,error)
    if (error) return
    ngibbs = min(32,max(0,iarg))
  !
  ! SET FIND
  elseif (nkey.eq.58) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET FIND',argum1,kw,nkey,voc15,mvoc15,error)
    if (error) return
    if (kw.eq.'UPDATE') then
      find_update = .true.
    else
      find_update = .false.
    endif
  !
  ! SET PLANET
  elseif (nkey.eq.59) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    call sic_ambigs('SET PLANET',argum1,kw,nkey,   &
      voc16,mvoc16,error)
    if (error) return
    if (kw.eq.'*') then
      planet_model = -1        ! DEFAULT ELLIPTIC FORMULA
      call message(6,2,'SET PLANET','DEFAULT BEHAVIOUR RESET')
    elseif (kw.eq.'PRIMARY') then
      planet_model = -2        ! CIRCULAR DISK + PRIMARY BEAM ATT.
    elseif (kw.eq.'FILE') then
      call sic_ch(line,0,3,ch,nch,.true.,error)
      if (error) return
      fich = ch
      call sic_parsef(ch,fich,' ','.SPL')
      call set_fluxspl(fich,planet_model)
    endif
  !
  ! SET RECEIVER
  elseif (nkey.eq.60) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1.eq.'*') then
      srecei = -1
    else
      call sic_i4(line,0,2,l,.true.,error)
      if (error) return
      srecei = l
    endif
  !
  ! SET UV_RANGE
  elseif (nkey.eq.61) then
    call sic_ke(line,0,2,argum1,nch,.true.,error)
    if (error) return
    if (argum1.eq.'*') then
      uv_range(1) = 0
    else
      call sic_r4(line,0,2,uv_range(1),.true.,error)
      if (error) return
      uv_range(1) = max(uv_range(1),0.)
    endif
    call sic_ke(line,0,3,argum1,nch,.true.,error)
    if (error) return
    if (argum1.eq.'*') then
      uv_range(2) = 1000.
    else
      call sic_r4(line,0,3,uv_range(2),.true.,error)
      if (error) return
      uv_range(2) = max(uv_range(1),uv_range(2))
    endif
    call show_display('UV_RANGE',.false.,error)
  !
  ! SET TIME_ORIGIN
  elseif (nkey.eq.62) then
    argum1 = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    call reset_time
    if (argum1.ne.'*') then
      call cdate(argum1,i,error)
      if (.not.error) dobs_0 = i
    endif
    if (dobs_0.eq.0) then
      call message(6,1,'SET','TIME ORIGIN IS AUTOMATIC')
    else
      call datec(i,argum1,error)
      call message(6,1,'SET','TIME ORIGIN IS '//argum1(1:12))
    endif
  !
  ! SET SORT RECEIVER|SCAN
  elseif (nkey.eq.63) then
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET SORT',argum1,kw,nkey,voc17,mvoc17,error)
    if (error) return
    if (kw.eq.'RECEIVER') then
      do_sort_receiver = .true.
      do_sort_num      = .false.
    elseif (kw.eq.'SCAN') then
      do_sort_receiver = .false.
      do_sort_num      = .false.
    elseif (kw.eq.'NUM') then
      do_sort_receiver = .false.
      do_sort_num      = .true.
    endif
  !
  ! SET COPY DATA|NODATA
  elseif (nkey.eq.64) then
    argum1 = '*'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET WRITE',argum1,kw,nkey,voc18,mvoc18,error)
    if (error) return
    if (kw.eq.'DATA') then
      do_write_data = .true.
    elseif (kw.eq.'NODATA') then
      do_write_data = .false.
    endif
  !
  ! SET GAIN_METHOD OLD|NEW
  elseif (nkey.eq.65) then
    argum1 = 'OLD'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET GAIN_METHOD',argum1,kw,nkey,voc19,   &
      mvoc19,error)
    if (error) return
    if (kw.eq.'OLD') then
      call message(6,1,'SET','OLD GAIN METHOD')
      new_ant_gain = .false.
    elseif (kw.eq.'NEW') then
      call message(6,1,'SET','NEW GAIN METHOD')
      new_ant_gain = .true.
    endif
  !
  ! SET POLARIZATION NO|HOR|VER|BOTH|EACH
  elseif (nkey.eq.66) then
    do_polar = 0
    argum1 = 'OFF'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET POLARIZATION',argum1,kw,nkey,voc20,   &
      mvoc20,error)
    if (error) return
    each_subb = .false.
    quar_subb = 0
    nbc_subb = 0
    widex_subb = 0
    narrow_input = 0
    widex_unit = 0
    each_polar = .false.
    if (kw.eq.'OFF') then
      call message(6,1,'CLIC_SET',   &
        'Selecting polarization mode: OFF')
      do_polar = 0
      all_subb = .true.
      pol_subb = 0
      call set_all_subbands
    elseif (kw.eq.'HORIZONTAL') then
      call message(6,1,'CLIC_SET',   &
        'Selecting polarization mode: HORIZONTAL')
      do_polar = 1
      all_subb = .false.
      pol_subb = 1
      call set_pol_subbands(error)
      if (error) return
    elseif (kw.eq.'VERTICAL') then
      call message(6,1,'CLIC_SET',   &
        'Selecting polarization mode: VERTICAL')
      do_polar = 2
      all_subb = .false.
      pol_subb = 2
      call set_pol_subbands(error)
      if (error) return
    elseif (kw.eq.'BOTH') then
      call message(6,1,'CLIC_SET',   &
        'Selecting polarization mode: BOTH')
      do_polar = 3
      all_subb =.true.
      pol_subb = 0
      call set_all_subbands
    elseif (kw.eq.'EACH') then
      call message(6,1,'CLIC_SET',   &
        'Selecting polarization mode: EACH')
      do_polar = 0
      all_subb =.false.
      each_polar =.true.
      pol_subb = 0
      call set_each_pol_subbands
    endif
    call select_pol
    call set_display(error)
    change_display = .true.
    call show_display('POLARIZATION',.false.,error)
  !
  ! SET FAKE OFF | (1|2|3|4)*8
  elseif (nkey.eq.67) then
    print *,'W-CLIC_SET, Highly experimental command, go away!'
    argum1='OFF'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (argum1.eq.'OFF') then
      print *,'I-CLIC_SET, SET FAKE OFF'
      fake_ngrx = .false.
      new_receivers = .false.
    else
      fake_fif1 = 6500
      first = .true.
      second = .false.
      do i=1,8
        fake_lpolmode(i) = 1
        call sic_i4(line,0,i+1,q,.true.,error)
        if (first) then
          first_quarter = q
          first = .false.
          print *,'I-CLIC_SET FIRST QUARTER: ',first_quarter
        else
          if (q.ne.first_quarter) then
            if (.not.second) then
              second_quarter = q
              second = .true.
              print *,'I-CLIC_SET SECOND QUARTER:',second_quarter
            else
              if (q.ne.second_quarter) then
                print *,'E-CLIC_SET, SELECT ONLY 2 QUARTERS'
                return
              endif
            endif
          endif
        endif
        if (q.eq.1) then
          fake_flo2(i) = 8100
          fake_flo2bis(i) = 4000
          fake_band2bis(i) = -1
          if (q.eq.first_quarter) then
            do j=1,mnant
              fake_lpolentry(j,i) = 1
            enddo
          else
            do j=1,mnant
              fake_lpolentry(j,i) = 2
            enddo
          endif
        elseif (q.eq.2) then
          fake_flo2(i) = 8100
          fake_flo2bis(i) = 2000
          fake_band2bis(i) = 1
          if (q.eq.first_quarter) then
            do j=1,mnant
              fake_lpolentry(j,i) = 1
            enddo
          else
            do j=1,mnant
              fake_lpolentry(j,i) = 2
            enddo
          endif
        elseif (q.eq.3) then
          fake_flo2(i) = 9900
          fake_flo2bis(i) = 4000
          fake_band2bis(i) = -1
          if (q.eq.first_quarter) then
            do j=1,mnant
              fake_lpolentry(j,i) = 2
            enddo
          else
            do j=1,mnant
              fake_lpolentry(j,i) = 1
            enddo
          endif
        elseif (q.eq.4) then
          fake_flo2(i) = 9900
          fake_flo2bis(i) = 2000
          fake_band2bis(i) = 1
          if (q.eq.first_quarter) then
            do j=1,mnant
              fake_lpolentry(j,i) = 2
            enddo
          else
            do j=1,mnant
              fake_lpolentry(j,i) = 1
            enddo
          endif
        else
          print *,'E-CLIC_SET, quarter must be 1-2-3-4'
          error = .true.
          return
        endif
      enddo
      print *,'FAKE_ENTRY',fake_lpolentry
      fake_ngrx = .true.
      new_receivers = .true.
      print *,'I-CLIC_SET, SET FAKE ON'
      do i=1,8
        write(*,'(A,I3,F6.0,F6.0)') '   Unit, FLO2, FLO2bis ',   &
          i, fake_flo2(i), fake_flo2bis(i)
      enddo
    endif
  !
  ! SET TOTAL_POWER RAW|PHYSICAL
  elseif (nkey.eq.68) then
    argum1 = 'PHYSICAL'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET TOTAL_POWER',argum1,kw,nkey,voc21,   &
      mvoc21,error)
    if (error) return
    if (kw.eq.'RAW') then
      call message(6,1,'SET','Raw total power scale')
      physical_power = .false.
    elseif (kw.eq.'PHYSICAL') then
      call message(6,1,'SET','Physical total power scale')
      physical_power = .true.
    endif
  !
  ! SET NARROW_INPUT 0|1|2
  elseif (nkey.eq.69) then
    call sic_delvariable('NARROW',.false.,error)
    error = .false.
    narrow_input = 0
    call sic_i4(line,0,2,iarg,.true.,error)
    if (error) return
    if ((iarg.lt.0).or.(iarg.gt.2)) then
      call message(6,3,'SET','Invalid narrow-band corr. input')
      error = .true.
      return
    endif
    narrow_input = iarg
    call sic_def_inte('NARROW',narrow_input,0,0,.false.,error)
    write (ch,'(A,I1)')   &
      'Selecting narrow-band correlator input ',narrow_input
    call message(6,1,'CLIC_SET',ch)
    each_subb = .false.
    pol_subb = 0
    quar_subb = 0
    widex_subb = 0
    each_polar = .false.
    if (narrow_input.ne.0) then
      nbc_subb = narrow_input
      all_subb = .false.
      call set_nbc_subbands(error)
      n_baseband = 1
      l_baseband(1) = 1
      i_baseband(1,1) = narrow_input
      bb_select = .true.
    else
      nbc_subb = 0
      all_subb = .true.
      bb_select = .false.
      call set_all_subbands
    endif
    if (error) return
    !
    ! Update polarization mode
    !         IF (NEW_RECEIVERS) THEN
    !            OLD_DO_POLAR = DO_POLAR
    !            CALL CHECK_POL_SUBBANDS(ERROR)
    !            KW = VOC20(DO_POLAR+1)
    !            N = LENC(KW)
    !            IF (DO_POLAR.NE.OLD_DO_POLAR) THEN
    !               CALL MESSAGE(6,1,'CLIC_SET',
    !     &         'Switching to polarization mode: '//KW(1:N))
    !            ELSE
    !               CALL MESSAGE(6,1,'CLIC_SET',
    !     &         'Polarization mode: '//KW(1:N))
    !            ENDIF
    !         ENDIF
    do_polar = 0
    widex_unit = 0
    call set_display(error)
    change_display = .true.
  !
  ! End
  elseif (nkey.eq.70) then
    call sic_delvariable('WIDEX',.false.,error)
    error = .false.
    widex_unit = 0
    call sic_i4(line,0,2,iarg,.true.,error)
    if (error) return
    if ((iarg.lt.0).or.(iarg.gt.4)) then
      call message(6,3,'SET','Invalid widex unit selection')
      error = .true.
      return
    endif
    widex_unit = iarg
    call sic_def_inte('WIDEX',widex_unit,0,0,.false.,error)
    write (ch,'(A,I1)')   &
      'Selecting widex unit number ',widex_unit
    n_baseband = 1
    l_baseband(1) = 1
    i_baseband(1,1) = 2+widex_unit
    bb_select = .true.
    call message(6,1,'CLIC_SET',ch)
    each_subb = .false.
    pol_subb = 0
    quar_subb = 0
    nbc_subb =0
    widex_subb = widex_unit
    all_subb = .false.
    call set_widex_subbands(error)
    if (error) return
    do_polar = 0
    narrow_input = 0
    each_polar = .false.
    call set_display(error)
    change_display = .true.
  !
  ! SET BBAND
  elseif (nkey.eq.71) then
    if (narg.le.1) goto 90
    bad = .true.
    n_savb = n_baseband
    do i=1, n_savb
      l_savb(i) = l_baseband(i)
      do j=1, l_savb(i)
        i_savb(j,i) = i_baseband(j,i)
      enddo
    enddo
    n_baseband = 0
    to = .false.
    and = .false.
    k = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      call sic_ambigs_sub('SET BBAND',argum1,kw,nkey,   &
        vsub, mvsub, error)
      if (nkey.eq.0) then
          call sic_i4(line,0,i,nkey,.true.,error)
          kw = 'NUMBER'
      endif
!      if (error) goto 279
      !
      if (kw.eq.'TO') then
        to = .true.
      elseif (kw.eq.'AND') then
        and = .true.
      !
      elseif (kw.eq.'ALL') then
        all_bband = .true.
        call set_all_bbands
      elseif (kw.eq.'EACH') then
        print *,"Work needed here"
        all_bband = .false.
      else
        all_bband = .false.
        all_subb = .false.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        if (to) then
          if (k.eq.0 .or. nkey.le.k) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
!            goto 279
          endif
          do j = k+1, nkey
            l_baseband(n_baseband) = l_baseband(n_baseband) + 1
            i_baseband(l_baseband(n_baseband),n_baseband) = j
          enddo
          k = nkey
          to = .false.
        elseif (and) then
          if (k.eq.0) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
!            goto 279
          endif
          l_baseband(n_baseband) = l_baseband(n_baseband) + 1
          i_baseband(l_baseband(n_baseband),n_baseband) = nkey
          k = nkey
          and = .false.
        else
          n_baseband = n_baseband+1
          k = nkey
          i_baseband(1,n_baseband) = nkey
          l_baseband(n_baseband) = 1
        endif
      endif
    enddo
    !
    error = .false.
    if (.not.sic_present(6,0)) call select_bb
    call set_bb_subbands(error)
    call set_subbands_if(error)
    !
    ! Now check/switch polarization mode
    !
    if ((new_receivers).and.(narrow_input.eq.0).and.(widex_unit.eq.0)) then
      old_do_polar = do_polar
      call check_pol_subbands(error)
      kw = voc20(do_polar+1)
      n = lenc(kw)
      if (do_polar.ne.old_do_polar) then
        call message(6,1,'CLIC_SET',   &
          'Switching to polarization mode: '//kw(1:n))
      else
        call message(6,1,'CLIC_SET',   &
          'Polarization mode: '//kw(1:n))
      endif
    endif
    !
    call set_display(error)
    bad = error
!279 continue
    if (bad) then
      n_subb = n_savb
      do i=1, n_savb
        l_subb(i) = l_savb(i)
        do j=1, l_savb(i)
          i_subb(j,i) = i_savb(j,i)
        enddo
      enddo
    else
      change_display = .true.
      call show_display('BBAND',.false.,error)
    endif
  !
  ! SET IF
  elseif (nkey.eq.72) then
    if (narg.le.1) goto 90
    bad = .true.
    n_savb = n_if
    do i=1, n_savb
      l_savb(i) = l_if(i)
      do j=1, l_savb(i)
        i_savb(j,i) = i_if(j,i)
      enddo
    enddo
    n_if = 0
    to = .false.
    and = .false.
    k = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      call sic_ambigs_sub('SET BBAND',argum1,kw,nkey,   &
        vsub, mvsub, error)
      if (nkey.eq.0) then
          call sic_i4(line,0,i,nkey,.true.,error)
          kw = 'NUMBER'
      endif
!      if (error) goto 279
      !
      if (kw.eq.'TO') then
        to = .true.
      elseif (kw.eq.'AND') then
        and = .true.
      !
      elseif (kw.eq.'ALL') then
        print *,"Work needed here"
!        n_subb = n_savb
!        all_subb = .true.
!        each_subb = .false.
!        pol_subb = 0
!        quar_subb = 0
!        nbc_subb = 0
!        widex_subb = 0
!        call set_all_subbands
      elseif (kw.eq.'EACH') then
        print *,"Work needed here"
!        n_subb = n_savb
!        all_subb = .false.
!        each_subb = .true.
!        pol_subb = 0
!        quar_subb = 0
!        nbc_subb = 0
!        widex_subb = 0
!        call set_each_subband
      else
        all_subb = .false.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        if (to) then
          if (k.eq.0 .or. nkey.le.k) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
!            goto 279
          endif
          do j = k+1, nkey
            l_if(n_if) = l_if(n_if) + 1
            i_if(l_if(n_if),n_if) = j
          enddo
          k = nkey
          to = .false.
        elseif (and) then
          if (k.eq.0) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
!            goto 279
          endif
          l_if(n_if) = l_if(n_if) + 1
          i_if(l_if(n_if),n_if) = nkey
          k = nkey
          and = .false.
        else
          n_if = n_if+1
          k = nkey
          i_if(1,n_if) = nkey
          l_if(n_if) = 1
        endif
      endif
    enddo
    !
    error = .false.
    if (.not.sic_present(6,0)) call select_if
    call set_if_subbands(error)
    call set_subbands_bb(error)
    !
    ! Now check/switch polarization mode
    !
    if ((new_receivers).and.(narrow_input.eq.0).and.(widex_unit.eq.0)) then
      old_do_polar = do_polar
      call check_pol_subbands(error)
      kw = voc20(do_polar+1)
      n = lenc(kw)
      if (do_polar.ne.old_do_polar) then
        call message(6,1,'CLIC_SET',   &
          'Switching to polarization mode: '//kw(1:n))
      else
        call message(6,1,'CLIC_SET',   &
          'Polarization mode: '//kw(1:n))
      endif
    endif
    !
    call set_display(error)
    bad = error
!279 continue
    if (bad) then
      n_if = n_savb
      do i=1, n_if
        l_if(i) = l_savb(i)
        do j=1, l_savb(i)
          i_if(j,i) = i_savb(j,i)
        enddo
      enddo
    else
      change_display = .true.
      call show_display('BBAND',.false.,error)
    endif
  !
  ! SET SPW
  elseif (nkey.eq.73) then
    if (narg.le.1) goto 90
    bad = .true.
    n_savb = n_subb
    do i=1, n_savb
      l_savb(i) = l_subb(i)
      do j=1, l_savb(i)
        i_savb(j,i) = i_subb(j,i)
      enddo
    enddo
    n_subb = 0
    to = .false.
    and = .false.
    k = 0
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.true.,error)
      if (error) goto 280
      call sic_ambigs(' ',argum1,kw,nkey,vsub, mvsub, more)
      if (more) then
        lc = len_trim(argum1)  ! ou la sortie de sic_ch
        if (lc.le.1) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (argum1(1:1).eq."C") then
          factor = 0
        elseif (argum1(1:1).eq."L") then
          factor = 1
        else
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (lc.gt.4) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        read(argum1(2:lc),'(I3)',iostat=ier) nkey
        if (ier.ne.0)  then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif
        if (nkey.lt.1 .or. nkey.gt.mbands) then
          call message(6,3,'CLIC_SET',   &
              'Invalid keyword '//argum1)
           error = .true.
           return
        endif  
        nkey = nkey + factor * mbands
      endif
      if (error) goto 280
      !
      if (kw.eq.'TO') then
        to = .true.
      elseif (kw.eq.'AND') then
        and = .true.
      !
      elseif (kw.eq.'ALL') then
        n_subb = n_savb
        all_subb = .true.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        call set_all_subbands
      elseif (kw.eq.'LINE') then
        n_subb = n_savb
        do j=1, n_subb
          if (i_subb(1,j).le.mbands) then
            do k=1, l_subb(j)
              i_subb(k,j) = i_subb(k,j)+mbands
            enddo
          endif
        enddo
      elseif (kw.eq.'CONTINUUM') then
        n_subb = n_savb
        do j=1, n_subb
          if (i_subb(1,j).gt.mbands) then
            do k=1, l_subb(j)
              i_subb(k,j) = i_subb(k,j)-mbands
            enddo
          endif
        enddo
      else
        all_subb = .false.
        each_subb = .false.
        pol_subb = 0
        quar_subb = 0
        nbc_subb = 0
        widex_subb = 0
        if (to) then
          if (k.eq.0 .or. nkey.le.k) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
            goto 280
          endif
          do j = k+1, nkey
            l_subb(n_subb) = l_subb(n_subb) + 1
            i_subb(l_subb(n_subb),n_subb) = j
          enddo
          k = nkey
          to = .false.
        elseif (and) then
          if (k.eq.0) then
            call message(6,3,'CLIC_SET',   &
              'Invalid subband range')
            goto 280
          endif
          l_subb(n_subb) = l_subb(n_subb) + 1
          i_subb(l_subb(n_subb),n_subb) = nkey
          k = nkey
          and = .false.
        else
          n_subb = n_subb+1
          k = nkey
          i_subb(1,n_subb) = nkey
          l_subb(n_subb) = 1
        endif
        !
        if (sic_present(2,0)) then
          argum1 = sw1(n_subb)
          call sic_ke(line,2,2*n_subb-1,argum1,nch,.true.,error)
          if (error) goto 280
          if (argum1.eq.'*') then
            sw1(n_subb) = '*'
            iw1(n_subb) = 0
          elseif (argum1.ne.'=') then
            call sic_i4(line,2,2*n_subb-1,iw1(n_subb),.true.,   &
              error)
            if (error) goto 280
            sw1(n_subb) = 'F'
          endif
          argum1 = sw2(n_subb)
          call sic_ke(line,2,2*n_subb,argum1,nch,.true.,error)
          if (error) goto 280
          if (argum1.eq.'*') then
            sw2(n_subb) = '*'
            iw2(n_subb) = 0
          elseif (argum1.ne.'=') then
            call sic_i4(line,2,2*n_subb, iw2(n_subb),.true.,   &
              error)
            if (error) goto 280
            sw2(n_subb) = 'F'
          endif
        else
          sw1(n_subb) = '*'
          iw1(n_subb) = 0
          sw2(n_subb) = '*'
          iw2(n_subb) = 0
        endif
      endif
    enddo
    !
    error = .false.
    if (.not.sic_present(6,0)) call select_subb
    call set_subbands_bb(error)
    call set_subbands_if(error)
    !
    ! Now check/switch polarization mode
    !
    if ((new_receivers).and.(narrow_input.eq.0).and.(widex_unit.eq.0)) then
      old_do_polar = do_polar
      call check_pol_subbands(error)
      kw = voc20(do_polar+1)
      n = lenc(kw)
      if (do_polar.ne.old_do_polar) then
        call message(6,1,'CLIC_SET',   &
          'Switching to polarization mode: '//kw(1:n))
      else
        call message(6,1,'CLIC_SET',   &
          'Polarization mode: '//kw(1:n))
      endif
    endif
    !
    ! Now check/switch narrow band correlator input
    !
    if ((new_receivers).and.(narrow_input.ne.0)) then
      old_narrow_input = narrow_input
      call check_nbc_subbands(error)
      if (narrow_input.ne.old_narrow_input) then
        write (ch, '(A,I1)')   &
          'Switching to narrow-band correlator input ',   &
          narrow_input
        call message(6,1,'CLIC_SET',ch)
      else
        write (ch, '(A,I1)')   &
          'Narrow-band correlator input ',   &
          narrow_input
        call message(6,1,'CLIC_SET',ch)
      endif
    endif
    !
    call set_display(error)
    bad = error
280 continue
    if (bad) then
      n_subb = n_savb
      do i=1, n_savb
        l_subb(i) = l_savb(i)
        do j=1, l_savb(i)
          i_subb(j,i) = i_savb(j,i)
        enddo
      enddo
    else
      change_display = .true.
      call show_display('SUBBAND',.false.,error)
    endif
  !
  ! SET SKIP YES|NO
  elseif (nkey.eq.74) then
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET SPIDX',argum1,kw,nkey,voc2,    &
      mvoc2,error)
    if (error) return
    if (kw.eq.'YES') then
      iskip = 1
    elseif(kw.eq.'NO') then
      iskip = 0
    endif
  !
  ! SET EXCLUDE
  elseif (nkey.eq.75) then
    nexcl = narg-1
    if (nexcl.gt.10) then
      call message(6,2,'SET EXCLUDE',   &
        'ONLY 10 PROCEDURES RETAINED')
      nexcl = min(nexcl,10)
    endif
    do i=1,nexcl
      call sic_ke(line,0,i+1,argum1,nch,.true.,error)
      if (error) return
      call sic_ambigs('SET EXCL',argum1,kw,nkey,voc12,mvoc12,   &
        error)
      if (error) then
        nexcl = 0
        return
      endif
      if (nkey.le.mvoc12-2) then
        ssexcl(i) = nkey+10
      elseif (kw.eq.'SKYDIP') then
        ssexcl(i) = 6
      elseif (kw.eq.'*') then
        nexcl = 0
      endif
    enddo
    find_needed = .true.
    call show_criteria('EXCLUDE',.false.,error)
  !
  ! SET SPIDX NAME [VALUE] [FREQUENCY] ([DATE]?) [/RESET]
  elseif (nkey.eq.76) then
    if (sic_present(5,0)) then
      call sic_ke(line,0,2,argum1,nch,.true.,error)
      ! WITH /RESET THE 3RD AND 4TH  ARGUMENTS ARE OPTIONALLY FREQUENCY AND DATE
      freq = -1e6
      call sic_r4(line,0,3,freq,.false.,error)
      if (error) return
      dayf = -1000000
      argum3 = '*'
      call sic_ke(line,0,4,argum3,nch,.false.,error)
      if (argum3.ne.'*') call cdate(argum3,dayf,error)
      if (error) return
      frmhz = freq*1000.
      if ((argum1.eq.'ALL').or.(argum1.eq.'all')) then
        n_spidx = 0
      else
        do i=1, n_spidx
          if (argum1.eq.c_spidx(i)) then
            fr_ok = (frmhz.le.0)   &
              .or. (abs(frmhz-freq_spidx(i)).lt.frtol)
            d_ok = (dayf.lt.-100000)   &
              .or. (abs(date_spidx(i)-dayf).le.1)
            if (fr_ok .and. d_ok) c_spidx(i) = '~'
          endif
        enddo
      endif
    else
      call sic_ke(line,0,2,argum1,nch,.true.,error)
      call sic_ke(line,0,3,argum2,nch,.true.,error)
      if (error) return
      if (argum2.eq.'*') then
        rarg = 0
      else
        call sic_r4(line,0,3,rarg,.true.,error)
        if (error) return
      endif
      freq = -1e6
      call sic_r4(line,0,4,freq,.false.,error)
      if (error) return
      dayf = -1000000
      argum3 = '*'
      call sic_ke(line,0,5,argum3,nch,.false.,error)
      if (argum3.ne.'*') call cdate(argum3,dayf,error)
      if (error) return
      frmhz = freq*1000.
      if = 0
      do i=1, n_spidx
        if (argum1.eq.c_spidx(i)) then
          ! WAS FIXED:
          if (f_spidx(i).and.(rarg.le.0)) then
            c_spidx(i) = '~'
            if = -1
          elseif (rarg.le.0) then
            if = -1
          else
            fr_ok = (freq_spidx(i).le.0)   &
              .or. (abs(frmhz-freq_spidx(i)).lt.frtol)
            d_ok = (date_spidx(i).lt.-100000)   &
              .or. (abs(date_spidx(i)-dayf).le.1)
            if (fr_ok .and. d_ok) then
              if (if.eq.0) then
                if = i
              else
                c_spidx(i) = '~'
              endif
            endif
          endif
        endif
      enddo
      ! NEW ONE
      if (if.eq.0) then
        if (n_spidx.lt.m_spidx) then
          n_spidx = n_spidx+1
          c_spidx(n_spidx) = argum1
          f_spidx(n_spidx) = rarg.lt.100
          freq_spidx(n_spidx) = frmhz
          date_spidx(n_spidx) = dayf ! THE OBSERVATION DATE
          spidx(n_spidx) = rarg
        else
          call message(8,3,'CLIC_SET','TOO MANY SPIDX')
          error = .true.
        endif
      elseif (rarg.ne.0) then
        f_spidx(if) = rarg.ne.0
        date_spidx(if) = dayf   ! THE OBSERVATION DATE
        freq_spidx(if) = max(freq_spidx(if),frmhz)
        if (rarg.ne.0) spidx(if) = rarg
      endif
    endif
    call sort_spidx(error)
  !
  ! SET VERSION 
  elseif (nkey.eq.77) then
    call sic_i4(line,0,2,iarg,.true.,error)
    if (error) return
    if (iarg.ge.2.and.iarg.le.version_last) then
      write (ch, '(A,I0)')   &
       'Setting observation version to ',iarg
      call message(6,1,'CLIC_SET',ch)
      write (ch, '(A,I0,A)')   &
       'Caution: use only if you know what you are doing'
      call message(6,2,'CLIC_SET',ch)
      version_current = iarg
    else
      write (ch, '(A,I0,A)')   &
       'Observation version ',iarg,' is not supported'
      call message(6,3,'CLIC_SET',ch)
      write (ch, '(A,I0)')   &
       'Latest supported version is ',version_last
      call message(6,3,'CLIC_SET',ch)
      error = .true.
      return
    endif
  !
  ! SET STOKES 
  elseif (nkey.eq.78) then
    if (narg.lt.2) return
    do i = 2, narg
      call sic_ke(line,0,i,argum1,nch,.false.,error)
      if (error) return
      if (argum1.eq.'RATIO') then
        nkey = code_stokes_ratio
      else
        call sic_ambigs_sub('SET STOKES',argum1,kw,nkey,voc23,   &
          mvoc23,error)
        if (nkey.ne.0) then
          if (kw.eq.'NATIVE') then
            do_leakage = .false.
            do_corrected = .false.
          elseif (kw.eq.'LEAKAGE') then
            do_leakage = .true.
            do_corrected = .false.
          elseif (kw.eq.'CORRECTED') then
            do_leakage = .false.
            do_corrected = .true.
          else
          endif
          return
        endif
        n_stokes = 0
        call sic_ambigs('SET STOKES',argum1,kw,nkey,gio_stokes_names,    &
          21,error)
        nkey = nkey-17
        if (nkey.eq.code_stokes_hh) do_polar = 1
        if (nkey.eq.code_stokes_vv) do_polar = 2
      endif
      n_stokes = n_stokes+1
      i_stokes(n_stokes) = nkey
    enddo
    if (error) return
    call show_display('STOKES',.false.,error)
  !
  ! SET TABLE
  elseif (nkey.eq.79) then
    argum1 = 'STANDARD'
    call sic_ke(line,0,2,argum1,nch,.false.,error)
    if (error) return
    call sic_ambigs('SET TABLE',argum1,kw,nkey,voc22,   &
      mvoc22,error)
    if (error) return
    if (kw.eq.'STANDARD') then
      call message(6,1,'SET','Standard TABLE command')
      table_prototype = .false.
    elseif (kw.eq.'PROTOTYPE') then
      call message(6,1,'SET','Prototype TABLE commad')
      table_prototype = .true.
    endif
  !
  ! SET FINDPOL
  elseif (nkey.eq.80) then
    argum1='*'
    snpol = 0
    do i=2,sic_narg(0)
      call sic_ke(line,0,i,argum1,nch,.false.,error)
      if (error) return
      snpol = snpol+1
      if (argum1(1:1).eq.'*') then 
        snpol = 0
        call show_criteria('FINDPOL',.false.,error)
        find_needed = .true.
        return
      else
        call sic_i4(line,0,i,spol(snpol),.false.,error)
        if (spol(snpol).lt.-1.or.spol(snpol).gt.mnpolscan) then
          call message(6,3,'FIND','Invalid polarisation subscan')
          error = .true.
          return
        endif
        if (spol(snpol).eq.-1) then
          snpol = 16
          do j=1,snpol
            spol(j)=j
          enddo
        endif
      endif
    enddo
    call show_criteria('FINDPOL',.false.,error)
    find_needed = .true.
  !
  ! SET NOCHECK
  elseif (nkey.eq.81) then
    do i=2,sic_narg(0)
      call sic_ke(line,0,i,argum1,nch,.false.,error)
      if (error) return
      call sic_ambigs('SET NOCHECK',argum1,kw,nkey,voc24,   &
            mvoc24,error)
      if (nkey.gt.0.and.nkey.le.mcheck) table_check(nkey) = .false.
    enddo
    call show_general('NOCHECK',.false.,line,error)
  else
    call message(6,3,'SET',keywor//' not implemented')
    error = .true.
    return
  endif
  !
90 nl = index(line,' ')+1
  nla = nl+lenc(argum)
  line(nl:) = keywor(1:lenc(keywor))//line(nla:)
  return
  !
98 call message(6,3,'CLIC_SET','Error decoding '//argum1)
  error = .true.
  return
end subroutine clic_set
!
subroutine get_antennas(line,iopt,nant,iant,needed,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Get list of antennas from /ANTENNA option
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  integer :: iopt                   !
  integer :: nant                   !
  integer :: iant(*)                !
  logical :: needed                 !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  ! Local
  character(len=4) :: arg
  integer :: i, nch
  !-----------------------------------------------------------------------
  do i=1, mnant
    iant(i) = 0
  enddo
  ! error in needed and /ANTENNA option not present
  if (.not.sic_present(iopt,1)) then
    if (needed) then
      call message(6,3,'GET_ANTENNAS','Give /ANTENNA i, please')
      error = .true.
      return
    endif
  endif
  ! All antennas (default if not needed)
  arg = 'ALL'
  call sic_ke(line,iopt,1,arg,nch,needed,error)
  if (arg.eq.'ALL') then
    nant = mnant
    do i=1, mnant
      iant(i) = i
    enddo
    return
  endif
  ! Get antenna list
  nant = sic_narg(iopt)
  do i=1, nant
    call sic_i4(line,iopt,i,iant(i),.true.,error)
    if (iant(i).gt.mnant .or. iant(i).le.0) then
      call message(6,3,'GET_ANTENNAS','Invalid antenna number')
    endif
  enddo
  return
end subroutine get_antennas

subroutine fix(set,idx,lx,nfound,error,erange,more)
  use phys_const
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fix
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !   Search in the input index for entries matching the parameters in
  ! flg% and smin%/smax%. Selected entries are appended to the output
  ! index (it is the responsibility of the caller to check for
  ! duplicates between old and new entries).
  !---------------------------------------------------------------------
  type(class_setup_t),        intent(in)           :: set        !
  type(optimize),             intent(in)           :: idx        ! The index to search in
  type(optimize),             intent(inout)        :: lx         ! The optimize'd index to be updated
  integer(kind=entry_length), intent(out)          :: nfound     ! Number of observations actually found
  logical,                    intent(inout)        :: error      ! Error status
  integer(kind=entry_length), intent(in), optional :: erange(2)  ! Entry range to search in (default all)
  integer(kind=entry_length), intent(in), optional :: more       ! Size of allocation extension
  ! Local
  character(len=*), parameter :: rname='FIX'
  logical :: lire
  integer(kind=4) :: tver
  integer(kind=entry_length) :: iobs,inew,jnew,k,ient,extend
  real(kind=4) :: r,any
  type(observation) :: obs
  logical :: readsec(-mx_sec:0)  ! Which section are to be read
  logical :: readobs,readhead,found
  type(indx_t) :: ind
  type(time_t) :: time
  !
  ! Set the range of entries to search in
  if (present(erange)) then
    inew = erange(1)
    jnew = erange(2)
  else
    inew = 1
    jnew = idx%next-1
  endif
  !
  if (jnew.lt.inew) then
    ! Input index is empty (or erange has null size): nothing can be found.
    ! lx%next unmodified (caller could be working in append mode)
    nfound = 0
    return
  endif
  !
  ! Set the size of allocation extension.
  if (present(more)) then
    ! Caller thinks he knows how many entries will be found here
    extend = more
  else
    ! Default is to enlarge lx so that is can store all the range of
    ! entries
    extend = jnew-inew+1
  endif
  ! Enlarge lx size so that it can append all the found entries
  call reallocate_optimize(lx,lx%next-1+extend,.true.,.true.,error)
  if (error) return
  !
  call chtoby('ANY ',any,4)
  !
  k = 0
  lire = flg%dobs.or.flg%dred.or.flg%posa
! lire = flg%line.or.flg%sourc.or.flg%teles.or.flg%dobs.or.flg%dred   &
!    .or.flg%off1.or.flg%off2.or.flg%scan.or.flg%subscan.or.flg%posa
  !
  ! readhead: need to read the entry descriptor and header
  readhead = flg%freq .or. flg%user .or. flg%dopos .or.  &
             flg%doswitch .or. flg%dodri .or. flg%dodir
  ! readobs: need to read the entry descriptor
  readobs  = flg%sect .or. readhead
  if (readobs) then
    call init_obs(obs)
    if (readhead) then
      readsec(:) = .false.  ! Read none...
      readsec(class_sec_spe_id)  = flg%freq                  ! except spectroscopic section
      readsec(class_sec_pos_id)  = flg%dopos                 ! and position section
      readsec(class_sec_swi_id)  = flg%doswitch              ! and switching section
      readsec(class_sec_dri_id)  = flg%dodri .or. flg%dodir  ! and drift section
      readsec(class_sec_user_id) = flg%user                  ! and user section (if any)
    endif
  endif
  !
  ! Loop on entries
  call gtime_init(time,jnew-inew+1,error)
  if (error)  return
  do iobs = inew,jnew
     ient = idx%ind(iobs)
     if (sic_ctrlc()) then
       call class_message(seve%w,rname,'Aborted by ^C, index may be incomplete')
       exit
     endif
     if (lire .or. readobs) then
        ! In these cases the informations are not in the input index in memory
        ! * lire = information is the input index on disk (was not saved in
        !          memory),
        ! * readobs = information is in the entry descriptor or in the entry on
        !             disk.
        ! This takes much more time, let's give feedback.
        call gtime_current(time)
     endif
     !
     ! General search in memory
     call index_fromoptimize(idx,iobs,ind,error)
     if (error)  return
     !
     if (flg%kind) then
       if (ind%kind.ne.smin%kind) cycle
     endif
     if (ind%qual.gt.smin%qual) cycle
     if (flg%last) then
        if (ind%ver.lt.0) cycle
     endif
     if (flg%num) then
        if (ind%num.lt.smin%num .or. ind%num.gt.smax%num) cycle
     endif
     if (flg%ver) then
        tver = abs(ind%ver)
        if (tver.lt.smin%ver .or. tver.gt.smax%ver) cycle
     endif
     if (flg%sourc) then
        if (flg%isourc.ge.1) then  ! There is a '*' in the source name
           if (.not.match_string(ind%csour,smin%csour)) cycle
        else
           if (ind%csour.ne.smin%csour) cycle
        endif
     endif
     if (flg%line) then
        if (flg%iline.ge.1) then  ! There is a '*' in the line name
           if (.not.match_string(ind%cline,smin%cline)) cycle
        else
           if (ind%cline.ne.smin%cline) cycle
        endif
     endif
     if (flg%teles) then
        if (flg%iteles.ge.1) then  ! There is a '*' in the telescope name
           if (.not.match_string(ind%ctele,smin%ctele)) cycle
        else
           if (ind%ctele.ne.smin%ctele) cycle
        endif
     endif
     if (flg%off1) then
        if (ind%off1.lt.smin%off1 .and. smin%off1.ne.any) cycle
        if (ind%off1.gt.smax%off1 .and. smax%off1.ne.any) cycle
     endif
     if (flg%off2) then
        if (ind%off2.lt.smin%off2 .and. smin%off2.ne.any) cycle
        if (ind%off2.gt.smax%off2 .and. smax%off2.ne.any) cycle
     endif
     if (flg%scan) then
        if (ind%scan.lt.smin%scan .or. ind%scan.gt.smax%scan) cycle
     endif
     if (flg%subscan) then
        if (ind%subscan.lt.smin%subscan .or. ind%subscan.gt.smax%subscan) cycle
     endif
     if (flg%dobs) then
        if (ind%dobs.lt.smin%dobs .or. ind%dobs.gt.smax%dobs) cycle
     endif
     if (flg%domask) then
        if (.not.fix_by_mask(ind%off1,ind%off2,flg%mask))  cycle
     endif
     ! The next tests need to read more data in the observation header
     if (readobs) then
        call robs(obs,ient,error)
        if (error)  return
        if (readhead) then
          call rheader_sub(set,obs,readsec,error)
          if (error)  return
        endif
     endif
     if (flg%sect) then
       if (.not.obs%head%presec(flg%sectval))  cycle
     endif
     if (flg%freq) then
        if (.not.fix_by_freq(obs,flg%freqmin,flg%freqmax,flg%freqsig)) cycle
     endif
     if (flg%doswitch) then
        if (.not.fix_by_switch(obs,flg%switch)) cycle
     endif
     if (flg%dodri) then
        if (.not.fix_by_drift(obs,flg%driang,pis)) cycle
     endif
     if (flg%dodir) then
        if (.not.fix_by_drift(obs,flg%dirang,2.*pis)) cycle
     endif
     if (flg%dopos) then
        if (.not.fix_by_posi(obs,flg%poslam,flg%posbet,flg%possys,flg%posequ,set%tole)) cycle
     endif
     if (flg%user) then
        call user_sec_fix(obs,found,error)
        if (error)  return
        if (.not.found)  cycle
     endif
     !
     ! More restrictive search
     if (lire) then
        call rix(ient,ind,error)
        if (error) return
        if (flg%dred) then
           if (ind%dred.lt.smin%dred .or. ind%dred.gt.smax%dred) cycle
        endif
        if (flg%posa) then
           r = mod(ind%posa,pis)
           if (r.lt.smin%posa .or. r.gt.smax%posa) cycle
        endif
     endif
     k = k+1
     !
     ! Update the input index
     if (lx%next.gt.lx%mobs) then
        call class_message(seve%e,rname,'Current Index is full')
        error = .true.
        return
     endif
     call index_tooptimize(ind,ient,.true.,lx%next,lx,error)
     if (error)  return
     lx%next = lx%next + 1
  enddo
  !
  nfound = k
  !
  ! Reset search flags
  flg%last = .true.
  flg%num = .false.
  flg%ver = .false.
  flg%line = .false.
  flg%sourc = .false.
  flg%teles = .false.
  flg%dobs = .false.
  flg%dred = .false.
  flg%off1 = .false.
  flg%off2 = .false.
  flg%freq = .false.
  flg%dopos = .false.
  flg%sect = .false.
  flg%domask = .false.
  flg%doswitch = .false.
  !
end subroutine fix
!
function fix_by_freq(obs,fmin,fmax,fsig)
  use classcore_interfaces, except_this=>fix_by_freq
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  !  Return .true. if the input range intersects the frequency range
  ! of the input observation.
  !---------------------------------------------------------------------
  logical                       :: fix_by_freq  ! Function value on return
  type(observation), intent(in) :: obs          ! Input observation
  real(kind=8),      intent(in) :: fmin         ! Frequency range (min)
  real(kind=8),      intent(in) :: fmax         ! Frequency range (max)
  logical,           intent(in) :: fsig         ! Signal or image frequencies?
  ! Local
  real(kind=8) :: freqmin,freqmax
  !
  if (fsig) then
    ! Signal frequencies
    if (obs%head%spe%fres.gt.0.d0) then
      ! Left side of spectrum:
      call abscissa_sigabs_left(obs%head,freqmin)
      ! Right side of spectrum
      call abscissa_sigabs_right(obs%head,freqmax)
    else
      call abscissa_sigabs_right(obs%head,freqmin)
      call abscissa_sigabs_left(obs%head,freqmax)
    endif
  else
    ! Image frequencies
    if (obs%head%spe%fres.gt.0.d0) then
      call abscissa_imaabs_right(obs%head,freqmin)
      call abscissa_imaabs_left(obs%head,freqmax)
    else
      call abscissa_imaabs_left(obs%head,freqmin)
      call abscissa_imaabs_right(obs%head,freqmax)
    endif
  endif
  !
  if (fmax.lt.0.d0) then
    ! Select from fmin to infinite
    fix_by_freq = freqmax.ge.fmin
  elseif (fmin.lt.0.d0) then
    ! Select from 0 to fmax
    fix_by_freq = freqmin.le.fmax
  else
    ! Select from fmin to fmax (which may be equal)
    fix_by_freq = freqmin.le.fmax .and. freqmax.ge.fmin
  endif
  !
end function fix_by_freq
!
function fix_by_switch(obs,swmode)
  use classcore_interfaces, except_this=>fix_by_switch
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return .true. if the observation matches the given switching mode
  !---------------------------------------------------------------------
  logical                       :: fix_by_switch ! Function value on return
  type(observation), intent(in) :: obs           ! Input observation
  integer(kind=4),   intent(in) :: swmode        ! Switching mode code
  !
  if (obs%head%presec(class_sec_swi_id)) then
    fix_by_switch = obs%head%swi%swmod.eq.swmode
  else
    fix_by_switch = swmode.eq.mod_unk
  endif
end function fix_by_switch
!
function fix_by_drift(obs,driang,modu)
  use phys_const
  use classcore_interfaces, except_this=>fix_by_drift
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return .true. if the drift matches the required angle modulo some
  ! angle
  !---------------------------------------------------------------------
  logical                       :: fix_by_drift  ! Function value on return
  type(observation), intent(in) :: obs           ! Input observation
  real(kind=4),      intent(in) :: driang        ! [rad] Drift angle
  real(kind=4),      intent(in) :: modu          ! [rad] Modulo angle
  !
  real(kind=4) :: thisang
  real(kind=4), parameter :: tolerance=1.0*rad_per_min  ! [rad] 1 minute tolerance
  !
  if (obs%head%presec(class_sec_dri_id)) then
    thisang = obs%head%dri%apos
    ! Set angle in range [0,modu[
    do while (thisang.lt.0.)  ! Strictly lower than
      thisang = thisang+modu
    enddo
    do while (thisang.ge.modu)  ! Greater or equal to
      thisang = thisang-modu
    enddo
    fix_by_drift = abs(thisang-driang).le.tolerance
  else
    fix_by_drift = .false.
  endif
end function fix_by_drift
!
function fix_by_posi(obs,reflam,refbet,refsys,refequ,tole)
  use gbl_message
  use gkernel_types
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>fix_by_posi
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  !  Return .true. if the observation position matches the reference
  ! position with the given tolerance
  !---------------------------------------------------------------------
  logical                          :: fix_by_posi  ! Function value on return
  type(observation), intent(inout) :: obs          ! Input observation
  real(kind=8),      intent(in)    :: reflam       ! [rad]  Reference lambda position
  real(kind=8),      intent(in)    :: refbet       ! [rad]  Reference beta position
  integer(kind=4),   intent(in)    :: refsys       ! [code] Reference system of coordinates
  real(kind=4),      intent(in)    :: refequ       ! [year] Reference equinox (if relevant)
  real(kind=4),      intent(in)    :: tole         ! [rad]  Tolerance
  ! Local
  character(len=*), parameter :: rname='FIND'
  type(projection_t) :: proj
  real(kind=8) :: rlam,rbet,rxoff,ryoff
  real(kind=4) :: rlamof,rbetof
  logical :: error
  !
  error = .false.
  fix_by_posi = .false.
  !
  ! 1) Convert reference position system to current observation system of
  ! coordinates. NB: conversion routines translate the old absolute reference
  ! to the new absolute reference, and the old offsets (from old reference) to
  ! new offsets (from new reference). If old offsets were 0 (i.e. considering
  ! only the reference position), they are also 0 in the new system! Which is
  ! our case here as we convert the reference position.
  select case (refsys)
  case (type_eq)
    if (obs%head%pos%system.eq.type_eq .and. obs%head%pos%equinox.eq.refequ) then  ! Same system
      rlam = reflam
      rbet = refbet
    elseif (obs%head%pos%system.eq.type_eq .and. obs%head%pos%equinox.ne.refequ) then
      call equ_to_equ(reflam,refbet,0.0,   0.0,   refequ,  &
                      rlam,  rbet,  rlamof,rbetof,obs%head%pos%equinox,error)
    elseif (obs%head%pos%system.eq.type_ga) then
      call equ_to_gal(reflam,refbet,0.0,   0.0,   refequ,  &
                      rlam,  rbet,  rlamof,rbetof,error)
    elseif (obs%head%pos%system.eq.type_ic) then
      call class_message(seve%e,rname,  &
        'Conversion between ICRS and Equatorial system not implemented')
      error = .true.
    endif
  case (type_ga)
    if (obs%head%pos%system.eq.type_ga) then  ! Same system
      rlam = reflam
      rbet = refbet
    elseif (obs%head%pos%system.eq.type_eq) then
      call gal_to_equ(reflam,refbet,0.0,   0.0,  &
                      rlam,  rbet,  rlamof,rbetof,obs%head%pos%equinox,error)
    elseif (obs%head%pos%system.eq.type_ic) then
      call class_message(seve%e,rname,  &
        'Conversion between ICRS and Equatorial system not implemented')
      error = .true.
    endif
  case (type_ic)
    if (obs%head%pos%system.eq.type_ic) then  ! Same system
      rlam = reflam
      rbet = refbet
    else
      call class_message(seve%e,rname,  &
        'Conversion between ICRS and other system not implemented')
      error = .true.
    endif
  case default
    call class_message(seve%e,rname,'Coordinate system not supported')
    error = .true.
  end select
  if (error)  return
  !
  ! 2) Convert absolute reference position to relative position in current
  !    observation projection system
  call gwcs_projec(obs%head%pos%lam,obs%head%pos%bet,obs%head%pos%projang,  &
    obs%head%pos%proj,proj,error)
  if (error)  return
  call abs_to_rel(proj,rlam,rbet,rxoff,ryoff,1)
  !
  ! 3) Compare using tolerance. Same selection as FIND /OFFSET, i.e. selection
  ! in a square, not a circle.
  fix_by_posi = obs%head%pos%lamof.ge.rxoff-tole .and.  &
                obs%head%pos%lamof.le.rxoff+tole .and.  &
                obs%head%pos%betof.ge.ryoff-tole .and.  &
                obs%head%pos%betof.le.ryoff+tole
  !
end function fix_by_posi
!
function fix_by_mask(lamof,betof,mask)
  use image_def
  use classcore_interfaces, except_this=>fix_by_mask
  !---------------------------------------------------------------------
  ! @ private
  !  Return .true. if the observation is selected by the input
  ! position-position mask.
  !  Note there is no consistency checking with the center of
  ! projection, kind of projection, and projection angle. This is the
  ! same feature as FIND /RANGE
  !---------------------------------------------------------------------
  logical :: fix_by_mask  ! Function value on return
  real(kind=4), intent(in) :: lamof,betof  ! Offsets
  type(gildas), intent(in) :: mask         ! The GDF 2D mask
  ! Local
  integer(kind=index_length) :: xc,yc
  integer(kind=4) :: xaxi,yaxi
  !
  xaxi = mask%gil%xaxi
  yaxi = mask%gil%yaxi
  !
  xc = nint((lamof-mask%gil%val(xaxi))/mask%gil%inc(xaxi)+mask%gil%ref(xaxi),kind=8)
  yc = nint((betof-mask%gil%val(yaxi))/mask%gil%inc(yaxi)+mask%gil%ref(yaxi),kind=8)
  !
  ! Out of area = not selected
  ! Negative or null value = not selected
  ! Blank value = not selected
  fix_by_mask = xc.ge.1                   .and.  &
                xc.le.mask%gil%dim(xaxi)  .and.  &
                yc.ge.1                   .and.  &
                yc.le.mask%gil%dim(yaxi)  .and.  &
                mask%r2d(xc,yc).gt.0.     .and.  &
                abs(mask%r2d(xc,yc)-mask%gil%bval).gt.mask%gil%eval
  !
end function fix_by_mask
!
!-----------------------------------------------------------------------
! Tools for fast search in Output File
!-----------------------------------------------------------------------
!
subroutine ox_sort_reset(set,error)
  use classcore_interfaces, except_this=>ox_sort_reset
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Recompute the sorting arrays of the Output indeX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  logical,             intent(inout) :: error
  !
  call fox_reset
  if (set%uniqueness) then
    call optimize_sort_set_dtt(ox,error)
    if (error)  return
  endif
  !
end subroutine ox_sort_reset
!
subroutine ox_sort_add(set,obs,dupl,error)
  use gbl_message
  use classcore_interfaces, except_this=>ox_sort_add
  use class_common
  use class_index
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Add a new observation in the sorting arrays of the Output indeX
  !---------------------------------------------------------------------
  type(class_setup_t), intent(in)    :: set
  type(observation),   intent(in)    :: obs
  logical,             intent(out)   :: dupl
  logical,             intent(inout) :: error
  !
  dupl = .false.
  if (set%uniqueness) then
    if (fileout%desc%vind.ne.3) then
      call class_message(seve%w,'UNIQUENESS',  &
        'Not checked (index version in output file must be 3)')
      return
    elseif (.not.fileout%desc%single) then
      call class_message(seve%w,'UNIQUENESS',  &
        'Not checked (output file must be single)')
      return
    endif
    call optimize_sort_add_dtt(ox,obs,dupl,error)
    if (error)  return
  endif
  !
  ! Do it last so that this sorting array remains correct in case of
  ! error above
  call fox_add(obs%head%gen%num,fileout%desc%xnext-1)
  !
end subroutine ox_sort_add
!
subroutine fox(anum,ifound)
  use gbl_message
  use classcore_interfaces, except_this=>fox
  use class_parameter
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  ! Search for observation number Anum (last version) in the sorted
  ! index.
  !----------------------------------------------------------------------
  integer(kind=obsnum_length), intent(in)  :: anum    ! Obs number being searched for
  integer(kind=entry_length),  intent(out) :: ifound  ! Corresponding Entry Number (0 if none)
  ! Local
  integer(kind=entry_length) :: jprev,jnext
  !
  ifound = 0
  if (ox%sort%nsort.eq.0) return
  call locplus(ox%sort%number,ox%sort%nsort,anum,jprev,jnext)
  !
  ! Not found
  if (ox%sort%number(jprev).eq.anum) then
    ifound = ox%sort%entry(jprev)
  else if (ox%sort%number(jnext).eq.anum) then
    ifound = ox%sort%entry(jnext)
  endif
  ! print *,'ox%sort%nsort ',ox%sort%nsort,jprev,jnext
end subroutine fox
!
subroutine fox_reset
  use gbl_message
  use classic_api
  use class_parameter
  use class_index
  !----------------------------------------------------------------------
  ! @ private
  ! Build up the Sorted Entry/Number list when opening an output file
  ! The Sorted list will then be kept up-to-date at each writing.
  !----------------------------------------------------------------------
  ! Local
  integer(kind=entry_length) :: iobs,j,ifound,jprev,jnext
  integer(kind=obsnum_length) :: anum
  !
  ox%sort%nsort = 0
  do iobs=1,ox%next-1
    if (ox%ver(iobs).lt.0) cycle ! Ignore "old" versions
    if (ox%sort%nsort.eq.0) then
      ox%sort%nsort = 1
      ox%sort%number(1) = ox%num(iobs)
      ox%sort%entry(1) = iobs
    else
      anum = ox%num(iobs)
      if (anum.gt.ox%sort%number(ox%sort%nsort)) then
        ox%sort%nsort = ox%sort%nsort+1
        ox%sort%number(ox%sort%nsort) = anum
        ox%sort%entry(ox%sort%nsort) = iobs
      else if (anum.lt.ox%sort%number(1)) then
        do j=ox%sort%nsort,1,-1
          ox%sort%number(j+1) = ox%sort%number(j)
          ox%sort%entry(j+1) = ox%sort%entry(j)
        enddo
        ox%sort%number(1) = anum
        ox%sort%entry(1) = iobs
        ox%sort%nsort = ox%sort%nsort+1
      else
        call locplus(ox%sort%number,ox%sort%nsort,anum,jprev,jnext)
        if (ox%sort%number(jprev).eq.anum) then
          ifound = ox%sort%entry(jprev)
        else if (ox%sort%number(jnext).eq.anum) then
          ifound = ox%sort%entry(jnext)
        else
          ! Insert between jprev and jnext
          do j=ox%sort%nsort,jnext,-1
            ox%sort%number(j+1) = ox%sort%number(j)
            ox%sort%entry(j+1) = ox%sort%entry(j)
          enddo
          ox%sort%number(jnext) = anum
          ox%sort%entry(jnext) = iobs
          ox%sort%nsort = ox%sort%nsort+1
        endif
      endif
    endif
  enddo
end subroutine fox_reset
!
subroutine fox_next(anum)
  use gbl_message
  use class_parameter
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! RW  Returns next available ObsNumber Anum (last version)
  !---------------------------------------------------------------------
  integer(kind=obsnum_length), intent(out) :: anum  !
  !
  if (ox%sort%nsort.eq.0) then
     anum = 1
  else
     anum = ox%sort%number(ox%sort%nsort)+1
  endif
end subroutine fox_next
!
subroutine fox_add (anum, entry)
  use gbl_message
  use classic_api
  use classcore_interfaces, except_this=>fox_add
  use class_parameter
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! RW  Search for ObsNumber Anum (last version)
  !---------------------------------------------------------------------
  integer(kind=obsnum_length), intent(in) :: anum   ! Obs number being searched for
  integer(kind=entry_length),  intent(in) :: entry  ! Corresponding Entry Number (0 if none)
  ! Local
  integer(kind=entry_length) :: j,jprev,jnext
  !
  if (ox%sort%nsort.eq.0) then
    ox%sort%nsort = 1
    ox%sort%number(1) = anum
    ox%sort%entry(1) = entry
  else
    if (anum.gt.ox%sort%number(ox%sort%nsort)) then
      ox%sort%nsort = ox%sort%nsort+1
      ox%sort%number(ox%sort%nsort) = anum
      ox%sort%entry(ox%sort%nsort) = entry
    else if (anum.lt.ox%sort%number(1)) then
      do j=ox%sort%nsort,1,-1
        ox%sort%number(j+1) = ox%sort%number(j)
        ox%sort%entry(j+1) = ox%sort%entry(j)
      enddo
      ox%sort%number(1) = anum
      ox%sort%entry(1) = entry
      ox%sort%nsort = ox%sort%nsort+1
    else
      call locplus(ox%sort%number,ox%sort%nsort,anum,jprev,jnext)
      if (ox%sort%number(jprev).eq.anum) then
        ox%sort%entry(jprev) = entry
      else if (ox%sort%number(jnext).eq.anum) then
        ox%sort%entry(jnext) = entry
      else
        ! Insert between jprev and jnext
        do j=ox%sort%nsort,jnext,-1
          ox%sort%number(j+1) = ox%sort%number(j)
          ox%sort%entry(j+1) = ox%sort%entry(j)
        enddo
        ox%sort%number(jnext) = anum
        ox%sort%entry(jnext) = entry
        ox%sort%nsort = ox%sort%nsort+1
      endif
    endif
  endif
end subroutine fox_add
!
subroutine locplus (x,np,xlim,nlim,mlim)
  use classic_api
  use class_parameter
  !---------------------------------------------------------------------
  ! @ private
  !  Find NLIM and MLIM such as
  !      X(NLIM) < XLIM < X(MLIM)
  !  for input data ordered increasingly
  !  Use a dichotomic search for that
  !---------------------------------------------------------------------
  integer(kind=entry_length),  intent(in)  :: np     !
  integer(kind=obsnum_length), intent(in)  :: x(np)  !
  integer(kind=obsnum_length), intent(in)  :: xlim   !
  integer(kind=entry_length),  intent(out) :: nlim   !
  integer(kind=entry_length),  intent(out) :: mlim   !
  ! Local
  integer(kind=entry_length) :: ninf,nsup,nmid
  !
  if (x(1).gt.xlim) then
     nlim = 1
     mlim = 1
     return
  elseif (x(np).lt.xlim) then
     nlim = np
     mlim = np
     return
  endif
  ninf = 1
  nsup = np
  !
  do while(nsup.gt.ninf+1)
     nmid = (nsup + ninf)/2
     if (x(nmid).lt.xlim) then
        ninf = nmid
     else
        nsup = nmid
     endif
  enddo
  nlim = ninf
  mlim = nsup
end subroutine locplus
!
subroutine optimize_sort_set_dtt(in,error)
  use gbl_message
  use classcore_dependencies_interfaces
  use classic_api
  use classcore_interfaces, except_this=>optimize_sort_set_dtt
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Compute the date-time-telescope sorting list of the given index
  !---------------------------------------------------------------------
  type(optimize), intent(inout) :: in     !
  logical,        intent(inout) :: error  !
  ! Local
  integer(kind=entry_length) :: nelem,ielem
  !
  nelem = in%next-1
  !
  do ielem=1,nelem
    in%sort%dtt(ielem) = ielem
  enddo
  !
  call gi0_quicksort_index_with_user_gtge(in%sort%dtt,nelem,setdtt_gt,  &
    setdtt_ge,error)
  if (error)  return
  !
contains
  !
  ! Sorting functions: first by DOBS, then by UT, then by TELES
  ! Use local functions which know the 'in' object (this avoids
  ! making it a global variable).
  function setdtt_gt(m,l)
    logical :: setdtt_gt
    integer(kind=entry_length), intent(in) :: m,l
    if (in%dobs(m).ne.in%dobs(l)) then
      setdtt_gt = in%dobs(m).gt.in%dobs(l)
      return
    endif
    if (in%ut(m).ne.in%ut(l)) then
      setdtt_gt = in%ut(m).gt.in%ut(l)
      return
    endif
    setdtt_gt = lgt(in%ctele(m),in%ctele(l))
  end function setdtt_gt
  !
  function setdtt_ge(m,l)
    logical :: setdtt_ge
    integer(kind=entry_length), intent(in) :: m,l
    if (in%dobs(m).ne.in%dobs(l)) then
      setdtt_ge = in%dobs(m).ge.in%dobs(l)
      return
    endif
    if (in%ut(m).ne.in%ut(l)) then
      setdtt_ge = in%ut(m).ge.in%ut(l)
      return
    endif
    setdtt_ge = lge(in%ctele(m),in%ctele(l))
  end function setdtt_ge
  !
end subroutine optimize_sort_set_dtt
!
subroutine optimize_sort_add_dtt(optx,obs,dupl,error)
  use gbl_message
  use classic_api
  use classcore_dependencies_interfaces
  use classcore_interfaces, except_this=>optimize_sort_add_dtt
  use class_types
  !---------------------------------------------------------------------
  ! @ private
  !  Add a new observation to the Date-Time-Telescope sorting list.
  ! Raise an error if this new observation is duplicate of a previous
  ! one.
  !---------------------------------------------------------------------
  type(optimize),    intent(inout) :: optx   ! Index to search in
  type(observation), intent(in)    :: obs    ! Observation to be added
  logical,           intent(out)   :: dupl   ! Observation is a duplicate?
  logical,           intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=entry_length) :: nelem,jent,kent
  integer(kind=entry_length), parameter :: first=1
  character(len=message_length) :: mess
  !
  dupl = .false.
  nelem = optx%next-2  ! Observation is already at last position in the index...
  !
  if (nelem.le.0) then
    optx%sort%dtt(1) = 1
    return
  elseif (add_dtt_lt(nelem)) then
    optx%sort%dtt(nelem+1) = nelem+1
    return
  elseif (add_dtt_gt(first)) then
    jent = 1
  else
    call gi0_dicho_with_user_ltgt(nelem,.true.,jent,add_dtt_lt,add_dtt_gt,  &
      error)
    if (error)  return
  endif
  ! In return jent is the element lower or equal to the request
  ! in the sorting array (optx%sort%dtt)
  !
  ! Check uniqueness
  kent = optx%sort%dtt(jent)
  if (optx%dobs(kent).eq.obs%head%gen%dobs .and.  &
      optx%ut(kent).eq.obs%head%gen%ut     .and.  &
      optx%ctele(kent).eq.obs%head%gen%teles) then
    dupl = .true.
    write(mess,'(A,I0,A,I0,A,F0.8,A,A)')  &
      'Duplicate observation #',obs%head%gen%num,': DOBS=',  &
      obs%head%gen%dobs,', UT=',obs%head%gen%ut,', TELES=',obs%head%gen%teles
    call class_message(seve%e,'UNIQUENESS',mess)
    error = .true.
    return
  endif
  !
  ! Fine, insert the observation at position jent in the sorting array
  do kent=nelem,jent,-1
    optx%sort%dtt(kent+1) = optx%sort%dtt(kent)
  enddo
  optx%sort%dtt(jent) = optx%next-1
  !
contains
  !
  function add_dtt_lt(m)
    ! Return .true. if the m-th element is lower than the observation
    logical :: add_dtt_lt
    integer(kind=entry_length), intent(in) :: m
    integer(kind=entry_length) :: ient
    ient = optx%sort%dtt(m)
    if (optx%dobs(ient).ne.obs%head%gen%dobs) then
      add_dtt_lt = optx%dobs(ient).lt.obs%head%gen%dobs
      return
    endif
    if (optx%ut(ient).ne.obs%head%gen%ut) then
      add_dtt_lt = optx%ut(ient).lt.obs%head%gen%ut
      return
    endif
    add_dtt_lt = llt(optx%ctele(ient),obs%head%gen%teles)
  end function add_dtt_lt
  !
  function add_dtt_gt(m)
    ! Return .true. if the m-th element is greater than the observation
    logical :: add_dtt_gt
    integer(kind=entry_length), intent(in) :: m
    integer(kind=entry_length) :: ient
    ient = optx%sort%dtt(m)
    if (optx%dobs(ient).ne.obs%head%gen%dobs) then
      add_dtt_gt = optx%dobs(ient).gt.obs%head%gen%dobs
      return
    endif
    if (optx%ut(ient).ne.obs%head%gen%ut) then
      add_dtt_gt = optx%ut(ient).gt.obs%head%gen%ut
      return
    endif
    add_dtt_gt = lgt(optx%ctele(ient),obs%head%gen%teles)
  end function add_dtt_gt
  !
end subroutine optimize_sort_add_dtt

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module clean_clark
  use gbl_message
  !
  public :: clark_comm
  private
  !
contains
  !
  subroutine clark_comm(line,error)
    use gkernel_interfaces
    use mapping_interfaces
    use clean_tool, only: sub_clean,clean_data
    use clean_types, only: beam_unit_conversion
    use clean_buffers, only: clean_user,clean_prog
    !----------------------------------------------------------------------
    ! Implementation of Barry Clark Clean
    !----------------------------------------------------------------------
    character(len=*), intent(in)    :: line
    logical,          intent(inout) :: error
    !
    integer :: iv,na
    character(len=8) :: name,argum,voc1(2)
    data voc1/'CLEAN','RESIDUAL'/
    !
    ! Data checkup
    clean_user%method = 'CLARK'
    call clean_data(error)
    if (error) return
    !
    ! Parameter Definitions
    call beam_unit_conversion(clean_user)
    call clean_user%copyto(clean_prog)
    clean_prog%pflux = sic_present(1,0)
    clean_prog%pcycle = sic_present(2,0)
    clean_prog%qcycle = sic_present(3,0)
    if (clean_prog%pcycle) then
       argum = 'RESIDUAL'
       call sic_ke(line,2,1,argum,na,.false.,error)
       if (error) return
       call sic_ambigs('PLOT',argum,name,iv,voc1,2,error)
       if (error) return
       clean_prog%pclean = iv.eq.1
    else
       clean_prog%pclean = .false.
    endif
    call sub_clean(line,error)
  end subroutine clark_comm
end module clean_clark
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

* DECK zdrscl.f
      SUBROUTINE ZDRSCL( N, SA, SX, INCX )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INCX, N
      DOUBLE PRECISION   SA
*     ..
*     .. Array Arguments ..
      COMPLEX*16         SX( * )
*     ..
*
*  Purpose
*  =======
*
*  ZDRSCL multiplies an n-element complex vector x by the real scalar
*  1/a.  This is done without overflow or underflow as long as
*  the final result x/a does not overflow or underflow.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of components of the vector x.
*
*  SA      (input) DOUBLE PRECISION
*          The scalar a which is used to divide each component of x.
*          SA must be >= 0, or the subroutine will divide by zero.
*
*  SX      (input/output) COMPLEX*16 array, dimension
*                         (1+(N-1)*abs(INCX))
*          The n-element vector x.
*
*  INCX    (input) INTEGER
*          The increment between successive values of the vector SX.
*          > 0:  SX(1) = X(1) and SX(1+(i-1)*INCX) = x(i),     1< i<= n
*
* =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            DONE
      DOUBLE PRECISION   BIGNUM, CDEN, CDEN1, CNUM, CNUM1, MUL, SMLNUM
*     ..
*     .. External Functions ..
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLABAD, ZDSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.LE.0 )
     $   RETURN
*
*     Get machine parameters
*
      SMLNUM = DLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
*
*     Initialize the denominator to SA and the numerator to 1.
*
      CDEN = SA
      CNUM = ONE
*
   10 CONTINUE
      CDEN1 = CDEN*SMLNUM
      CNUM1 = CNUM / BIGNUM
      IF( ABS( CDEN1 ).GT.ABS( CNUM ) .AND. CNUM.NE.ZERO ) THEN
*
*        Pre-multiply X by SMLNUM if CDEN is large compared to CNUM.
*
         MUL = SMLNUM
         DONE = .FALSE.
         CDEN = CDEN1
      ELSE IF( ABS( CNUM1 ).GT.ABS( CDEN ) ) THEN
*
*        Pre-multiply X by BIGNUM if CDEN is small compared to CNUM.
*
         MUL = BIGNUM
         DONE = .FALSE.
         CNUM = CNUM1
      ELSE
*
*        Multiply X by CNUM / CDEN and return.
*
         MUL = CNUM / CDEN
         DONE = .TRUE.
      END IF
*
*     Scale the vector X by MUL
*
      CALL ZDSCAL( N, MUL, SX, INCX )
*
      IF( .NOT.DONE )
     $   GO TO 10
*
      RETURN
*
*     End of ZDRSCL
*
      END
